package LoadDataModule;  #
use strict;
use Date::Parse;
use RRDp;
use File::Copy;



# standard data retentions
my $one_minute_sample=86400;
my $five_mins_sample=25920;
my $one_hour_sample=4320;
my $five_hours_sample=1734;
my $one_day_sample=1080;
my $one_minute_sample_mem=86400;
my $five_mins_sample_mem=25920;
my $one_hour_sample_mem=4320;
my $five_hours_sample_mem=1734;
my $one_day_sample_mem=1080;

my $JUMP_DETECT = 900;

my $rename_once = 0;
my @rename = "";

sub load_data {
  my ($managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp, $last_file,$no_time,$SSH,$hmc_user) = @_;
  my @lpar_trans = @{$trans_tmp};
  my $counter=0;
  my $counter_tot=0;
  my $counter_ins=0;
  my $last_rec = "";
  my $rrd ="";
  my $time = "";
  my $t = "";
  my $answer = "";
  my $utime = time() + 3600;
  $rename_once = 0;
  my $keep_virtual = 0;
  if ( $ENV{KEEP_VIRTUAL} )  {
    $keep_virtual = $ENV{KEEP_VIRTUAL}; # keep number of virt processors in RRD --> etc/.magic
  }
  else {
    $keep_virtual = 0;
  }


  if ($step > 60 ) {
    $JUMP_DETECT = 10800; # 3 hours
  }
  if ($type_sam =~ m/d/ ) {
    $JUMP_DETECT = 178000 # 2 days + for daily graphs/feed
  }

  print "updating RRD   : $host:$managedname:data:$input-$type_sam\n" if $DEBUG ;
  open(FH, "< $input-$type_sam") || main::error(" Can't open $input-$type_sam : $!".__FILE__.":".__LINE__) && return 0;

  my @lines = reverse <FH>;
  my $line = "";
  my @rrd_exist = "";
  my @rmd_exist = "";
  my @rsd_exist = "";

  my @lpar_name = "";
  my @lpar_time = "";
  my @lpar_jump = "";

  my $l_count_rmd = 0;
  my $ltime_rmd = 0;
  my @lpar_name_rmd = "";
  my @lpar_time_rmd = "";

  my $l_count_rsd = 0;
  my $ltime_rsd = 0;
  my @lpar_name_rsd = "";
  my @lpar_time_rsd = "";

  my $last_time = "";


  foreach $line (@lines) {
	#print "$line";
        chomp ($line);
	$time = "";
	my $lpar = "";
	my $lpar_id = "";
	my $curr_proc_units = "";
	my $curr_procs = "";
	my $curr_sharing_mode = "";
	my $entitled_cycles = "";
	my $capped_cycles ="";
	my $uncapped_cycles = "";
	my $shared_cycles_while_active = "";
        my $mem_mode = "";
	my $curr_mem = "";
	my $phys_run_mem = "";
	my $curr_io_entitled_mem = "";
	my $mapped_io_entitled_mem = "";
	my $mem_overage_cooperation = "";

        if ( $line =~ "HSCL" || $line =~ "VIOSE0" || $line =~ "No results were found" || $line =~ "invalid parameter was entered" ) {
	  # something wrong with the input data
	  main::error ("$host:$managedname : wrong input data in $host:$managedname:data:$input-$type_sam : $line");
	  return 1;
        }

        if ( $line =~ "An invalid parameter value was entered" ) {
	  # something wrong with the input data
	  main::error ("$host:$managedname : wrong input data in $host:$managedname:data:$input-$type_sam : $line");
	  next;
        }

        if ( $HMC == 1 ) {
          ($time, $lpar, $curr_proc_units, $curr_procs, $curr_sharing_mode, $entitled_cycles,
            $capped_cycles, $uncapped_cycles, $shared_cycles_while_active,
	    $mem_mode, $curr_mem, $phys_run_mem, $curr_io_entitled_mem,
	    $mapped_io_entitled_mem, $mem_overage_cooperation) = split(/,/,$line);
        } 
	if ( $IVM == 1 ) {
          ($time, $lpar_id, $curr_proc_units, $curr_procs, $curr_sharing_mode, $entitled_cycles,
            $capped_cycles, $uncapped_cycles, $shared_cycles_while_active,
	    $mem_mode, $curr_mem, $phys_run_mem, $curr_io_entitled_mem,
	    $mapped_io_entitled_mem, $mem_overage_cooperation) = split(/,/,$line);
        }
	if ( $SDMC == 1 ) {
          ($time, $lpar_id, $curr_proc_units, $curr_procs, $curr_sharing_mode, $entitled_cycles,
            $capped_cycles, $uncapped_cycles,
	    $mem_mode, $curr_mem, $phys_run_mem, $curr_io_entitled_mem,
	    $mapped_io_entitled_mem, $mem_overage_cooperation) = split(/,/,$line);
  	}

        # print "001 $lpar : $curr_proc_units, $curr_procs, $curr_sharing_mode, $entitled_cycles $capped_cycles, $uncapped_cycles\n";
        # $curr_proc_units can be null for dedicated partitions so do not test it here!!!!
        if ( $curr_procs eq '' || $curr_sharing_mode eq '' || $entitled_cycles eq '' || $capped_cycles eq '' || $uncapped_cycles eq '' ) {
          # something wrong with input data, skipping it
	  # it migh happen, here is en example : 05/03/2012 22:34:50,1,,,,,,
          next;
        }

	#print "$time $lpar \n";
	# Check whether the first character is a digit, if not then there is something wrong with the
	# input data
	my $ret = substr($time,0,1);
	#if (($ret =~ /\D/) || ( $lpar eq '' ))  {  
	# do not put there $lpar as it might be NULL when the systems is down, seen it for memory
	if ($ret =~ /\D/) {  
	  main::error ("Wrong input data, file : $input-$type_sam");
	  # leave it as wrong input data
          if ($type_sam =~ "d") {
	    main::error ("Migh be caused by freshly enabled new server and daily data is not yet collected, then it should disapear after  1 day");
          } 
          if ($type_sam =~ "h") {
	    main::error ("Migh be caused by freshly enabled new server and daily data is not yet collected, then it should disapear after  1 day");
          } 
          main::error ("Here is the content of the file");
          main::error ("head -1/tail -1 \"$input-$type_sam\"");
	  my $res = `head -1 \"$input-$type_sam\"`;
          chomp ($res);
          main::error ("$res");
	  $res = `tail -1 \"$input-$type_sam\"`;
          chomp ($res);
          main::error ("$res");
	  close (FH);
	  return 1;
	}

	if ( $HMC == 0) {	# IVM translation ids to names
	  # this will have a problem whether a "," is inside lpar name
          foreach my $li (@lpar_trans) {
	    chomp ($li);
 	    (my $id, my $name) = split(/,/,$li);
	    #print "---02 $li -- $id - $lpar_id\n";
	    if ($id == $lpar_id) {
	      $lpar = $name;
	      last;	
	    }
	  }
	}

        if ( $lpar =~ m/IOR Collection LP/ ) { #it is some trash, it exists time to tme, some IBM internal ...
          next; #ignore it
        }
        if ( $lpar eq '' ) {
          next; #again something wrong
        }

	# replace / by &&1, install-html.sh does the reverse thing
	$lpar =~ s/\//\&\&1/g;

	$t=str2time(substr($time,0,19));
	if ( length($t) < 10) {
	  # leave it as wrong input data
	  main::error  ("No valid lpar data time format got from HMC\n");
	  close (FH);
	  return 1;
	}

	if ($step == 3600) {
          # Put on the last time possition "00"!!!
          substr($t,8,2,"00");
          #print "$t $lpar\n"; 
          #print "Input data: $lpar\n"; 
	}
   
        $rrd = "$wrkdir/$managedname/$host/$lpar.rr$type_sam";

 	#create rrd db if necessary
        # find out if rrd db exist, and place info to the array to do not check its existency every time
        my $rrd_exist_ok = 0;
        my $rrd_exist_row = 0;
        foreach my $row (@rrd_exist) {
          $rrd_exist_row++;
          if ($row =~ m/^$lpar$/ ) {
            $rrd_exist_ok = 1;
            last;
          }
        }
        if ( $rrd_exist_ok == 0 ) {
	  my $ret = create_rrd($rrd,$t,$counter_tot,$step,$type_sam,$DEBUG,$host,$managedname,$no_time,$act_time,$SSH,$hmc_user,$wrkdir,$lpar,$t,$keep_virtual);
          if ( $ret == 1 ) {
            # this lpar has been recently renamed, ignore it then
            next;
          }
          $rrd_exist[$rrd_exist_row] = $lpar;
        }

        # found out last record and save it
        # it has to be done dou to better stability, when updating older record that the latest one update and process crashes
        my $l_count = 0;
        my $found = -1;
	my $ltime;
        my $lpar_meta = quotemeta($lpar);
        foreach my $l (@lpar_name) {
	  if ($l =~ m/^$lpar_meta$/ ) {
            $found = $l_count;		
            last;
	  }
	  $l_count++;
        }
	if ( $found > -1) {
	  $ltime = $lpar_time[$found];
	  $l_count = $found;
	}
	else {
  	  # find out last record in the db
	  # as this makes it slowly to test it each time then it is done
	  # once per a lpar for whole load and saved into the array

          # construction against crashing daemon Perl code when RRDTool error appears
          # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
          # construction is not too costly as it runs once per each load
          eval {
            RRDp::cmd qq(last "$rrd" );
            $last_rec = RRDp::read;    
          };
          if ($@) {
            rrd_error($@,$rrd);
            if ( $rrd_exist[$rrd_exist_row] =~ m/^$lpar$/ ) {
              $rrd_exist[$rrd_exist_row] = "";
            }
            next;
          }
	  chomp ($$last_rec);
	  $lpar_name[$l_count] = $lpar;
	  $lpar_time[$l_count] = $$last_rec;
          $lpar_jump[$l_count] = 0;
          $ltime = $$last_rec;
	}

        # when dedicated partitions then there is not set up $curr_proc_units as it is useless
        # I put curr_procs into curr_proc_units to make some gratphs for dedicated lpars
        if (length($curr_proc_units) == 0 ) {
          $curr_proc_units=$curr_procs;
        }

        # if $curr_proc_units == 0 then lpar is not running and it causing a problem with donated cycles
        if ($curr_proc_units > 0) {
          # exclude POWER5 systems where $shared_cycles_while_active does not exist
          # it is for donation of dedicated CPU lpars
          #if ( $HMC == 1) {   # IVM does not have shared_cycles_while_active
          # IVM supports it now, might be it is a new feature ....
          if ($curr_sharing_mode =~ "share_idle_procs" || $curr_sharing_mode =~ "share_idle_procs_active" || \
              $curr_sharing_mode =~ "share_idle_procs_always" ) {
            #if ( length($shared_cycles_while_active) > 0 ) {
            #if ( $shared_cycles_while_active !~ "" ) {
            if ( ! $shared_cycles_while_active eq '' ) {
              #print "- $entitled_cycles $shared_cycles_while_active\n";
              $entitled_cycles= $entitled_cycles - $shared_cycles_while_active;
              # necesary due to Perl behaviour whe it convert it to format X.YZ+eXY
              $entitled_cycles = Math::BigInt->new($entitled_cycles);
            }
          }
         #}
        }
	
        if ( $t > $ltime && length($curr_proc_units) > 0 ) {
          #print "$lpar: $time $t:$curr_proc_units:$entitled_cycles:$capped_cycles:$uncapped_cycles \n";
          if (data_check ($entitled_cycles,$capped_cycles,$uncapped_cycles,$lpar,$host,$managedname) == 0) { 

            my $jump_time = $ltime + $JUMP_DETECT; #set time for sudden jump detection (15mins)
            if ( $t > $jump_time ) {
              # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
	      # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
              if ( $lpar_jump[$l_count] == 0 ) {
                $lpar_jump[$l_count] = 1;
                #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
                #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
                next;
              }
              # looks like it is ok as it is second timestap in a row
            }
            $lpar_jump[$l_count] = 0;
	    
	    # It does not go there even when partition is switched off and counters are 0
            if ( $keep_virtual == 1 ) {
              # new one, DHL needs to keep virtual processors for accounting
              RRDp::cmd qq(update "$rrd" $t:$curr_proc_units:$curr_procs:$entitled_cycles:$capped_cycles:$uncapped_cycles);
            }
            else {
              # old way without storing number of virtual processors
              RRDp::cmd qq(update "$rrd" $t:$curr_proc_units:$entitled_cycles:$capped_cycles:$uncapped_cycles);
            }
            $answer = RRDp::read; 
            $last_time = $time;
	    $counter_ins++;
            if ( ! $$answer eq '' && $$answer =~ m/ERROR/ ) {
              main::error (" $host:$managedname : $rrd : $t:$curr_proc_units:$entitled_cycles:$capped_cycles:$uncapped_cycles : $$answer");
              if ( $$answer =~ m/is not an RRD file/ ) {
                (my $err,  my $file, my $txt) = split(/'/,$$answer);
                main::error ("Removing as it seems to be corrupted: $file");
                unlink("$file") || main::error("Cannot rm $file : $!".__FILE__.":".__LINE__) && return 0;
              }
            }
	    # to avoid a bug on HMC when it sometimes reports twice same value (for the same timestamp)
	    $lpar_time[$l_count] = $t;
          }

	  # memory should go through although switched off partition
          # sometimes (? when partition is halted??) it might have still allocated memory although it is off!!!
          
          #
          #  memory stuff 
          #

          if ( ! $mem_mode eq '' ) {
           if ( $mem_mode =~ m/shared/ ) {
            # AMS memory stuff only if it is activated
            if ( $curr_mem eq '' || $phys_run_mem eq '' || $curr_io_entitled_mem eq '' || $mapped_io_entitled_mem eq '' || $mem_overage_cooperation eq '') {
	      #main::error ("$host:$managedname : wrong mem input, shared defined but some value is null : $line");
              #main::error ("$host:$managedname: future timestamp: $rrd");
              #print "$curr_mem:$phys_run_mem:$curr_io_entitled_mem:$mapped_io_entitled_mem:$mem_overage_cooperation\n";
            }
            else {
 	      #create rrd db if necessary
              # find out if rrd db exist, and place info to the array to do not check its existency every time
              my $rmd_exist_ok = 0;
              my $rmd_exist_row = 0;
              foreach my $row1 (@rmd_exist) {
                $rmd_exist_row++;
                if ($row1 =~ m/^$lpar$/ ) {
                  $rmd_exist_ok = 1;
                  last;
                }
              }
              my $rmd = "$wrkdir/$managedname/$host/$lpar.rm$type_sam";
              if ( $rmd_exist_ok == 0 ) {
                $rmd_exist[$rmd_exist_row] = $lpar;
	        create_lpar_mem($rmd,$t,$counter_tot,$step,$type_sam,$DEBUG,$host,$managedname,$no_time,$act_time);
              }


              # found out last record and save it
              # it has to be done dou to better stability, when updating older record that the latest one update and process crashes
              $l_count_rmd = 0;
              my $found_rmd = -1;
              my $lpar_meta = quotemeta($lpar);
              foreach my $l (@lpar_name_rmd) {
	        if ($l =~ m/^$lpar_meta$/ ) {
                  $found_rmd = $l_count_rmd;		
                  last;
	        }
	        $l_count_rmd++;
              }
              #print "RMD 01: $lpar $found_rmd - $t\n";
	      if ( $found_rmd > -1) {
	        $ltime_rmd = $lpar_time_rmd[$found_rmd];
	        $l_count_rmd = $found_rmd;
	      }
	      else {
  	        # find out last record in the db
	        # as this makes it slowly to test it each time then it is done
	        # once per a lpar for whole load and saved into the array

                # construction against crashing daemon Perl code when RRDTool error appears
                # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
                # construction is not too costly as it runs once per each load
                eval {
                  RRDp::cmd qq(last "$rmd" );
                  $last_rec = RRDp::read;    
                };
                if ($@) {
                  rrd_error($@,$rmd);
                  if ( $rmd_exist[$rmd_exist_row] =~ m/^$lpar$/ ) {
                    $rmd_exist[$rmd_exist_row] = "";
                  }
                  next;
                }
	        chomp ($$last_rec);
	        $lpar_name_rmd[$l_count_rmd] = $lpar;
	        $lpar_time_rmd[$l_count_rmd] = $$last_rec;
                $ltime_rmd = $$last_rec;
                #print "RMD 01: $lpar $ltime_rmd - $t\n";
	      }
              #print "RMD 02: $lpar $ltime_rmd - $t\n";


              if ( $t > $ltime_rmd ) {
                RRDp::cmd qq(update "$rmd" $t:$curr_mem:$phys_run_mem:$curr_io_entitled_mem:$mapped_io_entitled_mem:$mem_overage_cooperation);
                $last_time = $time;
                if ($counter_ins == 0 ) { 
	          $counter_ins++;  # just to force update last.txt
                }
                $answer = RRDp::read;
                if ( ! $$answer eq '' && $$answer =~ m/ERROR/ ) {
                  main::error (" $host:$managedname : $rmd : $t:$curr_mem:$phys_run_mem:$curr_io_entitled_mem:$mapped_io_entitled_mem:$mem_overage_cooperation : $$answer");
                  if ( $$answer =~ m/is not an RRD file/ ) {
                    (my $err,  my $file, my $txt) = split(/'/,$$answer);
                    main::error ("Removing as it seems to be corrupted: $file");
                    unlink("$file") || main::error("Cannot rm $file : $!".__FILE__.":".__LINE__) && return 0;
                  }
                }
	        # to avoid a bug on HMC when it sometimes reports twice same value (for the same timestamp)
	        $lpar_time_rmd[$l_count_rmd] = $t;
              }
            }
           }
           else { 
            # dedicated mode, just 1 item inside
            if ( $curr_mem eq '' ) {
	      main::error ("$host:$managedname : wrong mem input, dedicated mem defined but curr_mem is null : $line");
              #print "$curr_mem\n";
            }
            else {
 	      #create rrd db if necessary
              # find out if rrd db exist, and place info to the array to do not check its existency every time
              my $rsd_exist_ok = 0;
              my $rsd_exist_row = 0;
              foreach my $row1 (@rsd_exist) {
                $rsd_exist_row++;
                if ($row1 =~ m/^$lpar$/ ) {
                  $rsd_exist_ok = 1;
                  last;
                }
              }
              my $rsd = "$wrkdir/$managedname/$host/$lpar.rs$type_sam";
              if ( $rsd_exist_ok == 0 ) {
                $rsd_exist[$rsd_exist_row] = $lpar;
	        create_lpar_mem_ded($rsd,$t,$counter_tot,$step,$type_sam,$DEBUG,$host,$managedname,$no_time,$act_time);
              }

              # found out last record and save it
              # it has to be done dou to better stability, when updating older record that the latest one update and process crashes
              $l_count_rsd = 0;
              my $found_rsd = -1;
              my $lpar_meta = quotemeta($lpar);
              foreach my $l (@lpar_name_rsd) {
	        if ($l =~ m/^$lpar_meta$/ ) {
                  $found_rsd = $l_count_rsd;		
                  #print "RSD 01: $lpar - $found_rsd - $lpar_meta\n";
                  last;
	        }
	        $l_count_rsd++;
              }
              #print "RSD 01: $lpar $found_rsd - $t\n";
	      if ( $found_rsd > -1) {
	        $ltime_rsd = $lpar_time_rsd[$found_rsd];
	        $l_count_rsd = $found_rsd;
                #print "RSD 02: $lpar $ltime_rsd - $found_rsd\n";
	      }
	      else {
  	        # find out last record in the db
	        # as this makes it slowly to test it each time then it is done
	        # once per a lpar for whole load and saved into the array

                # construction against crashing daemon Perl code when RRDTool error appears
                # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
                # construction is not too costly as it runs once per each load
                eval {
                  RRDp::cmd qq(last "$rsd" );
                  $last_rec = RRDp::read;    
                };
                if ($@) {
                  rrd_error($@,$rsd);
                  if ( $rsd_exist[$rsd_exist_row] =~ m/^$lpar$/ ) {
                    $rsd_exist[$rsd_exist_row] = "";
                  }
                  next;
                }
	        chomp ($$last_rec);
	        $lpar_name_rsd[$l_count_rsd] = $lpar;
	        $lpar_time_rsd[$l_count_rsd] = $$last_rec;
                $ltime_rsd = $$last_rec;
                #print "RSD 03: $lpar $ltime_rsd - $$last_rec\n";
	      }
              #print "RSD 04: $lpar $ltime_rsd - $t\n";

              if ( $t > $ltime_rsd ) { 
                RRDp::cmd qq(update "$rsd" $t:$curr_mem);
                if ($counter_ins == 0 ) { 
	          $counter_ins++;  # just to force update last.txt
                }
                $last_time = $time;
                $answer = RRDp::read;
                if ( ! $$answer eq '' && $$answer =~ m/ERROR/ ) {
                  main::error (" $host:$managedname : $rsd : $t:$curr_mem : $$answer");
                  if ( $$answer =~ m/is not an RRD file/ ) {
                    (my $err,  my $file, my $txt) = split(/'/,$$answer);
                    main::error ("Removing as it seems to be corrupted: $file");
                    unlink("$file") || main::error("Cannot rm $file : $!".__FILE__.":".__LINE__) && return 0;
                  }
                }
	        # to avoid a bug on HMC when it sometimes reports twice same value (for the same timestamp)
	        $lpar_time_rsd[$l_count_rsd] = $t; 
              }
            }
           }

          } #memory

        }
  } 
  if ($counter_ins > 0) {
    print "inserted       : $host:$managedname:lpar $counter_ins record(s)\n" if $DEBUG ;
  }

  # write down timestamp of last record 
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG ;
    open(FHLT, "> $wrkdir/$managedname/$host/$last_file") || main::error(" Can't open $wrkdir/$managedname/$host/$last_file : $!".__FILE__.":".__LINE__) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  }


  close(FH); 
  return 0;
}

sub load_data_pool_mem {
  my ($managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp, $last_file,$input_pool,$no_time) = @_;
  my @lpar_trans = @{$trans_tmp};
  my $counter=0;
  my $counter_tot=0;
  my $counter_ins=0;
  my $rrd ="";
  my $ltime = 0;    
  my $time = "";
  my $rrd_exist_ok = 0;
  my $jump = 0;
  my $last_time = "";

  if ($step > 60 ) {
    $JUMP_DETECT = 10800; # 3 hours
  }
  if ($type_sam =~ m/d/ ) {
    $JUMP_DETECT = 178000 # 2 days + for daily graphs/feed
  }

  if ( ! -f "$input_pool-$type_sam" ) {
    print "updating RRD   : $host:$managedname:ams:$input_pool-$type_sam - no AMS file detected\n" if $DEBUG ;
    return 0;
  }
  else {
    print "updating RRD   : $host:$managedname:ams:$input_pool-$type_sam - AMS\n" if $DEBUG ;
  }

  open(FH, "< $input_pool-$type_sam") ||  main::error(" Can't open $input_pool-$type_sam : $!".__FILE__.":".__LINE__) && return 0;

  my @lines = reverse <FH>;
  foreach my $line (@lines) {
        chomp($line);

        if ( $line =~ "HSCL" || $line =~ "VIOSE0" || $line =~ "No results were found" || $line =~ "invalid parameter was entered" ) {
	  # something wrong with the input data
	  # exceptionaly here also : No results were found as without AMS support it prints a lot of warnings
          if ( $line !~ m/No results were found/ ) {
	    main::error ("$host:$managedname : wrong input data in $host:$managedname:data:$input_pool-$type_sam : $line");
          }
	  return 1;
        }

        ($time, my $curr_pool_mem, my $lpar_curr_io_entitled_mem, my $lpar_mapped_io_entitled_mem, my $lpar_run_mem,
	 	my $sys_firmware_pool_mem) = split(/,/,$line);

	# Check whether first character is a digit, if not then there is something wrong with the
	# input data
	my $ret = substr($time,0,1);
	if ($ret =~ /\D/)  {  
	  # leave it as wrong input data
	  main::error ("$host:$managedname : No valid cpu data got from HMC :$ret");
          main::error ("Here is the content of the file:");
	  main::error ("\$ head -1/tail -1 \"$input_pool-$type_sam\"");
	  my $res = `head -1 \"$input_pool-$type_sam\"`;
          chomp ($res);
  	  main::error ("$res");
	  $res = `tail -1 \"$input_pool-$type_sam\"`;
          chomp ($res);
  	  main::error ("$res");
	  close (FH);
	  return 1;
	}
	my $t=str2time(substr($time,0,19));
	if ( length($t) < 10) {
	  # leave it as wrong input data
	  main::error ("$host:$managedname : No valid cpu data got from HMC :$ret");
          main::error ("Here is the content of the file:");
          main::error ("\$ head -1/tail -1 \"$input_pool-$type_sam\"");
	  my $res = `head -1 \"$input_pool-$type_sam\"`;
          chomp ($res);
  	  main::error ("$res");
	  $res = `tail -1 \"$input_pool-$type_sam\"`;
          chomp ($res);
  	  main::error ("$res");
	  close (FH);
	  return 1;
	}
	if ($step == 3600) {
          # Put on the last time possition "00"!!!
          substr($t,8,2,"00");
	}

	$rrd = "$wrkdir/$managedname/$host/mem-pool.rr$type_sam";

 	#create rrd db if necessary
        if ( $rrd_exist_ok == 0 ) {
	  create_rrd_pool_mem($rrd,$t,$counter_tot,$step,$type_sam,$DEBUG,$host,$managedname,$no_time,$act_time);
          $rrd_exist_ok = 1;
        }

  	# find out last record in the db, do it just once
	if ( $ltime == 0 ) {
          # construction against crashing daemon Perl code when RRDTool error appears
          # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
          # construction is not too costly as it runs once per each load
          my $last_rec = 0;
          eval {
            RRDp::cmd qq(last "$rrd" );
            $last_rec = RRDp::read;    
          };
          if ($@) {
            rrd_error($@,$rrd);
            $rrd_exist_ok = 0;
            next;
          }
	  chomp ($$last_rec);
	  $ltime = $$last_rec;
          $jump = 0;
	}

        # print "last pool : $ltime  actuall: $t\n";
	# it updates only if time is newer and there is the data (fix for situation that the data is missing)
        if ( $t > $ltime && length($curr_pool_mem) > 0 ) {

          my $jump_time = $ltime + $JUMP_DETECT; #set time for sudden jump detection (15mins)
          if ( $t > $jump_time ) {
            # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
            # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
            if ( $jump == 0 ) {
              $jump = 1;
              #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
              #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
              next;
            }
            # looks like it is ok as it is second timestap in a row
          }
          $jump = 0;

	  $counter_ins++;
          RRDp::cmd qq(update "$rrd" $t:$curr_pool_mem:$lpar_curr_io_entitled_mem:$lpar_mapped_io_entitled_mem:$lpar_run_mem:$sys_firmware_pool_mem);
          $last_time = $time;
          my $answer = RRDp::read; 

	  # update the time of last record
	  $ltime = $t;
        }
  } 
  if ($counter_ins > 0) {
    print "inserted       : $host:$managedname:ams $counter_ins record(s)\n" if $DEBUG ;
  }

  # write down timestamp of last record 
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG ;
    open(FHLT, "> $wrkdir/$managedname/$host/$last_file") || main::error(" Can't open $wrkdir/$managedname/$host/$last_file : $!".__FILE__.":".__LINE__) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  }

  close(FH); 
  return 0;
}

sub load_data_pool {
  my ($managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp, $last_file,$input_pool,$no_time) = @_;
  my @lpar_trans = @{$trans_tmp};
  my $counter=0;
  my $counter_tot=0;
  my $counter_ins=0;
  my $rrd ="";
  my $ltime = 0;    
  my $time = "";
  my $rrd_exist_ok = 0;
  my $utime = time() + 3600;
  my $jump = 0;
  my $last_time = "";

  if ($step > 60 ) {
    $JUMP_DETECT = 10800; # 3 hours
  }
  if ($type_sam =~ m/d/ ) {
    $JUMP_DETECT = 178000 # 2 days + for daily graphs/feed
  }

  print "updating RRD   : $host:$managedname:pool:$input_pool-$type_sam\n" if $DEBUG ;
  open(FH, "< $input_pool-$type_sam") ||  main::error(" Can't open $input_pool-$type_sam : $!".__FILE__.":".__LINE__) && return 0;

  my @lines = reverse <FH>;
  foreach my $line (@lines) {
        chomp($line);

        if ( $line =~ "HSCL" || $line =~ "VIOSE0" || $line =~ "No results were found" || $line =~ "invalid parameter was entered" ) {
	  # something wrong with the input data
	  main::error ("$host:$managedname : wrong input data in $host:$managedname:data:$input_pool-$type_sam : $line");
	  return 1;
        }

        ($time, my $total_pool_cycles, my $utilized_pool_cyc, my $configurable_pool_proc_units, my $borrowed_pool_proc_units) = split(/,/,$line);

	# Check whether first character is a digit, if not then there is something wrong with the
	# input data
	my $ret = substr($time,0,1);
	if ($ret =~ /\D/)  {  
	  # leave it as wrong input data
	  main::error ("$host:$managedname : No valid cpu data got from HMC :$ret");
          main::error ("Here is the content of the file:");
	  main::error ("\$ head -1/tail -1 \"$input_pool-$type_sam\"");
	  my $res = `head -1 \"$input_pool-$type_sam\"`;
          chomp ($res);
  	  main::error ("$res");
	  $res = `tail -1 \"$input_pool-$type_sam\"`;
          chomp ($res);
  	  main::error ("$res");
	  close (FH);
	  return 1;
	}
	my $t=str2time(substr($time,0,19));
	if ( length($t) < 10) {
	  # leave it as wrong input data
	  main::error ("$host:$managedname : No valid cpu data got from HMC :$ret");
          main::error ("Here is the content of the file:");
          main::error ("\$ head -1/tail -1 \"$input_pool-$type_sam\"");
	  my $res = `head -1 \"$input_pool-$type_sam\"`;
          chomp ($res);
  	  main::error ("$res");
	  $res = `tail -1 \"$input_pool-$type_sam\"`;
          chomp ($res);
  	  main::error ("$res");
	  close (FH);
	  return 1;
	}
	if ($step == 3600) {
          # Put on the last time possition "00"!!!
          substr($t,8,2,"00");
	}

	$rrd = "$wrkdir/$managedname/$host/pool.rr$type_sam";

 	#create rrd db if necessary
        if ( $rrd_exist_ok == 0 ) {
	  create_rrd_pool($rrd,$t,$counter_tot,$step,$type_sam,$DEBUG,$host,$managedname,$no_time,$act_time);
          $rrd_exist_ok = 1;
        }

  	# find out last record in the db, do it just once
	if ( $ltime == 0 ) {
          # construction against crashing daemon Perl code when RRDTool error appears
          # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
          # construction is not too costly as it runs once per each load
          my $last_rec = 0;
          eval {
           RRDp::cmd qq(last "$rrd" );
           $last_rec = RRDp::read;    
          };
          if ($@) {
            rrd_error($@,$rrd);
            $rrd_exist_ok = 0;
            next;
          }
	  chomp ($$last_rec);
	  $ltime = $$last_rec;
	}

        # print "last pool : $ltime  actuall: $t\n";
	# it updates only if time is newer and there is the data (fix for situation that the data is missing)
        if ( $t > $ltime && length($total_pool_cycles) > 0 ) {

          my $jump_time = $ltime + $JUMP_DETECT; #set time for sudden jump detection (15mins)
          if ( $t > $jump_time ) {
            # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
            # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
            if ( $jump == 0 ) {
              $jump = 1;
              #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
              #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
              next;
            }
            # looks like it is ok as it is second timestap in a row
          }
          $jump = 0;

	  $counter_ins++;
          #print "$counter_ins : $time $t:$total_pool_cycles:$utilized_pool_cyc:$configurable_pool_proc_units:$borrowed_pool_proc_units \n";
          RRDp::cmd qq(update "$rrd" $t:$total_pool_cycles:$utilized_pool_cyc:$configurable_pool_proc_units:$borrowed_pool_proc_units);
          $last_time = $time;
          my $answer = RRDp::read; 

	  # update the time of last record
	  $ltime = $t;
        }
  } 
  if ($counter_ins > 0) {
    print "inserted       : $host:$managedname:pool $counter_ins record(s)\n" if $DEBUG ;
  }

  # write down timestamp of last record 
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG ;
    open(FHLT, "> $wrkdir/$managedname/$host/$last_file") || main::error(" Can't open $wrkdir/$managedname/$host/$last_file : $!".__FILE__.":".__LINE__) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  }

  close(FH); 
  return 0;
}

sub load_data_pool_sh {
  my ($managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp, $last_file,$input_pool_sh,$SSH,$hmc_user,$pool_tmp,$pool_list_file,$no_time) = @_;
  my @lpar_trans = @{$trans_tmp};
  my @pool_list  = @{$pool_tmp};
  my $counter=0;
  my $counter_tot=0;
  my $counter_ins=0;
  my $rrd ="";
  my @shared_pool = "";
  my $max_pool_units = "";
  my $reserved_pool_units = "";
  my $time = "";
  my @rrd_exist = ""; 
  my $last_rec = 0;
  my $last_time = "";

  my @pool_name = "";
  my @pool_time = "";
  my @pool_jump = "";

  if ($step > 60 ) {
    $JUMP_DETECT = 10800; # 3 hours
  }
  if ($type_sam =~ m/d/ ) {
    $JUMP_DETECT = 178000 # 2 days + for daily graphs/feed
  }

  print "updating RRD   : $host:$managedname:pool_sh:$input_pool_sh-$type_sam\n" if $DEBUG ;

  # first check whether it supports more CPU pools (POWER6+), if not then return
  open(FH, "< $input_pool_sh-$type_sam") ||  return 1;
  while (my $line = <FH>) {
    chomp($line);
    if ( $line =~ "No results were found." ) {
      print "info           : $host:$managedname No shared CPU pools\n" if $DEBUG ;
      close (FH);
      return 0;
    } 
  }
  close (FH);

  print "fetching HMC   : $host:$managedname shared pools\n" if $DEBUG ;
  my $def_pool=`$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r pool -m \\"$managedname\\" -F configurable_pool_proc_units,borrowed_pool_proc_units  --filter \"event_types=sample\""`;
  my $ret1 = substr($def_pool,0,1);
  if ($ret1 =~ /\D/)   {  
    # leave it, it does not contain a digit, probably is there "No results were found"
    print "info           : $host:$managedname Probably no shared CPU pools are supported or configured\n" if $DEBUG ;
    return 0;
  }
  my @def_pool_list = split(/,/,$def_pool);
  my $max_def_pool = $def_pool_list[0] + $def_pool_list[1];
  #print "Default pool : $max_def_pool $def_pool_list[0] $def_pool_list[1] \n";
  print "fetching HMC   : $host:$managedname shared pool list\n" if $DEBUG ;
  @pool_list=`$SSH $hmc_user\@$host "export LANG=en_US; lshwres -r procpool  -m \\"$managedname\\" -F shared_proc_pool_id,max_pool_proc_units,curr_reserved_pool_proc_units,name"`;

  my @pool_list_no_gap = "";
  my $pool_indx = 0;

  # create mapping table between pool id and alias name
  open(FP, "> $wrkdir/$managedname/$host/cpu-pools-mapping.txt") || main::error ("Cannot open : $wrkdir/$host/$managedname/cpu-pools-mapping.txt : $!") ;
  foreach my $pool (@pool_list) {
    if ( $pool =~ "HSCL" || $pool =~ "VIOSE0" ) {
      # something wrong with the input data
      main::error ("$host:$managedname : wrong input data in $wrkdir/$managedname/$host/cpu-pools-mapping.txt : $pool");
      return 1;
    }

    if (length($pool) > 1) {
      my @shared_p = split(/,/,$pool);
      # if there is not a digit than the server probably does not support shared CPU pools
      if ($shared_p[0] =~ /\d/)  {  
        my $name=$shared_p[3];
        my $id  =$shared_p[0];
        if ( $id =~ "HSCL" || $name =~ "HSCL" ){
         next;
        }
        # lshwres avoid pools with no reserved CPU cores --> means they cannot be used what causes the gap
	# and brings problems in further processing
        while ($id > $pool_indx) {
          $pool_list_no_gap[$pool_indx] = "$pool_indx,0,0,SharedPool$pool_indx";
          print FP "$pool_indx,SharedPool$pool_indx\n";
	  $pool_indx++;
        }
        $pool_list_no_gap[$pool_indx] = $pool;
        $pool_indx++;
        print FP "$id,$name";
        #print "$id,$name";
      }
    }
  }
  close (FP);

  my $do_pool_agg = 0;
  open(FH, "< $input_pool_sh-$type_sam") ||  main::error ("Cannot open input pool sh : $input_pool_sh-$type_sam : $!");
  my @lines = reverse <FH>;
  foreach my $line (@lines) {
        chomp($line);

        ($time, my $shared_proc_pool_id, my $total_pool_cycles, my $utilized_pool_cyc) = split(/,/,$line);

        if ($shared_proc_pool_id > 0  && $do_pool_agg == 0) {
          # get pools list for pool aggregated charts
          `$SSH $hmc_user\@$host "lshwres -r procpool -m \\"$managedname\\" -F shared_proc_pool_id,lpar_names" > "$wrkdir/$managedname/$host/$pool_list_file"`;
          $do_pool_agg=1;
        }

       #if ($shared_proc_pool_id > 0 ) {
       #   $do_pool_agg=1;
       # }


	# Check whether first character is a digit, if not then there is something wrong with the
	# input data
	my $ret = substr($time,0,1);
	if ($ret =~ /\D/)  {  
	  # leave it as wrong input data
          print "info           : $host:$managedname Probably no shared CPU pools are supported or configured\n" if $DEBUG ;
          close (FH);
	  return 0;
	}

	# only for shared pools, not for default pool (id=0)
 	#if ( $shared_proc_pool_id) {
	  my $t=str2time(substr($time,0,19));
	  if ( length($t) < 10) {
	    # leave it as wrong input data
	    main::error ("$host:$managedname : No valid shared cpu pool data time format got from HMC : $t");
            main::error ("Here is the content of the file:");
	    main::error ("\$ head -1/tail -1 \"$input_pool_sh-$type_sam\"");
	    my $res = `head -1 \"$input_pool_sh-$type_sam\"`;
            chomp ($res);
	    main::error ("$res");
	    $res = `tail -1 \"$input_pool_sh-$type_sam\"`;
            chomp ($res);
	    main::error ("$res");
            close (FH);
	    return 0;
	  }
	  if ($step == 3600) {
            # Put on the last time possition "00"!!!
            substr($t,8,2,"00");
	  }

	  $rrd = "$wrkdir/$managedname/$host/SharedPool$shared_proc_pool_id.rr$type_sam";

 	  #create rrd db if necessary
          # find out if rrd db exist, and place info to the array to do not check its existency every time
          my $rrd_exist_ok = 0;
          my $rrd_exist_row = 0;
          foreach my $row (@rrd_exist) {
            $rrd_exist_row++;
            if ($row =~ m/^$shared_proc_pool_id$/ ) {  # from some reason must be string comparsion
              $rrd_exist_ok = 1;
              last;
            }
          }
          if ( $rrd_exist_ok == 0 ) {
            $rrd_exist[$rrd_exist_row] = $shared_proc_pool_id;
	    create_rrd_pool_shared($rrd,$t,$counter_tot,$step,$type_sam,$DEBUG,$host,$managedname,$no_time,$act_time);
          }

          # found out last record and save it
          # it has to be done dou to better stability, when updating older record that the latest one update and process crashes
          my $l_count = 0;
          my $found = -1;
          my $ltime;
          my $pool_meta = quotemeta($shared_proc_pool_id);
          foreach my $l (@pool_name) {
            if ($l =~ m/^$pool_meta$/ ) {
              $found = $l_count;
              last;
            }
            $l_count++;
          }
          if ( $found > -1) {
            $ltime = $pool_time[$found];
            $l_count = $found;
          }
          else {
  	    # find out last record in the db

            # construction against crashing daemon Perl code when RRDTool error appears
            # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
            # construction is not too costly as it runs once per each load
            eval {
              RRDp::cmd qq(last "$rrd" );
              $last_rec = RRDp::read;    
            };
            if ($@) {
              rrd_error($@,$rrd);
              if ( $rrd_exist[$rrd_exist_row] =~ m/^$shared_proc_pool_id$/ ) {
                $rrd_exist[$rrd_exist_row] = "";
              }
              next;
            }
	    chomp ($$last_rec);
            $pool_name[$l_count] = $shared_proc_pool_id;
            $pool_time[$l_count] = $$last_rec;
            $pool_jump[$l_count] = 0;
            $ltime = $$last_rec;
          }

          # print "last pool : $$last_rec  actuall: $t\n";
	  # it updates only if time is newer and there is the data (fix for situation that the data is missing)
          if ( $t > $pool_time[$l_count] && length($total_pool_cycles) > 0 ) {
            if ( $shared_proc_pool_id ) {
              @shared_pool = split(/,/,$pool_list_no_gap[$shared_proc_pool_id]);
	      $max_pool_units=$shared_pool[1];
	      $reserved_pool_units=$shared_pool[2];
	    }
	    else {
	      $max_pool_units=$max_def_pool;
	      $reserved_pool_units=$max_def_pool;
	    }

            my $jump_time = $ltime + $JUMP_DETECT; #set time for sudden jump detection (15mins)
            if ( $t > $jump_time ) {
              # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
              # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
              if ( $pool_jump[$l_count] == 0 ) {
                $pool_jump[$l_count] = 1;
                if ( $shared_proc_pool_id > 0 ) {
                  # do not print out that message for SharedPool0 it probably does not exist if there are no shared pools defined
                  #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
                  #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
                }
                next;
              }
              # looks like it is ok as it is second timestap in a row
            }
            $pool_jump[$l_count] = 0;

            #print "$time $t:$total_pool_cycles:$utilized_pool_cyc:$max_pool_units:$reserved_pool_units \n";
            if ( ! $max_pool_units eq '' && ! $reserved_pool_units eq '' ) {
	      # can happen in certain circumstance that the last pool is deleted but then cannot be 
	      # found $max_pool_units and $reserved_pool_units
              RRDp::cmd qq(update "$rrd" $t:$total_pool_cycles:$utilized_pool_cyc:$max_pool_units:$reserved_pool_units);
	      $counter_ins++;
              $last_time = $time;
              my $answer = RRDp::read; 
              $pool_time[$l_count] = $t;
            }
          }
	#}
  } 
  if ($counter_ins > 0) {
    print "inserted       : $host:$managedname:pool_sh $counter_ins record(s)\n" if $DEBUG ;
  }

  if ($do_pool_agg == 1) {
    # there are more CPU pools, will be created aggregated chart for each pool
    # download data now (list of lpars)
    main::procpoolagg($host,$managedname);
  }

  # write down timestamp of last record 
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG ;
    open(FHLT, "> $wrkdir/$managedname/$host/$last_file") || main::error(" Can't open $wrkdir/$managedname/$host/$last_file : $!".__FILE__.":".__LINE__) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  }

  close(FH); 
  return 0;
}

sub load_data_mem  {
  my ($managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp, $last_file,$input_mem,$no_time) = @_;
  my @lpar_trans = @{$trans_tmp};
  my $counter=0;
  my $counter_tot=0;
  my $counter_ins=0;
  my $rrd = "";
  my $ltime = 0;
  my $time = "";
  my $rrd_exist_ok = 0;
  my $jump = 0;
  my $last_time = "";

  if ($step > 60 ) {
    $JUMP_DETECT = 10800; # 3 hours
  }
  if ($type_sam =~ m/d/ ) {
    $JUMP_DETECT = 178000 # 2 days + for daily graphs/feed
  }

  print "updating RRD   : $host:$managedname:mem:$input_mem-$type_sam\n" if $DEBUG ;
  open(FH, "< $input_mem-$type_sam") || main::error(" Can't open $input-$type_sam : $!".__FILE__.":".__LINE__) && return 0;

  my @lines = reverse <FH>;
  foreach my $line (@lines) {
        chomp($line);

        if ( $line =~ "HSCL" || $line =~ "VIOSE0" || $line =~ "No results were found" || $line =~ "invalid parameter was entered" ) {
	  # something wrong with the input data
	  # do not alert for memory, this causing problems and logs a lot of errors but it is minor feature ...
	  main::error ("$host:$managedname : wrong input data in $host:$managedname:data:$input_mem-$type_sam : $line");
	  return 1;
        }

        ($time, my $curr_avail_sys_mem, my $configurable_sys_mem, my $sys_firmware_mem) = split(/,/,$line);

        if ( $curr_avail_sys_mem eq '' || $configurable_sys_mem eq '' || $sys_firmware_mem eq '' ) {
	  # problem with data
	  #main::error ("$host:$managedname : wrong input data in $host:$managedname:data:$input_mem-$type_sam : $line");
          next;
        }

	# Check whether first character is a digit, if not then there is something wrong with the
	# input data
	my $ret = substr($time,0,1);
	if ($ret =~ /\D/)  {  
	  main::error ("$host:$managedname : No valid mem data got from HMC : $ret");
	  main::error ("Here is the content of the file:");
	  main::error ("\$ head -1/tail -1 \"$input_mem-$type_sam\"");
	  my $res = `head -1 \"$input_mem-$type_sam\"`;
          chomp ($res);
	  main::error ("$res");
	  $res = `tail -1 \"$input_mem-$type_sam\"`;
          chomp ($res);
	  main::error ("$res");
	  close (FH);
	  return 0;
	}
	my $t=str2time(substr($time,0,19));
	if ($step == 3600) {
          # Put on the last time possition "00"!!!
          substr($t,8,2,"00");
	}

	$rrd = "$wrkdir/$managedname/$host/mem.rr$type_sam";

 	#create rrd db if necessary
        if ( $rrd_exist_ok == 0 ) {
	  create_rrd_mem($rrd,$t,$counter_tot,$step,$type_sam,$DEBUG,$host,$managedname,$no_time,$act_time);
          $rrd_exist_ok = 1;
        }

  	# find out last record in the db
	if ( $ltime == 0 ) {
          # construction against crashing daemon Perl code when RRDTool error appears
          # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
          # construction is not too costly as it runs once per each load
          my $last_rec = 0;
          eval {
    	    RRDp::cmd qq(last "$rrd" );
    	    $last_rec = RRDp::read;    
          };
          if ($@) {
            rrd_error($@,$rrd);
            $rrd_exist_ok = 0;
            next;
          }
	  chomp ($$last_rec);
	  $ltime = $$last_rec;
	}

        # print "last mem  : $ltime actuall: $t\n";
	# it updates only if time is newer and there is the data (fix for situation that the data is missing)
        if ( $t > $ltime && length($curr_avail_sys_mem) > 0 ) {

          my $jump_time = $ltime + $JUMP_DETECT; #set time for sudden jump detection (15mins)
          if ( $t > $jump_time ) {
            # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
            # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
            if ( $jump == 0 ) {
              $jump = 1;
              #main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
              #main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
              next;
            }
            # looks like it is ok as it is second timestap in a row
          }
          $jump = 0;

	  $counter_ins++;
          #print "++ 01 $time $t:$curr_avail_sys_mem \n";
          RRDp::cmd qq(update "$rrd" $t:$curr_avail_sys_mem:$configurable_sys_mem:$sys_firmware_mem);
          $last_time = $time;
          my $answer = RRDp::read;

	  # update the time of last record
	  $ltime = $t;
        }
  } 
  if ($counter_ins > 0) {
    print "inserted       : $host:$managedname:mem $counter_ins record(s)\n" if $DEBUG ;
  }

  # write down timestamp of last record 
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG ;
    open(FHLT, "> $wrkdir/$managedname/$host/$last_file") || main::error(" Can't open $wrkdir/$managedname/$host/$last_file : $!".__FILE__.":".__LINE__) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  }

  close(FH); 
  return 0;
}


sub load_data_cod  {
  my ($managedname, $host, $wrkdir, $input, $type_sam, $act_time, $HMC, $IVM, $SDMC, $step, $DEBUG, $trans_tmp, $last_file,$input_cod,$no_time) = @_;
  my @lpar_trans = @{$trans_tmp};
  my $counter=0;
  my $counter_tot=0;
  my $counter_ins=0;
  my $rrd = "";
  my $ltime = 0;
  my $time = "";
  my $rrd_exist_ok = 0;
  my $jump = 0;
  my $last_time = "";
  my $unreported_proc_min_last = 0;

  if ($step > 60 ) {
    $JUMP_DETECT = 10800; # 3 hours
  }
  if ($type_sam =~ m/d/ ) {
    $JUMP_DETECT = 178000 # 2 days + for daily graphs/feed
  }

  if ( ! -f "$input_cod-$type_sam" ) {
    print "CoD data load  : $host:$managedname:CoD:$input_cod-$type_sam - no input file found\n" if $DEBUG ;
    return 1;
  }

  print "updating RRD   : $host:$managedname:CoD:$input_cod-$type_sam\n" if $DEBUG ;
  open(FH, "< $input_cod-$type_sam") || main::error(" Can't open $input_cod-$type_sam : $!".__FILE__.":".__LINE__) && return 0;

  my @lines = reverse <FH>;
  foreach my $line (@lines) {
        chomp($line);

        if ( $line =~ "HSCL" || $line =~ "VIOSE0" || $line =~ "No results were found" || $line =~ "invalid parameter was entered" ) {
	  # something wrong with the input data
	  # do not alert for memory, this causing problems and logs a lot of errors but it is minor feature ...
	  #main::error ("$host:$managedname : wrong input data in $host:$managedname:data:$input_mem-$type_sam : $line");
	  return 1;
        }

        ($time, my $used_proc_min, my $unreported_proc_min) = split(/,/,$line);

        if ( $used_proc_min eq '' || $unreported_proc_min eq '' ) {
	  # problem with data
	  main::error ("$host:$managedname : wrong input data in $host:$managedname:data:$input_cod-$type_sam : $line");
          next;
        }

	# Check whether first character is a digit, if not then there is something wrong with the
	# input data
	my $ret = substr($time,0,1);
	if ($ret =~ /\D/)  {  
	  main::error ("$host:$managedname : No valid cod data got from HMC : $ret");
	  main::error ("Here is the content of the file:");
	  main::error ("\$ head -1/tail -1 \"$input_cod-$type_sam\"");
	  my $res = `head -1 \"$input_cod-$type_sam\"`;
          chomp ($res);
	  main::error ("$res");
	  $res = `tail -1 \"$input_cod-$type_sam\"`;
          chomp ($res);
	  main::error ("$res");
	  close (FH);
	  return 0;
	}
	my $t=str2time(substr($time,0,19));
	if ($step == 3600) {
          # Put on the last time possition "00"!!!
          substr($t,8,2,"00");
	}

	$rrd = "$wrkdir/$managedname/$host/cod.rr$type_sam";

 	#create rrd db if necessary
        if ( $rrd_exist_ok == 0 ) {
          if ( ! -f "$rrd" ) {
            # check if it is realy first run or just first run for that input file
            $ltime = -1;
          }
	  create_rrd_cod($rrd,$t-60,$counter_tot,$step,$type_sam,$DEBUG,$host,$managedname,$no_time,$act_time);
          $rrd_exist_ok = 1;
        }

  	# find out last record in the db
	if ( $ltime == 0 ) {
          # construction against crashing daemon Perl code when RRDTool error appears
          # this does not work well in old RRDTOool: $RRDp::error_mode = 'catch';
          # construction is not too costly as it runs once per each load
          my $last_rec = 0;
          eval {
    	    RRDp::cmd qq(last "$rrd" );
    	    $last_rec = RRDp::read;    
          };
          if ($@) {
            rrd_error($@,$rrd);
            $rrd_exist_ok = 0;
            next;
          }
	  chomp ($$last_rec);
	  $ltime = $$last_rec;

          # find out last value of unreported_proc_min
          my $l=localtime($$last_rec);
          # get LAST value from RRD
          #RRDp::cmd qq(fetch "$rrd" "MAX" "-s $$last_rec-$step" "-e $$last_rec-$step");
          RRDp::cmd qq(fetch "$rrd" "AVERAGE" "-s $$last_rec-$step" "-e $$last_rec-$step");
          my $row = RRDp::read;
          chomp($$row);
          my @row_arr = split(/\n/,$$row);
          my $m = "";
          my $i = 0;
          foreach $m (@row_arr) {
           chomp($m);
           $i++;
           if ( $i == 3 ) {
             my @m_arr = split(/ /,$m);
             # go further ony if it is a digit (avoid it when NaNQ (== no data) is there)
             if ($m_arr[1] =~ /\d/ && $m_arr[2] =~ /\d/ ) {
               #print "m : $m\n" if $DEBUG ;
               #print "\n$m_arr[1] $m_arr[2]" if $DEBUG ;
               $unreported_proc_min_last = sprintf("%d",$m_arr[2]);
             }
           }
          }
          #print "001 $ltime -----  $l : $$last_rec : $$row : $time $unreported_proc_min_last \n";
	}
        #print "002 $ltime -----  $time $unreported_proc_min_last \n";

        # print "last cod  : $ltime actuall: $t\n";
	# it updates only if time is newer and there is the data (fix for situation that the data is missing)
        if ( $t > $ltime && length($used_proc_min) > 0 ) {

          # Do not use that for CoD, it is pretty normal here!!!
          #my $jump_time = $ltime + $JUMP_DETECT; #set time for sudden jump detection (15mins)
          #if ( $t > $jump_time ) {
            #
            # here appeared sudden gap in the data, migh be an issue with HMC 77202 when appears a row with future timestamp
            # ignore this line, if that happens next time then it is ok, just one data stamp has been lost :)
            #if ( $jump == 0 ) {
            #  $jump = 1;
            #  main::error ("$host:$managedname: future data timestamp detected : $line, last rec: $ltime utime data:$t");
            #  main::error ("$host:$managedname: future timestamp: $rrd : ignoring the line ...");
            #  next;
            #}
            # looks like it is ok as it is second timestap in a row
          #}
          #$jump = 0;

          # there has to be filled in data gaps 
          #print "003 $time $t:$used_proc_min:$unreported_proc_min \n";
          while ( $t > ( $ltime + 60 ) ) {
            if ( $ltime == -1 ) {
              # initial CoD load with creation of rrd, skip it this time
              last;
            }
            $ltime = $ltime + 60;
            #print "004 $ltime:0:$unreported_proc_min_last  --- $t\n";
            RRDp::cmd qq(update "$rrd" $ltime:0:$unreported_proc_min_last);
            my $answer = RRDp::read;
          }

	  $counter_ins++;
          RRDp::cmd qq(update "$rrd" $t:$used_proc_min:$unreported_proc_min);
          $last_time = $time;
          my $answer = RRDp::read;

	  # update the time of last record
	  $ltime = $t;
          $unreported_proc_min_last = $unreported_proc_min;
        }
  } 
  if ($counter_ins > 0) {
    print "inserted       : $host:$managedname:cod $counter_ins record(s)\n" if $DEBUG ;
  }

  # write down timestamp of last record 
  if ( $type_sam !~ "d" && $counter_ins > 0 ) {
    print "upd last_file  : $host:$managedname $last_time : $wrkdir/$managedname/$host/$last_file\n" if $DEBUG ;
    open(FHLT, "> $wrkdir/$managedname/$host/$last_file") || main::error(" Can't open $wrkdir/$managedname/$host/$last_file : $!".__FILE__.":".__LINE__) && return 0;
    print FHLT "$last_time";
    close(FHLT);
  }

  close(FH); 
  return 0;
}

sub create_rrd_cod {
  my $rrd = shift;
  my $start_time = shift;
  my $counter_tot = shift;
  my $step = shift;
  my $type_sam = shift;
  my $DEBUG= shift;
  my $host = shift;
  my $managedname = shift;
  my $no_time = shift;
  my $act_time = shift;
  my $step_new = $step;
  #my $no_time_new = $no_time;
  my $no_time_new = $step_new;

  if ( $type_sam =~ "d" ) {
    if (not -f $rrd){
      $step_new=86400;
      $no_time_new = 200000;
      print "create_rrd_cod : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch ("create_rrd_cod $rrd");
      if ($step == 3600) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:used_proc_min:ABSOLUTE:$no_time_new:0:10000000000"
          "DS:unreported_proc_min:GAUGE:$no_time_new:0:100000000000"
          "RRA:AVERAGE:0.1:1:10000"
          "RRA:AVERAGE:0.1:24:1000"
        );
      }
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:used_proc_min:ABSOLUTE:$no_time_new:0:10000000000"
          "DS:unreported_proc_min:GAUGE:$no_time_new:0:100000000000"
	  "RRA:AVERAGE:0.1:1:1825"
	  "RRA:AVERAGE:0.1:7:260"
        );
      }
      my $answer = RRDp::read; 
      #chomp ($$answer);
      if ( $$answer ) {
        main::error("unable to create $rrd: answer: $$answer".__FILE__.":".__LINE__) && return 0;
      }
    }
  }
  else {
    if (not -f $rrd){
      load_retentions($step,$act_time); # load data retentions
      print "create_rrd_cod : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch ("create_rrd_cod $rrd");
      if ($step == 3600) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:used_proc_min:ABSOLUTE:$no_time_new:0:10000000000"
          "DS:unreported_proc_min:GAUGE:$no_time_new:0:100000000000"
          "RRA:AVERAGE:0.1:1:$one_minute_sample"
          "RRA:AVERAGE:0.1:24:$one_hour_sample"
        );
      }
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:used_proc_min:ABSOLUTE:$no_time_new:0:10000000000"
          "DS:unreported_proc_min:GAUGE:$no_time_new:0:100000000000"
	  "RRA:AVERAGE:0.1:1:$one_minute_sample"
	  "RRA:AVERAGE:0.1:60:$one_hour_sample"
	  "RRA:AVERAGE:0.1:1440:$one_day_sample"
        );
      }
      my $answer = RRDp::read; 
      #chomp ($$answer);
      if ( $$answer ) {
        main::error(" unable to create `$rrd': answer: $$answer".__FILE__.":".__LINE__) && return 0;
      }
    };
  }
  return 0;
}


sub create_lpar_mem_ded {
  my $rrd = shift;
  my $start_time = shift;
  my $counter_tot = shift;
  my $step = shift;
  my $type_sam = shift;
  my $DEBUG= shift;
  my $host = shift;
  my $managedname = shift;
  my $no_time = shift;
  my $act_time = shift;
  my $step_new = $step;
  my $no_time_new = $no_time;
  $start_time -= 3600; # must be here 

  if ( $type_sam =~ "d" ) {
    if (not -f $rrd){
      $step_new=86400;
      $no_time_new = 200000;
      print "create_mem_lpar: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch ("create_lpar_mem_ded $rrd");
      if ($step == 3600) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
          "DS:curr_mem:GAUGE:$no_time_new:0:10000000"
          "RRA:AVERAGE:0.5:1:10000"
          "RRA:AVERAGE:0.5:6:1500"
          "RRA:AVERAGE:0.5:24:1000"
          "RRA:AVERAGE:0.5:288:1000"
        );
      }
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
          "DS:curr_mem:GAUGE:$no_time_new:0:10000000"
	  "RRA:AVERAGE:0.5:1:1825"
	  "RRA:AVERAGE:0.5:7:260"
        );
      }
      my $answer = RRDp::read;
      #chomp ($$answer);
      if ( $$answer ) {
        main::error(" unable to create `$rrd': answer: $$answer".__FILE__.":".__LINE__) && return 0;
      }
    };
  }
  else {
    if (not -f $rrd){
      load_retentions($step,$act_time); # load data retentions
      #print "0000 $one_minute_sample - $five_mins_sample - $one_hour_sample - $five_hours_sample - $one_day_sample\n";
      print "create_mem_lpar: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch ("create_lpar_mem_ded $rrd");
      if ($step == 3600) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
          "DS:curr_mem:GAUGE:$no_time_new:0:10000000"
          "RRA:AVERAGE:0.5:1:$one_minute_sample_mem"
          "RRA:AVERAGE:0.5:6:$five_mins_sample_mem"
          "RRA:AVERAGE:0.5:24:$one_hour_sample_mem"
          "RRA:AVERAGE:0.5:288:$five_hours_sample_mem"
        );
      }
      else {
        #print "++ $rrd $start_time $step_new\n";
        RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
          "DS:curr_mem:GAUGE:$no_time_new:0:10000000"
	  "RRA:AVERAGE:0.5:1:$one_minute_sample_mem"
	  "RRA:AVERAGE:0.5:5:$five_mins_sample_mem"
	  "RRA:AVERAGE:0.5:60:$one_hour_sample_mem"
	  "RRA:AVERAGE:0.5:300:$five_hours_sample_mem"
	  "RRA:AVERAGE:0.5:1440:$one_day_sample_mem"
        );
      }
      my $answer = RRDp::read;
      #chomp ($$answer);
      if ( $$answer ) {
        main::error(" unable to create `$rrd': answer: $$answer".__FILE__.":".__LINE__) && return 0;
      }
    };
  }
  return 0;
}


# AMS memory
sub create_lpar_mem {
  my $rrd = shift;
  my $start_time = shift;
  my $counter_tot = shift;
  my $step = shift;
  my $type_sam = shift;
  my $DEBUG= shift;
  my $host = shift;
  my $managedname = shift;
  my $no_time = shift;
  my $act_time = shift;
  my $step_new = $step;
  my $no_time_new = $no_time;
  $start_time -= 3600; # must be here 

  if ( $type_sam =~ "d" ) {
    if (not -f $rrd){
      $step_new=86400;
      $no_time_new = 200000;
      print "create_mem_lpar: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch ("create_lpar_mem $rrd");
      if ($step == 3600) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
          "DS:curr_mem:GAUGE:$no_time_new:0:10000000"
          "DS:phys_run_mem:GAUGE:$no_time_new:0:10000000"
          "DS:io_ent:GAUGE:$no_time_new:0:10000000"
          "DS:mapped_io_ent:GAUGE:$no_time_new:0:10000000"
          "DS:overage:GAUGE:$no_time_new:0:10000000"
          "RRA:AVERAGE:0.5:1:10000"
          "RRA:AVERAGE:0.5:6:1500"
          "RRA:AVERAGE:0.5:24:1000"
          "RRA:AVERAGE:0.5:288:1000"
        );
      }
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
          "DS:curr_mem:GAUGE:$no_time_new:0:10000000"
          "DS:phys_run_mem:GAUGE:$no_time_new:0:10000000"
          "DS:io_ent:GAUGE:$no_time_new:0:10000000"
          "DS:mapped_io_ent:GAUGE:$no_time_new:0:10000000"
          "DS:overage:GAUGE:$no_time_new:0:10000000"
	  "RRA:AVERAGE:0.5:1:1825"
	  "RRA:AVERAGE:0.5:7:260"
        );
      }
      my $answer = RRDp::read;
      #chomp ($$answer);
      if ( $$answer ) {
        main::error(" unable to create `$rrd': answer: $$answer".__FILE__.":".__LINE__) && return 0;
      }
    };
  }
  else {
    if (not -f $rrd){
      load_retentions($step,$act_time); # load data retentions
      #print "0000 $one_minute_sample - $five_mins_sample - $one_hour_sample - $five_hours_sample - $one_day_sample\n";
      print "create_mem_lpar: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch ("create_lpar_mem $rrd");
      if ($step == 3600) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
          "DS:curr_mem:GAUGE:$no_time_new:0:10000000"
          "DS:phys_run_mem:GAUGE:$no_time_new:0:10000000"
          "DS:io_ent:GAUGE:$no_time_new:0:10000000"
          "DS:mapped_io_ent:GAUGE:$no_time_new:0:10000000"
          "DS:overage:GAUGE:$no_time_new:0:10000000"
          "RRA:AVERAGE:0.5:1:$one_minute_sample_mem"
          "RRA:AVERAGE:0.5:6:$five_mins_sample_mem"
          "RRA:AVERAGE:0.5:24:$one_hour_sample_mem"
          "RRA:AVERAGE:0.5:288:$five_hours_sample_mem"
        );
      }
      else {
        #print "++ $rrd $start_time $step_new\n";
        RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
          "DS:curr_mem:GAUGE:$no_time_new:0:10000000"
          "DS:phys_run_mem:GAUGE:$no_time_new:0:10000000"
          "DS:io_ent:GAUGE:$no_time_new:0:10000000"
          "DS:mapped_io_ent:GAUGE:$no_time_new:0:10000000"
          "DS:overage:GAUGE:$no_time_new:0:10000000"
	  "RRA:AVERAGE:0.5:1:$one_minute_sample_mem"
	  "RRA:AVERAGE:0.5:5:$five_mins_sample_mem"
	  "RRA:AVERAGE:0.5:60:$one_hour_sample_mem"
	  "RRA:AVERAGE:0.5:300:$five_hours_sample_mem"
	  "RRA:AVERAGE:0.5:1440:$one_day_sample_mem"
        );
      }
      my $answer = RRDp::read;
      #chomp ($$answer);
      if ( $$answer ) {
        main::error(" unable to create `$rrd': answer: $$answer".__FILE__.":".__LINE__) && return 0;
      }
    };
  }
  return 0;
}

sub create_rrd_pool_mem {
  my $rrd = shift;
  my $start_time = shift;
  my $counter_tot = shift;
  my $step = shift;
  my $type_sam = shift;
  my $DEBUG= shift;
  my $host = shift;
  my $managedname = shift;
  my $no_time = shift;
  my $act_time = shift;
  my $step_new = $step;
  my $no_time_new = $no_time;

  if ( $type_sam =~ "d" ) {
    if (not -f $rrd){
      $step_new=86400;
      $no_time_new = 200000;
      print "create_rrd_pool: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      # keep 5y 1 day averages, and 5y 7 day averages
      touch ("create_rrd_pool_mem $rrd");
      if ($step == 3600) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:curr_pool_mem:GAUGE:$no_time_new:0:100000000"
          "DS:curr_io_ent:GAUGE:$no_time_new:0:100000000"
          "DS:mapped_io_ent:GAUGE:$no_time_new:0:100000000"
          "DS:run_mem:GAUGE:$no_time_new:0:100000000"
          "DS:sys_firmware:GAUGE:$no_time_new:0:100000000"
          "RRA:AVERAGE:0.5:1:10000"
          "RRA:AVERAGE:0.5:6:1500"
          "RRA:AVERAGE:0.5:24:1000"
          "RRA:AVERAGE:0.5:288:1000"
        );
      }
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:curr_pool_mem:GAUGE:$no_time_new:0:100000000"
          "DS:curr_io_ent:GAUGE:$no_time_new:0:100000000"
          "DS:mapped_io_ent:GAUGE:$no_time_new:0:100000000"
          "DS:run_mem:GAUGE:$no_time_new:0:100000000"
          "DS:sys_firmware:GAUGE:$no_time_new:0:100000000"
	  "RRA:AVERAGE:0.5:1:1825"
	  "RRA:AVERAGE:0.5:7:260"
        );
      }
      my $answer = RRDp::read; 
      #chomp ($$answer);
      if ( $$answer ) {
        main::error(" unable to create `$rrd': answer: $$answer".__FILE__.":".__LINE__) && return 0;
      }
    }
  }
  else {
    if (not -f $rrd){
      load_retentions($step,$act_time); # load data retentions
      print "create_rrd_pool: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      # keep 30 days of 1m sample interval and then averages
      # 5h averages for 6m, 1day averages for 3y
      touch ("create_rrd_pool_mem $rrd");
      if ($step == 3600) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:curr_pool_mem:GAUGE:$no_time_new:0:100000000"
          "DS:curr_io_ent:GAUGE:$no_time_new:0:100000000"
          "DS:mapped_io_ent:GAUGE:$no_time_new:0:100000000"
          "DS:run_mem:GAUGE:$no_time_new:0:100000000"
          "DS:sys_firmware:GAUGE:$no_time_new:0:100000000"
          "RRA:AVERAGE:0.5:1:$one_minute_sample_mem"
          "RRA:AVERAGE:0.5:6:$five_mins_sample_mem"
          "RRA:AVERAGE:0.5:24:$one_hour_sample_mem"
          "RRA:AVERAGE:0.5:288:$five_hours_sample_mem"
        );
      }
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:curr_pool_mem:GAUGE:$no_time_new:0:100000000"
          "DS:curr_io_ent:GAUGE:$no_time_new:0:100000000"
          "DS:mapped_io_ent:GAUGE:$no_time_new:0:100000000"
          "DS:run_mem:GAUGE:$no_time_new:0:100000000"
          "DS:sys_firmware:GAUGE:$no_time_new:0:100000000"
	  "RRA:AVERAGE:0.5:1:$one_minute_sample_mem"
	  "RRA:AVERAGE:0.5:5:$five_mins_sample_mem"
	  "RRA:AVERAGE:0.5:60:$one_hour_sample_mem"
	  "RRA:AVERAGE:0.5:300:$five_hours_sample_mem"
	  "RRA:AVERAGE:0.5:1440:$one_day_sample_mem"
        );
      }
      my $answer = RRDp::read; 
      #chomp ($$answer);
      if ( $$answer ) {
        main::error(" unable to create `$rrd': answer: $$answer".__FILE__.":".__LINE__) && return 0;
      }
    };
  }
  return 0;
}


sub create_rrd_pool {
  my $rrd = shift;
  my $start_time = shift;
  my $counter_tot = shift;
  my $step = shift;
  my $type_sam = shift;
  my $DEBUG= shift;
  my $host = shift;
  my $managedname = shift;
  my $no_time = shift;
  my $act_time = shift;
  my $step_new = $step;
  my $no_time_new = $no_time;

  if ( $type_sam =~ "d" ) {
    if (not -f $rrd){
      $step_new=86400;
      $no_time_new = 200000;
      print "create_rrd_pool: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      # keep 5y 1 day averages, and 5y 7 day averages
      touch ("create_rrd_pool $rrd");
      if ($step == 3600) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:total_pool_cycles:COUNTER:$no_time_new:0:U"
          "DS:utilized_pool_cyc:COUNTER:$no_time_new:0:U"
          "DS:conf_proc_units:GAUGE:$no_time_new:0:1024"
          "DS:bor_proc_units:GAUGE:$no_time_new:0:1024"
          "RRA:AVERAGE:0.5:1:10000"
          "RRA:AVERAGE:0.5:6:1500"
          "RRA:AVERAGE:0.5:24:1000"
          "RRA:AVERAGE:0.5:288:1000"
        );
      }
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:total_pool_cycles:COUNTER:$no_time_new:0:U"
          "DS:utilized_pool_cyc:COUNTER:$no_time_new:0:U"
          "DS:conf_proc_units:GAUGE:$no_time_new:0:1024"
          "DS:bor_proc_units:GAUGE:$no_time_new:0:1024"
	  "RRA:AVERAGE:0.5:1:1825"
	  "RRA:AVERAGE:0.5:7:260"
        );
      }
      my $answer = RRDp::read; 
      #chomp ($$answer);
      if ( $$answer ) {
        main::error(" unable to create `$rrd': answer: $$answer".__FILE__.":".__LINE__) && return 0;
      }
    }
  }
  else {
    if (not -f $rrd){
      load_retentions($step,$act_time); # load data retentions
      print "create_rrd_pool: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      # keep 30 days of 1m sample interval and then averages
      # 5h averages for 6m, 1day averages for 3y
      touch ("create_rrd_pool $rrd");
      if ($step == 3600) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:total_pool_cycles:COUNTER:$no_time_new:0:U"
          "DS:utilized_pool_cyc:COUNTER:$no_time_new:0:U"
          "DS:conf_proc_units:GAUGE:$no_time_new:0:1024"
          "DS:bor_proc_units:GAUGE:$no_time_new:0:1024"
          "RRA:AVERAGE:0.5:1:$one_minute_sample"
          "RRA:AVERAGE:0.5:6:$five_mins_sample"
          "RRA:AVERAGE:0.5:24:$one_hour_sample"
          "RRA:AVERAGE:0.5:288:$five_hours_sample"
        );
      }
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:total_pool_cycles:COUNTER:$no_time_new:0:U"
          "DS:utilized_pool_cyc:COUNTER:$no_time_new:0:U"
          "DS:conf_proc_units:GAUGE:$no_time_new:0:1024"
          "DS:bor_proc_units:GAUGE:$no_time_new:0:1024"
	  "RRA:AVERAGE:0.5:1:$one_minute_sample"
	  "RRA:AVERAGE:0.5:5:$five_mins_sample"
	  "RRA:AVERAGE:0.5:60:$one_hour_sample"
	  "RRA:AVERAGE:0.5:300:$five_hours_sample"
	  "RRA:AVERAGE:0.5:1440:$one_day_sample"
        );
      }
      my $answer = RRDp::read; 
      #chomp ($$answer);
      if ( $$answer ) {
        main::error(" unable to create `$rrd': answer: $$answer".__FILE__.":".__LINE__) && return 0;
      }
    };
  }
  return 0;
}

sub create_rrd_pool_shared {
  my $rrd = shift;
  my $start_time = shift;
  my $counter_tot = shift;
  my $step = shift;
  my $type_sam = shift;
  my $DEBUG= shift;
  my $host = shift;
  my $managedname = shift;
  my $no_time = shift;
  my $act_time = shift;
  my $step_new = $step;
  my $no_time_new = $no_time;

  if ( $type_sam =~ "d" ) {
    if (not -f $rrd){
      $step_new=86400;
      $no_time_new = 200000;
      print "cr_rrd_pool_sh : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      # keep 5y 1 day averages, and 5y 7 day averages
      touch ("create_rrd_pool_shared $rrd");
      if ($step == 3600) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:total_pool_cycles:COUNTER:$no_time_new:0:U"
          "DS:utilized_pool_cyc:COUNTER:$no_time_new:0:U"
          "DS:max_pool_units:GAUGE:$no_time_new:0:1024"
          "DS:res_pool_units:GAUGE:$no_time_new:0:1024"
          "RRA:AVERAGE:0.5:1:10000"
          "RRA:AVERAGE:0.5:6:1500"
          "RRA:AVERAGE:0.5:24:1000"
          "RRA:AVERAGE:0.5:288:1000"
        );
      }
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:total_pool_cycles:COUNTER:$no_time_new:0:U"
          "DS:utilized_pool_cyc:COUNTER:$no_time_new:0:U"
          "DS:max_pool_units:GAUGE:$no_time_new:0:1024"
          "DS:res_pool_units:GAUGE:$no_time_new:0:1024"
	  "RRA:AVERAGE:0.5:1:1825"
	  "RRA:AVERAGE:0.5:7:260"
        );
      }
      my $answer = RRDp::read; 
      #chomp ($$answer);
      if ( $$answer ) {
        main::error(" unable to create `$rrd': answer: $$answer".__FILE__.":".__LINE__) && return 0;
      }
    }
  }
  else {
    if (not -f $rrd){
      load_retentions($step,$act_time); # load data retentions
      print "cr_rrd_pool_sh: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      # keep 30 days of 1m sample interval and then averages
      # 5h averages for 6m, 1day averages for 3y
      touch ("create_rrd_pool_shared $rrd");
      if ($step == 3600) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:total_pool_cycles:COUNTER:$no_time_new:0:U"
          "DS:utilized_pool_cyc:COUNTER:$no_time_new:0:U"
          "DS:max_pool_units:GAUGE:$no_time_new:0:1024"
          "DS:res_pool_units:GAUGE:$no_time_new:0:1024"
          "RRA:AVERAGE:0.5:1:$one_minute_sample"
          "RRA:AVERAGE:0.5:6:$five_mins_sample"
          "RRA:AVERAGE:0.5:24:$one_hour_sample"
          "RRA:AVERAGE:0.5:288:$five_hours_sample"
        );
      }
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:total_pool_cycles:COUNTER:$no_time_new:0:U"
          "DS:utilized_pool_cyc:COUNTER:$no_time_new:0:U"
          "DS:max_pool_units:GAUGE:$no_time_new:0:1024"
          "DS:res_pool_units:GAUGE:$no_time_new:0:1024"
	  "RRA:AVERAGE:0.5:1:$one_minute_sample"
	  "RRA:AVERAGE:0.5:5:$five_mins_sample"
	  "RRA:AVERAGE:0.5:60:$one_hour_sample"
	  "RRA:AVERAGE:0.5:300:$five_hours_sample"
	  "RRA:AVERAGE:0.5:1440:$one_day_sample"
        );
      }
      my $answer = RRDp::read; 
      #chomp ($$answer);
      if ( $$answer ) {
        main::error(" unable to create `$rrd': answer: $$answer".__FILE__.":".__LINE__) && return 0;
      }
    };
  }
  return 0;
}

sub create_rrd_mem {
  my $rrd = shift;
  my $start_time = shift;
  my $counter_tot = shift;
  my $step = shift;
  my $type_sam = shift;
  my $DEBUG= shift;
  my $host = shift;
  my $managedname = shift;
  my $no_time = shift;
  my $act_time = shift;
  my $step_new = $step;
  my $no_time_new = $no_time;
  # actual memory limit is 1000TB
  # this can be easily even online updated by 
  # find $HOMELPAR/data -name "mem.rr*" -exec rrdtool tune {} --maximum curr_avail_mem:1000000000 \;


  if ( $type_sam =~ "d" ) {
    if (not -f $rrd){
      $step_new=86400;
      $no_time_new = 200000;
      print "create_rrd_mem : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch ("create_rrd_mem $rrd");
      if ($step == 3600) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:curr_avail_mem:GAUGE:$no_time_new:0:10000000000"
          "DS:conf_sys_mem:GAUGE:$no_time_new:0:100000000000"
          "DS:sys_firmware_mem:GAUGE:$no_time_new:0:10000000000"
          "RRA:AVERAGE:0.5:1:10000"
          "RRA:AVERAGE:0.5:6:1500"
          "RRA:AVERAGE:0.5:24:1000"
          "RRA:AVERAGE:0.5:288:1000"
        );
      }
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:curr_avail_mem:GAUGE:$no_time_new:0:10000000000"
          "DS:conf_sys_mem:GAUGE:$no_time_new:0:100000000000"
          "DS:sys_firmware_mem:GAUGE:$no_time_new:0:10000000000"
	  "RRA:AVERAGE:0.5:1:1825"
	  "RRA:AVERAGE:0.5:7:260"
        );
      }
      my $answer = RRDp::read; 
      #chomp ($$answer);
      if ( $$answer ) {
        main::error(" unable to create `$rrd': answer: $$answer".__FILE__.":".__LINE__) && return 0;
      }
    }
  }
  else {
    if (not -f $rrd){
      load_retentions($step,$act_time); # load data retentions
      print "create_rrd_mem : $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
      touch ("create_rrd_mem $rrd");
      if ($step == 3600) {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:curr_avail_mem:GAUGE:$no_time_new:0:10000000000"
          "DS:conf_sys_mem:GAUGE:$no_time_new:0:100000000000"
          "DS:sys_firmware_mem:GAUGE:$no_time_new:0:10000000000"
          "RRA:AVERAGE:0.5:1:$one_minute_sample_mem"
          "RRA:AVERAGE:0.5:6:$five_mins_sample_mem"
          "RRA:AVERAGE:0.5:24:$one_hour_sample_mem"
          "RRA:AVERAGE:0.5:288:$five_hours_sample_mem"
        );
      }
      else {
        RRDp::cmd qq(create "$rrd"  --start "$start_time" --step "$step_new"
          "DS:curr_avail_mem:GAUGE:$no_time_new:0:10000000000"
          "DS:conf_sys_mem:GAUGE:$no_time_new:0:100000000000"
          "DS:sys_firmware_mem:GAUGE:$no_time_new:0:10000000000"
	  "RRA:AVERAGE:0.5:1:$one_minute_sample_mem"
	  "RRA:AVERAGE:0.5:5:$five_mins_sample_mem"
	  "RRA:AVERAGE:0.5:60:$one_hour_sample_mem"
	  "RRA:AVERAGE:0.5:300:$five_hours_sample_mem"
	  "RRA:AVERAGE:0.5:1440:$one_day_sample_mem"
        );
      }
      my $answer = RRDp::read; 
      #chomp ($$answer);
      if ( $$answer ) {
        main::error(" unable to create `$rrd': answer: $$answer".__FILE__.":".__LINE__) && return 0;
      }
    };
  }
  return 0;
}

sub create_rrd {
  my $rrd = shift;
  my $start_time = shift;
  my $counter_tot = shift;
  my $step = shift;
  my $type_sam = shift;
  my $DEBUG= shift;
  my $host = shift;
  my $managedname = shift;
  my $no_time = shift;
  my $act_time = shift;
  my $SSH = shift;
  my $hmc_user = shift;
  my $wrkdir = shift;
  my $lpar = shift;
  my $time_rec = shift;
  my $keep_virtual = shift;
  my $step_new = $step;
  my $no_time_new = $no_time;

  my $ret = recent_rename($host,$managedname,$lpar,$wrkdir,$DEBUG,$time_rec,$act_time);
  if ( $ret == 1 ) {
    # this lpar has been recently renamed, do not create rrdtool files
    return 1;
  }

  if ( $type_sam =~ "d" ) {
      if (not -f $rrd){ # do it once more, rename could create it
        $step_new=86400;
        $no_time_new = 200000;
        print "create_rrd_lpar: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
        touch ("create_rrd $rrd");
        if ($step == 3600) {
          RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
            "DS:curr_proc_units:GAUGE:$no_time_new:0:4096"
            "DS:virtual_procs:GAUGE:$no_time_new:0:4096"
            "DS:entitled_cycles:COUNTER:$no_time_new:0:U"
            "DS:capped_cycles:COUNTER:$no_time_new:0:U"
            "DS:uncapped_cycles:COUNTER:$no_time_new:0:U"
            "RRA:AVERAGE:0.5:1:10000"
            "RRA:AVERAGE:0.5:6:1500"
            "RRA:AVERAGE:0.5:24:1000"
            "RRA:AVERAGE:0.5:288:1000"
          );
        }
        else {
          if ( $keep_virtual == 1 ) {
            RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
              "DS:curr_proc_units:GAUGE:$no_time_new:0:4096"
              "DS:virtual_procs:GAUGE:$no_time_new:0:4096"
              "DS:entitled_cycles:COUNTER:$no_time_new:0:U"
              "DS:capped_cycles:COUNTER:$no_time_new:0:U"
              "DS:uncapped_cycles:COUNTER:$no_time_new:0:U"
	      "RRA:AVERAGE:0.5:1:1825"
	      "RRA:AVERAGE:0.5:7:260"
              );
          }
          else {
            RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
              "DS:curr_proc_units:GAUGE:$no_time_new:0:4096"
              "DS:entitled_cycles:COUNTER:$no_time_new:0:U"
              "DS:capped_cycles:COUNTER:$no_time_new:0:U"
              "DS:uncapped_cycles:COUNTER:$no_time_new:0:U"
	      "RRA:AVERAGE:0.5:1:1825"
	      "RRA:AVERAGE:0.5:7:260"
              );
          }
        }
        my $answer = RRDp::read;
        #chomp ($$answer);
        if ( $$answer ) {
          main::error(" unable to create `$rrd': answer: $$answer".__FILE__.":".__LINE__) && return 0;
        }
      }
  }
  else {
      rename_lpar ($host,$managedname,$lpar,$act_time,$SSH,$hmc_user,$wrkdir,$DEBUG,$time_rec);
      if (not -f $rrd){ # do it once more, rename could create it

        load_retentions($step,$act_time); # load data retentions
        #print "0000 $one_minute_sample - $five_mins_sample - $one_hour_sample - $five_hours_sample - $one_day_sample\n";
        print "create_rrd_lpar: $host:$managedname $rrd ; STEP=$step_new \n" if $DEBUG;
        touch ("create_rrd $rrd");
        if ($step == 3600) {
          RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
            "DS:curr_proc_units:GAUGE:$no_time_new:0:4096"
            "DS:virtual_procs:GAUGE:$no_time_new:0:4096"
            "DS:entitled_cycles:COUNTER:$no_time_new:0:U"
            "DS:capped_cycles:COUNTER:$no_time_new:0:U"
            "DS:uncapped_cycles:COUNTER:$no_time_new:0:U"
            "RRA:AVERAGE:0.5:1:$one_minute_sample"
            "RRA:AVERAGE:0.5:6:$five_mins_sample"
            "RRA:AVERAGE:0.5:24:$one_hour_sample"
            "RRA:AVERAGE:0.5:288:$five_hours_sample"
          );
        }
        else {
          #print "++ $rrd $start_time $step_new - $no_time_new \n";
          if ( $keep_virtual == 1 ) {
            RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
              "DS:curr_proc_units:GAUGE:$no_time_new:0:4096"
              "DS:virtual_procs:GAUGE:$no_time_new:0:4096"
              "DS:entitled_cycles:COUNTER:$no_time_new:0:U"
              "DS:capped_cycles:COUNTER:$no_time_new:0:U"
              "DS:uncapped_cycles:COUNTER:$no_time_new:0:U"
	      "RRA:AVERAGE:0.5:1:$one_minute_sample"
	      "RRA:AVERAGE:0.5:5:$five_mins_sample"
	      "RRA:AVERAGE:0.5:60:$one_hour_sample"
	      "RRA:AVERAGE:0.5:300:$five_hours_sample"
	      "RRA:AVERAGE:0.5:1440:$one_day_sample"
            );
          }
          else {
            RRDp::cmd qq(create "$rrd"  --start "$start_time"  --step "$step_new"
              "DS:curr_proc_units:GAUGE:$no_time_new:0:4096"
              "DS:entitled_cycles:COUNTER:$no_time_new:0:U"
              "DS:capped_cycles:COUNTER:$no_time_new:0:U"
              "DS:uncapped_cycles:COUNTER:$no_time_new:0:U"
	      "RRA:AVERAGE:0.5:1:$one_minute_sample"
	      "RRA:AVERAGE:0.5:5:$five_mins_sample"
	      "RRA:AVERAGE:0.5:60:$one_hour_sample"
	      "RRA:AVERAGE:0.5:300:$five_hours_sample"
	      "RRA:AVERAGE:0.5:1440:$one_day_sample"
            );
          }
        }
        my $answer = RRDp::read;
        #chomp ($$answer);
        if ( $$answer ) {
          main::error(" unable to create `$rrd': answer: $$answer".__FILE__.":".__LINE__) && return 0;
        }
      }
  }
  return 0;
}

# workaround for situation when during LPM move
# those counters appears all 0 on the targed systems what causes
# huge peak in the graph

sub data_check
{
  my $ent = shift;
  my $cap = shift;
  my $uncap = shift;
  my $lpar = shift;
  my $host = shift;
  my $managedname = shift;

  if ( $ent eq '' ) {
    main::error ("$host:$managedname:$lpar : ent is NULL, ignoring the line");
    return 1;
  }
  if ( $cap eq '' ) {
    main::error ("$host:$managedname:$lpar : cap is NULL, ignoring the line");
    return 1;
  }
  if ( $uncap eq '' ) {
    main::error ("$host:$managedname:$lpar : uncap is NULL, ignoring the line");
    return 1;
  }
  if ( $ent == 0 && $cap == 0 && $uncap == 0) {
    #main::error ("$host:$managedname:$lpar : LPM issue: $ent:$cap:$uncap - fixed, continue ...");
    return 1;
  }
  return 0;
}

sub touch
{
  my $text = shift;

  my $version="$ENV{version}";
  my $basedir = $ENV{INPUTDIR};
  my $new_change="$basedir/tmp/$version-run";
  my $host = $ENV{HMC};
  my $DEBUG = $ENV{DEBUG};


  if ( ! -f $new_change ) {
   `touch $new_change`; # say install_html.sh that there was any change
   if ( $text eq '' ) { 
     print "touch          : $host $new_change\n" if $DEBUG ;
   }
   else {
     print "touch          : $host $new_change : $text\n" if $DEBUG ;
   }
  }

  return 0
}


################################
# SDMC
################################

sub sdmc_procpool_load 
{
 my $SSH = shift;
 my $hmc_user = shift;
 my $host = shift;
 my $ivmy = shift;
 my $ivmm = shift;
 my $ivmd = shift;
 my $ivmh = shift;
 my $ivmmin = shift;
 my $managedname = shift;
 my $out_file = shift;
 my $type_sam = shift;
 my $timerange = shift;

 if ( $type_sam =~ "d" ) {
  `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s $type_sam -r procpool --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin -m \\"$managedname\\" -F time,shared_proc_pool_id,total_pool_cycles,utilized_pool_cycles  --filter \"event_types=sample\""|egrep -iv "Could not create directory|known hosts" > $out_file` ;
 }
 else {
   `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r procpool --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,shared_proc_pool_id,total_pool_cycles,utilized_pool_cycles "|egrep -iv "Could not create directory|known hosts" > $out_file` ;
 }

  return 1;
}

sub sdmc_cod_load 
{
 my $SSH = shift;
 my $hmc_user = shift;
 my $host = shift;
 my $ivmy = shift;
 my $ivmm = shift;
 my $ivmd = shift;
 my $ivmh = shift;
 my $ivmmin = shift;
 my $managedname = shift;
 my $out_file = shift;
 my $type_sam = shift;
 my $loadhours = shift;

#print "**** COD load switched off\n";
#return 1;

 if ( $type_sam =~ "d" ) {
   `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s $type_sam -r all --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,used_proc_min,unreported_proc_min --filter \"event_types=utility_cod_proc_usage\""|egrep -iv "Could not create directory|known hosts" > $out_file` ;
 }
 else {
   `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r all --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin -m \\"$managedname\\" -F time,used_proc_min,unreported_proc_min --filter \"event_types=utility_cod_proc_usage\" "|egrep -iv "Could not create directory|known hosts" > $out_file` ;
 }

  return 1;
}


sub sdmc_pool_load 
{
 my $SSH = shift;
 my $hmc_user = shift;
 my $host = shift;
 my $ivmy = shift;
 my $ivmm = shift;
 my $ivmd = shift;
 my $ivmh = shift;
 my $ivmmin = shift;
 my $managedname = shift;
 my $out_file = shift;
 my $type_sam = shift;
 my $loadhours = shift;

#return 1;

 if ( $type_sam =~ "d" ) {
   `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s $type_sam -r pool  --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,total_pool_cycles,utilized_pool_cycles,configurable_pool_proc_units,borrowed_pool_proc_units  --filter \"event_types=sample\""|egrep -iv "Could not create directory|known hosts" > $out_file` ;
 }
 else {
   `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r pool --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,total_pool_cycles,utilized_pool_cycles,configurable_pool_proc_units,borrowed_pool_proc_units"|egrep -iv "Could not create directory|known hosts" > $out_file` ;
 }


  return 1;
}


sub sdmc_lpar_load 
{
 my $SSH = shift;
 my $hmc_user = shift;
 my $host = shift;
 my $ivmy = shift;
 my $ivmm = shift;
 my $ivmd = shift;
 my $ivmh = shift;
 my $ivmmin = shift;
 my $managedname = shift;
 my $out_file = shift;
 my $type_sam = shift;
 my $loadhours = shift;
 my $lpars = shift; # for alerting, just get selectively data for particular lpars
 my $mem_params = shift;

 if ( $type_sam =~ "d" ) {
    if ( $lpars eq '' ) {
     `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s $type_sam -r lpar --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,lpar_id,curr_proc_units,curr_procs,curr_sharing_mode,entitled_cycles,capped_cycles,uncapped_cycles$mem_params"|egrep -iv "Could not create directory|known hosts" > $out_file` ;
    }
    else {
     `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s $type_sam -r lpar --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,lpar_id,curr_proc_units,curr_procs,curr_sharing_mode,entitled_cycles,capped_cycles,uncapped_cycles$mem_params  --filter \\\\\\"lpar_names=$lpars\\\\\\""|egrep -iv "Could not create directory|known hosts" > $out_file` ;
    }
 }
 else {
    if ( $lpars eq '' ) {
     `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r lpar --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,lpar_id,curr_proc_units,curr_procs,curr_sharing_mode,entitled_cycles,capped_cycles,uncapped_cycles$mem_params"|egrep -iv "Could not create directory|known hosts" > $out_file` ;
    }
    else {
     `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r lpar --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,lpar_id,curr_proc_units,curr_procs,curr_sharing_mode,entitled_cycles,capped_cycles,uncapped_cycles$mem_params --filter \\\\\\"lpar_names=$lpars\\\\\\""|egrep -iv "Could not create directory|known hosts" > $out_file` ;
    }
 }


  return 1;
}

sub sdmc_pool_mem_load 
{
 my $SSH = shift;
 my $hmc_user = shift;
 my $host = shift;
 my $ivmy = shift;
 my $ivmm = shift;
 my $ivmd = shift;
 my $ivmh = shift;
 my $ivmmin = shift;
 my $managedname = shift;
 my $out_file = shift;
 my $type_sam = shift;
 my $loadhours = shift;


 if ( $type_sam =~ "d" ) {
   `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s $type_sam -r mempool --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,curr_pool_mem,lpar_curr_io_entitled_mem,lpar_mapped_io_entitled_mem,lpar_run_mem,sys_firmware_pool_mem --filter \"event_types=sample\""|egrep -iv "Could not create directory|known hosts" > $out_file` ;
 }
 else {
   `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r mempool --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin -m \\"$managedname\\" -F time,curr_pool_mem,lpar_curr_io_entitled_mem,lpar_mapped_io_entitled_mem,lpar_run_mem,sys_firmware_pool_mem "|egrep -iv "Could not create directory|known hosts" > $out_file` ;
 }

  return 1;
}

sub sdmc_sys_load 
{
 my $SSH = shift;
 my $hmc_user = shift;
 my $host = shift;
 my $ivmy = shift;
 my $ivmm = shift;
 my $ivmd = shift;
 my $ivmh = shift;
 my $ivmmin = shift;
 my $managedname = shift;
 my $out_file = shift;
 my $type_sam = shift;
 my $loadhours = shift;


 if ( $type_sam =~ "d" ) {
   `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s $type_sam -r sys --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,curr_avail_sys_mem,configurable_sys_mem,sys_firmware_mem --filter \"event_types=sample\""|egrep -iv "Could not create directory|known hosts" > $out_file` ;
 }
 else {
   `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r sys --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin -m \\"$managedname\\" -F time,curr_avail_sys_mem,configurable_sys_mem,sys_firmware_mem "|egrep -iv "Could not create directory|known hosts" > $out_file` ;
 }

  return 1;
}

sub smdc_touch 
{
  my $SDMC = shift;
  my $wrkdir = shift;
  my $managedname = shift;
  my $host = shift;
  my $act_time = shift;

  if ($SDMC == 1) {
      if ( ! -f "$wrkdir/$managedname/$host/SDMC" ) {
        open(FH, "> $wrkdir/$managedname/$host/SDMC") || main::error(" Can't create $wrkdir/$managedname/$host/IVM : $!".__FILE__.":".__LINE__) && return 0;
        print FH "SDMC\n";
        close (FH);
      }
  }
  else {
      if ( -f "$wrkdir/$managedname/$host/SDMC" ) {
        unlink ("$wrkdir/$managedname/$host/SDMC");
      }
  }

  return 1;
}

################################
# End of SDMC
################################


sub load_retentions
{
  my $step=shift;
  my $act_time=shift;
  my $basedir = $ENV{INPUTDIR};

  # standards
  $one_minute_sample=86400;
  $five_mins_sample=25920;
  $one_hour_sample=4320;
  $five_hours_sample=1734;
  $one_day_sample=1080;

  $one_minute_sample_mem=86400;
  $five_mins_sample_mem=25920;
  $one_hour_sample_mem=4320;
  $five_hours_sample_mem=1734;
  $one_day_sample_mem=1080;

  if ( ! -f "$basedir/etc/retention.cfg" ) {
    # standard retentions in place
    return 0;
  }

  # extra retentions are specifiled in $basedir/etc/retention.cfg
  open(FH, "< $basedir/etc/retention.cfg") || main::error ("Can't read from: $basedir/etc/retention.cfg: $!");

  my @lines = <FH>;
  foreach my $line (@lines) {
    chomp ($line);

    # MEM
    if ( $line =~ m/^1min/ && $line =~ m/MEM/ ) {
      (my $trash, $one_minute_sample_mem) = split(/:/,$line);
      next;
    }
    if ( $line =~ m/^5min/ && $line =~ m/MEM/ ) {
      (my $trash, $five_mins_sample_mem) = split(/:/,$line);
      next;
    }
    if ( $line =~ m/^60min/ && $line =~ m/MEM/ ) {
      (my $trash, $one_hour_sample_mem) = split(/:/,$line);
      next;
    }
    if ( $line =~ m/^300min/ && $line =~ m/MEM/ ) {
      (my $trash, $five_hours_sample_mem) = split(/:/,$line);
      next;
    }
    if ( $line =~ m/^1440min/ && $line =~ m/MEM/ ) {
      (my $trash, $one_day_sample_mem) = split(/:/,$line);
      next;
    }

    # CPU
    if ( $line =~ m/^1min/ ) {
      (my $trash, $one_minute_sample) = split(/:/,$line);
    }
    if ( $line =~ m/^5min/ ) {
      (my $trash, $five_mins_sample) = split(/:/,$line);
    }
    if ( $line =~ m/^60min/ ) {
      (my $trash, $one_hour_sample) = split(/:/,$line);
    }
    if ( $line =~ m/^300min/ ) {
      (my $trash, $five_hours_sample) = split(/:/,$line);
    }
    if ( $line =~ m/^1440min/ ) {
      (my $trash, $one_day_sample) = split(/:/,$line);
    }
  }

  close (FH);

  $step = $step / 60;
  $one_minute_sample = $one_minute_sample / $step;
  $five_mins_sample = $five_mins_sample / $step;
  $one_hour_sample = $one_hour_sample / $step;
  $five_hours_sample = $five_hours_sample / $step;
  $one_day_sample = $one_day_sample / $step;

  $one_minute_sample_mem = $one_minute_sample_mem / $step;
  $five_mins_sample_mem = $five_mins_sample_mem / $step;
  $one_hour_sample_mem = $one_hour_sample_mem / $step;
  $five_hours_sample_mem = $five_hours_sample_mem / $step;
  $one_day_sample_mem = $one_day_sample_mem / $step;
  return 1;
}

sub basename {
  my $full = shift;
  my $out = "";

  # basename without direct function
  my @base = split(/\//,$full);
  foreach my $m (@base) {
    $out = $m;
  }

  return $out;
}


sub rename_lpar 
{
  my $host = shift;
  my $managedname = shift;
  my $lpar = shift;
  my $act_time = shift;
  my $SSH = shift;
  my $hmc_user = shift;
  my $wrkdir = shift;
  my $DEBUG = shift;
  my $time_rec = shift;
  my $serial = "";
  my $lpar_slash = $lpar;
  $lpar_slash =~ s/\&\&1/\//g;

  if ( $rename_once == 0 ) {
    # do it only once per a server
    @rename=`$SSH $hmc_user\@$host "lssyscfg -m \\"$managedname\\" -r lpar -F name,logical_serial_num" 2>&1`;
  }
  $rename_once = 1;

  # new lpar has been detected here, found its serial and check whether any already existing lpar has it
  foreach my $line (@rename) {
    chomp ($line);
    (my $name, my $serial_new) = split(/,/,$line);
    if ( $name =~ m/^$lpar_slash$/ ) {
      $serial = $serial_new;
      last;
     }
  }

  if ( $serial eq '' ) {
    main::error("$host:$managedname:$lpar have not been found serial, ignore that if that lpar has been recently renamed");
    return 0;
  }


 # now go through all cpu-cfg-$lpar and search serial
  my $tstamp = 0;
  my $lpar_recent = "";
  my $lpar_old = "";
  foreach my $cfg (<"$wrkdir/$managedname/$host/cpu.cfg-*">) {
    open(FHCPU, "< $cfg") || main::error(" Can't open $cfg : $!".__FILE__.":".__LINE__) && return 0;
    my @lines = <FHCPU>;
    #print "001 $cfg $serial\n";
    $lpar_old = $cfg;
    $lpar_old =~ s/^.*cpu\.cfg-//;

    foreach my $line (@lines) {
      chomp ($line);
      if ( $line =~ m/logical_serial_num/ && $line =~ m/\>$serial\</ ) {
        #print "002 $lpar_old\n";

        # find out a lpar with the last record --> this one was most probably used before rename last time
        if ( -f "$wrkdir/$managedname/$host/$lpar_old.rrm" ) {
          #print "003 $lpar_old $lpar\n";
          RRDp::cmd qq(last "$wrkdir/$managedname/$host/$lpar_old.rrm" );
          my $last_rec = RRDp::read;    
	  chomp ($$last_rec);
          if ( $$last_rec > $tstamp ) {
            #print "004 $wrkdir/$managedname/$host/$lpar_old.rrm $$last_rec $tstamp\n";
            $tstamp = $$last_rec;
            $lpar_recent = $lpar_old;
          }
        }
        if ( -f "$wrkdir/$managedname/$host/$lpar_old.rrh" ) {
          RRDp::cmd qq(last "$wrkdir/$managedname/$host/$lpar_old.rrh" );
          my $last_rec = RRDp::read;    
	  chomp ($$last_rec);
          if ( $$last_rec > $tstamp ) {
            #print "004 $wrkdir/$managedname/$host/$lpar_old.rrh $$last_rec $tstamp\n";
            $tstamp = $$last_rec;
            $lpar_recent = $lpar_old;
          }
        }
      }
    }
  }
  $lpar_old = $lpar_recent;

  if ( $lpar_old =~ m/^$lpar$/ ) {
     return 1; # actual lpar has most recent data, keep it as it is
  }
  
  if ( ! $lpar_recent eq '' ) {
    print "LPAR rename    : $host:$managedname: $lpar_old --> $lpar_slash\n" if $DEBUG ;
    touch ("lpar rename $host:$managedname: $lpar");

    # place lpar name and time spamp into rename.tmp file
    # there will not be created for 10minutes since then timestap a lpar with the same name
    # problem after a rename is that during next run there appear a few record with the originl lpar and 
    #  new rrdtool files are created altough they should not --> problem with aggregated graphs (lpar & mem)
    my $rename_tmp = "$wrkdir/$managedname/$host/rename.tmp";
    open(FR, ">> $rename_tmp") || main::error(" Can't open $rename_tmp : $!".__FILE__.":".__LINE__) && return 0;
    print FR "$time_rec:$lpar_old\n";
    close (FR);
    

    # at first find out last used if there is found more same serial (some rename in the past)
    if ( -f "$wrkdir/$managedname/$host/$lpar_old.rrm" ) {
      if ( -f "$wrkdir/$managedname/$host/$lpar.rrm" ) {
        print "LPAR rename org: $host:$managedname: $lpar.rrm --> $lpar.rrm-old\n" if $DEBUG ;
        rename("$wrkdir/$managedname/$host/$lpar.rrm","$wrkdir/$managedname/$host/$lpar.rrm-old")  || main::error(" Cannot mv $wrkdir/$managedname/$host/$lpar.rrm $wrkdir/$managedname/$host/$lpar.rrm-old: $!".__FILE__.":".__LINE__) && return 0;
      }
      print "LPAR rename    : $host:$managedname: $lpar_old --> $lpar_slash : rrm\n" if $DEBUG ;
      rename("$wrkdir/$managedname/$host/$lpar_old.rrm","$wrkdir/$managedname/$host/$lpar.rrm")  || main::error(" Cannot mv $wrkdir/$managedname/$host/$lpar_old.rrm $wrkdir/$managedname/$host/$lpar.rrm: $!".__FILE__.":".__LINE__) && return 0;
    }
    if ( -f "$wrkdir/$managedname/$host/$lpar_old.rrd" ) {
      if (  -f "$wrkdir/$managedname/$host/$lpar.rrd" ) {
        print "LPAR rename org: $host:$managedname: $lpar.rrd --> $lpar.rrd-old\n" if $DEBUG ;
        rename("$wrkdir/$managedname/$host/$lpar.rrd","$wrkdir/$managedname/$host/$lpar.rrd-old")  || main::error(" Cannot mv $wrkdir/$managedname/$host/$lpar.rrd $wrkdir/$managedname/$host/$lpar.rrd-old: $!".__FILE__.":".__LINE__) && return 0;
      }
      print "LPAR rename    : $host:$managedname: $lpar_old --> $lpar_slash : rrd\n" if $DEBUG ;
      rename("$wrkdir/$managedname/$host/$lpar_old.rrd","$wrkdir/$managedname/$host/$lpar.rrd")  || main::error(" Cannot mv $wrkdir/$managedname/$host/$lpar_old.rrd $wrkdir/$managedname/$host/$lpar.rrd: $!".__FILE__.":".__LINE__) && return 0;
    }
    if ( -f "$wrkdir/$managedname/$host/$lpar_old.rrh" ) {
      if ( -f "$wrkdir/$managedname/$host/$lpar.rrh" ) {
        print "LPAR rename org: $host:$managedname: $lpar.rrh --> $lpar.rrh-old\n" if $DEBUG ;
        rename("$wrkdir/$managedname/$host/$lpar.rrh","$wrkdir/$managedname/$host/$lpar.rrh-old")  || main::error(" Cannot mv $wrkdir/$managedname/$host/$lpar.rrh $wrkdir/$managedname/$host/$lpar.rrh-old: $!".__FILE__.":".__LINE__) && return 0;
      }
      print "LPAR rename    : $host:$managedname: $lpar_old --> $lpar_slash : rrh\n" if $DEBUG ;
      rename("$wrkdir/$managedname/$host/$lpar_old.rrh","$wrkdir/$managedname/$host/$lpar.rrh")  || main::error(" Cannot mv $wrkdir/$managedname/$host/$lpar_old.rrh $wrkdir/$managedname/$host/$lpar.rrh: $!".__FILE__.":".__LINE__) && return 0;
    }
    if ( -f "$wrkdir/$managedname/$host/$lpar_old.rmm" ) {
      if ( -f "$wrkdir/$managedname/$host/$lpar.rmm" ) {
        print "LPAR rename org: $host:$managedname: $lpar.rmm --> $lpar.rmm-old\n" if $DEBUG ;
        rename("$wrkdir/$managedname/$host/$lpar.rmm","$wrkdir/$managedname/$host/$lpar.rmm-old")  || main::error(" Cannot mv $wrkdir/$managedname/$host/$lpar.rmm $wrkdir/$managedname/$host/$lpar.rmm-old: $!".__FILE__.":".__LINE__) && return 0;
      }
      print "LPAR rename    : $host:$managedname: $lpar_old --> $lpar_slash : rmm\n" if $DEBUG ;
      rename("$wrkdir/$managedname/$host/$lpar_old.rmm","$wrkdir/$managedname/$host/$lpar.rmm")  || main::error(" Cannot mv $wrkdir/$managedname/$host/$lpar_old.rmm $wrkdir/$managedname/$host/$lpar.rmm: $!".__FILE__.":".__LINE__) && return 0;
    }
    if ( -f "$wrkdir/$managedname/$host/$lpar_old.rsm" ) {
      if ( -f "$wrkdir/$managedname/$host/$lpar.rsm" ) {
        print "LPAR rename org: $host:$managedname: $lpar.rsm --> $lpar.rsm-old\n" if $DEBUG ;
        rename("$wrkdir/$managedname/$host/$lpar.rsm","$wrkdir/$managedname/$host/$lpar.rsm-old")  || main::error(" Cannot mv $wrkdir/$managedname/$host/$lpar.rsm $wrkdir/$managedname/$host/$lpar.rsm-old: $!".__FILE__.":".__LINE__) && return 0;
      }
      print "LPAR rename    : $host:$managedname: $lpar_old --> $lpar_slash : rsd\n" if $DEBUG ;
      rename("$wrkdir/$managedname/$host/$lpar_old.rsm","$wrkdir/$managedname/$host/$lpar.rsm")  || main::error(" Cannot mv $wrkdir/$managedname/$host/$lpar_old.rsm $wrkdir/$managedname/$host/$lpar.rsm: $!".__FILE__.":".__LINE__) && return 0;
    }
    if ( -f "$wrkdir/$managedname/$host/$lpar_old.rsd" ) {
      if ( -f "$wrkdir/$managedname/$host/$lpar.rsd" ) {
        print "LPAR rename org: $host:$managedname: $lpar.rsd --> $lpar.rsd-old\n" if $DEBUG ;
        rename("$wrkdir/$managedname/$host/$lpar.rsd","$wrkdir/$managedname/$host/$lpar.rsd-old")  || main::error(" Cannot mv $wrkdir/$managedname/$host/$lpar.rsd $wrkdir/$managedname/$host/$lpar.rsd-old: $!".__FILE__.":".__LINE__) && return 0;
      }
      print "LPAR rename    : $host:$managedname: $lpar_old --> $lpar_slash : rsd\n" if $DEBUG ;
      rename("$wrkdir/$managedname/$host/$lpar_old.rsd","$wrkdir/$managedname/$host/$lpar.rsd")  || main::error(" Cannot mv $wrkdir/$managedname/$host/$lpar_old.rsd $wrkdir/$managedname/$host/$lpar.rsd: $!".__FILE__.":".__LINE__) && return 0;
    }
    
    # here delete LPM stuff, it will be recreated during next run for proper lpar names
    foreach my $lpm (<"$wrkdir/$managedname/$host/$lpar_old=====*=====*rrk">) {
      my $file_link=readlink("$lpm");
      print "LPAR rename lpm: $host:$managedname: $lpar_old --> $lpar_slash : $lpm --> $file_link\n" if $DEBUG ;
      unlink ("$file_link");
      unlink ("$lpm");
    }
    foreach my $lpm (<"$wrkdir/$managedname/$host/$lpar_old=====*=====*rrl">) {
      my $file_link=readlink("$lpm");
      print "LPAR rename lpm: $host:$managedname: $lpar_old --> $lpar_slash : $lpm --> $file_link\n" if $DEBUG ;
      unlink ("$file_link");
      unlink ("$lpm");
    } 
  }
  #else {
  #  print "LPAR rename    : $host:$managedname: $lpar:$serial has not been found for rename\n" if $DEBUG ;
  #}

  return 1;
}

sub recent_rename
{
  my $host = shift;
  my $managedname = shift;
  my $lpar = shift;
  my $wrkdir = shift;
  my $DEBUG = shift;
  my $time_rec = shift;
  my $act_time = shift;
  my $RENAME_PERIOD=600; # if there is detected same lpar name 10 minutes after a rename then it is ignored

  my $rename_tmp = "$wrkdir/$managedname/$host/rename.tmp";
  if ( ! -f "$rename_tmp" ) {
    return 0;
  }
  #print "001 $rename_tmp $lpar\n";

  open(FR, "< $rename_tmp") || main::error(" Can't open $rename_tmp : $!".__FILE__.":".__LINE__) && return 0;

  my @lines = <FR>;
  close (FR);
  foreach my $line (@lines) {
    chomp ($line);
    (my $time, my $lpar_act) = split(/:/,$line);
    #print "002 $line $time - $lpar_act - $lpar - ($time + $RENAME_PERIOD) > $time_rec\n";
    if ( $lpar_act eq '' ) {
      next; # some trash
    }
    if ( $lpar_act =~ m/^$lpar$/ && ($time + $RENAME_PERIOD) > $time_rec) {
      print "rename ignore  : $host:$managedname:$lpar : rename period ignore : ($time + $RENAME_PERIOD) > $time_rec\n" if $DEBUG ;
      return 1;
    }
  }

  return 0;
}


sub rrd_error
{
  my $err_text = shift;
  my $rrd_file = shift;
  my $basedir = $ENV{INPUTDIR};
  my $tmpdir = "$basedir/tmp";
  if (defined $ENV{TMPDIR}) {
    $tmpdir = $ENV{TMPDIR};
  }

  chomp ($err_text);

  if ( ! -f "$rrd_file" ) {
    return 0;
  }

  if ( $err_text =~ m/ERROR:/ ) {
    # copy of the corrupted file into "save" place and remove the original one
    copy ("$rrd_file","$tmpdir/") || main::error("Cannot: cp $rrd_file $tmpdir/: $!");
    unlink("$rrd_file") || main::error("Cannot rm $rrd_file : $!");
    main::error("$err_text, moving it into: $tmpdir/");
  }
  else {
    main::error("$err_text");
  }
  return 0;
}


return 1;
