#!/bin/sh

PATH=$PATH:/usr/bin:/bin:/usr/local/bin:/opt/freeware/bin
export PATH

LANG=C
export LANG

# it is necessary as files need to be readable also for WEB server user
umask 022

# Load LPAR2RRD configuration
. `dirname $0`/lpar2rrd.cfg

if [ "$INPUTDIR" = "." ]; then
   INPUTDIR=`pwd`
   export INPUTDIR
fi

ALERCFG="alert.cfg"

cd $INPUTDIR

if [ ! -f $ALERCFG ]; then
    if [ $DEBUG -eq 1 ]; then echo "There is no $ALERCFG cfg file"; fi
    exit 0
fi
SERVERS=`egrep "^ALERT:" $ALERCFG |awk -F: '{print $2}'|sort|uniq`
for server in $SERVERS
do
  LPARS=`egrep "^ALERT:$server:" $ALERCFG |awk -F: '{print $3,":"$4}'|sort|uniq`
  for lpar in $LPARS
  do
    echo "$server:$lpar"
  done
done
