#!/usr/bin/perl
use strict;
use Date::Parse;
use Math::BigInt;
#use File::Compare;
use LoadDataModule;
use RRDp;


# set unbuffered stdout
$| = 1;

# get cmd line params
my $upgrade="$ENV{UPGRADE}";
my $version="$ENV{version}";
my $host = $ENV{HMC};
my $hea = $ENV{HEA};
my $hmc_user = $ENV{HMC_USER};
my $webdir = $ENV{WEBDIR};
my $bindir = $ENV{BINDIR};
my $basedir = $ENV{INPUTDIR};
my $tmpdir = "$basedir/tmp";
if (defined $ENV{TMPDIR}) {
  $tmpdir = $ENV{TMPDIR};
}
my $rrdtool = $ENV{RRDTOOL};
my $DEBUG = $ENV{DEBUG};
#$DEBUG = 2;
my $pic_col = $ENV{PICTURE_COLOR};
my $STEP = $ENV{SAMPLE_RATE};
my $no_time = $STEP * 6; # says the time interval when RRDTOOL consideres a gap in input data
my $HWINFO = $ENV{HWINFO};
my $managed_systems_exclude =  $ENV{MANAGED_SYSTEMS_EXCLUDE};
my $SYS_CHANGE = $ENV{SYS_CHANGE};
my $STEP_HEA=$ENV{STEP_HEA};;
my $SSH = $ENV{SSH}." -q -o ConnectTimeout=80 -o StrictHostKeyChecking=no -o PreferredAuthentications=publickey";
# uncoment&adjust if you want to use your own ssh identification file
#my $SSH = $ENV{SSH}." -i ".$ENV{HOME}."/.ssh/lpar2rrd -o ConnectTimeout=5 -o StrictHostKeyChecking=no -o PreferredAuthentications=publickey";
my $new_change="$tmpdir/$version-run";
my $wrkdir = "$basedir/data";
my @lpar_trans = "";  # lpar translation names/ids for IVM systems
my $alert_log="$basedir/alert.log";
my $time_diff=0;
my $act_time = localtime();
my $nagios_dir="$basedir/nagios";
my $hmcv_num = 701;  # suppouse no one is using older nowadays --> it is now checked for HMC due to AMS support
print "LPAR2RRD alert script v:$version, started: $act_time\n";
my $step = $STEP;
my $HMC=1;
my $IVM=0;
my $SDMC=0;
my $input="m";
my $input_shell="m";
my $type_sam="m";
my @lpar_p = "";
my @lpar_a = "";
my $cfg = $ENV{ALERCFG};
#my $from_mail="lpar2rrd";
my $from_mail="support\@gmail.com";
my $subject="High CPU utilization";
my $alert_repeat="$tmpdir/alert_repeat.tmp";
my $ltime_str = localtime();
my $ltime = str2time($ltime_str);
my @emails_name = "";
my @emails_addr = "";
my $last_file_default="last.txt";
my $last_file="last-alrt.txt";
my $alert_history = "";
my $mem_params = "";
my $repeat_default="";
my $cpu_average_time_default = "";
my $email_default = "";
my @lines_rep = "";

# swapping
my @lpar_all_list = "";
my @server_list_all = "";


if ( -f "$bindir/premium.pl" ) {
  require "$bindir/premium.pl";
}
else {
  require "$bindir/standard.pl";
}


# use alert here to be sure it does not hang due to any problem
my $timeout = 600; # it must be enough
eval {
    my $act_time = localtime();
    local $SIG{ALRM} = sub {die "died in SIG ALRM: ";};
    alarm($timeout);

    RRDp::start "$rrdtool";
    read_cfg ();

    alarm (0);

    # close RRD pipe
    RRDp::end;
    my $unixt = str2time($act_time);
    $act_time = localtime();
    my $unixt_end = str2time($act_time);
    my $run_time = $unixt_end - $unixt;
    print "Finished       : $act_time, run time: $run_time secs\n";
};

if ($@) {
    if ($@ =~ /died in SIG ALRM/) {
      error ("$0 timed out after : $timeout seconds");
    }
    else {
      error ("$0 failed: $@");
    }
    exit (1);
}


exit (0);

sub read_cfg {
  my $host = "";
  my $managedname = "";
  my $lpar = "";
  my $cpulim = "";
  my $cpulimmin = "";
  my $tint = "";
  my $trepeat = "";
  my $email = "";
  my $util = "";
  my $name_rep = "";
  my $ltime_rep = "";
  my $ltime_human = "";
  my $emails_count = 0;
  my $nagios="";
  my $cpu_warning = "";
  my $extern_alert = "";
  my $trash = "";
  my $line_rep = "";
  my $email_admin = "";
  my $line = "";
  my $return = "";
  my @server_proc_pool = "";
  my $server_proc = 0;
  my $lpar_name_org = "";
  my $email_graph = 0;
  # those are globals due to swapping 
  $repeat_default="";
  $cpu_average_time_default = "";
  $email_default = "";
  

  open(FH, "< $cfg") || error("could not open $cfg : $!".__FILE__.":".__LINE__) && return 1 ;
  my @lines = <FH>;
  close (FH);
  my @lines_sort = sort(@lines);

  if ( -f $alert_repeat ) {
    open(FHR, "< $alert_repeat");
    @lines_rep = sort(<FHR>);
    close (FHR);
  }

  foreach $line (@lines) {
   if ( $line =~ m/^#/ ) {
     next;
   }
   chomp ($line);

   if ( $line =~ m/^EMAIL_ADMIN=/ ) {
     ($trash, $email_admin) = split(/=/,$line);
     $email_admin =~ s/ //g;
     $email_admin =~ s/	//g;
     $email_admin =~ s/#.*$//g;
     next;
   }
   if ( $line =~ m/^CPU_WARNING_ALERT=/ ) {
     ($trash, $cpu_warning) = split(/=/,$line);
     $cpu_warning =~ s/ //g;
     $cpu_warning =~ s/	//g;
     $cpu_warning =~ s/#.*$//g;
     my $ret = isdigit($cpu_warning,"CPU_WARNING_ALERT: $line");
     if ( $ret == 0 ) {
       exit 0;
     }
     next;
   }
   if ( $line =~ m/^NAGIOS=/ ) {
     ($trash, $nagios) = split(/=/,$line);
     $nagios =~ s/ //g;
     $nagios =~ s/	//g;
     $nagios =~ s/#.*$//g;
     my $ret = isdigit($nagios,"NAGIOS: $line");
     if ( $ret == 0 ) {
       exit 0;
     }
     next;
   }
   if ( $line =~ m/^EMAIL_GRAPH=/ ) {
     ($trash, $email_graph) = split(/=/,$line);
     $email_graph =~ s/ //g;
     $email_graph =~ s/	//g;
     $email_graph =~ s/#.*$//g;
     next;
   }
   if ( $line =~ m/^EXTERN_ALERT=/ ) {
     ($trash, $extern_alert) = split(/=/,$line);
     $extern_alert =~ s/ //g;
     $extern_alert =~ s/	//g;
     $extern_alert =~ s/#.*$//g;
     next;
   }
   if ( $line =~ m/^ALERT_HISTORY=/ ) {
     ($trash, $alert_history) = split(/=/,$line);
     $alert_history =~ s/ //g;
     $alert_history =~ s/	//g;
     $alert_history =~ s/#.*$//g;
     next;
   }
   if ( $line =~ m/^REPEAT_DEFAULT=/ ) {
     ($trash, $repeat_default) = split(/=/,$line);
     $repeat_default =~ s/ //g;
     $repeat_default =~ s/	//g;
     $repeat_default =~ s/#.*$//g;
     my $ret = isdigit($repeat_default,"REPEAT_DEFAULT: $line");
     if ( $ret == 0 ) {
       exit 0;
     }
     next;
   }
   if ( $line =~ m/^PEEK_TIME_DEFAULT=/ ) {
     ($trash, $cpu_average_time_default) = split(/=/,$line);
     $cpu_average_time_default =~ s/ //g;
     $cpu_average_time_default =~ s/	//g;
     $cpu_average_time_default =~ s/#.*$//g;
     my $ret = isdigit($cpu_average_time_default,"PEEK_TIME_DEFAULT: $line");
     if ( $ret == 0 ) {
       exit 0;
     }
     next;
   }
   if ( $line =~ m/^EMAIL=/ ) {
     ($trash, $email_default) = split(/=/,$line);
     $email_default =~ s/ //g;
     $email_default =~ s/	//g;
     $email_default =~ s/#.*$//g;
     next;
   }
   if ( $line =~ m/^EMAIL_/ ) {
     (my $email_name, my $email_addr) = split(/=/,$line);
     $email_name =~ s/ //g;
     $email_name =~ s/	//g;
     $email_name =~ s/#.*$//g;
     $email_addr =~ s/ //g;
     $email_addr =~ s/	//g;
     $email_addr =~ s/#.*$//g;
     $emails_name[$emails_count] = $email_name;
     $emails_addr[$emails_count] = $email_addr;
     #print "# 00 $emails_name[$emails_count] = $emails_addr[$emails_count] :: $email_name = $email_addr : $emails_count\n";
     $emails_count++;
     next;
   }
  }

  if ( $cpu_average_time_default eq '' ) {
    error ("PEEK_TIME_DEFAULT is not set, exiting ...");
    exit 1;
  }
  if ( $repeat_default eq '' ) {
    error ("REPEAT_DEFAULT is not set, exiting ...");
    exit 1;
  }
  if ( $alert_history eq '' ) {
    error ("ALERT_HISTORY is not set, exiting ...");
    exit 1;
  }
  if ( $nagios eq '' ) {
    error ("NAGIOS is not set, exiting ...");
    exit 1;
  }
  if ( $cpu_warning eq '' ) {
    error ("CPU_WARNING_ALERT is not set, exiting ...");
    exit 1;
  }

  # Handling all swapping
  swapping ($email_graph,$nagios,$extern_alert,\@lines_sort);

  #exit (0);

  # it has to be in separated run (sorted by hosts/server)
  # Load data selectively per lpar
  my $managedname_prev = "";
  my $lpars= "";
  my $last_type="";
  foreach $line (@lines_sort) {
   chomp ($line);
   if ( $line eq '' || $line =~ m/^#/ || $line =~ m/^SWAP/ || $line =~ m/SWAP:/ || $line !~ m/:/ ) {
     next; # exclude comments and swapping rules
   }

   ($trash,$managedname,$lpar,$cpulim,$cpulimmin,$tint,$trepeat,$email) = split(/:/,$line);
   if ( $lpar eq '' || $managedname eq '' ) {
     next;  # something wrong 
   }

   $lpar =~ s/\//\&\&1/g;

   if ( $line =~ m/^LPAR:/ ) {
     print "loading data   : $line\n";
     $last_type="LPAR";
     print "001 $line : $lpar - $managedname_prev : $managedname - $lpar - $cpulim - $cpulimmin - $tint - $trepeat - $email\n" if $DEBUG == 2;

     if ( $lpars eq '' ) {
       $managedname_prev = $managedname;
       $lpars .= $lpar;
       next;
     }
     if ( $managedname_prev =~ m/^$managedname$/ ) {
       $lpars .= ",".$lpar;
       next;
     }
     else {
       print "022 Load data      : $managedname_prev $lpars\n" if $DEBUG == 2;
       load_rrd_lpar ($managedname_prev,$lpars);
       $managedname_prev = $managedname;
       $lpars = "";
       next;
     }
   }

   if ( ! $lpars eq '' ) {
     # do last load which is in $lpars
     print "023 Load data last : $managedname_prev $lpars\n" if $DEBUG == 2;
     load_rrd_lpar ($managedname_prev,$lpars);
   }

   # same for pools
   
   if ( $line =~ m/^POOL:/ ) {
     print "loading data   : $line\n";
     if ( $last_type =~ m/LPAR/ ) {
       # when switch to POOL then must be last saved lpars loaded
       if ( ! $managedname eq '' && ! $lpars eq '' ) {
         load_rrd_lpar ($managedname_prev,$lpars);
       }
     }

     $last_type="POOL";
     $lpar = pool_translate ($lpar,$managedname);
     if ( $lpar eq '' ) {
       # something wrong
       next;
     }
     if ( $lpar =~ m/pool/ ) {
       print "023 Load data pool : $managedname $lpar\n" if $DEBUG == 2;
       load_rrd_pool ($managedname,$lpar);
       $lpars = "";
       next;
     }
     else {
       # save name of server where are proc pools, just uniq names and load data afterwards
       my $found_srv = 0;
       foreach my $server_line (@server_proc_pool) {
         if ( $server_line =~ m/^$managedname$/ ) {
           $found_srv = 1;
           last;
         }
       }
       if ( $found_srv == 0 ) {
         $server_proc_pool[$server_proc] = $managedname;
         $server_proc++;
       }
     }
   }


  }
  
  if ( $last_type =~ m/LPAR/ && ! $managedname eq '' && ! $lpars eq '' ) {
    # it can go here only if no any pool is in alerting
    load_rrd_lpar ($managedname,$lpars);
  }

  # Load data from hmc of servers with proc pools
  foreach my $server_line (@server_proc_pool) {
    if ( $server_line eq '' ) {
      next;
    }
    load_rrd_pool ($server_line,"");
  }

  # rrdtool databases are now up to date, now go again throuh all directive and check utilization

  foreach $line (@lines_sort) {
   chomp ($line);
   if ( $line =~ m/^SWAP/ || $line =~ m/SWAP:/) {
     next; # swapping
   }

   if ( $line =~ m/^LPAR:/ || $line =~ m/^POOL:/ ) {
     $last_type = "LPAR";
     ($trash,$managedname,$lpar,$cpulim,$cpulimmin,$tint,$trepeat,$email) = split(/:/,$line);
     print "Working for    : $line\n";
     print "002 $managedname,$lpar,$cpulim,$cpulimmin,$tint,$trepeat,$email\n" if $DEBUG == 2;
     if ( $managedname eq '' ) {
       error ("server name is not provided : $line");
       next;
     }

     $lpar_name_org = $lpar; # it keeps original name instead SharedPool, poll etc, must be used for alering
     if ( $line =~ m/^POOL:/ ) {
       $last_type = "POOL";
       $lpar = pool_translate ($lpar,$managedname);
       if ( $lpar eq '' ) {
         # something wrong
         next;
       }
     }

     # get the latest used HMC
     $host = get_hmc ($managedname,$lpar.".rrm");
     if ( $host eq '' ) {
       # something wrong
       next;
     }

     $cpulim =~ s/ //g; 
     $cpulimmin =~ s/ //g; 
     $tint =~ s/ //g;
     $trepeat =~ s/ //g;
     $email =~ s/ //g;
     if ( $lpar eq '' ) {
       error ("lpar name is not provided : $line");
       next;
     }

     if ( $cpulim eq '' ) {
       error ("CPU limit MAX is not provided : $host:$managedname:$lpar : $line");
       next;
     }
     my $ret = isdigit($cpulim,"cpulim: $cpulim : $line");
     if ( $ret == 0 ) {
       next;  
     }

     if ( $cpulimmin eq '' ) {
       error ("CPU limit MIN is not provided : $host:$managedname:$lpar : $line");
       next;
     }
     $ret = isdigit($cpulimmin,"cpulimmin: $cpulimmin : $line");
     if ( $ret == 0 ) {
       next;  
     }

     if ( $tint eq '' ) {
       if ( $cpu_average_time_default eq '' ) {
	 error ("PEEK_TIME is not provided and default is not specified as well: $host:$managedname:$lpar : $line");
         next;
       }
       else {
         $tint=$cpu_average_time_default * 60; # in seconds
       }
     }
     else {
       $ret = isdigit($tint,"tint: $tint : $line");
       if ( $ret == 0 ) {
         next;  
       }
       $tint=$tint * 60; # in seconds
     }

     if ( $trepeat eq '' ) {
       if ( $repeat_default eq '' ) {
	 error ("REPEAT is not provided and default is not specified as well: $host:$managedname:$lpar : $line");
         next;
       }
       else {
         $trepeat=$repeat_default * 60; # in seconds
       }
     }
     else {
       $ret = isdigit($trepeat,"trepeat: $trepeat : $line");
       if ( $ret == 0 ) {
         next;  
       }
       $trepeat = $trepeat * 60; # in seconds
     }

     # there must not be email alerting
     if ( $email eq '' ) {
       if ( ! $email_default eq '' ) {
         $email=$email_default;
       }
     }

     if ( $line =~ m/^LPAR:/ ) {
       # LPARS
       $util = read_rrd ($host,$managedname,$lpar,$wrkdir,$tint);
       print "003 read_rrd: $managedname $lpar : $util : $cpulim $cpulimmin $tint $trepeat $email\n" if $DEBUG == 2;
       if ( $util == -1 ) {
         next;
       }
     }
     else {
       # POOLS
       $util = read_rrd_pool ($host,$managedname,$lpar,$wrkdir,$tint);
       print "004 read_rrd_pool: $managedname $lpar : $util : $cpulim $cpulimmin $tint $trepeat $email\n" if $DEBUG == 2;
       if ( $util == -1 ) {
         next;
       }
     }
    }
    else {
      next;
    }

   if ( "$util" eq '' ) {
     error ("no utilizaton has been found : $host:$managedname:$lpar");
     next;
   }

   my $alert_type=0;
   my $alert_type_text="";
   #my $lpar_translated = $lpar;
   #$lpar = $lpar_name_org; # return original name before alerting, it is a must for pools


   # Critical
   if ( $util > $cpulim || $util < $cpulimmin) {
    $alert_type=2;
    $alert_type_text="CPU Critical";
    print "005 CPU Critical $lpar_name_org : $util > $cpulim < $cpulimmin ? \n" if $DEBUG == 2;
   }
   else {
     # Warning 
     my $maxw = $cpulim/100*$cpu_warning;
     my $minw = $cpulimmin+$cpulimmin/100*(100-$cpu_warning);
     if ( $util > $maxw || $util < $minw ) {
      $alert_type=1;
      $cpulim = $maxw;
      $cpulimmin = $minw;
      $alert_type_text="CPU Warning ";
      print "005 CPU Warning  $lpar_name_org : $util > $maxw  < $minw ? \n" if $DEBUG == 2;
     }
   }

   if ($alert_type > 0) {
    print "006 CPU alert $lpar_name_org : $util\n" if $DEBUG == 2;

    # check whether to send alam or not (retention)
    my $send_alarm=1;
    foreach $line_rep (@lines_rep) {
      chomp ($line_rep);
      if ( $line_rep eq '' ) {
        next;
      }
      ($name_rep, $ltime_rep, $ltime_human) = split(/\|/,$line_rep);
      if ( "$name_rep" eq '' ) {
        next;
      }
      if ( "$name_rep" =~ "$host$managedname$lpar_name_org" ) {
        if ( $ltime_rep + $trepeat > $ltime ) {
          $send_alarm=0;
        }
        last;
      }
    }
    if ( $send_alarm == 0 ) {
      # do not send alarm
      print "025 $host:$managedname:$lpar_name_org : do not send alarm this time : $ltime_rep + $trepeat < $ltime \n"  if $DEBUG == 2;
      print "Alert not send : $alert_type_text $last_type:$host:$managedname:$lpar_name_org act:$util : $cpulimmin - $cpulim: not this time due to repeat time $ltime_rep + $trepeat < $ltime\n";
      next;
    }

    # update retention alerts
    open(FHW, ">> $alert_repeat") || error("could not open $alert_repeat : $!".__FILE__.":".__LINE__) && return 1;
    print FHW "$host$managedname$lpar_name_org|$ltime|$ltime_str\n";
    close (FHW);

    # print alarm to stdout
    print "099 $alert_type_text ALARM: $ltime_str: $last_type:$host:$managedname:$lpar_name_org, actual util:$util, limit max-min:$cpulim - $cpulimmin\n" if $DEBUG == 2;
    print "Alert logged   : $alert_type_text ALARM: $ltime_str: $last_type:$host:$managedname:$lpar_name_org, actual util:$util, limit max-min:$cpulim - $cpulimmin\n";

    # log an alarm to a file : alert.log
    open(FHL, ">> $alert_history") || error("could not open $alert_history: $!".__FILE__.":".__LINE__) && return 1;
    print FHL "$ltime_str: $alert_type_text $last_type:$host:$managedname:$lpar_name_org, actual util:$util, limit max-min:$cpulim - $cpulimmin\n";
    close (FHL);

    # mail alarm   
    if ( ! $email eq '' ) {
      send_mail ($email,$host,$managedname,$lpar_name_org,$util,$cpulim,$cpulimmin,$ltime_str,$email_default,$last_type,$alert_type_text,$email_graph,$line,$lpar,$tint);
    }

    # nagios alarm
    if ( $nagios == 1 ) {
      nagios_alarm($host,$managedname,$lpar_name_org,$util,$cpulim,$cpulimmin,$ltime_str,$last_type,$alert_type_text);
    }

    # extern alert 
    if ( ! $extern_alert eq '' ) {
      extern_alarm($host,$managedname,$lpar_name_org,$util,$cpulim,$cpulimmin,$ltime_str,$last_type,$alert_type_text,$extern_alert);
    }
   }
   else {
     print "No alerting    :$alert_type_text $last_type:$host:$managedname:$lpar_name_org act utilization:$util\n";
   }
  }


  # clean out alert repeat
  my @lines_rep_new = "";
  my $counter = 0;
  if ( -f $alert_repeat ) {
    # read alert file with retentin alerts into an array
    open(FHR, "< $alert_repeat");
    @lines_rep = sort(<FHR>);
    close (FHR);
    my $name_rep_prev = "";
    my $ltime_rep_prev = "";
    my $ltime_human_prev = "";
    foreach $line_rep (@lines_rep) {
      chomp ($line_rep);
      ($name_rep, $ltime_rep, $ltime_human) = split(/\|/,$line_rep);
      if ( $name_rep_prev eq '' ) {
        $name_rep_prev = $name_rep;
        $ltime_rep_prev = $ltime_rep;
        $ltime_human_prev = $ltime_human;
        next;
      }
      if ( "$name_rep" =~ "$name_rep_prev" ) {
        $name_rep_prev = $name_rep;
        $ltime_rep_prev = $ltime_rep;
        $ltime_human_prev = $ltime_human;
      }
      else {
        $lines_rep_new[$counter] = "$name_rep_prev|$ltime_rep_prev|$ltime_human_prev";
        $counter++;
        $name_rep_prev = $name_rep;
        $ltime_rep_prev = $ltime_rep;
        $ltime_human_prev = $ltime_human;
      }  
    }
    if ( "$name_rep" =~ "$name_rep_prev" ) {
      if ( ! $name_rep eq '' ) {
        $lines_rep_new[$counter] = "$name_rep|$ltime_rep|$ltime_human";
        $counter++;
      }
    }
    else {
      $lines_rep_new[$counter] = "$name_rep_prev|$ltime_rep_prev|$ltime_human_prev";
      $counter++;
      $lines_rep_new[$counter] = "$name_rep|$ltime_rep|$ltime_human";
      $counter++;
    }

    open(FHW, "> $alert_repeat");
    foreach $line_rep (@lines_rep_new) {
      print FHW "$line_rep\n";
      print "007 alert_repeat: $line_rep\n" if $DEBUG == 2;
    }
    close (FHW);
  }

  return 0
}

sub read_rrd
{
  my $host = shift;
  my $managedname = shift;
  my $lpar = shift;
  my $wrkdir = shift;
  my $tint = shift;
  my $rrd = "$wrkdir/$managedname/$host/$lpar.rrm";
  my $answ_out = "";


  if ( ! -f $rrd ) {
    error ("lpar has not been found: $rrd : $host:$managedname:$lpar");
    return -1;
  }
  #print "--03 $time_diff \n";
  RRDp::cmd qq(graph "$tmpdir/name.png"
    "--start" "end-$tint-$time_diff"
    "DEF:cur=$rrd:curr_proc_units:AVERAGE"
    "DEF:ent=$rrd:entitled_cycles:AVERAGE"
    "DEF:cap=$rrd:capped_cycles:AVERAGE"
    "DEF:uncap=$rrd:uncapped_cycles:AVERAGE"
    "CDEF:tot=cap,uncap,+"
    "CDEF:util=tot,ent,/"
    "CDEF:utiltot=util,cur,*"
    "PRINT:utiltot:AVERAGE: %3.3lf"
  );
  my $answer = RRDp::read;
  #print "$$answer\n";
  print "008 read_rrd:answer: $rrd:\n $$answer\n" if $DEBUG == 2;
  # parse graph output, at the second line is avrg CPU load for TOP10 page
  my $once = 0;
  foreach my $answ (split(/ /,$$answer)) {
    if ( $once == 1 ) {
      $answ =~ s/ //g;
      my $ret = substr($answ,0,1);
      if ($ret =~ /\D/) {
        next;
      }
      else {
        chomp($answ);
        $answ_out = $answ;
      }
    }
    else {
      if ( $answ =~ "ERROR" ) {
        error ("Graph rrdtool error : $answ");
        if ( $answ =~ "is not an RRD file" ) {
          (my $err,  my $file, my $txt) = split(/'/,$answ);
	  error ("Removing as it seems to be corrupted: $file");
          unlink("$file") || error("Cannot rm $file : $!".__FILE__.":".__LINE__) && return 1;
        }
        else {
          print "027 Graph rrdtool error : $answ" if $DEBUG == 2;
        }
      }
    }
    $once++;
  }

  #print "----- $answ_out ---- $lpar|$managedname|$host|$HMC\n";
  print "009 read_rrd:parsed: $answ_out ---- $lpar|$managedname|$host|$HMC\n" if $DEBUG == 2;
  if ( $answ_out eq '' ) {
    RRDp::cmd qq(last "$rrd" );
    my $last_rec_raw = RRDp::read;
    chomp ($$last_rec_raw);
    my $last_rec=localtime($$last_rec_raw);
    error ("no CPU data has been found: $host:$managedname:$lpar, last data timestamp : $last_rec");
    return -1;
  }
  return $answ_out;
}

sub nagios_alarm
{
  my $host = shift;
  my $managed = shift;
  my $lpar = shift;
  my $util = shift;
  my $utillim = shift;
  my $utillimmin = shift;
  my $ltime_str = shift;
  my $last_type = shift;
  my $alert_type_text = shift;

  print "Alert nagios   : $last_type=$lpar:$managed:$lpar utilization=$util\n";

  if (! -d "$nagios_dir" ) {
    print "mkdir          : $nagios_dir\n" if $DEBUG ;
    mkdir("$nagios_dir", 0755) || error("Cannot mkdir $nagios_dir: $!".__FILE__.":".__LINE__) && return 1;
    chmod 0777, "$nagios_dir"  || error("Can't chmod 666 $nagios_dir: $!".__FILE__.":".__LINE__) && return 1;
  }

  if (! -d "$nagios_dir/$managed" ) {
    print "mkdir          : $nagios_dir/$managed\n" if $DEBUG ;
    mkdir("$nagios_dir/$managed", 0755) || error("Cannot mkdir $nagios_dir/$managed: $!".__FILE__.":".__LINE__) && return 1;
    chmod 0777, "$nagios_dir/$managed"  || error("Can't chmod 666 $nagios_dir/$managed: $!".__FILE__.":".__LINE__) && return 1;
  }

  open(FH, "> $nagios_dir/$managed/$last_type-$lpar") || error("Can't create $nagios_dir/$managed/$last_type-$lpar : $!".__FILE__.":".__LINE__) && return 1;

  if ( $alert_type_text =~ m/Swapping/ ) {
    print FH "$alert_type_text alert for: $last_type=$lpar server=$managed; $util, MAX limit=$utillim\n";
  }
  else {
    print FH "$alert_type_text alert for: $managed $last_type=$lpar server=$managed managed by = $host; utilization=$util, MAX limit=$utillim, MIN limit=$utillimmin\n";
  }

  close (FH);

  chmod 0666, "$nagios_dir/$managed/$last_type-$lpar" || error("Can't chmod 666 $nagios_dir/$managed/$last_type-$lpar : $!".__FILE__.":".__LINE__) && return 1;

  return 1;
}

sub send_mail 
{
  my $to=shift;
  my $host = shift;
  my $managed = shift;
  my $lpar = shift;
  my $util = shift;
  my $utillim = shift;
  my $utillimmin = shift;
  my $ltime_str = shift;
  my $email_default = shift;
  my $last_type = shift;
  my $alert_type_text = shift;
  my $email_graph = shift;
  my $line = shift;
  my $lpar_translated = shift;
  my $tint = shift;
  my $emails_counter = 0;

  $tint = $tint / 60;

  #print "010 send_mail: $to,$host,$managed,$lpar,$util,$utillim,$utillimmin,$ltime_str,$email_default,$emails_counter \n" if $DEBUG == 2;
  if ( $to eq '' ) {
    $to = $email_default;
  }
  else {
    if ( $to =~ m/^EMAIL_/ ) {
      foreach my $line (@emails_name) {
        #chomp ($line);
        if ( $line =~ m/^$to/ && length($line) == length($to) ) {
          $to=$emails_addr[$emails_counter];
        }
        $emails_counter++;
      }
    }
    else {
      if ( $to =~ m/^EMAIL/ ) {
        $to = $email_default;
      }
    }
  }

  if ( $to eq '' ) {
    error ("email isn not set for this alert: $host:$managed:$lpar");
    # is that realy error?? what about Nagios alerting?
    return -1;
  }

  my $graph_path = "$tmpdir/alert_graph_$host-$managed-$lpar_translated.png";
  if ( $email_graph > 0 ) {
    $graph_path  =~ s/;//g; # ";" cannot be in the path
    create_graph ($host,$managed,$lpar_translated,$graph_path,$basedir,$bindir,$line,$email_graph);
  }

  if ( $alert_type_text =~ m/Swapping/ ) {
    sendmail ($to,"$ltime_str: $alert_type_text alert for:\n LPAR: $lpar\n server: $managed\n swapping for last $tint mins: \n   $util\n\n",$lpar,$util,$last_type,$alert_type_text,$managed,$graph_path,$email_graph);
  }
  else {
    sendmail ($to,"$ltime_str: $alert_type_text alert for:\n $last_type: $lpar\n server: $managed\n managed by: $host\n avg utilization during last $tint mins: $util\n \($alert_type_text MAX limit: $utillim\n $alert_type_text MIN limit: $utillimmin\)\n\n",$lpar,$util,$last_type,$alert_type_text,$managed,$graph_path,$email_graph);
  }


  return 1;
}

sub load_data_lpar
{
  my $managedname = shift;
  my $host = shift;
  my $wrkdir = shift;
  my $type_sam = shift;
  my $act_time = shift;
  my $lpars = shift;
  my $HMC = shift;
  my $IVM = shift;
  my $SDMC = shift;
  my $last_file = shift;
  my $loadmins = 0;
  my $MAX_ROWS = 10000;
  my $MAX_ROWS_WORKAROUND = 100000; # some HMCs have a problem with lslparutil -s d -r lpar/sys -h XY, solution is ...
  my $restrict_rows = " -n $MAX_ROWS"; # workaround for HMC < 7.2.3 to do not exhaust memory

  if ( $lpars eq '' && $host eq '' && $managedname eq '') {
    print "No LPAR directive has been found, continuing with POOLs\n";
    return 1;
  }

  if ( $lpars eq '' ) {
    error ("$host:$managedname - not defined lpars for data load, continuing with the others");
    return 1;
  }


  # _shell variables for usage in shell cmd lines, must be to avoid a roblem with spaces in managed names

  $input = "$wrkdir/$managedname/$host/in-alrt";
  $input_shell = $input;
  $input_shell =~ s/ /\\ /g;

  # here must be local time on HMC, need Unix time and date in text to have complete time
  my $date = `$SSH $hmc_user\@$host "export LANG=en_US; date \'+%m/%d/%Y %H:%M:%S\'"`;
  chomp($date);
  my $t=str2time($date); # ignore date +%s on purpose!!!
  my $local_time=time();
  # must be here as global variable to pass it to rrd graph creation
  # it must cope with different time on the HMC to get last 10minutes or so
  $time_diff=$local_time-$t;

  my $last_rec = get_last_time ($host,$managedname,$type_sam,"LPAR");
  $loadmins  = sprintf ("%.0f", ($t - $last_rec)/60+5); # +5mins to be sure
  (my $sec,my $ivmmin,my $ivmh,my $ivmd,my $ivmm,my $ivmy,my $wday,my $yday,my $isdst) = localtime($last_rec);
  $ivmy += 1900;
  $ivmm += 1;
  print "last rec IVM   : $host:$managedname $ivmm/$ivmd/$ivmy $ivmh:$ivmmin\n" if $DEBUG ;


  my $timerange = " --minutes ".$loadmins." ";
  my $loadsecs = $loadmins * 60;
  my $hmc_start_utime = $t - $loadsecs;

  # Load lpar data
  print "fetching HMC   : $host:$managedname lpar data\n" if $DEBUG ;

	  if ( $HMC == 1 ){
	    #
	    # here is the workaround for HMC < 7.2.3 for the problem with exhasting the memory during lslparutil
	    #
	    my $rowCount = $MAX_ROWS;    
	    my $rowTotal = 0;    
            my $mins = 0;
            my $line = "";
            my $repeat = 0;
            while ( $rowCount == $MAX_ROWS ) { 
	      $repeat++;
              if ($rowTotal == 0) {
                 #print "--- $timerange  : $restrict_rows\n" if $DEBUG ;
                `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s s -r lpar $timerange $restrict_rows -m \\"$managedname\\" -F time,lpar_name,curr_proc_units,curr_procs,curr_sharing_mode,entitled_cycles,capped_cycles,uncapped_cycles,shared_cycles_while_active$mem_params --filter \"event_types=sample\"" > $input_shell-$type_sam` ;
              }
	      else {
                (my $time_end, my $lpar, my $curr_proc_units, my $curr_procs, my $curr_sharing_mode, my $entitled_cycles,
                   my $capped_cycles, my $uncapped_cycles, my $shared_cycles_while_active) = split(/,/,$line);
	        my $unixt = str2time($time_end);

                #print "--- $unixt - $rowCount : $line \n" if $DEBUG ;
	        (my $sec,my $hmcmin,my $hmch,my $hmcd,my $hmcm,my $hmcy,my $wday,my $yday,my $isdst) = localtime($unixt);
    		$hmcy += 1900;
    		$hmcm++; # month + 1, it starts from 0 in unix

                if ( $unixt < $hmc_start_utime ) {
                  print "end time reach : $host:$managedname $hmcy-$hmcm-$hmcd $hmch:$hmcmin(to be downloaded) - $time_end(downloaded): $unixt < $hmc_start_utime\n";
                  last; #already Rdownloaded required time range 
                }

                print "fetching HMC   : $host:$managedname lpar data : next $MAX_ROWS : $hmcy-$hmcm-$hmcd $hmch:$hmcmin - $time_end\n" if $DEBUG ;
                `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s s -r lpar $restrict_rows --endyear $hmcy --endmonth $hmcm --endday $hmcd --endhour $hmch --endminute $hmcmin -m \\"$managedname\\" -F time,lpar_name,curr_proc_units,curr_procs,curr_sharing_mode,entitled_cycles,capped_cycles,uncapped_cycles,shared_cycles_while_active$mem_params --filter \"event_types=sample\"" >> $input_shell-$type_sam` ;
	      }
              open(FH, "< $input-$type_sam") || error("Can't open $input-$type_sam : $!".__FILE__.":".__LINE__) && return 1;
	      $rowCount=0;    
              while (my $l = <FH>) {
		chomp($l);
                $rowCount++;
                $line = $l;
	      }
	      close(FH);
	      $rowTotal = $rowCount;
	      $rowCount = $rowCount / $repeat;
	    }
            print "fetched        : $host:$managedname $rowTotal rows\n" if $DEBUG ;
	  }
	  if ( $IVM == 1 ){
            `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r lpar --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin -m \\"$managedname\\" -F time,lpar_id,curr_proc_units,curr_procs,curr_sharing_mode,entitled_cycles,capped_cycles,uncapped_cycles,donated_cycles$mem_params --filter \\\\\\"lpar_names=$lpars\\\\\\"" > $input_shell-$type_sam` ;
	  }
	  if ( $SDMC == 1 ){
	     LoadDataModule::sdmc_lpar_load ($SSH,$hmc_user,$host,$ivmy,$ivmm,$ivmd,$ivmh,$ivmmin,$managedname,"$input_shell-$type_sam",$type_sam,0,$lpars,$mem_params);
	     # first 0 means that t is called from alerting --> HMC data input file must have "alert" suffix"
	  }

  return 0;
}

sub load_pool_data 
{
  my $managedname = shift;
  my $host = shift;
  my $wrkdir = shift;
  my $type_sam = shift;
  my $act_time = shift;
  my $lpars = shift;
  my $HMC = shift;
  my $IVM = shift;
  my $SDMC = shift;
  my $last_file = shift;
  my $loadhours = 0;
  my $loadmins = 0;
  my $MAX_ROWS = 10000;
  my $MAX_ROWS_WORKAROUND = 100000; # some HMCs have a problem with lslparutil -s d -r lpar/sys -h XY, solution is ...
  my $restrict_rows = " -n $MAX_ROWS"; # workaround for HMC < 7.2.3 to do not exhaust memory

  # _shell variables for usage in shell cmd lines, must be to avoid a roblem with spaces in managed names
  my $input_pool = "$wrkdir/$managedname/$host/pool.in-alrt";
  my $input_pool_sh = "$wrkdir/$managedname/$host/pool_sh.in-alrt";
  my $input_shell = $input;
  my $input_pool_shell = $input_pool;
  my $input_pool_sh_shell = $input_pool_sh;
  $input_shell =~ s/ /\\ /g;
  $input_pool_shell =~ s/ /\\ /g;
  $input_pool_sh_shell =~ s/ /\\ /g;


  # here must be local time on HMC, need Unix time and date in text to have complete time
  my $date = `$SSH $hmc_user\@$host "export LANG=en_US; date \'+%m/%d/%Y %H:%M:%S\'"`;
  chomp($date);
  my $t=str2time($date); # ignore date +%s on purpose!!!
  my $local_time=time();
  # must be here as global variable to pass it to rrd graph creation
  # it must cope with different time on the HMC to get last 10minutes or so
  $time_diff=$local_time-$t;

  my $last_rec = 0;
  if ( $lpars =~ m/^pool$/ ) {
    $last_rec = get_last_time ($host,$managedname,$type_sam,"POOL");
  }
  else {
    $last_rec = get_last_time ($host,$managedname,$type_sam,"POOLSH");
  }
  $loadmins  = sprintf ("%.0f", ($t - $last_rec)/60+5); # +5mins to be sure
  (my $sec,my $ivmmin,my $ivmh,my $ivmd,my $ivmm,my $ivmy,my $wday,my $yday,my $isdst) = localtime($last_rec);
  $ivmy += 1900;
  $ivmm += 1;

  my $timerange = " --minutes ".$loadmins." ";
  
  # Load CPU pool data
  print "fetching HMC   : $host:$managedname pool data\n" if $DEBUG ;

      if ($step == 3600) {
 	if ($loadhours >= 1){
	  if ( $HMC == 1 ){
            if ( $lpars =~ m/^pool$/ ) {
              `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s $type_sam -r pool  -h $loadhours $restrict_rows  -m \\"$managedname\\" -F time,total_pool_cycles,utilized_pool_cycles,configurable_pool_proc_units,borrowed_pool_proc_units  --filter \"event_types=sample\"" > $input_pool_shell-$type_sam` ;
            }
            else {
              print "fetching HMC   : $host:$managedname shared pool data\n" if $DEBUG ;
              `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s $type_sam -r procpool  -h $loadhours $restrict_rows -m \\"$managedname\\" -F time,shared_proc_pool_id,total_pool_cycles,utilized_pool_cycles  --filter \"event_types=sample\"" > $input_pool_sh_shell-$type_sam` ;
            }
	  }
	  if ( $IVM == 1 ){
            `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r pool --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,total_pool_cycles,utilized_pool_cycles,configurable_pool_proc_units,borrowed_pool_proc_units" > $input_pool_shell-$type_sam` ;
	  }
	  if ( $SDMC == 1 ){
            if ( $lpars =~ m/^pool$/ ) {
	      LoadDataModule::sdmc_pool_load ($SSH,$hmc_user,$host,$ivmy,$ivmm,$ivmd,$ivmh,$ivmmin,$managedname,"$input_pool_shell-$type_sam",$type_sam);
            }
            else {
              print "fetching HMC   : $host:$managedname shared pool data\n" if $DEBUG ;
	      LoadDataModule::sdmc_procpool_load ($SSH,$hmc_user,$host,$ivmy,$ivmm,$ivmd,$ivmh,$ivmmin,$managedname,"$input_pool_sh_shell-$type_sam",$type_sam);
            }
	  }
	}
      }
      else {
	  if ( $HMC == 1 ){
            if ( $lpars =~ m/^pool$/ ) {
            `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s s -r pool $timerange $restrict_rows -m \\"$managedname\\" -F time,total_pool_cycles,utilized_pool_cycles,configurable_pool_proc_units,borrowed_pool_proc_units  --filter \"event_types=sample\"" > $input_pool_shell-$type_sam` ;
            }
            else {
             print "fetching HMC   : $host:$managedname shared pool data\n" if $DEBUG ;
            `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -s s -r procpool $timerange $restrict_rows -m \\"$managedname\\" -F time,shared_proc_pool_id,total_pool_cycles,utilized_pool_cycles  --filter \"event_types=sample\"" > $input_pool_sh_shell-$type_sam` ;
            }
	  }
	  if ( $IVM == 1 ){
            `$SSH $hmc_user\@$host "export LANG=en_US; lslparutil -r pool --startyear $ivmy --startmonth $ivmm --startday $ivmd --starthour $ivmh --startminute $ivmmin  -m \\"$managedname\\" -F time,total_pool_cycles,utilized_pool_cycles,configurable_pool_proc_units,borrowed_pool_proc_units" > $input_pool_shell-$type_sam` ;
	  }
	  if ( $SDMC == 1 ){
            if ( $lpars =~ m/^pool$/ ) {
	      LoadDataModule::sdmc_pool_load ($SSH,$hmc_user,$host,$ivmy,$ivmm,$ivmd,$ivmh,$ivmmin,$managedname,"$input_pool_shell-$type_sam",$type_sam,0);
            }
            else {
              print "fetching HMC   : $host:$managedname shared pool data\n" if $DEBUG ;
	      LoadDataModule::sdmc_procpool_load ($SSH,$hmc_user,$host,$ivmy,$ivmm,$ivmd,$ivmh,$ivmmin,$managedname,"$input_pool_sh_shell-$type_sam",$type_sam,0);
            }
	  }
      }

  return 0;
}

# error handling
sub error
{
  my $text = shift;
  my $act_time = localtime();
  chomp ($text);

  print "ERROR          : $text : $!\n";
  print STDERR "$act_time: $text\n";

  return 1;
}

sub get_last_time 
{
   my $host = shift;
   my $managedname = shift;
   my $type_sam = shift;
   my $lpar_pool = shift;
   my $last_rec = "";
   my $last_rec_file = "";
   my $last_rec_human = "";

   # read timestamp of last record 
   # at first try last-alrt-lpar.txt
   if ( -f "$wrkdir/$managedname/$host/$last_file-$lpar_pool" ) {
     open(FHLT, "< $wrkdir/$managedname/$host/$last_file-$lpar_pool") || error("Can't open $wrkdir/$managedname/$host/$last_file-$lpar_pool $! ".__FILE__.":".__LINE__) && return 1;
     foreach my $line (<FHLT>) {
       chomp ($line);
       $last_rec_human = $line;
       $last_rec_file=str2time($line);
     }
     close(FHLT);
     my $ret = substr($last_rec_file,0,1);
     if ( $ret eq '' || $ret =~ /\D/) {  
       error ("Wrong input data, file : $wrkdir/$managedname/$host/$last_file-$lpar_pool : $last_rec_file");
       unlink ("$wrkdir/$managedname/$host/$last_file-$lpar_pool");
     }
     else {
       print "050 last_rec: $last_rec_file , $wrkdir/$managedname/$host/$last_file-$lpar_pool \n" if $DEBUG == 2;
       print "last rec       : $host:$managedname $last_rec_human $wrkdir/$managedname/$host/$last_file-$lpar_pool\n";
       return $last_rec_file;
     }
   }

   # now try last.txt 
   if ( -f "$wrkdir/$managedname/$host/$last_file_default" ) {
     open(FHLT, "< $wrkdir/$managedname/$host/$last_file_default") || error ("Can't open $wrkdir/$managedname/$host/$last_file_default: $! ".__FILE__.":".__LINE__) && return 1;
     foreach my $line (<FHLT>) {
       chomp ($line);
       $last_rec_human = $line;
       $last_rec_file=str2time($line);
     }
     close(FHLT);
     my $ret = substr($last_rec_file,0,1);
     if ( $ret eq '' || $ret =~ /\D/) {  
       error ("Wrong input data, file : $wrkdir/$managedname/$host/$last_file_default : $last_rec_file");
       unlink ("$wrkdir/$managedname/$host/$last_file_default");
     }
     else {
       print "last rec       : $host:$managedname $last_rec_human $wrkdir/$managedname/$host/$last_file_default\n";
       print "051 last_rec: $last_rec_file , $wrkdir/$managedname/$host/$last_file_default\n" if $DEBUG == 2;
       return $last_rec_file;
     }
   }
     
   # old not accurate way how to get last time stamp, keeping it here as backup if above temp fails for any reason
   if ( -f "$wrkdir/$managedname/$host/mem.rr$type_sam" ) {
     # find out last record in the db (hourly)
     my $last_rec_raw = 0;
     eval {
       RRDp::cmd qq(last "$wrkdir/$managedname/$host/mem.rr$type_sam" );
       $last_rec_raw = RRDp::read;
       chomp ($$last_rec_raw);
     };
     if ($@) {
       error($@.__FILE__.":".__LINE__);
       return -1;
     }

     if ( $$last_rec_raw < 0 ) { # Do not know why, but it sometimes happens!!!
       if ( -f "$wrkdir/$managedname/$host/pool.rr$type_sam" ) {
         # find out last record in the db (hourly)
         RRDp::cmd qq(last "$wrkdir/$managedname/$host/pool.rr$type_sam" );
         my $last_rec_raw = RRDp::read;
         chomp ($$last_rec_raw);
         return $$last_rec_raw;
       }
     }
     else {
       print "052 last_rec: $$last_rec_raw \n" if $DEBUG == 2;
       print "last rec       : $host:$managedname $$last_rec_raw $wrkdir/$managedname/$host/mem.rr$type_sam   \n";
       return $$last_rec_raw;
     }
   }

   return -1;
}

sub sendmail
{
  my $mailto = shift;
  my $text = shift;
  my $lpar = shift;
  my $util = shift;
  my $last_type = shift;
  my $alert_type_text = shift;
  my $managed = shift;
  my $graph_path = shift;
  my $email_graph = shift;
  my $mailfrom = "lpar2rrd";
  my $mailprog = "/usr/sbin/sendmail";
  my $subject = "LPAR2RRD: $alert_type_text alert for $managed $last_type: $lpar, utilization is: $util";
  my $message = "\n";

  $lpar =~ s/\&\&1/\//g;

  if ( $alert_type_text =~ m/Swapping/ ) {
    # for swapping
    $subject = "LPAR2RRD: $alert_type_text alert for $managed $last_type: $lpar : $util";
  }

  print "Alert emailing : $alert_type_text $last_type: $subject $mailto\n";

  if (open MAIL, "|$mailprog -t") {
     print MAIL "To: $mailto\n" ;
     print MAIL "From: $mailfrom\n" ;
     print MAIL "Reply-To: $mailfrom\n" ;
     print MAIL "X-Mailer: lpar2rrd 1.0\n" ;
     print MAIL "Subject: $subject\n\n" ;
     print MAIL $text ;
     print MAIL $message ;
     print MAIL "\n\n";
     if ( $email_graph > 0 && -f $graph_path ) {
       open(PNG, "uuencode $graph_path $managed:$lpar.png |");
       binmode(PNG);
       while (read(PNG,$b,4096)) {
         print MAIL "$b";
       }
       close(PNG);
       unlink ($graph_path);
     }
     close(MAIL);
  }
  return 0;
}

sub read_rrd_pool
{
  my $host = shift;
  my $managedname = shift;
  my $lpar = shift;
  my $wrkdir = shift;
  my $tint = shift;
  my $rrd = "$wrkdir/$managedname/$host/$lpar.rrm";
  my $answ_out = "";

  print "040 read_rrd_pool: $host $managedname $lpar $tint\n" if $DEBUG == 2;

  if ( ! -f $rrd ) {
    error ("lpar has not been found: $rrd : $host:$managedname:$lpar");
    return -1;
  }

  if ( $lpar =~ m/pool/ ) {
    RRDp::cmd qq(graph "$tmpdir/name.png"
    "--start" "end-$tint-$time_diff"
    "DEF:totcyc=$rrd:total_pool_cycles:AVERAGE"
    "DEF:uticyc=$rrd:utilized_pool_cyc:AVERAGE"
    "DEF:cpu=$rrd:conf_proc_units:AVERAGE"
    "DEF:cpubor=$rrd:bor_proc_units:AVERAGE"
    "CDEF:totcpu=cpu,cpubor,+"
    "CDEF:cpuutil=uticyc,totcyc,/"
    "CDEF:cpuutiltot=cpuutil,totcpu,*"
    "PRINT:cpuutiltot:AVERAGE: %3.3lf"
    );
  }
  else { 
    RRDp::cmd qq(graph "$tmpdir/name.png"
    "--start" "end-$tint-$time_diff"
    "DEF:max=$rrd:max_pool_units:AVERAGE"
    "DEF:res=$rrd:res_pool_units:AVERAGE"
    "DEF:totcyc=$rrd:total_pool_cycles:AVERAGE"
    "DEF:uticyc=$rrd:utilized_pool_cyc:AVERAGE"
    "CDEF:max1=max,res,-"
    "CDEF:cpuutil=uticyc,totcyc,/"
    "CDEF:cpuutiltot=cpuutil,max,*"
    "PRINT:cpuutiltot:AVERAGE: %3.3lf"
    );
  }

  my $answer = RRDp::read;
  print "008 read_rrd:answer: $rrd:\n $$answer\n" if $DEBUG == 2;
  my $once = 0;
  foreach my $answ (split(/ /,$$answer)) {
    if ( $once == 1 ) {
      $answ =~ s/ //g;
      my $ret = substr($answ,0,1);
      if ($ret =~ /\D/) {
        next;
      }
      else {
        chomp($answ);
        $answ_out = $answ;
      }
    }
    else {
      if ( $answ =~ "ERROR" ) {
        error ("Graph rrdtool error : $answ");
        if ( $answ =~ "is not an RRD file" ) {
          (my $err,  my $file, my $txt) = split(/'/,$answ);
	  error ("Removing as it seems to be corrupted: $file");
          #unlink("$file") || error("Cannot rm $file : $! ".__FILE__.":".__LINE__) && return 1;
        }
        else {
          print "027 Graph rrdtool error : $answ" if $DEBUG == 2;
        }
      }
    }
    $once++;
  }

  print "009 read_rrd:parsed: $answ_out ---- $lpar|$managedname|$host|$HMC\n" if $DEBUG == 2;
  if ( $answ_out eq '' ) {
    RRDp::cmd qq(last "$rrd" );
    my $last_rec_raw = RRDp::read;
    chomp ($$last_rec_raw);
    my $last_rec=localtime($$last_rec_raw);
    error ("no CPU data has been found: $host:$managedname:$lpar, last data timestamp : $last_rec");
    return -1;
  }
  return $answ_out;
}


sub load_rrd_lpar
{
  my $managedname = shift;
  my $lpars = shift;

  # get the latest used HMC
  $host = get_hmc ($managedname,"in-m");
  if ( $host eq '' ) {
    # something wrong
    return 1;
  }

  print "022 Load data      : $host $managedname $lpars\n" if $DEBUG == 2;
  if ( -f "$wrkdir/$managedname/$host/SDMC" ) {
      $SDMC=1;
      $HMC =0;
      $IVM =0;
  }
  else {
    $SDMC=0;
    if ( -f "$wrkdir/$managedname/$host/IVM" ) {
      $IVM=1;
      $HMC=0;
    }
    else {
      $HMC=1;
      $IVM=0;
    }
  }

  if ( $SDMC == 0 && $IVM == 0 ) {
    $HMC=1;
    my $hmcv = `$SSH $hmc_user\@$host "lshmc -v" 2>/dev/null|grep RM| tr -d \'[:alpha:]\'|tr -d \'[:punct:]\'`
 ;
    $hmcv =~ s/ //g;
    $hmcv_num = substr($hmcv,0,3);
    #print "DEBUG : $hmcv_num $hmcv\n";
    #print OUT "HMC version    : $hmcv" if $DEBUG ;
    if ( $hmcv_num > 734 || $hmcv_num < 600 ) {
      #$hmcv_num < 6 for PureFlex, not exact but should be ok  (actually it is in 1.2.0 version: Mar 2013)
      # set params for lslparutil and AMS available from HMC V7R3.4.0 Service Pack 2 (05-21-2009)
       $mem_params = ",mem_mode,curr_mem,phys_run_mem,curr_io_entitled_mem,mapped_io_entitled_mem,mem_overage_cooperation";
    }
    else {
      print "HMC version    : $host $hmcv $hmcv_num - no AMS ready : $HMC - $SDMC\n" if $DEBUG ;
    }
  }
  else {
    $mem_params = ",mem_mode,curr_mem,phys_run_mem,curr_io_entitled_mem,mapped_io_entitled_mem,mem_overage_cooperation";
  }
  print "023 Load data      : $host $managedname $lpars\n" if $DEBUG == 2;

  my $return = load_data_lpar($managedname,$host,$wrkdir,$type_sam,$ltime_str,$lpars,$HMC,$IVM,$SDMC,$last_file."-LPAR");
  print "014 load_data_lpar:return: $return\n" if $DEBUG == 2;
  if ( $return == 1 ) {
    # something wrong
    return 1;
  }

  print "014 LoadDataModule::load_data ($managedname,$host,$wrkdir,$input,$type_sam,$ltime_str,$HMC,$IVM,$SDMC,\n      $step,-,$last_file-LPAR,$no_time)\n" if $DEBUG == 2;

  if ( -f "$wrkdir/$managedname/$host/lpar_trans.txt" ) {
    # IVM/SDMC translation ids to names
    open (FHR,"< $wrkdir/$managedname/$host/lpar_trans.txt");
    my $idx = 0;
    foreach my $line_trans (<FHR>) {
      chomp($line_trans);
      $lpar_trans[$idx]=$line_trans;
      $idx++;
    }
    close (FHR);
  }

  print "017 LoadDataModule::load_data lpar_trans[0]: $lpar_trans[0]\n" if $DEBUG == 2;
  LoadDataModule::load_data ($managedname,$host,$wrkdir,$input,$type_sam,$ltime_str,$HMC,$IVM,$SDMC,$step,$DEBUG,\@lpar_trans,$last_file."-LPAR",$no_time,$SSH,$hmc_user);
;
  return 0;
}

sub pool_translate
{
  my $lpar = shift;
  my $managedname = shift;

  # pool name translation
  if ( $lpar =~ m/all_pools/ ) {
    $lpar = "pool";
  }
  else  {
    # open pool mapping file
    my @map = "";
    my $managedname_space = $managedname;
    if ( $managedname =~ m/ / ) { # workaround for server name with a space inside, nothing else works, grrr
      $managedname_space = "\"".$managedname."\"";
    }

    foreach my $map_file (<$wrkdir/$managedname_space/*/cpu-pools-mapping.txt>) {
      open (FHP,"< $map_file");
      @map = <FHP>;
      close (FHP);
      last;
    }

    my $found=0;
    foreach my $line_map (@map) {
      chomp ($line_map);
      if ( $line_map !~ m/^[0-9].*,/ ) {
        #something wrong , ignoring
        next;
      }
      (my $pool_indx_new, my $pool_name_new) = split(/,/,$line_map);
      if ($pool_name_new =~ m/^$lpar$/ ) {
        $lpar = "SharedPool$pool_indx_new";
        $found++;
        last;
      }
    }
    if ($found == 0 ) {
      print "alert error    :  could not found name for shared pool : $managedname:$lpar\n";
      error ("alert  : could not found name for shared pool : $managedname:$lpar");
      return "";
    }
  }
  print "029 pool name found: $lpar\n" if $DEBUG == 2;
  return $lpar;
}

sub get_hmc
{
  my $managedname = shift;
  my $file = shift;
  my $host = "";

  # get the latest used HMC
  my $host_allp = "";
  my $atime = 0;

  my $managedname_space = $managedname;
  if ( $managedname =~ m/ / ) { # workaround for server name with a space inside, nothing else works, grrr
    $managedname_space = "\"".$managedname."\"";
  }

  foreach my $line_host (<$wrkdir/$managedname_space/*>) {
   if ( -d $line_host && -f "$line_host/$file" ) {
     my $atime_act = (stat("$line_host/$file"))[9];
     if ($atime_act > $atime) {
       $host_allp = $line_host;
       $atime = $atime_act;
     }
   }
  }

  if ( $atime == 0 ) {
    $file =~ s/\.rr[m|h]//;
    print "HMC no found   : could not found HMC for: $managedname:$file, LPAR does not exist?\n";
    error ("Error  : could not found HMC for: $managedname:$file");
    return "";
  }

  # basename without direct function
  my @base = split(/\//,$host_allp);
  foreach my $m (@base) {
    $host = $m;
  }

  print "045 get_hmc: $host \n" if $DEBUG == 2;
  return $host;
}

sub load_rrd_pool
{
  my $managedname = shift;
  my $pool = shift;

  # get the latest used HMC
  $host = get_hmc ($managedname,"pool.in-m");
  if ( $host eq '' ) {
    # something wrong
    return 1;
  }

  print "053 Load data pool : $host $managedname $pool \n" if $DEBUG == 2;
  if ( -f "$wrkdir/$managedname/$host/SDMC" ) {
      $SDMC=1;
      $HMC =0;
      $IVM =0;
  }
  else {
    $SDMC=0;
    if ( -f "$wrkdir/$managedname/$host/IVM" ) {
      $IVM=1;
      $HMC=0;
    }
    else {
      $HMC=1;
      $IVM=0;
    }
  }
  print "054 Load data pool : $host $managedname $pool \n" if $DEBUG == 2;
  my $return = load_pool_data($managedname,$host,$wrkdir,$type_sam,$ltime_str,$pool ,$HMC,$IVM,$SDMC,$last_file."-POOL");
  if ( $return == 1 ) {
    # something wrong
    print "055 load_data_lpar:return: $return\n" if $DEBUG == 2;
    return 1;
  }


  my $input_pool = "$wrkdir/$managedname/$host/pool.in-alrt";
  my $input_pool_sh = "$wrkdir/$managedname/$host/pool_sh.in-alrt";
  $input_pool_sh =~ s/ /\\ /g;
  my @lpar_trans = "";


  if ( $pool =~ m/^pool$/ ) {
    # all pools
    print "056 LoadDataModule::load_data_pool ($managedname,$host,$wrkdir,$input,\n      $type_sam,$ltime_str,$HMC,$IVM,$SDMC,$step,$DEBUG,$last_file-POOL,$no_time)\n" if $DEBUG == 2;
    LoadDataModule::load_data_pool ($managedname,$host,$wrkdir,$input,$type_sam,$ltime_str,$HMC,$IVM,$SDMC,$step,$DEBUG,\@lpar_trans,$last_file."-POOL",$input_pool,$no_time);
  }
  else {

    my $pool_list_file = "pool_list.txt";
    my @pool_list = "";
    print "056 LoadDataModule::load_data_pool_sh ($managedname,$host,$wrkdir,$input,\n     $type_sam,$ltime_str,$HMC,$IVM,$SDMC,$step,$DEBUG,-,$last_file.-POOLSH,$input_pool_sh,ssh,$hmc_user,-,$pool_list_file,$no_time)\n" if $DEBUG == 2;
    LoadDataModule::load_data_pool_sh ($managedname,$host,$wrkdir,$input,$type_sam,$ltime_str,$HMC,$IVM,$SDMC,$step,$DEBUG,\@lpar_trans,$last_file."-POOLSH",$input_pool_sh,$SSH,$hmc_user,\@pool_list,$pool_list_file,$no_time);
  }

  return 0;
}

sub procpoolagg
{
  # just fake function, it is normally in lpar2rrd.pl byt called is from LoadDataModule
  return 1;
}

sub isdigit 
{
  my $digit = shift;
  my $text = shift;

  my $digit_work = $digit;
  $digit_work =~ s/[0-9]//g;
  $digit_work =~ s/\.//;

  if (length($digit_work) == 0) {
    # is a number
    return 1;
  }

  #if (($digit * 1) eq $digit){
  #  # is a number
  #  return 1;
  #}

  # NOT a number
  error ("there was expected a digit but a string is there, field: $text , value: $digit");
  return 0;
}

sub extern_alarm
{
  my $host = shift;
  my $managed = shift;
  my $lpar = shift;
  my $util = shift;
  my $utillim = shift;
  my $utillimmin = shift;
  my $ltime_str = shift;
  my $last_type = shift;
  my $alert_type_text = shift;
  my $extern_alert = shift;

  if ( ! -x "$extern_alert" ) {
    error ("EXTERN_ALERT is set but the file is not executable : $extern_alert");
    return 1;
  }

  print "Alert external : $last_type=$lpar:$managed:$lpar utilization=$util\n";

  system("$extern_alert", "$alert_type_text", "$last_type", "$managed", "$lpar", "$util", "$utillim", "$utillimmin");

  return 1;
}

sub  create_graph {
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $graph_path = shift;
  my $basedir = shift;
  my $bindir = shift;
  my $line = shift;
  my $email_graph = shift;
  my $type = shift;
  my $log = "$tmpdir/alert.log";
  my $perl = $ENV{PERL};

  print "Graph creation : $host:$server:$lpar\n";
  # set env for graphing script which is normally called via CGI-BIN
  if ( $line =~ m/^LPAR:/ ) {
    # for LPARs
    $ENV{'QUERY_STRING'} = "host=$host&server=$server&lpar=$lpar&item=lpar&time=d&type_sam=m&detail=0&none=none";
  }
  else {
    if ( $line =~ m/swap/ ) {
      # for swapping
      $ENV{'QUERY_STRING'} = "host=$host&server=$server&lpar=$lpar&item=paging&time=d&type_sam=m&detail=0&none=none";
    }
    else {
      if ( $lpar =~ m/^pool$/ ) {
        # all pools
        #$ENV{'QUERY_STRING'} = "host=$host&server=$server&lpar=$lpar&item=pool&time=d&type_sam=m&detail=0&none=none";
        $ENV{'QUERY_STRING'} = "host=$host&server=$server&lpar=$lpar&item=lparagg&time=d&type_sam=m&detail=0&none=none";
      }
      else {
        # shared pools
        $ENV{'QUERY_STRING'} = "host=$host&server=$server&lpar=$lpar&item=shpool&time=d&type_sam=m&detail=0&none=none";
      }
    }
  }

  `$perl $bindir/detail-graph-cgi.pl alarm $graph_path $email_graph > $log 2>&1`;

  if ( -f $log ) {
    open(FH, "< $log");
    foreach my $line (<FH>) {
      print "$line";
    }
    close (FH);
    # unlink ($log);
  }

  return 1;
}


######################################################
# Swapping part 
######################################################

# go through all SWAP lines
sub swapping 
{
  my ($email_graph,$nagios,$extern_alert,$lines_sort_tmp) = @_;
  my @lines_sort = @{$lines_sort_tmp};

  load_all_lpars();
  
  # to avoid double HMC setup
  my $time_mmm = 0;

  # go through all lines from the cfg file
  foreach my $line (@lines_sort) {
    chomp ($line);
    if ( $line =~ m/^#/ || $line !~ m/^SWAP/ ) {
      next; # exclude comments and no swapping rules
    }

    (my $trash,my $server,my $lpar,my $swaplim,my $tint,my $trepeat,my $email) = split(/:/,$line);

    print "001 $line : $lpar - $server - $swaplim - $tint - $trepeat - $email\n" if $DEBUG == 2;
    
    my $server_prev = "";
    my $lpar_prev = "";

    # compare each line "SWAP:..." with list of all lpars with memory data ".mmm" which are stored in @lpar_all_list
    # it is due to regular expressions
    foreach my $line_all (@lpar_all_list) {
      if ( $line_all =~ m/^$server\/.*\/$lpar$/ ) {
        # separate actual server, hmc and lpar from $line_all
        my $line_all_tmp = $line_all;
	$line_all_tmp =~ s/^$wrkdir\///;
        (my $server_new, my $host, my $lpar_new) = split(/\//,$line_all_tmp);
        if ( $server_prev eq '' && $lpar_prev eq '' ) {
          # first one
          print "003 $line_all\n" if $DEBUG == 2;
          swapping_lpar_work ($line_all,$server_new,$host,$lpar_new,$swaplim,$tint,$trepeat,$email,$extern_alert,$nagios,$email_graph);
          $server_prev = $server_new;
          $lpar_prev = $lpar_new;
        }
        else {
          if ( $server_prev =~ m/^$server_new$/ && $lpar_prev =~ m/^$lpar_new$/ ) {
            print "004 $line_all : avoid - double HMC\n" if $DEBUG == 2;
            next; # double HMC 
          }
          else {
            print "005 $line_all\n" if $DEBUG == 2;
            swapping_lpar_work ($line_all,$server_new,$host,$lpar_new,$swaplim,$tint,$trepeat,$email,$extern_alert,$nagios,$email_graph);
            $server_prev = $server_new;
            $lpar_prev = $lpar_new;
          } 
        }
      }
    }
  }
  return 1;
}

# find all lpars with memory data and keep then to can search through regular expressions
sub load_all_lpars {
  my $lpar_indx = 0;
  my $server_indx = 0;

  # goes through all hmc/server and find all lpars
  foreach my $server (<$wrkdir/*>) {
    if ( -l "$server" ) {
      # avoid symlinks
      next;
    }
    if ( -f "$server" ) {
      # avoid regular files
      next;
    }

    my $server_space = $server;
    if ( $server =~ m/ / ) { # workaround for server name with a space inside, nothing else works, grrr
      $server_space = "\"".$server."\"";
    }

    foreach my $lpar_fullp (<$server_space/*/*/pgs.mmm>) {
      chomp ($lpar_fullp);
      $lpar_fullp =~ s/\.mmm//;

      # place lpars into an array
      $lpar_all_list[$lpar_indx] = $lpar_fullp;
      $lpar_all_list[$lpar_indx] =~ s/^$wrkdir\///g; # it must be here due to sorting purposes bellow
      $lpar_indx++;
      #print "33 $lpar_fullp\n";
    }
    $server_list_all[$server_indx] = $server;

    # basename without direct function
    my @link_l = split(/\//,$server_list_all[$server_indx]);
    foreach my  $m (@link_l) {
      $server_list_all[$server_indx] = $m; #lpar name, basename from $file
    }

    $server_indx++;

  }

  # sorting lpars due to dual HMC ....
  @lpar_all_list = sort { (split '/', $a)[2] cmp (split '/', $b)[2] } @lpar_all_list;

  #foreach my $a (@lpar_all_list) {
  #  print "001 $a\n";
  #}
  return 1;
}

# check each lpar for swapping
sub swapping_lpar_work 
{
  my $line_all = shift;
  my $server = shift;
  my $host = shift;
  my $lpar = shift;
  my $swaplim = shift;
  my $tint = shift;
  my $trepeat = shift;
  my $email = shift;
  my $extern_alert = shift;
  my $nagios = shift;
  my $email_graph = shift;
  my $ltime_rep = "";
  my $alert_type_text = "";
  my $ltime_human = "";
  $alert_type_text="Swapping Critical";

  $swaplim =~ s/ //g; 
  $tint =~ s/ //g;
  $trepeat =~ s/ //g;
  $email =~ s/ //g;

  if ( $lpar eq '' ) {
    error ("lpar name is not provided : $line_all");
    next;
  }

  if ( $swaplim eq '' ) {
    error ("SWAP max limit is not provided: $host:$server:$lpar : $line_all");
    return 0;
  }
  my $ret = isdigit($swaplim,"swaplim: $swaplim : $line_all");
  if ( $ret == 0 ) {
    return 0;
  }

  if ( $tint eq '' ) {
    if ( $cpu_average_time_default eq '' ) {
      error ("PEEK_TIME is not provided and default is not specified as well: $host:$server:$lpar : $line_all");
      return 0;
    }
    else {
      $tint=$cpu_average_time_default * 60; # in seconds
    }
  }
  else {
    $ret = isdigit($tint,"tint: $tint : $line_all");
    if ( $ret == 0 ) {
      return 0;
    }
    $tint=$tint * 60; # in seconds
  }

  if ( $trepeat eq '' ) {
    if ( $repeat_default eq '' ) {
      error ("REPEAT is not provided and default is not specified as well: $host:$server:$lpar : $line_all");
      return 0;
    }
    else {
      $trepeat=$repeat_default * 60; # in seconds
    }
  }
  else {
    $ret = isdigit($trepeat,"trepeat: $trepeat : $line_all");
    if ( $ret == 0 ) {
      next;  
    }
    $trepeat = $trepeat * 60; # in seconds
  }

  # Note there must not be email alerting
  if ( $email eq '' ) {
    if ( ! $email_default eq '' ) {
      $email=$email_default;
    }
  }

  my $page_in = read_rrd_swap($line_all,$server,$lpar,$wrkdir,$tint,"page_in");
  if ($page_in == -1 ) {
    return 1; # all ok
  }

  my $page_out = read_rrd_swap($line_all,$server,$lpar,$wrkdir,$tint,"page_out");
  if ($page_out == -1 ) {
    return 1; # all ok
  }

  if ($page_in > $swaplim && $page_out > $swaplim ) {
    #print "010 SWAPPING : $line_all : page_in: $page_in kB/s, page_out: $page_out kB/s, limit: $swaplim kB/s \n";

    # check whether to send alam or not (retention)
    my $send_alarm=1;
    foreach my $line_rep (@lines_rep) {
      chomp ($line_rep);
      if ( $line_rep eq '' ) {
        next;
      }
      (my $name_rep, $ltime_rep, $ltime_human) = split(/\|/,$line_rep);
      if ( "$name_rep" eq '' ) {
        next;
      }
      if ( "$name_rep" =~ "$host$server$lpar-SWAP" ) {  # SWAP string is significant for swaping
        if ( $ltime_rep + $trepeat > $ltime ) {
          $send_alarm=0;
        }
        last;
      }
    }
    if ( $send_alarm == 0 ) {
      # do not send alarm
      print "125 $host:$server:$lpar : do not send alarm this time : $ltime_rep + $trepeat < $ltime \n"  if $DEBUG == 2;
      print "Alert not send : $alert_type_text $server:$lpar  page_in: $page_in kB/s, page_out: $page_out kB/s, limit: $swaplim kB/s :  not this time due to repeat time $ltime_rep + $trepeat < $ltime\n";
      return 1;
    }

    # update retention alerts
    open(FHW, ">> $alert_repeat") || error("could not open $alert_repeat : $! ".__FILE__.":".__LINE__) && return 1;
    print FHW "$host$server$lpar-SWAP|$ltime|$ltime_str\n";
    close (FHW);

    # print alarm to stdout
    print "099 $alert_type_text ALARM: $ltime_str: $server:$lpar,  page_in: $page_in kB/s, page_out: $page_out kB/s, limit: $swaplim kB/s\n" if $DEBUG == 2;
    print "Alert logged   : $alert_type_text ALARM: $ltime_str: $server:$lpar,  page_in: $page_in kB/s, page_out: $page_out kB/s, limit: $swaplim kB/s\n";

    # log an alarm to a file : alert.log
    open(FHL, ">> $alert_history") || error("could not open $alert_history: $! ".__FILE__.":".__LINE__) && return 1;
    print FHL "$ltime_str: $alert_type_text $server:$lpar,  page_in: $page_in kB/s, page_out: $page_out kB/s, limit: $swaplim kB/s\n";
    close (FHL);

    # mail alarm   
    if ( ! $email eq '' ) {
      send_mail ($email,$host,$server,$lpar,"page_in: $page_in kB/s, page_out: $page_out kB/s",$swaplim,0,$ltime_str,$email_default,"",$alert_type_text,$email_graph,"swap",$lpar,$tint);
    }

    $lpar =~ s/\&\&1/\//g;

    # nagios alarm
    if ( $nagios == 1 ) {
      nagios_alarm($host,$server,$lpar,"page_in: $page_in kB/s, page_out: $page_out kB/s",$swaplim,0,$ltime_str,"",$alert_type_text);
    }

    # extern alert 
    if ( ! $extern_alert eq '' ) {
      extern_alarm($host,$server,$lpar,"page_in: $page_in kB/s, page_out: $page_out kB/s",$swaplim,0,$ltime_str,"",$alert_type_text,$extern_alert);
    }
  }
  else {
     $lpar =~ s/\&\&1/\//g;
     print "No alerting    :$alert_type_text $server:$lpar act: page_in: $page_in kB/s, page_out: $page_out kB/s\n" if $DEBUG == 2;
  }


  return 1;
}

sub read_rrd_swap 
{
  my $line_all = shift;
  my $server = shift;
  my $lpar = shift;
  my $wrkdir = shift;
  my $tint = shift;
  my $page_in_out = shift; # page_in or page_out
  my $rrd = "$wrkdir/$line_all.mmm";
  my $page     = "";

  #print "040 read_rrd_swap: $line_all :  $server $lpar $tint\n" if $DEBUG == 2;

  if ( ! -f $rrd ) {
    error ("SWAP: lpar has not been found: $rrd :$server:$lpar");
    return -1;
  }

  my $rrd_time = (stat("$rrd"))[9];
  my $ltime = time(); # alwas do it here, do not use any global one
  my $delta_time = 0;
  if ( ($ltime - $rrd_time) < 1800 ) {
    # if rrd file is not older than 30m then exactly count last 10minutes to geat data from whole last interval
    #  although it does not nhave to be last 10m (agent send data every 10m)
    # when diff more than 30m then something is wrong == no data
    $delta_time = $ltime - $rrd_time;
  }
  #print "033 $delta_time = $ltime - $rrd_time : $tint-$time_diff-$delta_time\n";
  
  RRDp::cmd qq(graph "$tmpdir/name.png"
    "--start" "now-$delta_time-$tint-$time_diff" 
    "DEF:pi=$rrd:$page_in_out:AVERAGE"
    "CDEF:pi_b=pi,4096,*"
    "CDEF:pi_kb=pi_b,1024,/"
    "PRINT:pi_kb:AVERAGE: %3.1lf"
  );
  # there must be at least one decimal place otherwise parsing does not work well

  my $answer = RRDp::read;
  #print "008 read_rrd:answer: $rrd:\n $$answer\n" if $DEBUG == 2;
  my $once = 0;
  foreach my $answ (split(/ /,$$answer)) {
    if ( $once == 1 ) {
      $answ =~ s/ //g;
      my $ret = substr($answ,0,1);
      if ($ret =~ /\D/) {
        next;
      }
      else {
        chomp($answ);
        $page     = $answ;
      }
    }
    else {
      if ( $answ =~ "ERROR" ) {
        error ("SWAP: Graph rrdtool error : $answ");
        if ( $answ =~ "is not an RRD file" ) {
          (my $err,  my $file, my $txt) = split(/'/,$answ);
	  error ("SWAP: Removing as it seems to be corrupted: $file");
          #unlink("$file") || error("Cannot rm $file : $!".__FILE__.":".__LINE__) && return 1;
        }
        else {
          print "027 Graph rrdtool error : $answ" if $DEBUG == 2;
        }
      }
    }
    $once++;
  }

  print "009 read_rrd_swap:parsed: \"$page\"  $lpar|$server|$line_all|$HMC ; rrd:$rrd\n" if $DEBUG == 2;
  if ( $page   eq '' ) {
    RRDp::cmd qq(last "$rrd" );
    my $last_rec_raw = RRDp::read;
    chomp ($$last_rec_raw);
    my $last_rec=localtime($$last_rec_raw);
    error ("SWAP: no data has been found: $rrd :$server:$lpar, last data timestamp : $last_rec");
    return -1;
  }

  return $page ;
}

