#!/usr/bin/perl

use strict;
use Date::Parse;
use RRDp;

my $DEBUG = $ENV{DEBUG};
my $errlog = $ENV{ERRLOG};
my $xport = $ENV{EXPORT_TO_CSV};
my $webdir = $ENV{WEBDIR};
my $lpm_env = $ENV{LPM};
my $basedir = $ENV{INPUTDIR};
my $wrkdir = $basedir."/data";
my $base = 0;
my $detail_yes = 1;
my $detail_no  = 0;

# set unbuffered stdout
$| = 1;


open(OUT, ">> $errlog")  if $DEBUG == 2 ;

#foreach $key (sort keys(%ENV)) {
#   print "$key = $ENV{$key}<p>";
#} 
#window.open(href, windowname, 'width=1200,height=450,scrollbars=yes');

# get QUERY_STRING
use Env qw(QUERY_STRING);
print OUT "-- $QUERY_STRING\n" if $DEBUG == 2 ;

#`echo "QS $QUERY_STRING " >> /tmp/xx32`;
(my $host, my $server, my $lpar, my $item, my $entitle, my $referer) = split(/&/,$QUERY_STRING);

$entitle =~ s/entitle=//;
$host =~ s/host=//;
my $host_url = $host;
$host =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/seg;
$host =~ s/\+/ /g;
$host =~ s/%23/\#/g;
$server =~ s/server=//;
my $server_url = $server;
$server =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/seg;
$server =~ s/\+/ /g;
$server =~ s/%23/\#/g;
$lpar =~ s/lpar=//;
$lpar =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/seg;
my $lpar_url = $lpar;
$lpar_url =~ s/ /+/g;
$lpar_url =~ s/\#/%23/g;
$lpar =~ s/\+/ /g;
$lpar =~ s/%23/\#/g;
$item =~ s/item=//;
my $lpar_slash = $lpar;
$lpar_slash =~ s/\//\&\&1/g; # replace for "/"


# http_base must be passed through cgi-bin script to get location of jquery scripts and others
# it is taken from HTTP_REFERER first time and then passed in the HTML GET
my $html_base = "";
$referer =~ s/referer=//;    #for paging aggregated : PH: not only for paging!!
#`echo "01 $referer " >> /tmp/xx32`;
if ( $referer ne "" && $referer !~ m/none=none/ ) {
  # when is referer set then it is already html_base --> not call html_base($refer) again
  $referer =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/seg;
  $referer =~ s/\+/ /g;
  $html_base = $referer ;
}
else {
  $referer = $ENV{HTTP_REFERER};
  $html_base = html_base($referer); # it must be here behind $base setting
}
#`echo "1 $html_base $html_base, $referer " >> /tmp/xx32`;

#`echo "QS $QUERY_STRING : LPAR: $lpar ( LPAR_slash: $lpar_slash) : $server : $referer : $html_base" >> /tmp/xx32`;

 
# print HTML header, must be after html_base
print_head ();

  if ( $item =~ m/^smenu$/ ) {
    # Server menu (tabs)
    #`echo "$host_url,$server_url,$host,$server,$webdir,$wrkdir,$html_base,$entitle" >> /tmp/xx2`;
    print_smenu ($host_url,$server_url,$host,$server,$webdir,$wrkdir,$html_base,$entitle);
    exit (0);
  }


  # find out $type_sam [m/d/h]
  my $type_sam = type_sam($host,$server,$lpar,0,$lpar_slash);
  my $type_sam_year = type_sam($host,$server,$lpar,1,$lpar_slash);
  my $upper = -1;

  if ( $item =~ m/^codused$/ ) {
    # CoD
    print_cod ($host_url,$server_url,$lpar_url,$item,$type_sam,$entitle,$upper);
    exit (0);
  }

  if ( $item =~ m/^pagingagg$/ ) {
    # Epaging aggregated
    print_pagingagg ($host_url,$server_url,$lpar_url,$item,$type_sam,$entitle,$upper);
    exit (0);
  }

  # TABs
  my $tab_number = 0;
  print "\n<div  id=\"tabs\"> <ul>\n";

  # basic CPU from the HMC
  my $cpu = 0;
  if ( -f "$wrkdir/$server/$host/$lpar_slash.rr$type_sam" ) {
    my $filesize = -s "$wrkdir/$server/$host/$lpar_slash.rr$type_sam";
    # OS agent based lpars without the HMC does have only touched .rrh file
    if ( $filesize >  0 ) {
      $tab_number++;
      $cpu = $tab_number;
      print "  <li><a href=\"#tabs-$tab_number\">CPU</a></li>\n";
      $upper = rrd_upper($wrkdir,$server,$host,$lpar,$type_sam,$type_sam_year,$item,$lpar_slash);
    }
  }

  my $lpm = is_lpm ($host,$server,$lpar,$lpm_env);
  if ( $lpm > 0 ) {
    $tab_number++;
    $lpm = $tab_number;
    print "  <li><a href=\"#tabs-$tab_number\">LPM</a></li>\n";
  }
  my $ams = 0;
  if ( -f "$wrkdir/$server/$host/$lpar_slash.rm$type_sam" ) {
    $tab_number++;
    $ams = $tab_number;
    print "  <li><a href=\"#tabs-$tab_number\">AMS</a></li>\n";
  }

  my @item_agent="";
  my @item_agent_tab="";
  my $item_agent_indx = 0;
  my $os_agent = 0;
  if (test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","cpu" )) {
    $item_agent[$item_agent_indx] = "oscpu" ;
    $tab_number++;
    $os_agent = $tab_number;
    print "  <li><a href=\"#tabs-$tab_number\">CPU OS</a></li>\n";
    $item_agent_tab[$item_agent_indx] = $tab_number;
    $item_agent_indx++;
  }
  if (test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","mem" )) {
    $item_agent[$item_agent_indx] = "mem" ;
    $tab_number++;
    $os_agent = $tab_number;
    print "  <li><a href=\"#tabs-$tab_number\">Memory</a></li>\n";
    $item_agent_tab[$item_agent_indx] = $tab_number;
    $item_agent_indx++;
  }
  if (test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","pgs" )) {
    $item_agent[$item_agent_indx] = "pg1" ;
    $tab_number++;
    $os_agent = $tab_number;
    print "  <li><a href=\"#tabs-$tab_number\">Paging 1</a></li>\n";
    $item_agent_tab[$item_agent_indx] = $tab_number;
    $item_agent_indx++;
    $item_agent[$item_agent_indx] = "pg2" ;
    $tab_number++;
    $os_agent = $tab_number;
    print "  <li><a href=\"#tabs-$tab_number\">Paging 2</a></li>\n";
    $item_agent_tab[$item_agent_indx] = $tab_number;
    $item_agent_indx++;
  }
  if (test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","lan" )) {
    $item_agent[$item_agent_indx] = "lan"  ;
    $tab_number++;
    $os_agent = $tab_number;
    print "  <li><a href=\"#tabs-$tab_number\">LAN</a></li>\n";
    $item_agent_tab[$item_agent_indx] = $tab_number;
    $item_agent_indx++;
  }
  if (test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","san" )) {
    $item_agent[$item_agent_indx] = "san1";
    $tab_number++;
    $os_agent = $tab_number;
    print "  <li><a href=\"#tabs-$tab_number\">SAN</a></li>\n";
    $item_agent_tab[$item_agent_indx] = $tab_number;
    $item_agent_indx++;
    $item_agent[$item_agent_indx] = "san2" ;
    $tab_number++;
    $os_agent = $tab_number;
    print "  <li><a href=\"#tabs-$tab_number\">SAN IOPS</a></li>\n";
    $item_agent_tab[$item_agent_indx] = $tab_number;
    $item_agent_indx++;
  }
  if (test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","ame" )) {
    $item_agent[$item_agent_indx] = "ame" ;
    $tab_number++;
    $os_agent = $tab_number;
    print "  <li><a href=\"#tabs-$tab_number\">AME</a></li>\n";
    $item_agent_tab[$item_agent_indx] = $tab_number;
    $item_agent_indx++;
  }
  if (test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","sea" )) {
    $item_agent[$item_agent_indx] = "sea" ;
    $tab_number++;
    $os_agent = $tab_number;
    print "  <li><a href=\"#tabs-$tab_number\">SEA</a></li>\n";
    $item_agent_tab[$item_agent_indx] = $tab_number;
    $item_agent_indx++;
  }

  # TABs header end
  print "   </ul> \n";
  $tab_number = 1;

  if ( $cpu > 0 ) {
    # lpar without HMC use only agents --> so no cpu graphs
    print "<div id=\"tabs-$tab_number\"><br><br>\n";
    print "<center><b>$lpar</b>";
    print "&nbsp;&nbsp;<font size=-1><A HREF=\"/lpar2rrd-cgi/lpar2rrd-realt.sh?source=$lpar_url&hmc=$host_url&mname=$server_url\">Refresh</A></font>";
    print "\n<table align=\"center\" summary=\"Graphs\">\n";
    print "<tr>\n";
    print_item ($host_url,$server_url,$lpar_url,$item,"d",$type_sam,$entitle,$detail_yes);
    print_item ($host_url,$server_url,$lpar_url,$item,"w",$type_sam,$entitle,$detail_yes);
    print "</tr>\n<tr>\n";
    print_item ($host_url,$server_url,$lpar_url,$item,"m",$type_sam,$entitle,$detail_yes);
    print_item ($host_url,$server_url,$lpar_url,$item,"y",$type_sam_year,$entitle,$detail_yes);
    print "</tr></table>\n";
    # Trend graph
    print "<table align=\"center\" summary=\"Trend graphs\">\n";
    print "<tr>\n";
    print_item ($host_url,$server_url,$lpar_url,"trend","y",$type_sam_year,$entitle,$detail_no);
    print "</tr></table>\n";
    print_lpar_cfg ($wrkdir,$server,$host,$lpar_slash,$html_base,$lpar);
    print "</div>\n\n";
  }

  # LPM
  print OUT "002 LPM : $host,$server,$lpar,$lpm : $lpm \n" if $DEBUG == 2 ;
  if ( $lpm > 0 ) {
      print "<div id=\"tabs-$lpm\"><br><br>\n";
      print "<center><b>$lpar: Live Partition Mobility</b>";
      print "\n<table align=\"center\" summary=\"Graphs\">\n";
      $item = "lpm";
      print "<tr>\n";
      print_item ($host_url,$server_url,$lpar_url,$item,"d",$type_sam,$entitle,$detail_no);
      print_item ($host_url,$server_url,$lpar_url,$item,"w",$type_sam,$entitle,$detail_no);
      print "</tr>\n<tr>\n";
      print_item ($host_url,$server_url,$lpar_url,$item,"m",$type_sam,$entitle,$detail_no);
      print_item ($host_url,$server_url,$lpar_url,$item,"y",$type_sam_year,$entitle,$detail_no);
      print "</tr></table>\n";
      print "</center></div>\n\n";
  }


  # AMS
  if ( $ams > 0 ) {
      print "<div id=\"tabs-$ams\"><br><br>\n";
      print "<center><b>$lpar: Active Memory Sharing</b>";
      print OUT "003 AMS : $wrkdir/$server/$host/$lpar_slash.rm$type_sam \n" if $DEBUG == 2 ;
      print "\n<table align=\"center\" summary=\"Graphs\">\n";
      $item = "ams";
      print "<tr>\n";
      print_item ($host_url,$server_url,$lpar_url,$item,"d",$type_sam,$entitle,$detail_yes);
      print_item ($host_url,$server_url,$lpar_url,$item,"w",$type_sam,$entitle,$detail_yes);
      print "</tr>\n<tr>\n";
      print_item ($host_url,$server_url,$lpar_url,$item,"m",$type_sam,$entitle,$detail_yes);
      print_item ($host_url,$server_url,$lpar_url,$item,"y",$type_sam_year,$entitle,$detail_yes);
      print "</tr></table>\n";
      print "</center></div>\n\n";
  }


  # memory - agent
  print OUT "004 OS : $wrkdir/$server/$host/$lpar_slash.mmm : $lpar \n" if $DEBUG == 2 ;
  if ( $os_agent > 0 ) {
      my $tab_number = 0;
      foreach my $item (@item_agent) { 
        print "<div id=\"tabs-$item_agent_tab[$tab_number]\"><br><br>\n";
        if ( $item =~ m/^oscpu$/ ) { print "<center><b>$lpar: CPU utilization - Operating System</b> <a href=\"http://www.lpar2rrd.com/os_cpu_monitoring.html\" target=\"_blank\"><font size=\"-1\">- How it works</font></a>"; }
        if ( $item =~ m/^mem$/ )   { print "<center><b>$lpar: Memory utilization</b>"; }
        if ( $item =~ m/^pg1$/ )   { print "<center><b>$lpar: Paging / Swapping activity</b>"; }
        if ( $item =~ m/^pg2$/ )   { print "<center><b>$lpar: Paging / Swapping utilization</b>"; }
        if ( $item =~ m/^lan$/ )    { print "<center><b>$lpar: Ethernet Adapter Statistics</b>"; }
        if ( $item =~ m/^san1$/ )   { print "<center><b>$lpar: Fibre Channel Statistics</b>"; }
        if ( $item =~ m/^san2$/ )   { print "<center><b>$lpar: Fibre Channel IOPS Statistics</b>"; }
        if ( $item =~ m/^ame$/ )    { print "<center><b>$lpar: Active Memory Expansion Statistics</b>"; }
        if ( $item =~ m/^sea$/ )    { print "<center><b>$lpar: Shared Ethernet Adapter statistics</b>"; }
        print OUT "005 OS : $item \n" if $DEBUG == 2 ;
        print "\n<table align=\"center\" summary=\"Graphs\">\n";
        print "<tr>\n";
        print_item ($host_url,$server_url,$lpar_url,$item,"d",$type_sam,$entitle,$detail_yes);
        print_item ($host_url,$server_url,$lpar_url,$item,"w",$type_sam,$entitle,$detail_yes);
        print "</tr>\n<tr>\n";
        print_item ($host_url,$server_url,$lpar_url,$item,"m",$type_sam,$entitle,$detail_yes);
        print_item ($host_url,$server_url,$lpar_url,$item,"y",$type_sam_year,$entitle,$detail_yes);
        print "</tr></table>\n";
        # summary graphs
        if ( $item =~ m/lan/ || $item =~ m/san1/ || $item =~ m/san2/ || $item =~ m/sea/ ) {
           my $sitem = "s".$item;
           my $text_sum = "Summary of transfered Bytes a Day"; 
           if ( $item =~ m/san2/  ) { $text_sum = "Summary of IO requests a Day" };
           print "<br><table align=\"center\" summary=\"Graphs\">\n";
           print "<tr><td colspan=\"2\"><hr></td></tr>\n";
           print "<tr><td colspan=\"2\" align=\"center\"><h4>$text_sum</h4></td></tr>\n";
           print "<tr>\n";
           print_item ($host_url,$server_url,$lpar_url,$sitem,"m",$type_sam,$entitle,$detail_yes);
           print_item ($host_url,$server_url,$lpar_url,$sitem,"y",$type_sam_year,$entitle,$detail_yes);
           print "</tr>\n";
           print "</table>\n";
        } 
        print "</center></div>\n\n";
        $os_agent++;
        $tab_number++;
      }
  }

  print "</div><br></BODY></HTML>";

exit (0);


sub is_lpm
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $lpm = shift;
  my $lpm_count = 0;

  if ( $lpm == 1) {
    my $lpm_suff = "rrl";
    # never use function "grab", grrrr ...
    my $server_space = $server;
    if ( $server =~ m/ / ) { # workaround for server name with a space inside, nothing else works, grrr
      $server_space = "\"".$server."\"";
    }
    my $host_space = $host;
    if ( $host =~ m/ / ) { # workaround for server name with a space inside, nothing else works, grrr
      $host_space = "\"".$host."\"";
    }
    my $lpar_space = $lpar;
    if ( $lpar =~ m/ / ) { # workaround for server name with a space inside, nothing else works, grrr
      $lpar_space = "\"".$lpar."\"";
    }


    foreach my $trash (<$wrkdir/$server_space/$host_space/$lpar_space=====*=====*.$lpm_suff>) {
      $lpm_count++;
    }
    $lpm_suff = "rrk";
    foreach my $trash (<$wrkdir/$server_space/$host_space/$lpar_space=====*=====*.$lpm_suff>) {
      $lpm_count++;
    }
    $lpm_suff = "rri";
    foreach my $trash (<$wrkdir/$server_space/$host_space/$lpar_space=====*=====*.$lpm_suff>) {
      $lpm_count++;
    }
    #print STDERR "001 $host,$server,$lpar,$lpm : $lpm_count\n";

    if ( ! -f "$wrkdir/$server/$host/lpm-exclude.txt" ) {
      return $lpm_count;
    }

    # if it is a VIO server then do not go for LPM
    # it is already being exlcuded in install-html.sh, this is just for sure
    my $lpm_excl= "$wrkdir/$server/$host/lpm-exclude.txt";
    open(FH, "< $lpm_excl") || return $lpm_count;
    my @lpm_excl_vio = <FH>;
    close(FH);

    foreach my $lpm_line (@lpm_excl_vio) {
      chomp($lpm_line);
      if ( "$lpm_line" =~ m/$lpar/ && length($lpm_line) == length($lpar)){
        #print STDERR "LPM VIO exclude: $host:$server:$lpar: - $lpm_line\n" if $DEBUG ;
        $lpm_count=0;
        last;
      }
    }
  }
  #print STDERR "002 $host,$server,$lpar,$lpm : $lpm_count\n";

  return $lpm_count;
}

sub type_sam 
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $yearly = shift;
  my $lpar_slash = shift;

  if ( $yearly == 1 ) {
    if ( -f "$wrkdir/$server/$host/$lpar_slash.rrd" ) {
      return "d";
    }
    return "m";
  }
 
  if ( -f "$wrkdir/$server/$host/$lpar_slash.rrm" ) {
    return "m";
  }

  if ( -f "$wrkdir/$server/$host/$lpar_slash.rrh" ) {
    return "h";
  }

  return "m";
}

# find out max value to get fixed upper limit for all 4 graphs
sub rrd_upper
{
  my $wrkdir = shift;
  my $server = shift;
  my $host   = shift;
  my $lpar   = shift;
  my $type_sam = shift;
  my $type_sam_year = shift;
  my $item = shift;
  my $lpar_slash = shift;
  my $rrd= "$wrkdir/$server/$host/$lpar_slash.rr$type_sam";


  if ( ! -f "$rrd" || $item =~ m/^codused$/ || $item =~ m/^pagingagg$/  ) {
    # Capacity on demad also does not go here
    return 0;
  }

  my $rrdtool = $ENV{RRDTOOL};

  # start RRD via a pipe
  RRDp::start "$rrdtool";


  my $ret   = find_rrd_upper ($rrd,"now-1d");
  my $ret_w = find_rrd_upper ($rrd,"now-1w");
  my $ret_m = find_rrd_upper ($rrd,"now-1m");

  $rrd= "$wrkdir/$server/$host/$lpar_slash.rr$type_sam_year";
  if ( ! -f "$rrd" ) {
    $rrd= "$wrkdir/$server/$host/$lpar_slash.rr$type_sam";
  }
  my $ret_y = find_rrd_upper ($rrd,"now-1y");

  if ( $ret_w > $ret ) { $ret = $ret_w; }
  if ( $ret_m > $ret ) { $ret = $ret_m; }
  if ( $ret_y > $ret ) { $ret = $ret_y; }

  # close RRD pipe
  RRDp::end;


  return $ret;

}

sub find_rrd_upper
{
  my $rrd = shift;
  my $start_time = shift;


    RRDp::cmd qq(graph "tmp/name.png"
      "--start" "$start_time"
      "--end" "now"
      "DEF:cur=$rrd:curr_proc_units:AVERAGE"
      "DEF:ent=$rrd:entitled_cycles:AVERAGE"
      "DEF:cap=$rrd:capped_cycles:AVERAGE"
      "DEF:uncap=$rrd:uncapped_cycles:AVERAGE"
      "CDEF:tot=cap,uncap,+"
      "CDEF:util=tot,ent,/"
      "CDEF:utiltot=util,cur,*"
      "PRINT:utiltot:MAX: %3.3lf"
    );
  my $answer = RRDp::read;
  $$answer =~ s/0x0//;
  $$answer =~ s/\n//;
  $$answer =~ s/ //g;
  chomp ($$answer);

  if ( $$answer =~ m/N/ ) {
    return 0;
  }

  #print "$$answer\n";
  return $$answer;
}


sub html_base
{
  my $refer = shift;

    # Print link to full lpar cfg (must find out at first html_base
    # find out HTML_BASE
    # renove from the path last 3 things
    # http://nim.praha.cz.ibm.com/lpar2rrd/hmc1/PWR6B-9117-MMA-SN103B5C0%20ttt/pool/top.html
    # --> http://nim.praha.cz.ibm.com/lpar2rrd
    my $html_base = "";
      my @full_path = split(/\//, $refer);
      my $k = 0;
      foreach my $path (@full_path){
        $k++
      }
      $k--;
      if ( $refer !~ m/topten-glo/ && $refer !~ m/cpu_max_check/ ) { # when top10 global then just once
        $k--; $k--;
      }
      my $j = 0;
      foreach my $path (@full_path){
        if ($j < $k) {
          if ( $j == 0 ) {
            $html_base .= $path;
          }
          else {
            $html_base .= "/".$path;
          }
          $j++;
        }
      }
    
    return $html_base;
}

sub print_head
{
# print HTML header
print "Content-type: text/html\n";
my $time = gmtime();
print "Expires: $time\n\n";
print "<HTML><HEAD>
<META HTTP-EQUIV=\"pragma\" CONTENT=\"no-cache\"> 
<META HTTP-EQUIV=\"Expires\" CONTENT=\"NOW\"> 
<META HTTP-EQUIV=\"last modified\" CONTENT=\"NOW\">
<STYLE TYPE=\"text/css\">
<!--
.header, .header TD, .header TH
{
background-color:#D3D2F3;
}
-->
</STYLE>
<style>
<!--
a {text-decoration: none}
-->
</style>
<SCRIPT TYPE=\"text/javascript\">
<!--
function popup(mylink, windowname)
{
if (! window.focus)return true;
var href;
if (typeof(mylink) == 'string')
   href=mylink;
else
   href=mylink.href;
window.open(href, windowname, 'width=1329,height=670,scrollbars=yes');
return false;
}
//-->
</SCRIPT>
<link rel=\"stylesheet\" href=\"$html_base/jquery/jquery-ui-1.10.3.custom.min.css\">
<link rel=\"stylesheet\" href=\"$html_base/jquery/magnific-popup.css\">

<script src=\"$html_base/jquery/jquery-1.9.1.js\"></script>
<script src=\"$html_base/jquery/jquery-ui-1.10.3.custom.min.js\"></script>
<script src=\"$html_base/jquery/jquery.lazy.min.js\"></script>
<script src='$html_base/jquery/magnific-popup.min.js'></script>
<script>
\$( document ).ready(function() {
	\$( \"#tabs\" ).tabs({
		activate: function() {
			\$(\"img.lazy\").lazy({
				bind: \"event\",
				effect: \"fadeIn\", 
				effectTime: 1000
				});
		}
	});
	\$( \"img.lazy\" ).lazy({
			effect: \"fadeIn\", 
			effectTime: 1000
			}
	);

	\$( 'a.detail' ).magnificPopup({
		type: 'image',
		closeOnContentClick: true,
		closeBtnInside: false,
		fixedContentPos: true,
		mainClass: 'mfp-no-margins mfp-with-zoom', // class to remove default margin from left and right side
		image: {
			verticalFit: true
		},
		zoom: {
			enabled: true,
			duration: 300 // don't foget to change the duration also in CSS
		}
	});
});


</script>

</HEAD>
<BODY BGCOLOR=\"#D3D2D2\" TEXT=\"#000000\" LINK=\"#0000FF\" VLINK=\"#0000FF\" ALINK=\"#FF0000\" >";


return 1;
}


# CoD  codunreport
sub print_cod
{
  my ($host_url,$server_url,$lpar_url,$item,$type_sam,$entitle,$upper) = @_;
 
  print "<center><b>Capacity on Demand</b>";
  print "<table align=\"center\" summary=\"Graphs\">\n";
  print OUT "006 CoD : $item \n" if $DEBUG == 2 ;
  print "<tr><td colspan=\"2\" align=\"center\"><A NAME=COD></A> <H3>Capacity on Demand</H3> <BR></td></tr>\n";
  $item="codunreport";
  print "<tr>";
  print_item ($host_url,$server_url,$lpar_url,$item,"d",$type_sam,$entitle,$detail_yes);
  print_item ($host_url,$server_url,$lpar_url,$item,"w",$type_sam,$entitle,$detail_yes);
  print "</tr>\n<tr>\n";
  print_item ($host_url,$server_url,$lpar_url,$item,"m",$type_sam,$entitle,$detail_yes);
  print_item ($host_url,$server_url,$lpar_url,$item,"y",$type_sam_year,$entitle,$detail_yes);
  print "</tr></table>";
  print "</div><br></BODY></HTML>";


  return 1;
}

# print Lpar cfg table
sub print_lpar_cfg
{
  my ($wrkdir,$server,$host,$lpar_slash,$html_base,$lpar) = @_;

    print OUT "007 CFG : $wrkdir/$server/$host/cpu.cfg-$lpar_slash \n" if $DEBUG == 2 ;
    my $cfg = "$wrkdir/$server/$host/cpu.cfg-$lpar_slash";
    print "</center>\n";
    if ( ! -f "$cfg" ) {
      return 1; # CFG does not exist
    }
    open (FH," < $cfg") || error("Cannot open $cfg: $!".__FILE__.":".__LINE__) && return 0;
    foreach my $line (<FH>) {
      if ( $line =~ m/logical_serial_num/ ) { #exclude serial info
        next;
      }
      else {
        print $line;
      }
    }

    print OUT "008 LNK : $html_base/$host/$server/config.html#$lpar_url \n" if $DEBUG == 2 ;
    print "LPAR configuration: <a href=\"$html_base/$host/$server/config.html#$lpar_url\" target=\"sample\"><b>$lpar</b></a>\n";
    
    return 1;
}

# print a link with detail 
sub print_item 
{
  my ($host_url,$server_url,$lpar_url,$item,$time_graph,$type_sam,$entitle,$detail) = @_;

  if ( $detail > 0 ) {
    print "<td valign=\"top\"><a class=\"detail\" href=\"/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar_url&item=$item&time=$time_graph&type_sam=$type_sam&detail=1&upper=$upper&entitle=$entitle&none=none\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar_url&item=$item&time=$time_graph&type_sam=$type_sam&detail=0&upper=$upper&entitle=$entitle&none=none\" src=\"$html_base/jquery/images/loading.gif\"></font></a></td>\n";
  }
  else {
    print "<td align=\"center\" valign=\"top\" colspan=\"2\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar_url&item=$item&time=$time_graph&type_sam=$type_sam&detail=0&entitle=$entitle&none=none\" src=\"$html_base/jquery/images/loading.gif\"></td>\n";
  }
  return 1;
}

sub print_smenu 
{
  my $host_url = shift;
  my $server_url = shift ;
  my $host = shift;
  my $server = shift;
  my $webdir = shift;
  my $wrkdir = shift;
  my $html_base = shift;
  my $entitle = shift;

  #$| = 1;

  # TABs
  my $tab_number = 1;
  print "<div  id=\"tabs\"> <ul>\n";
  print "  <li><a href=\"#tabs-$tab_number\">CPU</a></li>\n";
  $tab_number++;
  print "  <li><a href=\"#tabs-$tab_number\">LPAR aggr</a></li>\n";
  $tab_number++;
  print "  <li><a href=\"#tabs-$tab_number\">Mem aggr</a></li>\n";
  $tab_number++;
  print "  <li><a href=\"#tabs-$tab_number\">Paging</a></li>\n";

  # CPU pools
  opendir(DIR, "$webdir/$host/$server") || error(" $webdir/$host/$server: $! :".__FILE__.":".__LINE__) && return 0;
  my @pools = readdir(DIR);
  closedir(DIR);

  my $pool_no = 0;
  foreach my $pool (@pools) {
    chomp ($pool);
    if ( $pool =~ m/SharedPool/ ) {
      $pool_no++;
    }
  }

  if ( $pool_no > 1 ) {
    # Go further only if is any pool defined (>1 as CPU pool 0 is always there)
    foreach my $pool (@pools) {
      chomp ($pool);
      if ( $pool =~ m/SharedPool/ ) {
        $tab_number++;
        my $pool_id = $pool;
        $pool_id =~ s/SharedPool//;
        print "  <li><a href=\"#tabs-$tab_number\">CPU pool $pool_id</a></li>\n";
      }
    }
  }




  # TABs header end
  print "   </ul> \n";

  # CPU tab
  $tab_number = 1;
  my $lpar = "pool";
  my $item = "pool";
  my $type_sam = type_sam($host,$server,$lpar,0,$lpar);
  my $type_sam_year = type_sam($host,$server,$lpar,1,$lpar);

  print "<div id=\"tabs-$tab_number\"><br><br>\n";
  print "<center><b>$server: All CPU pools</b>";
  print "&nbsp;&nbsp;<font size=-1><A HREF=\"/lpar2rrd-cgi/lpar2rrd-realt.sh?source=$lpar_url&hmc=$host_url&mname=$server_url\">Refresh</A></font>";
  print "<table align=\"center\" summary=\"Graphs\">\n";
  print "<tr>";
  print_item ($host_url,$server_url,$lpar,$item,"d",$type_sam,$entitle,$detail_yes);
  print_item ($host_url,$server_url,$lpar,$item,"w",$type_sam,$entitle,$detail_yes);
  print "</tr>\n<tr>\n";
  print_item ($host_url,$server_url,$lpar,$item,"m",$type_sam,$entitle,$detail_yes);
  print_item ($host_url,$server_url,$lpar,$item,"y",$type_sam_year,$entitle,$detail_yes);
  print "</tr>\n<tr>\n";
  # Trend graph
  print_item ($host_url,$server_url,$lpar,"trend","y",$type_sam_year,$entitle,$detail_no);
  print "</tr></table>";
  #print_lpar_cfg ($wrkdir,$server,$host,$lpar,$html_base,$lpar);
  print "</div>\n";


  # LPAR aggr tab
  $tab_number++;
  my $lpar = "lparagg";
  my $item = "lparagg";
  my $type_sam = type_sam($host,$server,$lpar,0,$lpar);
  my $type_sam_year = type_sam($host,$server,$lpar,1,$lpar);

  print "<div id=\"tabs-$tab_number\"><br><br>\n";
  print "<center><b>$server: LPARs aggregated</b>";
  #print "&nbsp;&nbsp;<font size=-1><A HREF=\"/lpar2rrd-cgi/lpar2rrd-realt.sh?source=$lpar_url&hmc=$host_url&mname=$server_url\">Refresh</A></font>";
  print "<table align=\"center\" summary=\"Graphs\">\n";
  print "<tr>";
  print_item ($host_url,$server_url,$lpar,$item,"d",$type_sam,$entitle,$detail_yes);
  print_item ($host_url,$server_url,$lpar,$item,"w",$type_sam,$entitle,$detail_yes);
  print "</tr>\n<tr>\n";
  print_item ($host_url,$server_url,$lpar,$item,"m",$type_sam,$entitle,$detail_yes);
  print_item ($host_url,$server_url,$lpar,$item,"y",$type_sam_year,$entitle,$detail_yes);
  print "</tr></table>";
  #print_lpar_cfg ($wrkdir,$server,$host,$lpar,$html_base,$lpar);
  print "</div>\n";


  # MEM aggr tab
  $tab_number++;
  my $lpar = "memagg";
  my $item = "memagg";
  my $type_sam = type_sam($host,$server,$lpar,0,$lpar);
  my $type_sam_year = type_sam($host,$server,$lpar,1,$lpar);

  print "<div id=\"tabs-$tab_number\"><br><br>\n";
  print "<center><b>$server: Memory aggregated</b>";
  #print "&nbsp;&nbsp;<font size=-1><A HREF=\"/lpar2rrd-cgi/lpar2rrd-realt.sh?source=$lpar_url&hmc=$host_url&mname=$server_url\">Refresh</A></font>";
  print "<table align=\"center\" summary=\"Graphs\">\n";
  print "<tr>";
  print_item ($host_url,$server_url,$lpar,$item,"d",$type_sam,$entitle,$detail_yes);
  print_item ($host_url,$server_url,$lpar,$item,"w",$type_sam,$entitle,$detail_yes);
  print "</tr>\n<tr>\n";
  print_item ($host_url,$server_url,$lpar,$item,"m",$type_sam,$entitle,$detail_yes);
  print_item ($host_url,$server_url,$lpar,$item,"y",$type_sam_year,$entitle,$detail_yes);
  print "</tr></table>";
  #print_lpar_cfg ($wrkdir,$server,$host,$lpar,$html_base,$lpar);
  print "</div>\n";

  # Paging
  $tab_number++;
  my $lpar = "paging";
  my $item = "paging";
  my $type_sam = type_sam($host,$server,$lpar,0,$lpar);
  my $type_sam_year = type_sam($host,$server,$lpar,1,$lpar);

  print "<div id=\"tabs-$tab_number\"><br><br>\n";
  print "<center><b>$server: Paging aggregated</b>";
  print "show only max paging > xxkBytes";
  print "</div>\n";


  # CPU pools 
  if ( $pool_no > 1 ) {
    # Go further only if is any pool defined (>1 as CPU pool 0 is always there)
    foreach my $pool (@pools) {
      chomp ($pool);
      if ( $pool =~ m/SharedPool/ ) {
        $tab_number++;
        my $pool_id = $pool;
        $pool_id =~ s/SharedPool//;
        my $lpar = $pool;
        my $item = "shpool";
        my $type_sam = type_sam($host,$server,$lpar,0,$lpar);
        my $type_sam_year = type_sam($host,$server,$lpar,1,$lpar);

        print "<div id=\"tabs-$tab_number\"><br><br>\n";
        print "<center><b>$server: CPU pool $pool_id</b>";
        #print "&nbsp;&nbsp;<font size=-1><A HREF=\"/lpar2rrd-cgi/lpar2rrd-realt.sh?source=$lpar_url&hmc=$host_url&mname=$server_url\">Refresh</A></font>";
        print "<table align=\"center\" summary=\"Graphs\">\n";
        print "<tr>";
        print_item ($host_url,$server_url,$lpar,$item,"d",$type_sam,$entitle,$detail_yes);
        print_item ($host_url,$server_url,$lpar,$item,"w",$type_sam,$entitle,$detail_yes);
        print "</tr>\n<tr>\n";
        print_item ($host_url,$server_url,$lpar,$item,"m",$type_sam,$entitle,$detail_yes);
        print_item ($host_url,$server_url,$lpar,$item,"y",$type_sam_year,$entitle,$detail_yes);
        print "</tr>\n<tr>\n";
        # Trend graph
        print_item ($host_url,$server_url,$lpar,"trend","y",$type_sam_year,$entitle,$detail_no);
        print "</tr></table>";
        #print_lpar_cfg ($wrkdir,$server,$host,$lpar,$html_base,$lpar);
        print "</div>\n";
      }
    }
  }
  print "</div><br></BODY></HTML>";
  return 1;
}

sub test_file_in_directory
{
# Use a regular expression to find files
#    beginning by $fpn
#    ending by .mmm
#    returns 0 (zero) or first filename found i.e. non zero

 my $dir=shift;
 my $fpn=shift;

 my $found = 0;
 if ( !-d $dir ) { return $found;}
 opendir (DIR, $dir) || error("Error in opening dir $dir $! :".__FILE__.":".__LINE__) && return 0;
 
 while (my $file = readdir(DIR)) {
     if ($file =~ m/^$fpn.*\.mmm$/) {
        #if ($file =~ m/\.mmm$/) {
           $found = "$dir/$file";
           last;
        #}
     }
 }
 closedir (DIR);
 return $found;
}

# paging aggregated
sub print_pagingagg
{
  my ($host_url,$server_url,$lpar_url,$item,$type_sam,$entitle,$upper) = @_;

  #`echo "002 $entitle" > /tmp/xx32`;
  my $bmax = $entitle; # entitle passes max of paging peak when lpar is displayed then
  $bmax =~ s/MAX=//;
  if ($bmax <= 0) { $bmax = 10; } # default 

 # `echo $type_sam,$entitle,$upper,$amax,$bmax >>/tmp/MXP1`;
 # print "<center><b>Paging aggregated graphs</b>";
  #print "<table width=\"100%\">";
  print "<FORM METHOD=\"GET\" ACTION=\"/lpar2rrd-cgi/detail.sh\" target=\"sample\"><tr>";
  print "<p style=\"text-align: right\"><font size=-1>\n";
  print "<INPUT type=\"hidden\" name=\"host\" value=\"$host_url\">";
  print "<INPUT type=\"hidden\" name=\"server\" value=\"$server_url\">";
  print "<INPUT type=\"hidden\" name=\"lpar\" value=\"$lpar_url\">";
  print "<INPUT type=\"hidden\" name=\"item\" value=\"pagingagg\">";
  print "Displayed are only LPARs with MAX above ";
  print "<INPUT TYPE=\"TEXT\" TITLE=\"Write new Max\" onblur=\"this.style.color='#f00'\" size=\"2\" NAME=\"MAX\" VALUE=\"$bmax\">";
  print "<INPUT type=\"hidden\" name=referer value=\"$html_base\">";
  print "<INPUT TYPE=\"SUBMIT\" NAME=\"peak\" VALUE=\"kB/s\" ALT=\"MAX peak\">";
  print "</font>\n";
  print "<center><b>Paging aggregated graphs</b></center>";
  #print "</tr></form></table>";
  print "<table align=\"center\" summary=\"Graphs\">\n";
  print OUT "006 CoD : $item \n" if $DEBUG == 2 ;
  print "<tr>";
  print_item ($host_url,$server_url,$lpar_url,$item,"d",$type_sam,$bmax,$detail_yes);
  print_item ($host_url,$server_url,$lpar_url,$item,"w",$type_sam,$bmax,$detail_yes);
  print "</tr>\n<tr>\n";
  print_item ($host_url,$server_url,$lpar_url,$item,"m",$type_sam,$bmax,$detail_yes);
  print_item ($host_url,$server_url,$lpar_url,$item,"y",$type_sam_year,$bmax,$detail_yes);
  print "</tr></table>";
  print "</div><br>";
#  print "Only LPARs with MAX above $bmax kBytes/sec are displayed ..... <br>";

  print "</BODY></HTML>";


  return 1;

}

# error handling
sub error
{
  my $text = shift;
  my $act_time = localtime();
  chomp ($text);

  #print "ERROR          : $text : $!\n";
  print STDERR "$act_time: $text : $!\n";

  return 1;
}


# print Lpar cfg table
