#!/usr/bin/perl
  my $version="2.65";

  use strict;

  my $infile="data.txt";
  $infile=shift;
  my $wrkdir="/home/lpar2rrd/lpar2rrd/data-all";
  my $act_time = localtime();
  my $host = "";
  my $managedname = "";
  my $step = "";
  my $DEBUG = 1;

  if (! -d "$wrkdir" ) {
    print "mkdir          : $wrkdir\n" if $DEBUG ;
    mkdir("$wrkdir", 0755) || die   "$act_time: Cannot mkdir $wrkdir: $!";
  }

  open(FH, "< $infile") || die "$act_time: Can't open $infile : $!";
  while (my $line = <FH>) {
    chomp($line);
    if ($line =~ m/^-ID/) {
      $managedname = $line;
      $managedname =~ s/-ID //g;
      print "$managedname\n" if $DEBUG ;
      if (! -d "$wrkdir/$managedname" ) {
        print "mkdir          : $wrkdir/$managedname\n" if $DEBUG ;
        mkdir("$wrkdir/$managedname", 0755) || die   "$act_time: Cannot mkdir $wrkdir/$managedname: $!";
      }
      if (! -d "$wrkdir/$managedname/$host" ) {
        print "mkdir          : $wrkdir/$managedname/$host\n" if $DEBUG ;
        mkdir("$wrkdir/$managedname/$host", 0755) || die   "$act_time: Cannot mkdir $wrkdir/$managedname/$host: $!";
      }
      next;
    }
    if ($line =~ m/^-HMC/) {
      ( my $trash, $host) = split(/ /,$line);
      print "$host\n" if $DEBUG ;
      next;
    }
    if ($line =~ m/^-STEP/) {
      ( my $trash, $step) = split(/ /,$line);
      print "$step\n" if $DEBUG ;
      close (FW);
      open(FW, "> $wrkdir/$managedname/$host/step") || die "$act_time: Can't create $wrkdir/$managedname/$host/in-m : $!";
      print FW "$step\n";
      close (FW);
      next;
    }
    if ($line =~ m/^-LPAR/) {
      print "LPAR\n" if $DEBUG ;
      open(FW, "> $wrkdir/$managedname/$host/in-m") || die "$act_time: Can't create $wrkdir/$managedname/$host/in-m : $!";
      next;
    }
    if ($line =~ m/^-POOL/) {
      print "POOL\n" if $DEBUG ;
      close (FW);
      open(FW, "> $wrkdir/$managedname/$host/pool.in-m") || die "$act_time: Can't create $wrkdir/$managedname/$host/pool.in-m : $!";
      next;
    }
    if ($line =~ m/^-PROCPOOL/) {
      print "PROCPOOL\n" if $DEBUG ;
      close (FW);
      open(FW, "> $wrkdir/$managedname/$host/pool_sh.in-m") || die "$act_time: Can't create $wrkdir/$managedname/$host/pool_sh.in-m : $!";
      next;
    }
    if ($line =~ m/^-MAPPOOL/) {
      print "MAPPOOL\n" if $DEBUG ;
      close (FW);
      open(FW, "> $wrkdir/$managedname/$host/cpu-pools-mapping.txt") || die "$act_time: Can't create $wrkdir/$managedname/$host/cpu-pools-mapping.txt : $!";
      next;
    }
    print FW "$line\n";
  }
  close (FW);
