#################################################
# Favourites graphs
#################################################


print_fav_body  () {

cat << END 
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<HTML>
<HEAD>
  <TITLE>LPAR2RRD</TITLE>
  <META HTTP-EQUIV="pragma" CONTENT="no-cache"> 
  <META HTTP-EQUIV="Expires" CONTENT="NOW"> 
  <META HTTP-EQUIV="last modified" CONTENT="NOW">
  <META HTTP-EQUIV="refresh" CONTENT="600">
<style>
<!--
a {text-decoration: none}
-->
</style>
</HEAD>
<BODY BGCOLOR="#D3D2D2" TEXT="#000000" LINK="#0000FF" VLINK="#0000FF" ALINK="#FF0000" >
END

if [ "$1"x = "x" ]; then
  #no group defined
  cat << END 
<br>
Favourites feature allows you choice typically most important or most often viewed CPU pools or lpars and place them into separated menu for quick access.
<br>
You can assign them aliases which then appear under "favourites" menu.
<br>
<br>
<b>How to start?</b><br>
<ul>
<li>Create configuration file<br>
(upgrade process creates configuration file automatically, so you might skip this)<br>
<b>$ cd $INPUTDIR<br>
$ ./scripts/update_cfg_favourites.sh <br></b>
it creates this configuration file: <b>./etc/favourites.cfg</b> <br>
</li>
<li> edit <b>./etc/favourites.cfg</b> and assign lpars or pools to your favourite names <br><br></li>
<li>
when you want to refresh list of servers/pools/lpars within favourites.cfg then just run again:<br>
<b>$ ./scripts/update_cfg_favourites.sh <br></b>
</li>
</ul>
<br>
For more details and configuration examples visit <b><a href="http://www.lpar2rrd.com/favourites.html" target="_blank">Favourites</a></b><br>
You can also try this functionality on <b><a href="http://www.lpar2rrd.com/live_demo.html" target="_blank">LPAR2RRD live demo</a></b>
END
else
  cat << END 
<CENTER>
<BR>
<table border="0"><tr><td valign="top">
<IMG SRC="d.png" ALT="daily stats">
</td><td valign="top">
<IMG SRC="w.png" ALT="weekly stats">
</td></tr><tr><td valign="top">
<IMG SRC="m.png" ALT="monthly stats">
</td><td valign="top">
<IMG SRC="y.png" ALT="yearly stats">
</td></tr></table>
</CENTER>
END
fi

}

favourite () {

FAV_INDX_TMP_GROUPS="$WEBDIR/fav_index.html-group"

# go through all favourites
number_fav=0
cd $WEBDIR/favourites
for fav_space in `ls|sort|sed 's/ /+===============+/g'`
do
  fav=`echo $fav_space|sed 's/+===============+/ /g'`
  if [ ! -d "$fav" ]; then
    continue # favourites are here only sym links
  fi

  echo "favourite      : $fav"

  # Add others managed systems into the menu
  echo "<BR><TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD nowrap>" >> $FAV_INDX_TMP_GROUPS
  echo "<CENTER><B>FAVOURITES</B></CENTER>" >> $FAV_INDX_TMP_GROUPS
  echo "</TR></TD></TABLE>" >> $FAV_INDX_TMP_GROUPS
  echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $FAV_INDX_TMP_GROUPS

  count=0
  for rest_fav_space in `ls|sed -e 's/ *$//g' -e 's/ /+===============+/g'`
  do
    rest_fav=`echo $rest_fav_space|sed 's/+===============+/ /g'`
    rest_fav_nbsp=`echo $rest_fav_space|sed 's/+===============+/\&nbsp;/g'`
    if [ ! -d "$rest_fav" ]; then
      continue # some trash
    fi
    (( count = count + 1 ))

    if [ "$fav" = "$rest_fav" ]; then
      echo "<TR><TD nowrap><b>$rest_fav_nbsp</b>" >> $FAV_INDX_TMP_GROUPS
    else
     echo "<TR><TD nowrap><A HREF=\"../$rest_fav/$rest_fav/index.html\" target=\"main\">$rest_fav_nbsp</A>" >> $FAV_INDX_TMP_GROUPS
    fi
    echo "</TD></TR>" >> $FAV_INDX_TMP_GROUPS
  done

  # where there is only 1 favourite
  if [ $count -eq 0 ]; then
    fav_nbsp=`echo $fav_space|sed 's/+===============+/\&nbsp;/g'`
    echo "<TR><TD nowrap><b>$fav_nbsp</b>" >> $FAV_INDX_TMP_GROUPS
    echo "</TD></TR>" >> $FAV_INDX_TMP_GROUPS
  fi

  echo "</TD></TR></TABLE>" >> $FAV_INDX_TMP_GROUPS
  cat $FAV_INDX_TMP-trailer >> $FAV_INDX_TMP_GROUPS
  echo "</BODY> </HTML>" >> $FAV_INDX_TMP_GROUPS

  cat $FAV_INDX_TMP-header > "$fav/servers.html"
  cat $FAV_INDX_TMP  >> "$fav/servers.html"
  cat $FAV_INDX_TMP_GROUPS  >> "$fav/servers.html"
  rm -f $FAV_INDX_TMP_GROUPS

  (( number_fav = number_fav + 1 ))
done

if [ $number_fav -eq 0 ]; then
  # no favourites defined yet, place there just default template

  echo "favourites     : no defined yet, placing default"
  # Add others managed systems into the menu
  echo "<BR><TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD nowrap>" >> $FAV_INDX_TMP_GROUPS
  echo "<CENTER><B>FAVOURITES</B></CENTER>" >> $FAV_INDX_TMP_GROUPS
  echo "</TR></TD></TABLE>" >> $FAV_INDX_TMP_GROUPS
  echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $FAV_INDX_TMP_GROUPS

  echo "</TD></TR></TABLE>" >> $FAV_INDX_TMP_GROUPS
  cat $FAV_INDX_TMP-trailer >> $FAV_INDX_TMP_GROUPS
  echo "</BODY> </HTML>" >> $FAV_INDX_TMP_GROUPS

  print_fav_body  "" > "cpu.html"

  # must be sed there as without any favourite root is one directory lower
  cat $FAV_INDX_TMP-header | sed 's/\.\.\///' > "servers.html"
  cat $FAV_INDX_TMP | sed 's/\.\.\///'  >> "servers.html"
  cat $FAV_INDX_TMP_GROUPS | sed 's/\.\.\///'  >> "servers.html"
  rm -f $FAV_INDX_TMP_GROUPS
  if [ ! -f index.html ]; then
    cp $INDEX/index.html $INDEX/right_all.html ./
    sed 's/\.\.\/servers/servers/' $INDEX/menuframe.html > ./menuframe.html
    sed 's/XXXXXXXX/No favourites defined/g' $INDEX/top.src  > ./top.html 
  fi
fi

# cleanup do not do a cleanup!!!
# rm -f $FAV_INDX_TMP $FAV_INDX_TMP_GROUPS $FAV_INDX_TMP-trailer $FAV_INDX_TMP-header

} # end of favourite()


#################################################
# End of favourites graphs
#################################################

