#!/bin/ksh

PATH=$PATH:/usr/bin:/bin
export PATH
umask 0022

if [ ! -d $WEBDIR ]; then
   echo "WEBDIR does not exist, supply it as the first parametr"
   exit 1
fi
if [ ! -d $INPUTDIR ]; then
   echo "Source does not exist, supply it as the second parametr"
   exit 1
fi
if [ ! -f $PERL ]; then
   echo "perl path is invalid, correct it and re-run the tool"
   exit 1
fi



IVM=0
SDMC=0
if [ "$TMPDIR"x = "x" ]; then
  TMPDIR="$INPUTDIR/tmp"
fi
INDEX=$INPUTDIR/html
MENU_OUT=$WEBDIR/menu.txt
MENU_SRC=$WEBDIR/menu.html
#rm -f $MENU_OUT
pwd=`pwd`
CONFIG_DIR=$INPUTDIR/data	# must be absolute path
VIEW=" daily-view weekly-view monthly-view yearly-view"
MINDEX=servers.html
MINDEX_TMP=servers.tmp
TIME=`$PERL -e '$v = time(); print "$v\n"'`
TOPTEN_OUT=topten.html
TOPTEN_OUT_GLO=topten-glo.html
CUSTOM_INDX_TMP="$WEBDIR/custom/tmp_file"
FAV_INDX_TMP="$WEBDIR/favourites/tmp_file"
. $BINDIR/fav.sh  # read favorites code
if [ "$KEEP_VIRTUAL"x = "x" ]; then # accounting for DHL
  KEEP_VIRTUAL=0
fi
if [ "$ENTITLEMENT_LESS"x = "x" ]; then # DTE Energy
  ENTITLEMENT_LESS=0
fi

if [ $DEBUG ]; then echo "installing WWW : install-html.sh "; fi
if [ $DEBUG ]; then echo "Host identif   : $UNAME "; fi
DATE=`date`
if [ $DEBUG ]; then echo "timestamp      : $DATE "; fi

if [ -f $BINDIR/premium.sh -a $LPM -eq 1 ]; then
  . $BINDIR/premium.sh

  # prepare LPM, graph will be created one run after
  # find and symlink lpar under LPM
  if [ $DEBUG ]; then echo "LPM search     : rrm"; fi
  RR="rrm"
  RR_NEW="rrl"
  lpm_support 

  # find and symlink lpar under LPM for daily rrdtool data
  #if [ $DEBUG ]; then echo "LPM search     : rrd"; fi
  #RR="rrd"
  #RR_NEW="rrk"
  #lpm_support 
  # not necessary as it is never alone, there is always rrm or rrh so it is done together with them

  # find and symlink lpar under LPM for old hourly DBs
  if [ $DEBUG ]; then echo "LPM search     : rrh"; fi
  RR="rrh"
  RR_NEW="rri"
  lpm_support 

  RR=""
  DATE=`date`
  if [ $DEBUG ]; then echo "timestamp LPM  : $DATE "; fi
fi


if [ ! -d "$WEBDIR/custom" ]; then
  mkdir "$WEBDIR/custom"
fi
if [ ! -d "$WEBDIR/favourites" ]; then
  mkdir "$WEBDIR/favourites"
fi

if [ ! -f "$TMPDIR/favourites-tmp" ]; then
  if [ $DEBUG -eq 1 ]; then echo "Favorite update: cfg change detected"; fi 
  touch "$TMPDIR/favourites-tmp"
  touch "$TMPDIR/$version-run" # force recreation of the web 
else
  cfg_fav=`$PERL -e '$inp=shift;$v = (stat("$inp/etc/favourites.cfg"))[9]; print "$v\n";' $INPUTDIR`
  tmp_fav=`$PERL -e '$inp=shift;$v = (stat("$inp/favourites-tmp"))[9]; print "$v\n";' $TMPDIR`
  if [ $cfg_fav -gt $tmp_fav ]; then
    if [ $DEBUG -eq 1 ]; then echo "Favorite update: cfg change detected"; fi 
    touch "$TMPDIR/favourites-tmp"
    touch "$TMPDIR/$version-run" # force recreation of the web due to favourutes.cfg modification
  fi
fi

# create skeleton of menu
menu () {
  hmc=$1
  server=$2
  lpar=$3

  if [ "$server"x = "x" -a  "$lpar"x = "x" ]; then
    type="HMC"
    echo "$hmc::" >> $MENU_OUT
  fi

  if [ ! "$server"x = "x" -a "$lpar"x = "x" ]; then
    type="SERVER"
    echo "$hmc:$server:" >> $MENU_OUT
  fi

  if [ ! "$lpar"x = "x" ]; then
    type="LPAR"
    echo "$hmc:$server:$lpar" >> $MENU_OUT
  fi

}

menu_head  () {

path=jquery
if [ ! "$1"x = "x" ]; then
  path="$1/jquery"
fi

#<link rel="stylesheet" href="$path/my.css">
#  <META HTTP-EQUIV="refresh" CONTENT="600">
cat << END  
<!doctype html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <title>LPAR2RRD</title>
  <META HTTP-EQUIV="pragma" CONTENT="no-cache"> 
  <META HTTP-EQUIV="Expires" CONTENT="NOW"> 
  <META HTTP-EQUIV="last modified" CONTENT="NOW">
  <link rel="stylesheet" href="$path/jquery-ui-1.10.3.custom.min.css">
  <script src="$path/jquery-1.9.1.js"></script>
  <script src="$path/jquery-ui-1.10.3.custom.min.js"></script>
  <script src="$path/jquery.lazy.min.js"></script>
  <script>
  \$( document ).ready(function() {
        \$( "#tabs" ).tabs({
                activate: function() {
                        \$("img.lazy").lazy({
                                bind: "event",
                                effect: "fadeIn",
                                effectTime: 1000
                                });
                }
        });
        \$( "#tabs-1 img.lazy" ).lazy({
                        effect: "fadeIn",
                        effectTime: 1000
                        }
        );
  });
  </script>
  <script>
    \$(function() {
    \$( "#menu" ).menu();
    });
  </script>
  <style>
    .ui-menu { width: 150px; }
  </style>
  <STYLE TYPE="text/css">
  <!--
  .header, .header TD, .header TH
  {
    background-color:#D3D2F3;
  }
  -->
  </STYLE>
  <style>
  <!--
    a {text-decoration: none}
  -->
  </style>
  <SCRIPT TYPE="text/javascript">
  <!--
  function popup(mylink, windowname)
  {
    if (! window.focus)return true;
    var href;
    if (typeof(mylink) == 'string')
       href=mylink;
    else
       href=mylink.href;
    window.open(href, windowname, 'width=1329,height=670,scrollbars=yes');
    return false;
    }
  //-->
  </SCRIPT>


</head>
<BODY BGCOLOR="#D3D2D2" TEXT="#000000" LINK="#0000FF" VLINK="#0000FF" ALINK="#FF0000" >
END

}

print_log () {

# print html header
menu_head ""

cat << END
<div  id="tabs"> <ul>
  <li><a href="/lpar2rrd-cgi/log-cgi.sh?name=errlog">Global</a></li>
  <li><a href="/lpar2rrd-cgi/log-cgi.sh?name=errcgi">cgi-bin</a></li>
  <li><a href="/lpar2rrd-cgi/log-cgi.sh?name=alhist">Alert history</a></li>
END
if [ ! $ENTITLEMENT_LESS -eq 1 ]; then
  echo "  <li><a href=\"/lpar2rrd-cgi/log-cgi.sh?name=entitle\">Configuration Advisor</a></li>"
fi
cat << END
   </ul>
</div>
</body></html>
END
}


print_sys_log () {

# print html header
menu_head "../.."

cat << END
<div  id="tabs"> <ul>
  <li><a href="change-state.html">State change</a></li>
  <li><a href="change-config.html">Config change</a></li>
   </ul>
</div>
</body></html>
END
}


print_cfg () {

# print html header
menu_head ""

cat << END
<div  id="tabs"> <ul>
  <li><a href="/lpar2rrd-cgi/log-cgi.sh?name=maincfg">Global</a></li>
  <li><a href="/lpar2rrd-cgi/log-cgi.sh?name=favcfg">Favourites</a></li>
  <li><a href="/lpar2rrd-cgi/log-cgi.sh?name=custcfg">Custom groups</a></li>
  <li><a href="/lpar2rrd-cgi/log-cgi.sh?name=alrtcfg">Alerting</a></li>
   </ul>
</div>
</body></html>
END
}


# create menu itself

menu_create () {

  # Header
  menu_head  > $MENU_SRC

  echo "<div id=\"panel-left\" class=\"mypanel\">" >> $MENU_SRC
  echo "<ul id=\"menu\">" >> $MENU_SRC

  # GLOBAL
  echo " <li> <a href=\"#\">GLOBAL</a> <ul>" >> $MENU_SRC
  echo "   <li> <a href=\"favourites/aggregated/aggregated/index.html\">Favourites</A> </li>" >> $MENU_SRC
  echo "   <li> <a href=\"custom/AIX group/index.html\">Custom groups</A> </li>" >> $MENU_SRC
  echo "   <li> <a href=\"/lpar2rrd-cgi/cpu-workl-est.sh?sort=server&sortpool=server\">CPU Workload Estimator</A> </li>" >> $MENU_SRC
  echo "   <li> <a href=\"cpu_max_check.html\">Configuration Advisor</A> </li>" >> $MENU_SRC
  echo "   <li> <a href=\"/lpar2rrd-cgi/lpar-list.sh?sort=server\">Historical reports</A> </li>" >> $MENU_SRC
  echo "   <li> <a href=\"config-global.htm\">Physical&nbsp;and&nbsp;logical&nbsp;configuration</A> </li>" >> $MENU_SRC
  echo "   <li> <a href=\"topten-glo.html\">Top 10 global</A> </li>" >> $MENU_SRC
  echo "   <li> <a href=\"rmc.html\">RMC check</A> </li>" >> $MENU_SRC
  echo "   <li> <a href=\"pool-multi.html\">HMC totals</A> </li>" >> $MENU_SRC
  #echo "   <li> <a href=\"/lpar2rrd-cgi/virtual.sh?sort=server\">Accounting</A> </li>" >> $MENU_SRC
  echo " </ul> </li>" >> $MENU_SRC



  # HMC
  echo " <li class=\"ui-state-disabled\"><center>HMCs</center></li>" >> $MENU_SRC
  hmc_prev=""
  server_prev=""
  lpar_no=1
  for item_space in `sort $MENU_OUT|uniq|sed 's/ /====space====/g'`
  do
    item=`echo "$item_space"|sed 's/====space====/ /g'`
    hmc=`echo $item|cut -d":" -f1`
    server=`echo $item|cut -d":" -f2`
    lpar=`echo $item|cut -d":" -f3`
   
    if [ "$server"x = "x" -a  "$lpar"x = "x" ]; then
      if [ ! "$server_prev"x = "x" ]; then
        echo "   </ul> </li>" >> $MENU_SRC
      fi
      if [ ! "$hmc_prev"x = "x" ]; then
        echo " </ul> </li>" >> $MENU_SRC
      fi
      echo " <li> <a href=\"#\">$hmc</a> <ul>" >> $MENU_SRC
      hmc_prev=$hmc
      server_prev=""
      hmc_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$hmc"|sed -e 's/%20/ /g' -e 's/\#/\%23/g'`
    fi

    if [ ! "$server"x = "x" -a "$lpar"x = "x" ]; then
      if [ ! "$server_prev"x = "x" ]; then
        echo "   </ul> </li>" >> $MENU_SRC
      fi
      echo "   <li> <a href=\"#\">$server</a> <ul>" >> $MENU_SRC
      server_prev=$server
      server_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$server"|sed -e 's/%20/ /g' -e 's/\#/\%23/g'`
      lpar_no=0
    fi

    if [ ! "$lpar"x = "x" ]; then
      if [ $lpar_no -eq 0 ]; then
        # start of a new server, place first link
        lpar_no=1
        SYS_LINK="/lpar2rrd-cgi/detail-new.sh?host=$hmc_url&server=$server_url&lpar=smenu&item=smenu&none=none"
        echo "     <li> <a href=\"$SYS_LINK\">server</a> </li>" >> $MENU_SRC
        echo "     <li class=\"ui-state-disabled\">LPARs</li>" >> $MENU_SRC
      fi
      lpar_url=`$PERL -e '$s=shift;$s=~s/ /+/g;;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$lpar"|sed -e 's/%20/ /g' -e 's/\&\&1/\//g'`
      LPAR_LINK="/lpar2rrd-cgi/detail-new.sh?host=$hmc_url&server=$server_url&lpar=$lpar_url&item=lpar&entitle=$ENTITLEMENT_LESS&none=none"
      echo "     <li> <a href=\"$LPAR_LINK\">$lpar</a> </li>" >> $MENU_SRC
    fi


  done
  echo " </ul> </li>" >> $MENU_SRC # server
  echo " </ul> </li>" >> $MENU_SRC # HMC

  # System
  echo " <li> <a href=\"#\">SYSTEM</a> <ul>" >> $MENU_SRC
  echo "   <li> <a href=\"help.html\">Documentation</A>  </li>" >> $MENU_SRC
  echo "   <li> <a href=\"daily_lpar_check.html\">Data check</A>  </li>" >> $MENU_SRC

  print_cfg > cfg.html
  echo "   <li> <a href=\"cpu.html\">Configuration</A>  </li>" >> $MENU_SRC
  echo "   <li> <a href=\"/lpar2rrd-cgi/log-cgi.sh?name=alhist\">Alert history log</A>  </li>" >> $MENU_SRC
  echo "   <li> <a href=\"/lpar2rrd-cgi/log-cgi.sh?name=errlog\">Error log</A>  </li>" >> $MENU_SRC
  echo "   <li> <a href=\"/lpar2rrd-cgi/log-cgi.sh?name=errcgi\">Error log cgi-bin</A>  </li>" >> $MENU_SRC
  echo "   <li> <a href=\"/lpar2rrd-cgi/log-cgi.sh?name=entitle\">Configuration Advisor log</A>  </li>" >> $MENU_SRC
  echo " </ul> </li>" >> $MENU_SRC

  echo " </ul> " >> $MENU_SRC # menu
  echo "</div>" >> $MENU_SRC
  echo "<div id=\"main\">" >> $MENU_SRC

}

# --PH temp
#menu_create
#exit 0
rm -f $MENU_OUT

# build hmc bsased lpar and server cvs files into global one
create_cvs_global () {

first=0
cvs_global_lpar="lpar-config.csv"
for cvs_file in $WEBDIR/*/*-lpar-config.csv
do
  if [ $first -eq 0 ]; then
    first=1
    cp "$cvs_file" "$WEBDIR/$cvs_global_lpar"
    continue
  fi

  egrep -v "^HMC;server;lpar_name;" "$cvs_file" >> "$WEBDIR/$cvs_global_lpar"
done


first=0
cvs_global_server="server-config.csv"
for cvs_file in $WEBDIR/*/*-server-config.csv
do
  if [ $first -eq 0 ]; then
    first=1
    cp "$cvs_file" "$WEBDIR/$cvs_global_server"
    continue
  fi

  egrep -v "^HMC;server;" "$cvs_file" >> "$WEBDIR/$cvs_global_server"
done

}

print_cfg_global () {
cat << END
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<HTML>
<HEAD>
  <TITLE>LPAR2RRD</TITLE>
  <META HTTP-EQUIV="pragma" CONTENT="no-cache">
  <META HTTP-EQUIV="Expires" CONTENT="NOW">
  <META HTTP-EQUIV="last modified" CONTENT="NOW">
<style>
<!--
a {text-decoration: none}
-->
</style>
</HEAD>
<BODY BGCOLOR="#D3D2D2" TEXT="#000000" LINK="#0000FF" VLINK="#0000FF" ALINK="#FF0000" >
<BR>
<font size="-1"><A HREF="lpar-config.csv" target="_blank">CSV LPAR GLOBAL</A> / <A HREF="server-config.csv" target="_blank">CSV Server GLOBAL</A></font>
<CENTER>
<TABLE border="0"> <TR>
END

cd $WEBDIR

# header at first
for lcfg in `ls */config-high-sum.html-tmp|sort`
do
  hmccfg=`echo $lcfg|cut -d"/" -f1`
  servercfg=`echo $lcfg|cut -d"/" -f2`
  lcfg_path=`echo $lcfg|sed s/-tmp$//`
  echo "<td><center><h3><a href="$lcfg_path" target="sample">$hmccfg</a></h3></center></td>"
done
echo "</tr><tr>"

# body
for lcfg in `ls */config-high-sum.html-tmp|sort`
do
  #hmccfg=`echo $lcfg|cut -d"/" -f1`
  #servercfg=`echo $lcfg|cut -d"/" -f2`
  echo "<TD valign="top">"
  cat $lcfg
  echo "</td>"
done
echo "</tr></table>"
echo "</center><br><br><table><tr><td bgcolor=\"#80FF80\"> <font size=\"-1\"> running</font></td>"
echo "<td bgcolor=\"#FF8080\"> <font size=\"-1\"> not running</font></td>"
echo "<td  bgcolor=\"#FFFF80\"> <font size=\"-1\"> CPU pool</font></td></tr></table><br>"
date=`date`
echo "<font size="-1">It is updated once a day, last run: $date"
echo "</BODY></HTML>"


}

print_cfg_sum () {
hmccfg=$1
CFG_SUM="config-high-sum.html"

if [ -f $CFG_SUM-tmp ]; then
  cat << END 
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<META HTTP-EQUIV="pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="NOW">
<META HTTP-EQUIV="last modified" CONTENT="NOW">
<STYLE TYPE="text/css">
<!--
.header, .header TD, .header TH
{
background-color:#D3D2D2;
}
-->
</STYLE>
<style>
<!--
a {text-decoration: none}
-->
</style>
</head>";
<BODY BGCOLOR="#D3D2D2" TEXT="#000000" LINK="#0000FF" VLINK="#0000FF" ALINK="#FF0000" >
<A HREF="$hmcfg/config-high.html" target="sample">Summary configuration</A><br>
END

cat $hmcfg/$CFG_SUM

  cat << END 
END

fi
}


print_topten_head () {
server="$1"
host_act="$2"

cat << END 
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<HTML>
<HEAD>
  <TITLE>LPAR2RRD</TITLE>
  <META HTTP-EQUIV="pragma" CONTENT="no-cache"> 
  <META HTTP-EQUIV="Expires" CONTENT="NOW"> 
  <META HTTP-EQUIV="last modified" CONTENT="NOW">
<style>
<!--
a {text-decoration: none}
-->
</style>
</HEAD>
<BODY BGCOLOR="#D3D2D2" TEXT="#000000" LINK="#0000FF" VLINK="#0000FF" ALINK="#FF0000" >
<CENTER>
<BR>
END

if [ "$server"x = "x" ]; then
  #global one
  echo   "<h3>Top10 lpars per average CPU load </h3> "
else
  if [ "$host_act"x = "x" ]; then
    echo  "<h3>Top10 lpars per average CPU load for server : $server</h3> "
  else
    if [ -f "$inputdir/data/$server/$host_act/IVM" ]; then
      echo  "<h3>Top10 lpars per average CPU load for server : $host_act</h3> "
    else
      echo  "<h3>Top10 lpars per average CPU load for server : $server</h3> "
    fi
  fi
fi

cat << END
<TABLE border="0" CLASS="header">
<TR><TD  align="center"> <b>Last day</b> </TD><TD  align="center"> <b>Last week</b> </TD></TR>
END

return 0
}

print_topten () {
server="$2"

echo "<TD><TABLE border=\"0\" CLASS=\"header\">"
echo "<TR><TD nowrap valign=\"top\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<B>Avg load in cores</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD><TD nowrap><B>LPAR</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD><TD nowrap>&nbsp;&nbsp;&nbsp;&nbsp;<B>Server</B></TD></TR>"

if [ "$server"x = "x" ]; then
  #global one
  LIST=`find $TMPDIR -name \*-$1-tmp -mtime -1|egrep -v ".in-"`
else
  LIST=`find $TMPDIR -name "$server*-$1-tmp" -mtime -1|egrep -v ".in-"`
fi

for i in $LIST
do
  if [ -s $i ]; then
    name=`basename $i -tmp`
    mv $i $TMPDIR/$name
  fi
done

if [ "$TOPTEN"x = "x" ]; then
  TOPTEN=10
fi
topten_count=$TOPTEN

(( topten_dualhmc = TOPTEN * 2 )) # it is fix for dual HMC env

if [ "$server"x = "x" ]; then
  #global one
  LIST=`find $TMPDIR -name \*-\*-$1 -mtime -1 -exec cat {} \;|sed 's/ /%20/g'|grep "|"|sort -rn|uniq|head -$topten_dualhmc`
else
  LIST=`find $TMPDIR -name "$server-*-$1" -mtime -1 -exec cat {} \;|sed 's/ /%20/g'|grep "|"|sort -rn|uniq|head -$topten_dualhmc`
fi

lpar_old=""
for top in $LIST
do
  # echo "-- $1 : $topten_count : $top" > /tmp/e
  if [ $topten_count -eq 0 ]; then
    break
  fi
  load=`echo $top|sed 's/%20/ /g'|cut -d"|" -f1`
  lpar=`echo $top|sed -e 's/%20/ /g' -e 's/\&\&1/\//g'|cut -d"|" -f2`
  if [ "$lpar" = "$lpar_old" ]; then # most probably it is dual HMC record
    continue
  fi
  lpar_old=$lpar
  lpar_url=`$PERL -e '$s=shift;$s=~s/ /+/g;;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$lpar"`
  (( topten_count = topten_count - 1 ))
  managed=`echo "$top"|sed -e 's/%20/ /g'|cut -d"|" -f3`
  managed_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$managed"`
  managed_url_hash=`echo "$managed_url"|sed -e 's/\#/\%23/g'` # for support hashes in teh server name
  hmc=`echo $top|sed 's/%20/ /g'|cut -d"|" -f4`
  hmc_yes=`echo $top|sed 's/%20/ /g'|cut -d"|" -f5`
  hmc_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$hmc"`
  if [ $hmc_yes -eq 1 -o $hmc_yes -eq 2 ]; then
    # HMC || SDMC
    if [ "$server"x = "x" ]; then
      echo "<TR><TD  align=\"center\" nowrap><font size=\"-1\">$load</font></TD><TD nowrap><font size=\"-1\"><A HREF=\"/lpar2rrd-cgi/detail.sh?host=$hmc_url&server=$managed_url&lpar=$lpar_url&item=lpar&entitle=$ENTITLEMENT_LESS&none=none\" target=\"sample\">$lpar</A></font></TD><TD nowrap>&nbsp;&nbsp;&nbsp;&nbsp;<font size=\"-1\"><A HREF=\"$hmc/$managed_url_hash/pool/index.html\" target=\"main\">$managed</A></font></TD></TR>"
    else
      echo "<TR><TD  align=\"center\" nowrap><font size=\"-1\">$load</font></TD><TD nowrap><font size=\"-1\"><A HREF=\"/lpar2rrd-cgi/detail.sh?host=$hmc_url&server=$managed_url&lpar=$lpar_url&item=lpar&entitle=$ENTITLEMENT_LESS&none=none\" target=\"sample\">$lpar</A></font></TD><TD nowrap>&nbsp;&nbsp;&nbsp;&nbsp;<font size=\"-1\"><A HREF=\"../../$hmc/$managed_url_hash/pool/index.html\" target=\"main\">$managed</A></font></TD></TR>"
    fi
  else
    if [ "$server"x = "x" ]; then
      echo "<TR><TD  align=\"center\" nowrap><font size=\"-1\">$load</font></TD><TD nowrap><font size=\"-1\"><A HREF=\"/lpar2rrd-cgi/detail.sh?host=$hmc_url&server=$managed_url&lpar=$lpar_url&item=lpar&entitle=$ENTITLEMENT_LESS&none=none\" target=\"sample\">$lpar</A></font></TD><TD nowrap>&nbsp;&nbsp;&nbsp;&nbsp;<font size=\"-1\"><A HREF=\"$hmc/$managed_url_hash/pool/index.html\" target=\"main\">$hmc</A></font></TD></TR>"
    else
      echo "<TR><TD  align=\"center\" nowrap><font size=\"-1\">$load</font></TD><TD nowrap><font size=\"-1\"><A HREF=\"/lpar2rrd-cgi/detail.sh?host=$hmc_url&server=$managed_url&lpar=$lpar_url&item=lpar&entitle=$ENTITLEMENT_LESS&none=none\" target=\"sample\">$lpar</A></font></TD><TD nowrap>&nbsp;&nbsp;&nbsp;&nbsp;<font size=\"-1\"><A HREF=\"../../$hmc/$managed_url_hash/pool/index.html\" target=\"main\">$hmc</A></font></TD></TR>"

    fi
  fi
done
echo "</TABLE></TD>"

return 0
}

print_topten_all ()
{
server="$1"
hmc_act="$2"
print_topten_head "$server" "$hmc_act"
echo "<TR>"
print_topten d "$server"
print_topten w "$server"
echo "</TR>"
echo "<TR><TD  align=\"center\"> <br><br><b>Last month</b> </TD><TD  align=\"center\"> <br><br><b>Last year</b> </TD></TR>"
echo "<TR>"
print_topten m "$server"
print_topten y "$server"
echo "</TR></TABLE>"
echo "</center><br><br><font size=-1>Note that this page is refreshed once a day, the first LPAR2RRD run after the midnight"
echo "<br>If you want to have different number of lpars here like top 20 etc, then modify parameter TOPTEN=10 in etc/lpar2rrd.cfg</font>"
echo "</body></html>"
}

#
# real start of the script
#

# Global top10
print_topten_all > $WEBDIR/$TOPTEN_OUT_GLO

#Top10 per each server
for line in `cd $WEBDIR;find . -type d|cut -d "/" -f 2,3|grep "/"|sort|uniq|sed 's/ /+===============+/g'`
do
  hmc=`echo $line |sed 's/+===============+/ /g'|cut -d"/" -f1`
  server=`echo $line |sed 's/+===============+/ /g'|cut -d"/" -f2`

  if [ "$server"x = "x" -o "$hmc"x = "x" -o "$hmc" = "favourites" -o "$hmc" = "custom" -o "$hmc" = "jquery" ]; then
    continue
  fi

  print_topten_all "$server" "$hmc" > $WEBDIR/$hmc/$server/$TOPTEN_OUT
done

if [ $UPGRADE -eq 0 ]; then
  if [ ! -f $TMPDIR/$version-run ]; then
    if [ $DEBUG -eq 1 ]; then echo "Apparently nothing new, install_html.sh exiting"; fi
    exit 0
  else
    if [ $DEBUG -eq 1 ]; then echo "Apparently some changes in the env, install_html.sh continuing"; fi
  fi
else
  if [ $DEBUG -eq 1 ]; then echo "Looks like there was an upgrade, re-newing web pages"; fi
  touch $TMPDIR/$version
fi
rm -f $TMPDIR/$version-run

if [ ! -f "$WEBDIR/help.html" ]; then
  # copy of help file
  cp "$INPUTDIR/html/help.html" "$WEBDIR/" 
fi

if [ ! -d "$WEBDIR/jquery" -o $UPGRADE -eq 1 ]; then
  mkdir "$WEBDIR/jquery" 2>/dev/null
  cp -R "$INPUTDIR/html/jquery/"* "$WEBDIR/jquery"
fi

if [ $UPGRADE -eq 1 ]; then
  cp "$INPUTDIR/html/help.html" "$WEBDIR/"
fi


# create pages with physical and logical configuration
echo "config global  : creating global config"
G_CFG="$WEBDIR/config-global.htm"
print_cfg_global > "$G_CFG"
echo "config global  : creating CSV global config"
create_cvs_global

print_views () {

# print html header
menu_head "../.."

cat << END
<div  id="tabs"> <ul>
  <li><a href="#tabs-1">Daily</a></li>
  <li><a href="#tabs-2">Weekly</a></li>
  <li><a href="#tabs-3">Monthly</a></li>
  <li><a href="#tabs-4">Yearly</a></li>
   </ul> 
END


echo "<div id="tabs-1">"
cat daily-view/cpu.html
echo "</div>"

echo "<div id="tabs-2">"
cat weekly-view/cpu.html
echo "</div>"

echo "<div id="tabs-3">"
cat monthly-view/cpu.html
echo "</div>"

echo "<div id="tabs-4">"
cat yearly-view/cpu.html
echo "</div>"

echo "</div>"
echo "</body></html>"
}

print_multipool () {
hmc_multi=$1

# print html header
menu_head ".."
cat << END
<div  id="tabs"> <ul>
  <li><a href="#tabs-1">SERVER</a></li>
  <li><a href="#tabs-2">LPAR</a></li>
  <li><a href="#tabs-3">COUNT</a></li>
   </ul> 
END


cat << END 
<div id="tabs-1">
<center>
<h4>Servers CPU utilization per $hmc_multi</h4>
<table border="0"><tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$hmc_multi&server=nope&lpar=nope&item=multihmc&time=d&type_sam=m&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="pool-multi-d.png" ALT="daily stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$hmc_multi&server=nope&lpar=nope&item=multihmc&time=w&type_sam=m&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="pool-multi-w.png" ALT="daily stats"></font></a>
</td></tr><tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$hmc_multi&server=nope&lpar=nope&item=multihmc&time=m&type_sam=m&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="pool-multi-m.png" ALT="daily stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$hmc_multi&server=nope&lpar=nope&item=multihmc&time=y&type_sam=m&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="pool-multi-y.png" ALT="daily stats"></font></a>
</td></tr>
</table>
</center>

<font size="-1">
Above graphs do not take into consideration CPU dedicated partitions which have pre-allocated CPUs.<br>
Bellow graphs show everything on LPAR detail level and take into consideration CPU dedicated partitions.<br>
</font>
</div>

<div id="tabs-2">
<center>
<h4>LPARs CPU utilization per $hmc_multi</h4>
<table border="0"><tr><td valign="top">
<tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$hmc_multi&server=nope&lpar=nope&item=multihmclpar&time=d&type_sam=m&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="lpar-multi-d.png" ALT="daily stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$hmc_multi&server=nope&lpar=nope&item=multihmclpar&time=w&type_sam=m&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="lpar-multi-w.png" ALT="daily stats"></font></a>
</td></tr><tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$hmc_multi&server=nope&lpar=nope&item=multihmclpar&time=m&type_sam=m&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="lpar-multi-m.png" ALT="daily stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$hmc_multi&server=nope&lpar=nope&item=multihmclpar&time=y&type_sam=m&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="lpar-multi-y.png" ALT="daily stats"></font></a>
</td></tr>
</table>
<BR>
<BR>
</center>
<font size=-1>
Here are all CPUs from pools of servers under specific HMC. <br>Note that CPU utilization of CPU dedicated partitions is not shown in the graph so final result can be different from the server graphs above.<BR>
</font>
</div>
END

if [ -f "$WEBDIR/$hmc_multi/lpars_count_m.png" ]; then
cat << END 
<div id="tabs-3">
<CENTER>
<h4>Number of LPARs and servers per $hmc_multi</h4>
<table border="0"><tr><td valign="top">
<tr><td valign="top">
<IMG SRC="lpars_count_m.png" ALT="monthly stats">
</td><td valign="top">
<IMG SRC="lpars_count_y.png" ALT="yearly stats">
</td></tr></table>
</center>
<font size=-1>Graphs are updated once a day</font>
</div>
END
fi

echo "</div></BODY></HTML>"


}

print_search () {
cat << END 
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<HTML>
<HEAD>
  <TITLE>LPAR2RRD</TITLE>
  <META HTTP-EQUIV="pragma" CONTENT="no-cache"> 
  <META HTTP-EQUIV="Expires" CONTENT="NOW"> 
  <META HTTP-EQUIV="last modified" CONTENT="NOW">
  <META HTTP-EQUIV="refresh" CONTENT="600">
<style>
<!--
a {text-decoration: none}
-->
</style>
</HEAD>
<BODY BGCOLOR="#D3D2D2" TEXT="#000000" LINK="#0000FF" VLINK="#0000FF" ALINK="#FF0000" >
<font size=-1>
          <BR><BR>
<CENTER>
  <TABLE WIDTH=80% BORDER=0 CELLSPACING=5 SUMMARY="History reports">
	</CENTER>
    <TR> <TD>
       <FORM METHOD="GET" ACTION="/lpar2rrd-cgi/lpar-search.sh">
          <INPUT TYPE="TEXT" NAME="LPAR">
          <INPUT TYPE="SUBMIT" NAME="Search" VALUE="Search" ALT="Lpar Search"></TD></TR><TR><TD>
	  Case sensitive: <input type="hidden" name="case" value="1" />
       </TD>
      </TR>
       </FORM>
   </TABLE>
</BODY> </HTML>

END
}

print_header_lpar () {
cat << END 
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<HTML> <HEAD>
  <TITLE>LPAR2RRD</TITLE>
  <META HTTP-EQUIV="pragma" CONTENT="no-cache">
  <META HTTP-EQUIV="Expires" CONTENT="NOW">
  <META HTTP-EQUIV="last modified" CONTENT="NOW">
  <META HTTP-EQUIV="refresh" CONTENT="600">
<style>
<!--
a {text-decoration: none}
-->
</style>
<SCRIPT TYPE="text/javascript">
<!--
function popup(mylink, windowname)
{
if (! window.focus)return true;
var href;
if (typeof(mylink) == 'string')
   href=mylink;
else
   href=mylink.href;
window.open(href, windowname, 'width=1329,height=670,scrollbars=yes');
return false;
}
//-->
</SCRIPT>
</HEAD>
 <BODY BGCOLOR="#D3D2D2" TEXT="#000000" LINK="#0000FF" VLINK="#0000FF" ALINK="#FF0000" >
<CENTER><B>$1</B></CENTER><BR>
END
}

print_header_hmc () {
cat << END 
<html> <head>
<title>menu</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<META HTTP-EQUIV="pragma" CONTENT="no-cache"> 
<META HTTP-EQUIV="Expires" CONTENT="NOW"> 
<META HTTP-EQUIV="last modified" CONTENT="NOW">
<STYLE TYPE="text/css">
<!--
.header, .header TD, .header TH
{
background-color:#D3D2F3;
}
-->
</STYLE>
<style>
<!--
a {text-decoration: none}
-->
</style>
</head>
<BODY BGCOLOR="#C8C8C8" TEXT="#000000" LINK="#0000FF" VLINK="#0000FF" ALINK="#FF0000" >
<TABLE width="100%" border="0" cellpadding="0" cellspacing="0">
<TR><TD valign="bottom" nowrap><center>
<a href="http://www.lpar2rrd.com/" target="_blank"><font color="#C8C8C8"><img src="../../lpar2rrd-logo.png" border="0" alt="LPAR2RRD HOME"></font></a>
</center><br></TD></TR>
</TABLE>
END
cp $INDEX/lpar2rrd-logo.png $WEBDIR/
cp $INDEX/logo-stor2rrd-42.png $WEBDIR/
}

#<BODY BGCOLOR="#C8C8C8" TEXT="#000000" LINK="#0000FF" VLINK="#000080" ALINK="#FF0000" >
#<font size="-2" face="Tahoma" color="#333333" letterSpacing="0.000000">
#<font size=\"-2\" face="Tahoma" size="11" color="#333333" letterSpacing="0.000000">
#<font face=\"Tahoma\">

print_index () {
hmcB="$1"
managednameB_org="$2"

#KDS
managednameB=`echo "$managednameB_org"|sed 's/\#/%23/g'`
#managednameB=`echo "$managednameB_org"|sed -e 's/\#/%23/g' -e 's/ /%20/g'`
cp $INDEX/favicon.ico $WEBDIR/

cat << END > $WEBDIR/index.html
<html>
<head>
<title>LPAR2RRD</title>
<meta HTTP-EQUIV="Content-Type" CONTENT="text/html;">
<link rel="shortcut icon" href="favicon.ico">
</head>
<frameset border="0" frameborder="0" framespacing="0" cols="*" rows="*">
    <frame SRC="$hmcB/$managednameB/pool/index.html" NAME="main" border="0" scrolling="auto" noresize >
</frameset>
<BODY BGCOLOR="#99ccFF">
</body></html>
END
}

print_cpu_html_head () { 
lpar=$2
managedname=$3
host=$4

menu_head "../../.."

if [ `echo $managedname|egrep -- "--unknown$"|wc -l` -eq 1 ]; then
  echo "<center><h3>LPARs not being managed by the HMC</h3></center>"
  return
fi


# Exclude excluded systems
#echo "--- $managedname $lpar"
excl=1
eval 'echo "$LPM_HMC_EXCLUDE" | egrep "^$host:|:$host:|:$host$|^$host$" >/dev/null 2>&1'
if [ $? -eq 0 ]; then
  #if [ $DEBUG -eq 1 ]; then echo "Excluding LPM H: $host"; fi cannot be here
  excl=0 # it will be excluded as complete server is excluded from LPM
fi
eval 'echo "$LPM_SERVER_EXCLUDE" | egrep "^$managedname:|:$managedname:|:$managedname$|^$managedname$" >/dev/null 2>&1'
if [ $? -eq 0 ]; then
  #if [ $DEBUG -eq 1 ]; then echo "Excluding LPM S: $managedname"; fi cannot be here
  excl=0 # it will be excluded as complete server is excluded from LPM
fi
eval 'echo "$LPM_LPAR_EXCLUDE" | egrep "^$lpar:|:$lpar:|:$lpar$|^$lpar$" >/dev/null 2>&1'
if [ $? -eq 0 ]; then
  #if [ $DEBUG -eq 1 ]; then echo "Excluding LPM L: $lpar"; fi cannot be here
  excl=0 # LPM is excluded
fi

if [ -f "$2/d-lpm.png" -a $excl -eq 1 ]; then
cat << END 
<A HREF="cpu.html#LPM"><b>LPM</b></A>
END
fi
if [ -f "$2/d-ams.png" ]; then
cat << END 
&nbsp;&nbsp;<A HREF="cpu.html#AMS"><b>AMS</b></A>
END
fi

sh_pool=`echo $lpar|grep SharedPool|wc -l`

if [ "$lpar" = "pool" -o $sh_pool -gt 0 ]; then
  cat << END
  <div  id="tabs"> 
  <ul>
    <li><a href="#tabs-1">CPU POOL</a></li>
    <li><a href="#tabs-2">LPARs aggregated</a></li>
    <li><a href="#tabs-3">Configuration</a></li>
  </ul>
  <div id="tabs-1">
END

  #pages with on-click detail
  host_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$host"`
  server_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$managedname"`
  if [ "$lpar" = "pool" ]; then
    item="pool"
  else
    item="shpool"
  fi
  type_sam=`echo $RR|sed 's/rr//'`
  type_sam_year=$type_sam
  if [ -f "$INPUTDIR/data/$managedname/$host/pool.rrd" ]; then
    type_sam_year="d"
  fi



  cat << END 
<CENTER>
<h4>$1 $refresh</h4>
<table border="0"><tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar&item=$item&time=d&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="d.png" ALT="daily stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar&item=$item&time=w&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="w.png" ALT="weekly stats"></font></a>
</td></tr><tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar&item=$item&time=m&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="m.png" ALT="monthly stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar&item=$item&time=y&type_sam=$type_sam_year&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="y.png" ALT="yearly stats"></font></a>
</td></tr><tr><td align="center" valign="top" colspan="2">
<IMG SRC="y-trend.png" ALT="yearly stats - trend">
</td></tr></table>
</CENTER>
</div>
END

else # pages without on-click detail
cat << END 
<CENTER>
<h4>$1 $refresh</h4>
<table border="0"><tr><td valign="top">
<IMG SRC="d.png" ALT="daily stats">
</td><td valign="top">
<IMG SRC="w.png" ALT="weekly stats">
</td></tr><tr><td valign="top">
<IMG SRC="m.png" ALT="monthly stats">
</td><td valign="top">
<IMG SRC="y.png" ALT="yearly stats">
</td></tr><tr><td align="center" valign="top" colspan="2">
<IMG SRC="y-trend.png" ALT="yearly stats - trend">
</td></tr></table>
</CENTER>
END
fi  



# CPU pools aggregated except the main CPU pool
if [ -f "$2/d-agg.png" ]; then
cat << END
<div id="tabs-2">
<CENTER>
<h4>$1 LPARs aggregated</h4>
</center>
<font size=-1>Note that aggregated graphs here are only informative. <br>
LPAR list in the pool is actual and if it is different than it was in the past then historical graphs might not be accurate (they migh not contain proper LPAR list).
</font>
<center>
<BR><br>
<table border="0"><tr><td valign="top">
<IMG SRC="d-agg.png" ALT="daily aggregated stats">
</td><td valign="top">
<IMG SRC="w-agg.png" ALT="weekly aggregated stats">
</td></tr><tr><td valign="top">
<IMG SRC="m-agg.png" ALT="monthly aggregated stats">
</td><td valign="top">
<IMG SRC="y-agg.png" ALT="yearly aggregated stats">
</td></tr></table>
<BR>
</center>
</div>
END
fi


# CPU main pool
if [ "$item" = "pool" ]; then
item_new="lparagg"
lpar_new="pool-multi"
cat << END 
<div id="tabs-2">
<CENTER>
<h4>$1 : LPARs aggregated</h4>
</CENTER>
<table border="0"><tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar_new&item=$item_new&time=d&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="../pool-multi/d.png" ALT="daily stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar_new&item=$item_new&time=w&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="../pool-multi/w.png" ALT="weekly stats"></font></a>
</td></tr><tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar_new&item=$item_new&time=m&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="../pool-multi/m.png" ALT="monthly stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar_new&item=$item_new&time=y&type_sam=$type_sam_year&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="../pool-multi/y.png" ALT="yearly stats"></font></a>
</td></tr></table>
</div>
END
fi

# LPM stuff
if [ -f "$2/d-lpm.png" -a $excl -eq 1 ]; then
cat << END
<A NAME=LPM>
<CENTER>
<B>Live Partition Mobility</B>
</center>
<BR><br>
<table border="0"><tr><td valign="top">
<IMG SRC="d-lpm.png" ALT="daily LPM stats">
</td><td valign="top">
<IMG SRC="w-lpm.png" ALT="weekly LPM stats">
</td></tr><tr><td valign="top">
<IMG SRC="m-lpm.png" ALT="monthly LPM stats">
</td><td valign="top">
<IMG SRC="y-lpm.png" ALT="yearly LPM stats">
</td></tr></table>
<BR>
END
fi

# AMS stuff
if [ -f "$2/d-ams.png" ]; then
cat << END
<A NAME=AMS>
<CENTER>
<B>Memory - Active Memory Sharing</B>
</center>
<BR><br>
<table border="0"><tr><td valign="top">
<IMG SRC="d-ams.png" ALT="daily AMS stats">
</td><td valign="top">
<IMG SRC="w-ams.png" ALT="weekly AMS stats">
</td></tr><tr><td valign="top">
<IMG SRC="m-ams.png" ALT="monthly AMS stats">
</td><td valign="top">
<IMG SRC="y-ams.png" ALT="yearly AMS stats">
</td></tr></table>
<BR>
END
fi

}


print_hea_html_head () { 
cat << END 
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<HTML>
<HEAD>
  <TITLE>LPAR2RRD</TITLE>
  <META HTTP-EQUIV="pragma" CONTENT="no-cache"> 
  <META HTTP-EQUIV="Expires" CONTENT="NOW"> 
  <META HTTP-EQUIV="last modified" CONTENT="NOW">
  <META HTTP-EQUIV="refresh" CONTENT="600">
<style>
<!--
a {text-decoration: none}
-->
</style>
</HEAD>
<BODY BGCOLOR="#D3D2D2" TEXT="#000000" LINK="#0000FF" VLINK="#0000FF" ALINK="#FF0000" >
<CENTER>
END
}


print_mem_html_head () { 
type=$2

menu_head "../../.."

cat << END
  <div  id="tabs">
  <ul>
    <li><a href="#tabs-1">Allocation</a></li>
    <li><a href="#tabs-2">Aggregated</a></li>
END
if [ -f "mem-multi/d.png" ]; then
  echo "    <li><a href=\"#tabs-3\">AMS</a></li>"
fi
cat << END
    <li><a href="#tabs-4">Configuration</a></li>
  </ul>
END


MEM_AGG_DIR="mem-agg"
 

#pages with on-click detail
host_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$host"`
server_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$managedname"`
item="memagg"
type_sam=`echo $RR|sed 's/rr//'`
type_sam_year=$type_sam
if [ -f "$INPUTDIR/data/$managedname/$host/pool.rrd" ]; then
  type_sam_year="d"
fi

# static memory total allocation
cat << END 
<div id="tabs-1">
<center> <h4>$1</h4>
<table border="0"><tr><td valign="top">
<IMG SRC="d.png" ALT="daily stat">
</td><td valign="top">
<IMG SRC="w.png" ALT="weekly stat">
</td></tr><tr><td valign="top">
<IMG SRC="m.png" ALT="monthly stat">
</td><td valign="top">
<IMG SRC="y.png" ALT="yearly stat">
</td></tr>
<tr><td valign="top" colspan="2" align="center">
<IMG SRC="y-trend.png" ALT="yearly stat - trend">
</td></tr>
</table>
</div>
END

if [ -f $MEM_AGG_DIR/d.png ]; then
cat << END 
<div id="tabs-2">
<center>
<h4>Memory allocation - aggregated</h4>
<A NAME=MEMAGG></A>
<table border="0"><tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar&item=$item&time=d&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="../$MEM_AGG_DIR/d.png" ALT="daily stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar&item=$item&time=w&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="../$MEM_AGG_DIR/w.png" ALT="weekly stats"></font></a>
</td></tr><tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar&item=$item&time=m&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="../$MEM_AGG_DIR/m.png" ALT="monthly stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar&item=$item&time=y&type_sam=$type_sam_year&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="../$MEM_AGG_DIR/y.png" ALT="yearly stats"></font></a>
</td></tr></table>
</CENTER>
</div>
END
fi

# AMS stuff
if [ -f "mem-multi/d.png" ]; then
cat << END
<div id="tabs-3">
<A NAME=AMS>
<CENTER>
<h4>Memory - Active Memory Sharing</h4>
</center>
<table border="0"><tr><td valign="top">
<IMG SRC="../mem-multi/d.png" ALT="daily AMS stats">
</td><td valign="top">
<IMG SRC="../mem-multi/w.png" ALT="weekly AMS stats">
</td></tr><tr><td valign="top">
<IMG SRC="../mem-multi/m.png" ALT="monthly AMS stats">
</td><td valign="top">
<IMG SRC="../mem-multi/y.png" ALT="yearly AMS stats">
</td></tr></table>
</div>
END
fi


}

print_cpu_multi_html_head () { 
type=$2

cat << END 
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<HTML>
<HEAD>
  <TITLE>LPAR2RRD</TITLE>
  <META HTTP-EQUIV="pragma" CONTENT="no-cache"> 
  <META HTTP-EQUIV="Expires" CONTENT="NOW"> 
  <META HTTP-EQUIV="last modified" CONTENT="NOW">
  <META HTTP-EQUIV="refresh" CONTENT="600">
<style>
<!--
a {text-decoration: none}
-->
</style>
<SCRIPT TYPE="text/javascript">
<!--
function popup(mylink, windowname)
{
if (! window.focus)return true;
var href;
if (typeof(mylink) == 'string')
   href=mylink;
else
   href=mylink.href;
window.open(href, windowname, 'width=1329,height=670,scrollbars=yes');
return false;
}
//-->
</SCRIPT>
</HEAD>
<BODY BGCOLOR="#D3D2D2" TEXT="#000000" LINK="#0000FF" VLINK="#0000FF" ALINK="#FF0000" >
<CENTER>
END

 
if [ "$2" = "cpu" ]; then
  echo "<B>$1</B><BR>"
else
  # for Memory based pages add "How to on the right up corner"
cat << END 
  <TABLE BORDER=0 width="100%"><tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td align="center">
  <b>$1</b>
  </td><td align="right" valign="top"><font size="-1"><a href="http://www.lpar2rrd.com/active_memory_sharing_ams.html" target="_blank">How it works</a></font> </td></tr></table>
END
fi

if [ "$2" = "cpu" ]; then
  #pages with on-click detail
  host_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$host"`
  server_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$managedname"`
  item="lparagg"
  type_sam=`echo $RR|sed 's/rr//'`
  type_sam_year=$type_sam
  if [ -f "$INPUTDIR/data/$managedname/$host/pool.rrd" ]; then
    type_sam_year="d"
  fi

cat << END 
<table border="0"><tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar&item=$item&time=d&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="d.png" ALT="daily stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar&item=$item&time=w&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="w.png" ALT="weekly stats"></font></a>
</td></tr><tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar&item=$item&time=m&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="m.png" ALT="monthly stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar&item=$item&time=y&type_sam=$type_sam_year&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="y.png" ALT="yearly stats"></font></a>
</td></tr></table>
</CENTER>
<BR>
<BR>
END

else # pages without on-click detail


cat << END 
<table border="0"><tr><td valign="top">
<IMG SRC="d.png" ALT="daily stat">
</td><td valign="top">
<IMG SRC="w.png" ALT="weekly stat">
</td></tr><tr><td valign="top">
<IMG SRC="m.png" ALT="monthly stat">
</td><td valign="top">
<IMG SRC="y.png" ALT="yearly stat">
</td></tr></table>
</CENTER>
<BR>
<BR>
END
fi


if [ "$2" = "cpu" ]; then
  echo "<A HREF=\"/lpar2rrd-cgi/lpar-list.sh?\">LPARs aggregated accross all HMC/IVM/SDMC</A>"
fi
if [ $HWINFO -eq 1 ]; then
  if [ "$2" = "mem" ]; then
    echo "<A HREF=\"../../../$hmc/$managedname/config.html#Memory\">Memory configuration</A> "
  fi
fi

}


# put the link to configuration depends on the source (CPU/CPU pools/MEM/LPAR)
print_cpu_html_tail () { 

  if [ `echo $managedname|egrep -- "--unknown$"|wc -l` -eq 1 ]; then
    echo "</BODY> </HTML>" >> "$1"
    return
  fi

  # print CPU cfg info for each lpar
  lpar_slash=`echo "$3"|sed 's/\//\&\&1/g'`
  if [ -f "$lpar_slash" ]; then
    grep -iv "logical_serial_num" "$lpar_slash" >> $1 # exclude logical_serial_num from CPU info on the web
  fi

  if [ $HWINFO -eq 1 ]; then
    if [ "$2" = "Memory usage" ]; then
      echo "<div id=\"tabs-4\">" >> "$1"
      cat "$INPUTDIR/data/$managedname/$hmc/mem.html" >> "$1"
      echo "</center><br>The table is updated once a day"  >> "$1"
      echo "<br><br><A HREF=\"../../../$hmc/$managedname/config.html#Memory\">Detailed configuration</A> " >> "$1"
    else
      echo "<div id=\"tabs-3\">" >> "$1"
      if [ "$2" = "Totally for all CPU pools" -o "$2" = "CPU pool" ]; then
         if [ -f "$INPUTDIR/data/$managedname/$hmc/cpu.html" ]; then
           cat "$INPUTDIR/data/$managedname/$hmc/cpu.html" >> "$1"
         fi
         echo "<br>The table is updated once a day"  >> "$1"
         echo "<br><br><A HREF=\"../../../$hmc/$managedname/config.html#CPU_pool\">Detailed configuration</A> " >> "$1"
      else    
        echo "$2" | egrep "CPU pool" >/dev/null 2>&1
        if [ $? -eq 0 ]; then
           if [ -f "$INPUTDIR/data/$managedname/$hmc/cpu.html" ]; then
             # get details for cpu pools from cpu.html
             pool_name=`echo $2|sed -e 's/^CPU pool: //' -e 's/ :$//`
             egrep "<TABLE|TABLE>|<TH>LPAR name|>$pool_name</TD> <TD align=\"center\">&nbsp;" "$INPUTDIR/data/$managedname/$hmc/cpu.html" >> "$1"
           fi
           echo "<br>The table is updated once a day"  >> "$1"
           echo "<br><br><A HREF=\"../../../$hmc/$managedname/config.html#CPU_pools\">Detailed configuration</A> " >> "$1"
        else 
          echo "<A HREF=\"../../../$hmc/$managedname/config.html#$2\">Detailed configuration</A> " >> "$1"
        fi
      fi
    fi
    echo "</div></div>" >> "$1"
  fi
  echo "</BODY> </HTML>" >> "$1"
}

# checks if managed name is alive (if it does not update
#  pool.rrm for 10 days then it is considered as death)
is_alive() {

# never use same name of variable in function as it the program globally!!!!
hmcA=`echo "$1"|sed 's/\\\\_/ /g'`
managednameA=`echo "$2"|sed 's/\\\\_/ /g'`

if [ `echo $managednameA|egrep -- "--unknown$"|wc -l` -eq 1 ]; then
  # lpars without the HMC
  # always alive so far
  return 0
fi

# 10 days in secs
TEND=864000
#TEND=600

#echo "$INPUTDIR/data/$managednameA/$hmcA $WEBDIR/$hmcA/$managednameA"
if [ ! -d $INPUTDIR/data/"$managednameA"/"$hmcA" ]; then
 if [ -d "$WEBDIR/$hmcA/$managednameA" ]; then
   if [ $DEBUG -eq 1 ]; then echo "rm old system  : rm -rf $WEBDIR/$hmcA/$managednameA (no HMC found)"; fi
   rm -rf $WEBDIR/"$hmcA"/"$managednameA"
 fi
 return 1
fi


if [ -f "$INPUTDIR/data/$managednameA/$hmcA/pool.in-m" ]; then
  access_t=`$PERL -e '$inp=shift;$m=shift;$h=shift;$v = (stat("$inp/data/$m/$h/pool.in-m"))[9]; print "$v\n";' $INPUTDIR "$managednameA" $hmcA`
else if [ -f "$INPUTDIR/data/$managednameA/$hmcA/pool.in-h" ]; then
       access_t=`$PERL -e '$inp=shift;$m=shift;$h=shift;$v = (stat("$inp/data/$m/$h/pool.in-h"))[9]; print "$v\n";' $INPUTDIR "$managednameA" $hmcA`
     else if [ -f "$INPUTDIR/data/$managednameA/$hmcA/pool.in-d" ]; then
       access_t=`$PERL -e '$inp=shift;$m=shift;$h=shift;$v = (stat("$inp/data/$m/$h/pool.in-d"))[9]; print "$v\n";' $INPUTDIR "$managednameA" $hmcA`
          else
       	    access_t=0
	  fi
     fi
fi

tot=`expr $TEND + $access_t`
#echo "-- $tot --"
#echo "++ $access_t -- $TIME "$managedname"A"
#echo "-- $inp/data/$m/$h/pool.in-m anagednameA"

if [ $tot -lt $TIME ]; then
  # it is death
  if [ -d "$WEBDIR/$hmcA/$managednameA" ]; then
    if [ $DEBUG -eq 1 ]; then echo "rm old system  : rm -rf $WEBDIR/$hmcA/$managednameA (is not being updated for >10days)"; fi
    rm -rf $WEBDIR/"$hmcA"/"$managednameA"
  fi
  return 1
fi

return 0
}


###################################################################################################
# Main section
###################################################################################################

for dir1 in $INPUTDIR/data/*
do

  # exclude sym links 
  if [ -L "$dir1" ]; then
    continue
  fi

  managedname=`basename "$dir1"`

  # Exclude excluded systems
  eval 'echo "$MANAGED_SYSTEMS_EXCLUDE" | egrep "^$managedname:|:$managedname:|:$managedname$|^$managedname$" >/dev/null 2>&1'
  if [ $? -eq 0 ]; then
    if [ $DEBUG -eq 1 ]; then echo "Excluding      : $managedname"; fi
    continue
  fi

  for dir2 in $INPUTDIR/data/"$managedname"/*
  do
    if [ ! -d "$dir2" ]; then
      continue
    fi

    hmc=`basename "$dir2"`
    if [ $DEBUG -eq 1 ]; then echo "server start   : $hmc:$managedname"; fi

    # sed bellow is a workaround for managed names with spaces
    is_alive `echo "$hmc"|sed 's/ /\\\\\\_/g'`  `echo "$managedname" |sed 's/ /\\\\\\_/g'`
    if [ $? -eq 1 ] ; then
      # remove systems not being updated (only from WEB!)
      continue
    fi

    # Create HMC and managed name dirs, they are usually created in lpar2rrd.pl
    if [ ! -d $WEBDIR ]; then
      if [ $DEBUG -eq 1 ]; then echo "Creating basedir: $WEBDIR"; fi
      mkdir $WEBDIR
    fi
    cd $WEBDIR
    if [ ! -d $WEBDIR/$hmc ]; then
      if [ $DEBUG -eq 1 ]; then echo "Creating new HMC: $WEBDIR/$hmc"; fi
      mkdir $WEBDIR/$hmc
    fi
  
    if [ ! -d "$WEBDIR/$hmc/$managedname" ]; then
      if [ $DEBUG -eq 1 ]; then echo "New server     : $WEBDIR/$hmc/$managedname"; fi
      mkdir "$WEBDIR/$hmc/$managedname"
    fi
    cd "$WEBDIR/$hmc/$managedname"
    rm -f "$INPUTDIR/data/$managedname/$hmc/.rr*" # workaround to delete .rrm files which somehow appears there

    # LPARs without the HMC (comming only from the agent and a trick how to import then into std processing
    # create pool.rrh  --> fake pool data, rrh on purpose
    if [ `echo $managednameA|egrep -- "--unknown$"|wc -l` -eq 1 ]; then
      if [ ! -f $INPUTDIR/data/"$managedname"/"$hmc"/pool.rrh ]; then
        touch $INPUTDIR/data/"$managedname"/"$hmc"/pool.rrh
      fi
      for i in $INPUTDIR/data/"$managedname"/"$hmc"/*
      do
        if [ -d "$i" ]; then
          if [ ! -f "$i.rrh" ]; then
            # create fake lpar
            touch "$i.rrh"
          fi
        fi
      done
    fi

    # find what kind of sample rata is being used 3600 or less
    if [ -f "$INPUTDIR/data/$managedname/$hmc/pool.rrm" ];  then
      if [ -f "$INPUTDIR/data/$managedname/$hmc/pool.rrh" ];  then
        rrh=`$PERL -e '$inp=shift;$m=shift;$h=shift;$v = (stat("$inp/data/$m/$h/pool.rrh"))[9]; print "$v\n";' $INPUTDIR "$managedname" $hmc`
        rrm=`$PERL -e '$inp=shift;$m=shift;$h=shift;$v = (stat("$inp/data/$m/$h/pool.rrm"))[9]; print "$v\n";' $INPUTDIR "$managedname" $hmc`
        #echo "---- $rrh $rrm"
	if [ $rrh -gt $rrm ]; then
          RR=rrh
	else
          RR=rrm
	fi	
      else
        RR=rrm
      fi
    else
      RR=rrh
    fi
    #echo "-- $RR"
    
    empty=`find $INPUTDIR/data/"$managedname"/"$hmc" -name "*.$RR"|wc -l`
    if [ ! $empty -eq 0 ]; then

      for viewdir in $VIEW
      do
        if [ ! -d $viewdir -o $UPGRADE -eq 1 ]; then
          if [ ! -d "$viewdir" ]; then
            if [ $DEBUG -eq 1 ]; then echo "new view       : $viewdir"; fi
            mkdir "$viewdir"
          else
            if [ $UPGRADE -eq 1 ]; then
              # delete all links and html to let it create clean after an upgrade
              rm $viewdir/*
              if [ $DEBUG -eq 1 ]; then echo "view recreate  : $hmc:$managedname:$view"; fi
            fi
          fi
          cp $INDEX/index.html $INDEX/menuframe.html $INDEX/right_all.html $viewdir/
          m=`echo "$managedname" |sed -e 's/ /\\\\ /g' -e 's/--unknown$//'`
          if [ $IVM -eq 0 ]; then
            eval 'sed -e 's/XXXXXXXX/$hmc:$m/g' -e 's/ENTITLE/$ENTITLEMENT_LESS/' $INDEX/top.src  > $viewdir/top.html ' 2>/dev/null
          else
            eval 'sed -e 's/XXXXXXXX/$hmc/g' -e 's/ENTITLE/$ENTITLEMENT_LESS/' $INDEX/top.src  > $viewdir/top.html ' 2>/dev/null
          fi
        fi 
      done

      for i in $INPUTDIR/data/"$managedname"/"$hmc"/*.$RR
      do
        # Check whewther it is IVM based box
	IVM=0
        if [ -f "$INPUTDIR/data/$managedname/$hmc/IVM" ];  then
          IVM=1
        fi
	SDMC=0
        if [ -f "$INPUTDIR/data/$managedname/$hmc/SDMC" ];  then
          SDMC=1
        fi
	#pregarz start - lpar with space in name#
	ff=$(echo "$i"|tr ' ' '@')
	gg=`basename "$ff" ".$RR"`
	lpar=$(echo "$gg"|tr '@' ' ')
	#pregarz end #
	lpar_slash=`echo "$lpar" | sed 's/\&\&1/\//g'`
        if [ $DEBUG -eq 1 ]; then echo "updating web   : $hmc:$managedname:$lpar_slash"; fi
    
        if [ ! -f "$lpar/index.html" -o $UPGRADE -eq 1 ]; then
          if [ ! -d "$lpar" ]; then
            if [ $DEBUG -eq 1 ]; then echo "new lpar       : $hmc:$managedname:$lpar_slash"; fi
            mkdir "$lpar"
          else
            if [ $DEBUG -eq 1 ]; then echo "lpar refresh   : $hmc:$managedname:$lpar_slash"; fi
          fi
          cp $INDEX/index.html $INDEX/menuframe.html $INDEX/right_all.html "$lpar/"
          m=`echo "$managedname" |sed -e 's/ /\\\\ /g' -e 's/--unknown$//'`
          if [ $IVM -eq 0 ]; then
            eval 'sed -e 's/XXXXXXXX/$hmc:$m/g' -e 's/ENTITLE/$ENTITLEMENT_LESS/' $INDEX/top.src  > "$lpar/top.html" ' 2>/dev/null
	  else
            eval 'sed -e 's/XXXXXXXX/$hmc/g' -e 's/ENTITLE/$ENTITLEMENT_LESS/' $INDEX/top.src  > "$lpar/top.html" ' 2>/dev/null
          fi 
	  if [ ! -f "$lpar/y.png" ]; then
            # probably fresh allowed utilization data collection on the HMC then put there temporary defaut picture
	    cp $INDEX/y-def.jpg "$lpar/y.png"
          fi
	  if [ ! -f "$lpar/y-trend.png" ]; then
            # probably fresh allowed utilization data collection on the HMC then put there temporary defaut picture
	    cp $INDEX/y-def.jpg "$lpar/y-trend.png"
          fi

          cd daily-view
          eval 'ln -sf ../"$lpar"/d-view.png "$lpar"-d.png' 2>/dev/null
          cd ../weekly-view
          eval 'ln -sf ../"$lpar"/w-view.png "$lpar"-w.png' 2>/dev/null
          cd ../monthly-view
          eval 'ln -sf ../"$lpar"/m-view.png "$lpar"-m.png' 2>/dev/null
          cd ../yearly-view
          if [ ! -f "../$lpar/y-view.png" ]; then
            # workaround when 3.37 upgrade hapens and yearly -view.png is not created yet
            cp "../$lpar/y.png" "../$lpar/y-view.png" 2>/dev/null
          fi
          eval 'ln -sf ../"$lpar"/y-view.png "$lpar"-y.png' 2>/dev/null
          cd ..
        fi

	# create cpu.html (each time it has to be recreated)
	header=$lpar
	if [ "$lpar" = "pool" ]; then
    	  shared_pools=0
   	  for dir8 in SharedPool*
    	  do
      	    if [ -d $dir8 -a ! "$dir8" = "SharedPool0" ]; then
       	      shared_pools=1
      	    fi
    	  done
     	  if [ $shared_pools -gt 0 ]; then
	    header="Totally for all CPU pools"
	  else
	    header="CPU pool"
  	  fi
 	fi

	if [ "$lpar" = "mem" ]; then
	  namelpar="Memory usage"
          refresh=""    # memory does not have "refresh" button
	  print_mem_html_head "Memory allocated" "mem" > "$lpar/cpu.html" 
	  print_cpu_html_tail "$lpar/cpu.html" "$namelpar" "$INPUTDIR/data/$managedname/$hmc/cpu.cfg-$lpar"
          continue
	else
          namelpar=`echo "$header" |sort -f|sed -e 's/SharedPool/CPU pool /g' -e 's/\&\&1/\//g'`
          name_space=`echo "$namelpar" |sed -e 's/Totally for all CPU pools/CPU pool/' -e 's/ /%20/g'`
          refresh="&nbsp;&nbsp;<font size=-1><A HREF=\"/lpar2rrd-cgi/lpar2rrd-realt.sh?source=$name_space&hmc=$hmc&mname=$managedname\">Refresh</A></font>"
          # refresh must be here before bellow code, it is passwed to print_cpu_html_head as a global variable

	  if [ `echo $lpar|egrep "SharedPool|CPU pool "|wc -l` -gt 0 ]; then
            # CPU pool name translation
            if [ -f $INPUTDIR/data/"$managedname"/"$hmc"/cpu-pools-mapping.txt ]; then
              pool_id=`echo "$lpar"|sed -e 's/SharedPool//g' -e 's/CPU pool //'`
              pool_alias=`egrep "^$pool_id," $INPUTDIR/data/"$managedname"/"$hmc"/cpu-pools-mapping.txt|sed 's/^\$pool_id,//g'| awk -F, '{print $2 }'`
              if [ ! "$pool_alias"x = "x" ]; then
                namelpar="CPU pool: $pool_alias :"
              fi
            fi
          fi
 	fi

	print_cpu_html_head "$namelpar" "$lpar" "$managedname" "$hmc" > "$lpar/cpu.html" 
	print_cpu_html_tail "$lpar/cpu.html" "$namelpar" "$INPUTDIR/data/$managedname/$hmc/cpu.cfg-$lpar"

        # create structure for lpar aggregated graphs
        if [ "$lpar" = "pool" ]; then
          lpar="pool-multi" 
          if [ ! -f "$lpar/index.html" -o $UPGRADE -eq 1 ]; then
            if [ $DEBUG -eq 1 ]; then echo "new pool multi : $hmc:$managedname:$lpar"; fi
            if [ ! -d "$lpar" ]; then
              mkdir "$lpar" 
            fi
            cp $INDEX/index.html $INDEX/menuframe.html $INDEX/right_all.html "$lpar/"
            m=`echo "$managedname" |sed -e 's/ /\\\\ /g' -e 's/--unknown$//'`
            if [ $IVM -eq 0 ]; then
              eval 'sed -e 's/XXXXXXXX/$hmc:$m/g' -e 's/ENTITLE/$ENTITLEMENT_LESS/' $INDEX/top.src  > "$lpar/top.html" ' 2>/dev/null
	    else
              eval 'sed -e 's/XXXXXXXX/$hmc/g' -e 's/ENTITLE/$ENTITLEMENT_LESS/' $INDEX/top.src  > "$lpar/top.html" ' 2>/dev/null
            fi 
	    if [ ! -f "$lpar/y.png" ]; then
              # probably fresh allowed utilization data collection on the HMC then put there temporary defaut picture
	      cp $INDEX/y-def.jpg "$lpar/y.png"
            fi
	    if [ ! -f "$lpar/y-trend.png" ]; then
              # probably fresh allowed utilization data collection on the HMC then put there temporary defaut picture
	      cp $INDEX/y-def.jpg "$lpar/y-trend.png"
            fi
            cd daily-view
            eval 'ln -sf ../"$lpar"/d-view.png "$lpar"-d.png' 2>/dev/null
            cd ../weekly-view
            eval 'ln -sf ../"$lpar"/w-view.png "$lpar"-w.png' 2>/dev/null
            cd ../monthly-view
            eval 'ln -sf ../"$lpar"/m-view.png "$lpar"-m.png' 2>/dev/null
            cd ../yearly-view
            if [ ! -f "../$lpar/y-view.png" ]; then
              # workaround when 3.37 upgrade hapens and yearly -view.png is not created yet
              cp "../$lpar/y.png" "../$lpar/y-view.png" 2>/dev/null
            fi
            eval 'ln -sf ../"$lpar"/y-view.png "$lpar"-y.png' 2>/dev/null
            cd ..
          fi

          # it is already in the tab
	  #print_cpu_multi_html_head "LPARs aggregated" "cpu" > "$lpar/cpu.html" 

          lpar="mem-multi" 
          if [ -f "$lpar/d.png" ]; then # only if AMS graphs already exist
           if [ ! -f "$lpar/index.html" -o $UPGRADE -eq 1 ]; then
            if [ $DEBUG -eq 1 ]; then echo "new mem multi  : $hmc:$managedname:$lpar"; fi
            if [ ! -d "$lpar" ]; then
              mkdir "$lpar" 
            fi
            cp $INDEX/index.html $INDEX/menuframe.html $INDEX/right_all.html "$lpar/"
            m=`echo "$managedname" |sed -e 's/ /\\\\ /g' -e 's/--unknown$//'`
            if [ $IVM -eq 0 ]; then
              eval 'sed -e 's/XXXXXXXX/$hmc:$m/g' -e 's/ENTITLE/$ENTITLEMENT_LESS/' $INDEX/top.src  > "$lpar/top.html" ' 2>/dev/null
	    else
              eval 'sed -e 's/XXXXXXXX/$hmc/g' -e 's/ENTITLE/$ENTITLEMENT_LESS/' $INDEX/top.src  > "$lpar/top.html" ' 2>/dev/null
            fi 
	    if [ ! -f "$lpar/y.png" ]; then
              # probably fresh allowed utilization data collection on the HMC then put there temporary defaut picture
	      cp $INDEX/y-def.jpg "$lpar/y.png"
            fi
	    if [ ! -f "$lpar/y-trend.png" ]; then
              # probably fresh allowed utilization data collection on the HMC then put there temporary defaut picture
	      cp $INDEX/y-def.jpg "$lpar/y-trend.png"
            fi
            cd daily-view
            eval 'ln -sf ../"$lpar"/d-view.png "$lpar"-d.png' 2>/dev/null
            cd ../weekly-view
            eval 'ln -sf ../"$lpar"/w-view.png "$lpar"-w.png' 2>/dev/null
            cd ../monthly-view
            eval 'ln -sf ../"$lpar"/m-view.png "$lpar"-m.png' 2>/dev/null
            cd ../yearly-view
            if [ ! -f "../$lpar/y-view.png" ]; then
              # workaround when 3.37 upgrade hapens and yearly -view.png is not created yet
              cp "../$lpar/y.png" "../$lpar/y-view.png" 2>/dev/null
            fi
            eval 'ln -sf ../"$lpar"/y-view.png "$lpar"-y.png' 2>/dev/null
            cd ..
           fi
	   print_cpu_multi_html_head "LPARs memory aggregated" "mem" > "$lpar/cpu.html" 
          fi

          lpar="mem-agg" 
          if [ ! -f "$lpar/index.html" -o $UPGRADE -eq 1 ]; then
            if [ $DEBUG -eq 1 ]; then echo "new mem agg    : $hmc:$managedname:$lpar"; fi
            if [ ! -d "$lpar" ]; then
              mkdir "$lpar" 
            fi
            cp $INDEX/index.html $INDEX/menuframe.html $INDEX/right_all.html "$lpar/"
            m=`echo "$managedname" |sed -e 's/ /\\\\ /g' -e 's/--unknown$//'`
            if [ $IVM -eq 0 ]; then
              eval 'sed -e 's/XXXXXXXX/$hmc:$m/g' -e 's/ENTITLE/$ENTITLEMENT_LESS/' $INDEX/top.src  > "$lpar/top.html" ' 2>/dev/null
	    else
              eval 'sed -e 's/XXXXXXXX/$hmc/g' -e 's/ENTITLE/$ENTITLEMENT_LESS/' $INDEX/top.src  > "$lpar/top.html" ' 2>/dev/null
            fi 
	    if [ ! -f "$lpar/y.png" ]; then
              # probably fresh allowed utilization data collection on the HMC then put there temporary defaut picture
	      cp $INDEX/y-def.jpg "$lpar/y.png"
            fi
	    if [ ! -f "$lpar/y-trend.png" ]; then
              # probably fresh allowed utilization data collection on the HMC then put there temporary defaut picture
	      cp $INDEX/y-def.jpg "$lpar/y-trend.png"
            fi
            cd daily-view
            eval 'ln -sf ../"$lpar"/d-view.png "$lpar"-d.png' 2>/dev/null
            cd ../weekly-view
            eval 'ln -sf ../"$lpar"/w-view.png "$lpar"-w.png' 2>/dev/null
            cd ../monthly-view
            eval 'ln -sf ../"$lpar"/m-view.png "$lpar"-m.png' 2>/dev/null
            cd ../yearly-view
            if [ ! -f "../$lpar/y-view.png" ]; then
              # workaround when 3.37 upgrade hapens and yearly -view.png is not created yet
              cp "../$lpar/y.png" "../$lpar/y-view.png" 2>/dev/null
            fi
            eval 'ln -sf ../"$lpar"/y-view.png "$lpar"-y.png' 2>/dev/null
            cd ..
          fi
	  #print_cpu_multi_html_head "Memory aggregated" "mem" > "$lpar/cpu.html" 
          # --> no no, it is under global memory graphs now 
        fi
     done
    fi
  done
done


# create the index page with a pointer to the first HMC and the first managed name
# not nice code as necessary to use a temp file, it needs to be re-writen with awk to avoid it
TMP=/var/tmp/lpar2rrd.$$
FLIST=`for m in $INPUTDIR/data/*/*; do echo "$m"|sed 's/ /\\\\\\\\_/g'; done|sort -fr|xargs -n 1024`
for m in $FLIST
do 
  hmc=`basename "$m"`
  m_space=`echo "$m"|sed 's/\\\\_/ /g'`
  msys_all=`dirname "$m_space"`
  msys=`basename "$msys_all"`
  # exclude sym links 
  if [ -L "$INPUTDIR/data/$msys" -o ! -d "$INPUTDIR/data/$msys/$hmc" ]; then
    continue
  fi

  # Exclude excluded systems
  eval 'echo "$MANAGED_SYSTEMS_EXCLUDE" | egrep "^$msys:|:$msys:|:$msys$|^$msys$" >/dev/null 2>&1'
  if [ $? -eq 0 ]; then
    continue
  fi

  # sed bellow is a workaround for managed names with a space inside
  is_alive `echo "$hmc"|sed 's/ /\\\\\\_/g'`  `echo "$msys" |sed 's/ /\\\\\\_/g'` >/dev/null 2>&1
  if [ $? -eq 1 ] ; then
    # avoid systems not being updated 
    continue
  fi
  if [ -f "$hmc/$msys/IVM" ]; then
    echo "IVM/$hmc"
  else
    echo "$hmc/$msys"
  fi
done|egrep -v -- "--unknown$"|sort -f|head -1 > $TMP

# find out first HMC
first_hmc=`cat $TMP`
msys=`basename "$first_hmc"`
hmc=`dirname "$first_hmc"`
print_index "$hmc" "$msys"
rm -f $TMP

custom=0
print_header_hmc > $CUSTOM_INDX_TMP-header
cp $CUSTOM_INDX_TMP-header $FAV_INDX_TMP-header

# find out first custom group
cd $WEBDIR/custom
for group_space in `ls|sort|sed -e 's/ *$//g' -e 's/ /+===============+/g'`
do
  group=`echo $group_space|sed 's/+===============+/ /g'`
  if [ ! -d "$group" ]; then
    continue # some trash
  fi

  # avoid group actually not configured
  egrep -v "#" $INPUTDIR/etc/custom_groups.cfg|sed 's/ *$//g'|egrep ".*:$group$" >/dev/null
  if [ ! $? -eq 0 ]; then
     #echo "custom group $group is not more configured"
     continue
  fi

  group_first="$group"
  break
done

cd "$WEBDIR/favourites"
fav_first=""
for fav_space in `ls|sort|sed -e 's/ *$//g' -e 's/ /+===============+/g'`
do
  fav=`echo $fav_space|sed 's/+===============+/ /g'`
  if [ -d "$fav" ]; then
    fav_first="$fav"
    break
  fi
done


# workaround for sorting 
HLIST=`for m in $INPUTDIR/data/*; do echo "$m"|sed 's/ /\\\\\\\\_/g'; done|sort -fr|xargs -n 1024`
for dir1 in $HLIST
do

  # workaround for managed names with a space inside
  dir1_space=`echo "$dir1"|sed 's/\\\\_/ /g'`
  managedname=`basename "$dir1_space"`
  # exclude sym links 
  if [ -L "$dir1" -o -f "$dir1" ]; then
    continue
  fi

  # Exclude excluded systems
  eval 'echo "$MANAGED_SYSTEMS_EXCLUDE" | egrep "^$managedname:|:$managedname:|:$managedname$|^$managedname$" >/dev/null 2>&1'
  if [ $? -eq 0 ]; then
    if [ $DEBUG -eq 1 ]; then echo "Excluding      : $managedname"; fi
    continue
  fi

  # workaround for sorting 
  MLIST=`for m in $INPUTDIR/data/"$managedname"/*; do echo "$m"|sed 's/ /\\\\\\\\_/g'; done|sort -f|xargs -n 1024`
  for dir2 in $MLIST
  do

    # workaround for managed names with a space inside
    dir2_space=`echo "$dir2"|sed 's/\\\\_/ /g'`
    if [ ! -d "$dir2_space" ]; then
      continue # is not HMC, some trash
    fi

    hmc=`basename "$dir2_space"`

    is_alive `echo "$hmc"|sed 's/ /\\\\\\_/g'`  `echo "$managedname" |sed 's/ /\\\\\\_/g'`
    if [ $? -eq 1 ] ; then
      # avoid systems not being updated 
      continue
    fi

    if [ $HWINFO -eq 1 ]; then
      if [ -f "$CONFIG_DIR/$managedname/$hmc/config.cfg" ]; then
        if [ ! -d "$WEBDIR/$hmc" ]; then
	  mkdir "$WEBDIR/$hmc"
        fi
        if [ ! -d "$WEBDIR/$hmc/$managedname" ]; then
	  mkdir "$WEBDIR/$hmc/$managedname"
        fi
        cp "$CONFIG_DIR/$managedname/$hmc/config.cfg" "$WEBDIR/$hmc/$managedname/config.html" 2>/dev/null
        if [ $DEBUG -eq 1 ]; then echo "copy save cfg  : $hmc:$managedname"; fi
      else 
        if [ $DEBUG -eq 1 ]; then echo "copy save cfg  : $hmc:$managedname : $CONFIG_DIR/$managedname/$hmc/config.cfg does not exist"; fi
      fi
    fi

    # Check whewther it is IVM based box
    IVM=0
    if [ -f "$INPUTDIR/data/$managedname/$hmc/IVM" ];  then
      IVM=1
    fi
    SDMC=0
    if [ -f "$INPUTDIR/data/$managedname/$hmc/SDMC" ];  then
      SDMC=1
    fi

    cd "$WEBDIR/$hmc/$managedname"
    # find what kind of sample rata is being used 3600 or less
    # must be once more as it can vary for different managed systems
    if [ -f "$INPUTDIR/data/$managedname/$hmc/pool.rrm" ];  then
      if [ -f "$INPUTDIR/data/$managedname/$hmc/pool.rrh" ];  then
        rrh=`$PERL -e '$inp=shift;$m=shift;$h=shift;$v = (stat("$inp/data/$m/$h/pool.rrh"))[9]; print "$v\n";' $INPUTDIR "$managedname" $hmc`
        rrm=`$PERL -e '$inp=shift;$m=shift;$h=shift;$v = (stat("$inp/data/$m/$h/pool.rrm"))[9]; print "$v\n";' $INPUTDIR "$managedname" $hmc`
	if [ $rrh -gt $rrm ]; then
          RR=rrh
	else
         RR=rrm
	fi	
      else
        RR=rrm
      fi
    else
      RR=rrh
    fi

    if [ $SYS_CHANGE -gt 0 -a $IVM -eq 0 ]; then
      if [ -f $INPUTDIR/data/"$managedname"/"$hmc"/change-state.txt ]; then
        cp $INPUTDIR/data/"$managedname"/"$hmc"/change-state.txt change-state.html
        if [ $DEBUG -eq 1 ]; then echo "copy change sta: $hmc:$managedname"; fi
      else 
        if [ $DEBUG -eq 1 ]; then echo "copy save cfg  : $hmc:$managedname : $INPUTDIR/data/$managedname/$hmc/change-state.txt does not exist"; fi
      fi
      if [ -f $INPUTDIR/data/"$managedname"/"$hmc"/change-config.txt ]; then
        cp $INPUTDIR/data/"$managedname"/"$hmc"/change-config.txt change-config.html
        if [ $DEBUG -eq 1 ]; then echo "copy change cfg: $hmc:$managedname"; fi
      else 
        if [ $DEBUG -eq 1 ]; then echo "copy change cfg: $hmc:$managedname : $INPUTDIR/data/$managedname/$hmc/change-config.txt"; fi
      fi
    fi

    print_header_hmc > $MINDEX_TMP

    (( custom = custom + 1 ))

    if [ $custom -eq 1 ]; then 
      # favourites
      echo "<TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD nowrap>" >> $FAV_INDX_TMP-header 
      echo "<CENTER><B>GLOBAL</B></CENTER>" >> $FAV_INDX_TMP-header 
      echo " </TD></TR></TABLE>" >> $FAV_INDX_TMP-header 
      echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $FAV_INDX_TMP-header 
      echo "<TR><TD nowrap><b>Favourites</b>" >> $FAV_INDX_TMP-header
      echo "</TD></TR>" >> $FAV_INDX_TMP-header 
      echo "<TR><TD nowrap><A HREF=\"../../custom/$group_first/index.html\" target=\"main\">Custom groups</A>"|sed 's/\/\//\//' >> $FAV_INDX_TMP-header
      echo "</TD></TR>" >> $FAV_INDX_TMP-header
      echo "<TR><TD nowrap><A HREF=\"/lpar2rrd-cgi/cpu-workl-est.sh?sort=server&sortpool=server\" target=\"sample\">CPU Workload Estimator</A>" >> $FAV_INDX_TMP-header 
      echo "</TD></TR>" >> $FAV_INDX_TMP-header 
      if [ ! $ENTITLEMENT_LESS -eq 1 ]; then
        echo "<TR><TD nowrap><A HREF=\"../../cpu_max_check.html\" target=\"sample\">Configuration Advisor</A>" >> $FAV_INDX_TMP-header
        echo "</TD></TR>" >> $FAV_INDX_TMP-header 
      fi
      echo "<TR><TD nowrap><A HREF=\"/lpar2rrd-cgi/lpar-list.sh?sort=server\" target=\"sample\">Historical reports</A>" >> $FAV_INDX_TMP-header 
      echo "</TD></TR>" >> $FAV_INDX_TMP-header 
      echo "<TR><TD nowrap><A HREF=\"../../config-global.htm\" target=\"sample\">Physical and logical configuration</A>" >> $FAV_INDX_TMP-header 
      echo "</TD></TR>" >> $FAV_INDX_TMP-header 
      echo "<TR><TD nowrap><A HREF=\"../../$TOPTEN_OUT_GLO\" target=\"sample\">Top 10 global</A>" >> $FAV_INDX_TMP-header 
      echo "</TD></TR>" >> $FAV_INDX_TMP-header 
      if [ ! $ENTITLEMENT_LESS -eq 1 ]; then
        echo "<TR><TD nowrap><A HREF=\"../../rmc.html\" target=\"sample\">RMC check</A>" >> $FAV_INDX_TMP-header 
        echo "</TD></TR>" >> $FAV_INDX_TMP-header 
      fi
      if [ $KEEP_VIRTUAL -eq 1 ]; then # accounting for DHL
        echo "<TR><TD nowrap><A HREF=\"/lpar2rrd-cgi/virtual.sh?sort=server\" target=\"sample\">Accounting</A>" >> $FAV_INDX_TMP-header 
        echo "</TD></TR>" >> $FAV_INDX_TMP-header 
      fi
      echo "</TABLE>" >> $FAV_INDX_TMP-header 
    fi

    if [ $custom -eq 1 ]; then 
      # Custom groups
      echo "<TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD nowrap>" >> $CUSTOM_INDX_TMP-header 
      echo "<CENTER><B>GLOBAL</B></CENTER>" >> $CUSTOM_INDX_TMP-header 
      echo " </TD></TR></TABLE>" >> $CUSTOM_INDX_TMP-header 
      echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $CUSTOM_INDX_TMP-header 
      echo "<TR><TD nowrap><A HREF=\"../../favourites/$fav_first/$fav_first/index.html\" target=\"main\">Favourites</A>" |sed -e 's/\/\/\//\//' -e 's/\/\//\//' >> $CUSTOM_INDX_TMP-header
      echo "</TD></TR>" >> $CUSTOM_INDX_TMP-header
      echo "<TR><TD nowrap><b>Custom groups</b>" >> $CUSTOM_INDX_TMP-header
      echo "</TD></TR>" >> $CUSTOM_INDX_TMP-header 
      echo "<TR><TD nowrap><A HREF=\"/lpar2rrd-cgi/cpu-workl-est.sh?sort=server&sortpool=server\" target=\"sample\">CPU Workload Estimator</A>" >> $CUSTOM_INDX_TMP-header 
      echo "</TD></TR>" >> $CUSTOM_INDX_TMP-header 
      if [ ! $ENTITLEMENT_LESS -eq 1 ]; then
        echo "<TR><TD nowrap><A HREF=\"../../cpu_max_check.html\" target=\"sample\">Configuration Advisor</A>" >> $CUSTOM_INDX_TMP-header
        echo "</TD></TR>" >> $CUSTOM_INDX_TMP-header
      fi
      echo "<TR><TD nowrap><A HREF=\"/lpar2rrd-cgi/lpar-list.sh?sort=server\" target=\"sample\">Historical reports</A>" >> $CUSTOM_INDX_TMP-header 
      echo "</TD></TR>" >> $CUSTOM_INDX_TMP-header 
      echo "<TR><TD nowrap><A HREF=\"../../config-global.htm\" target=\"sample\">Physical and logical configuration</A>" >> $CUSTOM_INDX_TMP-header 
      echo "</TD></TR>" >> $CUSTOM_INDX_TMP-header 
      echo "<TR><TD nowrap><A HREF=\"../../$TOPTEN_OUT_GLO\" target=\"sample\">Top 10 global</A>" >> $CUSTOM_INDX_TMP-header 
      echo "</TD></TR>" >> $CUSTOM_INDX_TMP-header 
      if [ ! $ENTITLEMENT_LESS -eq 1 ]; then
        echo "<TR><TD nowrap><A HREF=\"../../rmc.html\" target=\"sample\">RMC check</A>" >> $CUSTOM_INDX_TMP-header
        echo "</TD></TR>" >> $CUSTOM_INDX_TMP-header
      fi
      if [ $KEEP_VIRTUAL -eq 1 ]; then # accounting for DHL
        echo "<TR><TD nowrap><A HREF=\"/lpar2rrd-cgi/virtual.sh?sort=server\" target=\"sample\">Accounting</A>" >> $CUSTOM_INDX_TMP-header
        echo "</TD></TR>" >> $CUSTOM_INDX_TMP-header
      fi
      echo "</TABLE>" >> $CUSTOM_INDX_TMP-header 
    fi

    echo "<TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD nowrap>" >> $MINDEX_TMP
    echo "<CENTER><B>GLOBAL</B></CENTER>" >> $MINDEX_TMP
    echo " </TD></TR></TABLE>" >> $MINDEX_TMP
    echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $MINDEX_TMP
    echo "<TR><TD nowrap><A HREF=\"../../favourites/$fav_first/$fav_first/index.html\" target=\"main\">Favourites</A>"|sed -e 's/\/\/\//\//' -e 's/\/\//\//' >> $MINDEX_TMP
    echo "</TD></TR>" >> $MINDEX_TMP
    echo "<TR><TD nowrap><A HREF=\"../../custom/$group_first/index.html\" target=\"main\">Custom groups</A>"|sed 's/\/\//\//' >> $MINDEX_TMP
    echo "</TD></TR>" >> $MINDEX_TMP
    echo "<TR><TD nowrap><A HREF=\"/lpar2rrd-cgi/cpu-workl-est.sh?sort=server&sortpool=server\" target=\"sample\">CPU Workload Estimator</A>" >> $MINDEX_TMP
    echo "</TD></TR>" >> $MINDEX_TMP
    if [ ! $ENTITLEMENT_LESS -eq 1 ]; then
      echo "<TR><TD nowrap><A HREF=\"../../cpu_max_check.html\" target=\"sample\">Configuration Advisor</A>" >> $MINDEX_TMP
      echo "</TD></TR>" >> $MINDEX_TMP
    fi
    echo "<TR><TD nowrap><A HREF=\"/lpar2rrd-cgi/lpar-list.sh?sort=server\" target=\"sample\">Historical reports</A>" >> $MINDEX_TMP
    echo "</TD></TR>" >> $MINDEX_TMP
    echo "<TR><TD nowrap><A HREF=\"../../config-global.htm\" target=\"sample\">Physical and logical configuration</A>" >> $MINDEX_TMP
    echo "</TD></TR>" >> $MINDEX_TMP
    echo "<TR><TD nowrap><A HREF=\"../../$TOPTEN_OUT_GLO\" target=\"sample\">Top 10 global</A>" >> $MINDEX_TMP
    echo "</TD></TR>" >> $MINDEX_TMP
    if [ ! $ENTITLEMENT_LESS -eq 1 ]; then
      echo "<TR><TD nowrap><A HREF=\"../../rmc.html\" target=\"sample\">RMC check</A>" >> $MINDEX_TMP
      echo "</TD></TR>" >> $MINDEX_TMP
    fi
    if [ $IVM -eq 0 ]; then
      print_multipool $hmc > ../pool-multi.html
      echo "<TR><TD nowrap><A HREF=\"../pool-multi.html\" target=\"sample\">HMC totals</A>" >> $MINDEX_TMP
      echo "</TD></TR>" >> $MINDEX_TMP
    fi
    if [ $KEEP_VIRTUAL -eq 1 ]; then # accounting for DHL
      echo "<TR><TD nowrap><A HREF=\"/lpar2rrd-cgi/virtual.sh?sort=server\" target=\"sample\">Accounting</A>" >> $MINDEX_TMP
      echo "</TD></TR>" >> $MINDEX_TMP
    fi
    echo "</TABLE>" >> $MINDEX_TMP




    # Add others HMCs into the menu
    echo "<br><TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD nowrap>" >> $MINDEX_TMP
    echo "<CENTER><B>HMC/SDMC/IVM</B></CENTER>" >> $MINDEX_TMP
    echo "</TD></TR></TABLE>" >> $MINDEX_TMP
    echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $MINDEX_TMP
    if [ $custom -eq 1 ]; then 
      echo "<br><TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD nowrap>" > $CUSTOM_INDX_TMP
      echo "<CENTER><B>HMC/SDMC/IVM</B></CENTER>" >> $CUSTOM_INDX_TMP
      echo "</TD></TR></TABLE>" >> $CUSTOM_INDX_TMP
      echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $CUSTOM_INDX_TMP

      echo "<br><TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD nowrap>" > $FAV_INDX_TMP # must be ">"
      echo "<CENTER><B>HMC/SDMC/IVM</B></CENTER>" >> $FAV_INDX_TMP
      echo "</TD></TR></TABLE>" >> $FAV_INDX_TMP
      echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $FAV_INDX_TMP
    fi

      ivm=0
      HLIST=`for m in ../../*; do echo $m; done|sort -f|egrep -v ".png|.html"|xargs -n 1024`
      for hmcnew in $HLIST
      do
        if [ ! -d "$hmcnew" ]; then
          continue
        fi

        hmcnewbase=`basename "$hmcnew"`

        ivm_file=`ls $INPUTDIR/data/*/"$hmcnewbase"/IVM 2>/dev/null`
        if [ ! "$ivm_file"x = "x" ]; then
	  # Looks like IVM, exclude it here
          ivm=1
          continue
        fi

          #echo "001 $hmc: $hmcnewbase $hmcnew"

        if [ ! "$hmcnewbase" = "$hmc" ]; then
	  # find the first managed name
 	  managed2=` for mm in "$hmcnew"/*;
  	  do
	    if [ ! -d "$mm" ]; then
              continue # avoid trash
            fi

    	    mmb=\`basename "$mm"\`
	    if [ ! -d "$INPUTDIR/data/$mmb/$hmcnewbase" -o ! -f "$mm/pool/index.html" ]; then
              # do not take into consideration server withoiut data or without main web page
              if [ \`echo "$mm" |egrep -- "--unknown$"|wc -l\` -eq 0 ]; then
                # exclude --unknown --> lpars without the HMC
	        continue 
	      fi
	    fi
	    # Exclude excluded systems
  	    eval 'echo "$MANAGED_SYSTEMS_EXCLUDE" | egrep "^$mmb:|:$mmb:|:$mmb$|^$mmb$" >/dev/null 2>&1'
  	    if [ $? -eq 0 ]; then
    	      continue
  	    fi
	    echo "$mm"
	  done |sort -f |head -1`

          #echo "002 $hmc: $hmcnewbase $managed2"

          if [ "$managed2"x = "x" ]; then
	    if [ $DEBUG  -a ! "$hmcnewbase" = "custom" -a ! "$hmcnewbase" = "favourites" -a ! "$hmcnewbase" = "jquery" ]; then 
		echo "Wrong HMC      : $hmc: could not be found any server for that HMC: $hmcnewbase"
            fi
            continue 
          fi

          #echo "003 $hmc: $hmcnewbase $managed2"
  
          #if [ ! -f "$managed2/pool/index.html" ]; then
	  #  #if [ $DEBUG ]; then echo "Wrong server   : does not exist index page of : $managed2/pool/index.html"; fi
          #  continue # probably something wrong as does not exist home page of the server
          #fi
 	  managed2_space=`echo "$managed2"|sed 's/\#/\%23/g'`	
          if [ $custom -eq 1 ]; then 
            echo "<TR><TD nowrap><A HREF=\"$managed2_space/pool/index.html\" target=\"main\">$hmcnewbase</A>" >> $CUSTOM_INDX_TMP
            echo "</TD></TR>" >> $CUSTOM_INDX_TMP

            echo "<TR><TD nowrap><A HREF=\"$managed2_space/pool/index.html\" target=\"main\">$hmcnewbase</A>" >> $FAV_INDX_TMP
            echo "</TD></TR>" >> $FAV_INDX_TMP
          fi
          echo "<TR><TD nowrap><A HREF=\"$managed2_space/pool/index.html\" target=\"main\">$hmcnewbase</A>" >> $MINDEX_TMP
          echo "</TD></TR>" >> $MINDEX_TMP
        fi
        if [ "$hmcnewbase" = "$hmc" ]; then
          if [ $custom -eq 1 ]; then 
 	    managedname_space=`echo "$managedname"|sed 's/\#/\%23/g'`	
            echo "<TR><TD nowrap><A HREF=\"../../$hmc/$managedname_space/pool/index.html\" target=\"main\">$hmcnewbase</A>" >> $CUSTOM_INDX_TMP
            echo "</TD></TR>" >> $CUSTOM_INDX_TMP

            echo "<TR><TD nowrap><A HREF=\"../../$hmc/$managedname_space/pool/index.html\" target=\"main\">$hmcnewbase</A>" >> $FAV_INDX_TMP
            echo "</TD></TR>" >> $FAV_INDX_TMP
          fi
          menu "$hmcnewbase"
          echo "<TR><TD nowrap><B>$hmcnewbase</B>" >> $MINDEX_TMP
          echo "</TD></TR>" >> $MINDEX_TMP
        fi
      done

    if [ $ivm -eq 1 ]; then
      # workaround for sorting
      HLIST=`for m in $INPUTDIR/data/*/*; do echo $m; done|sort -f|egrep -v ".png|.html"|xargs -n 1024`
      ivmfirst=`for hmcnew in $HLIST
      do
        if [ ! -f "$hmcnew/IVM" ]; then
          continue
        fi
	# find the first managed name
        mmb=\`basename "$hmcnew"\`
	mm_tmp=\`dirname "$hmcnew"\`
	mm=\`basename "$mm_tmp"\`
        if [ -L "$mm_tmp" ]; then
          continue
        fi
        # Exclude excluded systems
        eval 'echo "$MANAGED_SYSTEMS_EXCLUDE" | egrep "^$mmb:|:$mmb:|:$mmb$|^$mmb$" >/dev/null 2>&1'
        if [ $? -eq 0 ]; then
          continue
        fi
        echo "$mmb/$mm"
      done |sort -f |head -1`
      ivmfirst_name=`echo "$ivmfirst"| cut -d/ -f1`
      ivmfirst_mn=`echo "$ivmfirst"| cut -d/ -f2`
      if [ $IVM -eq 1 ]; then
         if [ $custom -eq 1 ]; then 
           echo "<TR><TD nowrap><B>IVM</B>" >> $CUSTOM_INDX_TMP
           echo "<TR><TD nowrap><B>IVM</B>" >> $FAV_INDX_TMP
         fi
         echo "<TR><TD nowrap><B>IVM</B>" >> $MINDEX_TMP
      else
        if [ $custom -eq 1 ]; then 
          echo "<TR><TD nowrap><A HREF=\"../../$ivmfirst_name/$ivmfirst_mn/pool/index.html\" target=\"main\">IVM</A>" >> $CUSTOM_INDX_TMP
          echo "<TR><TD nowrap><A HREF=\"../../$ivmfirst_name/$ivmfirst_mn/pool/index.html\" target=\"main\">IVM</A>" >> $FAV_INDX_TMP
        fi
        echo "<TR><TD nowrap><A HREF=\"../../$ivmfirst_name/$ivmfirst_mn/pool/index.html\" target=\"main\">IVM</A>" >> $MINDEX_TMP
      fi
      if [ $custom -eq 1 ]; then 
        echo "</TD></TR>" >> $CUSTOM_INDX_TMP
        echo "</TD></TR>" >> $FAV_INDX_TMP
      fi
      echo "</TD></TR>" >> $MINDEX_TMP
    fi   
     
    # Custom graphs end
    if [ $custom -eq 1 ]; then 
      echo "</TABLE>" >> $CUSTOM_INDX_TMP
      echo "</TABLE>" >> $FAV_INDX_TMP
    fi
    echo "</TABLE>" >> $MINDEX_TMP

    # Add others managed systems into the menu
    echo "<BR><TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD nowrap>" >> $MINDEX_TMP
    echo "<CENTER><B>SERVER</B></CENTER>" >> $MINDEX_TMP
    echo "</TD></TR></TABLE>" >> $MINDEX_TMP
    echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $MINDEX_TMP
    hmc_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$hmc"`
    hmc_url_hash=`echo "$hmc_url"|sed -e 's/\#/\%23/g'` # for support hashes in teh server name
    managedname_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$managedname"`
    managedname_url_hash=`echo "$managedname_url"|sed -e 's/\#/\%23/g'` # for support hashes in teh server name

      # workaround for sorting 
      MLIST=`for m in ../*; do echo "$m"|sed 's/ /\\\\\\\\_/g'; done|sort -f|egrep -v ".png|.html"|xargs -n 1024`
      for managed1 in $MLIST
      do
        # workaround for managed names with a space inside
        managed1base_space=`echo "$managed1"|sed 's/\\\\_/ /g'`
        if [ ! -d "$managed1base_space" ]; then
          continue # exclude other stuff
        fi
        managed1base=`basename "$managed1base_space"`
        # Exclude excluded systems
        eval 'echo "$MANAGED_SYSTEMS_EXCLUDE" | egrep "^$managed1base:|:$managed1base:|:$managed1base$|^$managed1base$" >/dev/null 2>&1'
        if [ $? -eq 0 ]; then
          if [ $DEBUG -eq 1 ]; then echo "Excluding      : $managed1base"; fi
          continue
        fi
        # exclude already renamed managed system
        if [ ! -d "$INPUTDIR/data/$managed1base" ]; then
          if [ -d $WEBDIR/"$hmc"/"$managed1base" ]; then
            if [ $DEBUG -eq 1 ]; then echo "rm old system  : rm -rf $WEBDIR/$hmc/$managed1base (only from WEB, it is not being updated for >10days)"; fi
            rm -rf $WEBDIR/"$hmc"/"$managed1base"
          fi
          continue
        fi

        name1=`ls $INPUTDIR/data/"$managed1base"/*/IVM 2>/dev/null`
        if [ ! "$name1"x = "x" ]; then
          # IVM section, go through all IVM's
          if [ -f "$name1" ]; then
            name2=`dirname "$name1"`
            managedname_ivm_all=`dirname "$name2"`
            managedname_ivm=`basename "$managedname_ivm_all"`
	    managed1base=`basename "$name2"`
          fi

          # workaround for sorting
	  AKT_PWD=`pwd`  # another workaround to get IVM's sorted, there is full path in bellow for cyclus
	  # --> grrrrrr how to fix sorting
          HLIST=`for m in $INPUTDIR/data/*/*; do echo $m; done|grep -v ".png"|awk '{print $1,"|", system ("basename "$1)}'|egrep -v "^[0-9]"| sort -t "|" -k 2 |cut -d "|" -f 1|xargs -n 1024`
          for hmcnew in $HLIST
          do
            if [ ! -f "$hmcnew/IVM" ]; then
              continue
            fi
	    # find the first managed name
            mmb=`basename "$hmcnew"`
	    mm_tmp=`dirname "$hmcnew"`
	    mm=`basename "$mm_tmp"`
            if [ -L "$mm_tmp" ]; then
              continue
            fi
            # Exclude excluded systems
            eval 'echo "$MANAGED_SYSTEMS_EXCLUDE" | egrep "^$mmb:|:$mmb:|:$mmb$|^$mmb$" >/dev/null 2>&1'
            if [ $? -eq 0 ]; then
              continue
            fi
            mmb_web=`echo "$mmb" | sed 's/--unknown$//'` # filter "--unknown" for lpar without the HMC
            if [ "$mm" = "$managedname" ]; then
              echo "<TR><TD nowrap><B>$mmb_web</B>" >> $MINDEX_TMP
              echo "</TD></TR>" >> $MINDEX_TMP
            else
              #KDS
 	      managed1base_space=`echo "$mm"|sed 's/\#/\%23/g'`	
              echo "<TR><TD nowrap><A HREF=\"../../$mmb/$managed1base_space/pool/index.html\" target=\"main\">$mmb_web</A>" >> $MINDEX_TMP
              echo "</TD></TR>" >> $MINDEX_TMP
            fi

          done
        else
          # HMC section
          managed1base_web=`echo "$managed1base" | sed 's/--unknown$//'` # filter "--unknown" for lpar without the HMC
          if [ "$managed1base" = "$managedname" ]; then
            menu "$hmc" "$managed1base"
            echo "<TR><TD nowrap><B>$managed1base_web</B>" >> $MINDEX_TMP
            echo "</TD></TR>" >> $MINDEX_TMP
          else
            menu "$hmc" "$managed1base"
            #KDS
# --PH tabs test
            #managed_base=`basename $managed1base`
 	    #managed_base_space=`echo "$managed_base"|sed 's/\#/\%23/g'`	
            #managedname_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$managed_base_space"`
            #echo "<TR><TD nowrap><A HREF=\"/lpar2rrd-cgi/detail.sh?host=$hmc_url_hash&server=$managedname_url&lpar=smenu&item=smenu&none=none\" target=\"sample\">$managed1base</A>" >> $MINDEX_TMP
            managed1base_space=`echo "$managed1base_space"|sed 's/\#/\%23/g'`
            echo "<TR><TD nowrap><A HREF=\"$managed1base_space/pool/index.html\" target=\"main\">$managed1base_web</A>" >> $MINDEX_TMP
            echo "</TD></TR>" >> $MINDEX_TMP
          fi
        fi
      done
    echo "</TABLE>" >> $MINDEX_TMP

   if [ `echo $managedname|egrep -- "--unknown$"|wc -l` -eq 0 ]; then
    # exclude that for non HMC based lpars

    echo "<BR><TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD nowrap>" >> $MINDEX_TMP
    echo "<CENTER><B>CPU / MEMORY / CFG / LOG</B></CENTER>" >> $MINDEX_TMP
    echo " </TD></TR></TABLE>" >> $MINDEX_TMP
    echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $MINDEX_TMP

    shared_pools=0
    for dir4 in SharedPool*
    do
      lpar1=`basename "$dir4" .$RR`
      if [ -d "$dir4" -a ! "$lpar1" = "SharedPool0" ]; then
        shared_pools=1
      fi
    done

    if [ $shared_pools -eq 1 -a $IVM -eq 0 ]; then
      # go here if there is defined at least one additional shared pool except the default one
      echo "<TR><TD nowrap><A HREF=\"pool/cpu.html\" target=\"sample\">Totally for all CPU pools</A><BR>" >> $MINDEX_TMP
      echo " </TD></TR>" >> $MINDEX_TMP
      # not use "-mtime -2" as SharedPools should be visible all the time
      # workaround for sorting 
      PLIST=`for m in SharedPool*; do echo $m; done|sort -f|xargs -n 1024`
      for dir4 in $PLIST
      do
        if [ -d "$dir4" ]; then
          lpar1=`basename "$dir4" .$RR`
	  lpar_slash=`echo "$lpar1" | sed 's/\&\&1/\//g'`
          if [ $DEBUG -eq 1 ]; then echo "creating html  : $hmc:$managedname:$lpar_slash"; fi
          lpar1_sep=`echo "$lpar1"|sed 's/SharedPool/CPU pool /g'`

	  # add cpu pool alias if mapping table exists
	  if [ -f $INPUTDIR/data/"$managedname"/"$hmc"/cpu-pools-mapping.txt ]; then
	    pool_id=`echo "$lpar1"|sed 's/SharedPool//g'`
            pool_alias=`egrep "^$pool_id," $INPUTDIR/data/"$managedname"/"$hmc"/cpu-pools-mapping.txt|sed 's/^\$pool_id,//g'| awk -F, '{print $2 }'`
            if [ "$pool_alias" = "$lpar1" ]; then
              echo "<TR><TD nowrap><A HREF=\"$lpar1/cpu.html\" target=\"sample\">$lpar1_sep</A>" >> $MINDEX_TMP
	    else
              echo "<TR><TD nowrap><A HREF=\"$lpar1/cpu.html\" target=\"sample\">$lpar1_sep : $pool_alias</A>" >> $MINDEX_TMP
            fi
	  else
            echo "<TR><TD nowrap><A HREF=\"$lpar1/cpu.html\" target=\"sample\">$lpar1_sep</A>" >> $MINDEX_TMP
	  fi
          echo " </TD></TR>" >> $MINDEX_TMP
        fi  
      done
    else
      echo "<TR><TD nowrap><A HREF=\"pool/cpu.html\" target=\"sample\">CPU pool</A>" >> $MINDEX_TMP
      echo " </TD></TR>" >> $MINDEX_TMP
    fi
    # already in the tab 
    #if [ -f pool-multi/d.png ]; then
    #  echo "<TR><TD nowrap><A HREF=\"pool-multi/cpu.html\" target=\"sample\">LPARs aggregated</A>" >> $MINDEX_TMP
    #  echo " </TD></TR>" >> $MINDEX_TMP
    #fi
    #if [ -f mem-multi/d.png ]; then
    #  echo "<TR><TD nowrap><A HREF=\"mem-multi/cpu.html\" target=\"sample\">Memory pool - AMS</A>" >> $MINDEX_TMP
    #  echo "</TD></TR>" >> $MINDEX_TMP
    #fi
    echo "<TR><TD nowrap><A HREF=\"mem/cpu.html\" target=\"sample\">Memory</A>" >> $MINDEX_TMP
    echo "</TD></TR>" >> $MINDEX_TMP

    if [ `ls -l $INPUTDIR/data/"$managedname"/"$hmc"/*/pgs.mmm| wc -l |sed 's/ //g'` -gt 0 ]; then
      echo "<TR><TD nowrap><A HREF=\"/lpar2rrd-cgi/detail.sh?host=$hmc_url_hash&server=$managedname_url_hash&lpar=cod&item=pagingagg&entitle=$ENTITLEMENT_LESS&none=none\" target=\"sample\">Paging aggregated</A>" >> $MINDEX_TMP
      echo "</TD></TR>" >> $MINDEX_TMP
    fi
    if [ -f mem-os/d.png ]; then
      echo "<TR><TD nowrap><A HREF=\"mem-os/cpu.html\" target=\"sample\">Memory - OS usage</A>" >> $MINDEX_TMP
      echo "</TD></TR>" >> $MINDEX_TMP
    fi

    # It is above
    #managedname_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$managedname"`
    #managedname_url_hash=`echo "$managedname_url"|sed -e 's/\#/\%23/g'` # for support hashes in teh server name
    #hmc_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$hmc"`
    #hmc_url_hash=`echo "$hmc_url"|sed -e 's/\#/\%23/g'` # for support hashes in teh server name

    echo "<TR><TD nowrap><A HREF=\"/lpar2rrd-cgi/historical_reports.sh?hmc=$hmc_url_hash&managedname=$managedname_url_hash\" target=\"sample\">Historical reports</A>" >> $MINDEX_TMP
    echo "</TD></TR>" >> $MINDEX_TMP
    if [ $HWINFO -eq 1 ]; then
      if [ -f config.html ]; then
        # if does not exist cfg high then put there at least defailed cfg
        echo "<TR><TD nowrap><A HREF=\"../config-high-sum.html\" target=\"sample\">Physical and logical configuration</A>" >> $MINDEX_TMP
        echo "</TD></TR>" >> $MINDEX_TMP
      fi
    fi
    echo "<TR><TD nowrap><A HREF=\"$TOPTEN_OUT\" target=\"sample\">Top 10</A>" >> $MINDEX_TMP
    echo "</TD></TR>" >> $MINDEX_TMP

    if [ -f "$INPUTDIR/data/$managedname/$hmc/cod.$RR" ]; then
      # Capacity on Demand if exist data
      echo "<TR><TD nowrap><A HREF=\"/lpar2rrd-cgi/detail.sh?host=$hmc_url&server=$managedname_url&lpar=cod&item=codused&entitle=$ENTITLEMENT_LESS&none=none\" target=\"sample\">Capacity on Demand</A>" >> $MINDEX_TMP
      echo "</TD></TR>" >> $MINDEX_TMP
    fi

    if [ $SYS_CHANGE -gt 0 -a $IVM -eq 0 ]; then
      print_sys_log  > sys_log.html
      echo "<TR><TD nowrap><A HREF=\"sys_log.html\" target=\"sample\">Server's logs</A>" >> $MINDEX_TMP
      echo "</TD></TR>" >> $MINDEX_TMP
    fi


    #
    # Create index of daily-view
    #


    #echo "<BR><TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD>" >> $MINDEX_TMP
    #echo "<CENTER><B>VIEWs</B></CENTER>" >> $MINDEX_TMP
    #echo " </TR></TD></TABLE>" >> $MINDEX_TMP
    #hmc_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$hmc"`
    #managedname_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$managedname"`

    
    table_count=0
    type_sam="m"
    if [ -d "daily-view" ]; then
      #print_header_lpar "Daily view" > daily-view/cpu.html 
      echo "<table border=\"0\"><tr>" > daily-view/cpu.html
      echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=pool&item=pool&time=d&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=pool&item=pool&time=d&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> daily-view/cpu.html
      echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"daily-view/mem-d.png\" ALT=\"last day\" src=\"../../jquery/images/loading.gif\"></td></tr><tr>" >> daily-view/cpu.html
      echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=pool-multi&item=lparagg&time=d&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=pool-multi&item=lparagg&time=d&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> daily-view/cpu.html
      #echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"pool-multi-d.png\" ALT=\"last day\"></td>" >> daily-view/cpu.html
      echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"daily-view/mem-agg-d.png\" ALT=\"last day\" src=\"../../jquery/images/loading.gif\"></td></tr><tr>" >> daily-view/cpu.html
      if [ -f "daily-view/daily-view/mem-multi-d.png" ]; then # AMS
        echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"daily-view/mem-multi-d.png\" ALT=\"last day\" src=\"../../jquery/images/loading.gif\"></td>" >> daily-view/cpu.html
        table_count=1
      fi

        for dir4 in SharedPool*
        do
          if [ -d "$dir4" ]; then
            lpar1=`basename "$dir4" .$RR`
  	    #echo "<td valign=\"top\"><IMG SRC=\"$lpar1-d.png\" ALT=\"last day\"></td>" >> daily-view/cpu.html
            echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar1&item=shpool&time=d&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar1&item=shpool&time=d&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> daily-view/cpu.html
            if [ $table_count -eq 0 ]; then
               table_count=1
            else
               echo "</tr><tr>" >> daily-view/cpu.html
               table_count=0
            fi
	  fi
        done
	# show just actuall lpars (not deleted once)
        # no, use cpu.cfg instead -mtime 2
	for i in `find . -name d.png |sed 's/ /\%20/g'|sort -f`
	do
	  lpardir=`dirname "$i"|sed 's/\.\///'|sed 's/\%20/ /g'`
	  # need exclude shared pools but regex does not work in "if"
          echo "$lpardir" | egrep "^SharedPool[0-9]*" >/dev/null 2>&1
          if [ $? -eq 1 ]; then
	    if [ ! "$lpardir" = "pool" -a ! "$lpardir" = "mem" -a ! "$lpardir" = "pool-multi" -a ! "$lpardir" = "mem-agg" -a ! "$lpardir" = "mem-multi" ]; then

              # show just active lpar (must be in cpu.cfg file)
              lpardir_slash=`echo "$lpardir"|sed 's/\&\&1/\//g'`
              lpar_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$lpardir"`
              if [ -f "$INPUTDIR/data/$managedname/$hmc/cpu.cfg" ]; then
                egrep "^lpar_name=$lpardir_slash,lpar_id=" "$INPUTDIR/data/$managedname/$hmc/cpu.cfg" >/dev/null
                if [ $? -eq 0 ]; then
                  echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar_url&item=lpar&time=d&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar_url&item=lpar&time=d&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> daily-view/cpu.html
                  if [ $table_count -eq 0 ]; then
                    table_count=1
                  else
                    echo "</tr><tr>" >> daily-view/cpu.html
                    table_count=0
                  fi
                fi
              else
                # cpu.cfg does not exist from some reason, ignore it and show the lpar
                echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname&_urllpar=$lpar_url&item=lpar&time=d&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar_url&item=lpar&time=d&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> daily-view/cpu.html
                if [ $table_count -eq 0 ]; then
                  table_count=1
                else
                  echo "</tr><tr>" >> daily-view/cpu.html
                  table_count=0
                fi
              fi

	    fi
          fi
        done
        echo "</tr></table><br></center>" >> daily-view/cpu.html
        #echo "<br><font size=\"-1\">Graphs here are refreshed once a day, first LPAR2RRD run after the midnight</font></BODY> </HTML>" >> daily-view/cpu.html
    fi

    #
    # Create index of weekly-view
    #

    table_count=0
    if [ -d "weekly-view" ]; then
      #print_header_lpar "Weekly view" > weekly-view/cpu.html 
      echo "<table border=\"0\"><tr>" > weekly-view/cpu.html
      echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=pool&item=pool&time=w&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=pool&item=pool&time=w&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> weekly-view/cpu.html
      echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"weekly-view/mem-w.png\" ALT=\"last week\" src=\"../../jquery/images/loading.gif\"></td></tr><tr>" >> weekly-view/cpu.html
      echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=pool-multi&item=lparagg&time=w&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=pool-multi&item=lparagg&time=w&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> weekly-view/cpu.html
      #echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"pool-multi-w.png\" ALT=\"last week\"></td>" >> weekly-view/cpu.html
      echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"weekly-view/mem-agg-w.png\" ALT=\"last week\" src=\"../../jquery/images/loading.gif\"></td></tr><tr>" >> weekly-view/cpu.html
      if [ -f "weekly-view/weekly-view/mem-multi-w.png" ]; then # AMS
        echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"weekly-view/mem-multi-w.png\" ALT=\"last week\" src=\"../../jquery/images/loading.gif\"></td>" >> weekly-view/cpu.html
        table_count=1
      fi

        for dir4 in SharedPool*
        do
          if [ -d "$dir4" ]; then
            lpar1=`basename "$dir4" .$RR`
  	    #echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"$lpar1-w.png\" ALT=\"last week\"></td>" >> weekly-view/cpu.html
            echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar1&item=shpool&time=w&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar1&item=shpool&time=w&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> weekly-view/cpu.html
            if [ $table_count -eq 0 ]; then
               table_count=1
            else
               echo "</tr><tr>" >> weekly-view/cpu.html
               table_count=0
            fi
	  fi
        done
	# show just actuall lpars (not deleted once)
        # no, use cpu.cfg instead -mtime 2
	for i in `find . -name w.png |sed 's/ /\%20/g'|sort -f`
	do
	  lpardir=`dirname "$i"|sed 's/\.\///'|sed 's/\%20/ /g'`
	  # need exclude shared pools but regex does not work in "if"
          echo "$lpardir" | egrep "^SharedPool[0-9]*" >/dev/null 2>&1
          if [ $? -eq 1 ]; then
	    if [ ! "$lpardir" = "pool" -a ! "$lpardir" = "mem" -a ! "$lpardir" = "pool-multi" -a ! "$lpardir" = "mem-agg" -a ! "$lpardir" = "mem-multi" ]; then

              # show just active lpar (must be in cpu.cfg file)
              lpardir_slash=`echo "$lpardir"|sed 's/\&\&1/\//g'`
              lpar_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$lpardir"`
              if [ -f "$INPUTDIR/data/$managedname/$hmc/cpu.cfg" ]; then
                egrep "^lpar_name=$lpardir_slash,lpar_id=" "$INPUTDIR/data/$managedname/$hmc/cpu.cfg" >/dev/null
                if [ $? -eq 0 ]; then
                  echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar_url&item=lpar&time=w&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar_url&item=lpar&time=w&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> weekly-view/cpu.html
                  if [ $table_count -eq 0 ]; then
                    table_count=1
                  else
                    echo "</tr><tr>" >> weekly-view/cpu.html
                    table_count=0
                  fi
                fi
              else
                # cpu.cfg does not exist from some reason, ignore it and show the lpar
                echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar_url&item=lpar&time=w&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar_url&item=lpar&time=w&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> weekly-view/cpu.html
                if [ $table_count -eq 0 ]; then
                  table_count=1
                else
                  echo "</tr><tr>" >> weekly-view/cpu.html
                  table_count=0
                fi
              fi

	    fi
	  fi
        done
        echo "</tr></table><br></center>" >> weekly-view/cpu.html
        #echo "<br><font size=\"-1\">Graphs here are refreshed once a day, first LPAR2RRD run after the midnight</font></BODY> </HTML>" >> weekly-view/cpu.html
    fi
  
    #
    # Create index of monthly-view
    #

    table_count=0
    if [ -d "monthly-view" ]; then
      #print_header_lpar "Monthly view" > monthly-view/cpu.html 
      echo "<table border=\"0\"><tr>" > monthly-view/cpu.html
      echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=pool&item=pool&time=m&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=pool&item=pool&time=m&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> monthly-view/cpu.html
      echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"monthly-view/mem-m.png\" ALT=\"last month\" src=\"../../jquery/images/loading.gif\"></td></tr><tr>" >> monthly-view/cpu.html
      echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=pool-multi&item=lparagg&time=m&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=pool-multi&item=lparagg&time=m&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> monthly-view/cpu.html
      #echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"pool-multi-m.png\" ALT=\"last month\"></td>" >> monthly-view/cpu.html
      echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"monthly-view/mem-agg-m.png\" ALT=\"last month\" src=\"../../jquery/images/loading.gif\"></td></tr><tr>" >> monthly-view/cpu.html
      if [ -f "monthly-view/monthly-view/mem-multi-m.png" ]; then # AMS
        echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"monthly-view/mem-multi-m.png\" ALT=\"last month\" src=\"../../jquery/images/loading.gif\"></td>" >> monthly-view/cpu.html
        table_count=1
      fi

        for dir4 in SharedPool*
        do
          if [ -d "$dir4" ]; then
            lpar1=`basename "$dir4" .$RR`
  	    #echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"$lpar1-m.png\" ALT=\"last month\"></td>" >> monthly-view/cpu.html
            echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar1&item=shpool&time=m&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar1&item=shpool&time=m&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> monthly-view/cpu.html
            if [ $table_count -eq 0 ]; then
               table_count=1
            else
               echo "</tr><tr>" >> monthly-view/cpu.html
               table_count=0
            fi
          fi
        done
	# show just actuall lpars (not deleted once)
        # no, use cpu.cfg instead -mtime 2
	for i in `find . -name m.png |sed 's/ /\%20/g'|sort -f`
	do
	  lpardir=`dirname "$i"|sed 's/\.\///'|sed 's/\%20/ /g'`
	  # need exclude shared pools but regex does not work in "if"
          echo "$lpardir" | egrep "^SharedPool[0-9]*" >/dev/null 2>&1
          if [ $? -eq 1 ]; then
	    if [ ! "$lpardir" = "pool" -a ! "$lpardir" = "mem" -a ! "$lpardir" = "pool-multi" -a ! "$lpardir" = "mem-agg" -a ! "$lpardir" = "mem-multi" ]; then

              # show just active lpar (must be in cpu.cfg file)
              lpardir_slash=`echo "$lpardir"|sed 's/\&\&1/\//g'`
              lpar_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$lpardir"`
              if [ -f "$INPUTDIR/data/$managedname/$hmc/cpu.cfg" ]; then
                egrep "^lpar_name=$lpardir_slash,lpar_id=" "$INPUTDIR/data/$managedname/$hmc/cpu.cfg" >/dev/null
                if [ $? -eq 0 ]; then
                  echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar_url&item=lpar&time=m&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar_url&item=lpar&time=m&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> monthly-view/cpu.html
                  if [ $table_count -eq 0 ]; then
                    table_count=1
                  else
                    echo "</tr><tr>" >> monthly-view/cpu.html
                    table_count=0
                  fi
                fi
              else
                # cpu.cfg does not exist from some reason, ignore it and show the lpar
                echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar_url&item=lpar&time=m&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar_url&item=lpar&time=m&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> monthly-view/cpu.html
                if [ $table_count -eq 0 ]; then
                  table_count=1
                else
                  echo "</tr><tr>" >> monthly-view/cpu.html
                  table_count=0
                fi
              fi

	    fi
	  fi
        done
        echo "</tr></table><br></center>" >> monthly-view/cpu.html
        #echo "<br><font size=\"-1\">Graphs here are refreshed once a day, first LPAR2RRD run after the midnight</font></BODY> </HTML>" >> monthly-view/cpu.html
    fi
  
    #
    # Create index of yearly-view
    #

    table_count=0
    if [ $IVM -eq 0 -a $SDMC -eq 0 ]; then
      type_sam=d
    fi
    if [ -d "yearly-view" ]; then
      #print_header_lpar "Yearly view" > yearly-view/cpu.html 
      echo "<table border=\"0\"><tr>" > yearly-view/cpu.html
      echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=pool&item=pool&time=y&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=pool&item=pool&time=y&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> yearly-view/cpu.html
      echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"yearly-view/mem-y.png\" ALT=\"last year\" src=\"../../jquery/images/loading.gif\"></td></tr><tr>" >> yearly-view/cpu.html
      echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=pool-multi&item=lparagg&time=y&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=pool-multi&item=lparagg&time=y&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> yearly-view/cpu.html
      #echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"pool-multi-y.png\" ALT=\"last year\" src=\"../../jquery/images/loading.gif\"></td>" >> yearly-view/cpu.html
      echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"yearly-view/mem-agg-y.png\" ALT=\"last year\" src=\"../../jquery/images/loading.gif\"></td></tr><tr>" >> yearly-view/cpu.html
      if [ -f "yearly-view/yearly-view/mem-multi-y.png" ]; then # AMS
        echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"yearly-view/mem-multi-y.png\" ALT=\"last year\" src=\"../../jquery/images/loading.gif\"></td>" >> yearly-view/cpu.html
        table_count=1
      fi

        for dir4 in SharedPool*
        do
          if [ -d "$dir4" ]; then
            lpar1=`basename "$dir4" .$RR`
  	    #echo "<td valign=\"top\"><IMG class=\"lazy\" data-src=\"$lpar1-y.png\" ALT=\"last year\" src=\"../../jquery/images/loading.gif\"></td>" >> yearly-view/cpu.html
            echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar1&item=shpool&time=y&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar1&item=shpool&time=y&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> yearly-view/cpu.html
            if [ $table_count -eq 0 ]; then
               table_count=1
            else
               echo "</tr><tr>" >> yearly-view/cpu.html
               table_count=0
            fi
	  fi
        done
	# show just actuall lpars (not deleted once)
        # no, use cpu.cfg instead -mtime 2
	for i in `find . -name y.png |sed 's/ /\%20/g'|sort -f`
	do
	  lpardir=`dirname "$i"|sed 's/\.\///'|sed 's/\%20/ /g'`
	  # need exclude shared pools but regex does not work in "if"
          echo "$lpardir" | egrep "^SharedPool[0-9]*" >/dev/null 2>&1
          if [ $? -eq 1 ]; then
	    if [ ! "$lpardir" = "pool" -a ! "$lpardir" = "mem" -a ! "$lpardir" = "pool-multi" -a ! "$lpardir" = "mem-agg" -a ! "$lpardir" = "mem-multi" ]; then

              # show just active lpar (must be in cpu.cfg file)
              lpardir_slash=`echo "$lpardir"|sed 's/\&\&1/\//g'`
              lpar_url=`$PERL -e '$s=shift;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$lpardir"`
              if [ -f "$INPUTDIR/data/$managedname/$hmc/cpu.cfg" ]; then
                egrep "^lpar_name=$lpardir_slash,lpar_id=" "$INPUTDIR/data/$managedname/$hmc/cpu.cfg" >/dev/null
                if [ $? -eq 0 ]; then
                  echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar_url&item=lpar&time=y&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar_url&item=lpar&time=y&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> yearly-view/cpu.html
                  if [ $table_count -eq 0 ]; then
                    table_count=1
                  else
                    echo "</tr><tr>" >> yearly-view/cpu.html
                    table_count=0
                  fi
                fi
              else
                # cpu.cfg does not exist from some reason, ignore it and show the lpar
                echo "<td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar_url&item=lpar&time=y&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none\" onClick=\"return popup(this, 'detail')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar_url&item=lpar&time=y&type_sam=$type_sam&detail=0&upper=0&entitle=$ENTITLEMENT_LESS&none=none\" src=\"../../jquery/images/loading.gif\"></font></a></td>" >> yearly-view/cpu.html
                if [ $table_count -eq 0 ]; then
                  table_count=1
                else
                  echo "</tr><tr>" >> yearly-view/cpu.html
                  table_count=0
                fi
              fi

	    fi
	  fi
        done
        echo "</tr></table><br></center>" >> yearly-view/cpu.html
        #echo "<br><font size=\"-1\">Graphs here are refreshed once a day, first LPAR2RRD run after the midnight</font></BODY> </HTML>" >> yearly-view/cpu.html
    fi

    #echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $MINDEX_TMP
    #echo "<TR><TD nowrap><A HREF=\"daily-view/cpu.html\" target=\"sample\">Daily</A><BR>" >> $MINDEX_TMP
    #echo "</TD></TR>" >> $MINDEX_TMP
    #echo "<TR><TD nowrap><A HREF=\"weekly-view/cpu.html\" target=\"sample\">Weekly</A><BR>" >> $MINDEX_TMP
    #echo "</TD></TR>" >> $MINDEX_TMP
    #echo "<TR><TD nowrap><A HREF=\"monthly-view/cpu.html\" target=\"sample\">Monthly</A><BR>" >> $MINDEX_TMP
    #echo "</TD></TR>" >> $MINDEX_TMP
    #echo "<TR><TD nowrap><A HREF=\"yearly-view/cpu.html\" target=\"sample\">Yearly</A><BR>" >> $MINDEX_TMP
    #echo "</TD></TR>" >> $MINDEX_TMP
    #echo "</TABLE>" >> $MINDEX_TMP

    echo "<TR><TD nowrap><A HREF=\"views.html\" target=\"sample\">VIEWs</A>" >> $MINDEX_TMP
    echo "</TD></TR>" >> $MINDEX_TMP
    echo "</TABLE>" >> $MINDEX_TMP

    print_views > views.html

   fi  # not for HMC managed lpar --> --unknown server suffix


    echo "<BR><TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD>" >> $MINDEX_TMP
    echo "<CENTER><B>LPAR</B></CENTER>" >> $MINDEX_TMP
    echo " </TD></TR></TABLE>" >> $MINDEX_TMP

    # exclude LPARs removed 7 days ago and more
    # do not exlude it, use cpu.cfg to check what is actual and what is not
    echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $MINDEX_TMP
    for dir3 in `find "$INPUTDIR/data/$managedname/$hmc" |egrep ".$RR$"|sed 's/ /\%20/g'|sort -f`
    do
      #pregarz start space in lpar name
      ff=$(echo "$dir3"|tr '@' ' ')
      i=`basename "$ff" .$RR`
      #pregarz end
      #i=`basename "$dir3" .$RR`
      if [ ! "$i" = "pool-multi" -a ! "$i" = "lpar-search.html" -a ! "$i" = "lpar-cgi.html" -a ! "$i" = "mem" -a ! "$i" = "pool" -a ! "$i" = "daily-view" -a ! "$i" = "weekly-view" -a ! "$i" = "monthly-view" -a ! "$i" = "yearly-view" -a ! "$i" = "index.html" -a ! "$i" = "menu.html"  -a ! "$i" = "menu.html"  -a ! "$i" = "menuframe.html" -a ! "$i" = "right.html" -a ! "$i" = "right_all.html" -a ! "$i" = "$MINDEX_TMP" ]; then
	# need to exclude shared pools but regex does not work in "if"
        echo "$i" | egrep "^SharedPool[0-9]*" >/dev/null 2>&1
        if [ ! $? -eq 0 ]; then
          i_space=`echo "$i"|sed 's/\%20/ /g'`
	  i_slash=`echo "$i_space"|sed 's/\&\&1/\//g'`
          lpar_url=`$PERL -e '$s=shift;$s=~s/ /+/g;;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$i_slash"`

          # show just active lpar (must be in cpu.cfg file)
	  if [ -f $INPUTDIR/data/$managedname/$hmc/cpu.cfg ]; then           
            egrep "^lpar_name=$i_slash,lpar_id=" $INPUTDIR/data/$managedname/$hmc/cpu.cfg >/dev/null
            if [ $? -eq 0 ]; then 
              if [ $DEBUG -eq 1 ]; then echo "creating html  : $hmc:$managedname:$i_slash : lpar_url:$lpar_url"; fi
              menu "$hmc" "$managedname" "$i_slash"
              echo "<TR><TD nowrap><A HREF=\"/lpar2rrd-cgi/detail.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar_url&item=lpar&entitle=$ENTITLEMENT_LESS&none=none\" target=\"sample\">$i_slash</A>" >> $MINDEX_TMP
              echo " </TD></TR>" >> $MINDEX_TMP
            fi
          else
            # cpu.cfg does not exist from some reason, ignore it and show the lpar
            if [ $DEBUG -eq 1 ]; then echo "creating html  : $hmc:$managedname:$i_slash : lpar_url:$lpar_url : no cpu.cfg"; fi
            menu "$hmc" "$managedname" "$i_slash"
            echo "<TR><TD nowrap><A HREF=\"/lpar2rrd-cgi/detail.sh?host=$hmc_url&server=$managedname_url&lpar=$lpar_url&item=lpar&entitle=$ENTITLEMENT_LESS&none=none\" target=\"sample\">$i_slash</A>" >> $MINDEX_TMP
            echo " </TD></TR>" >> $MINDEX_TMP
          fi

        fi
      fi
    done
    echo "</TABLE>" >> $MINDEX_TMP

    if [ $HEA -eq 1 ]; then
      ls hea/*port*png >/dev/null 2>/dev/null    # workaround as 2.56 had a bug and created hea subdir even when no HEA presented
      if [ $? -eq 0 ]; then
        echo "<BR><TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD>" >> $MINDEX_TMP
        echo "<CENTER><B>HEA/IVE</B></CENTER>" >> $MINDEX_TMP
        echo " </TD></TR></TABLE>" >> $MINDEX_TMP
        echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $MINDEX_TMP
	heaindx=1
        for h in `find hea -name \*.png|egrep -v "VIOSE0|HSCL"|cut -d. -f1|sort -n|uniq|sed 's/hea\///'`
        do
          for port in `find hea -name $h\*.png|egrep -v "error|summ|HSCL|VIOSE0"|sed -e 's/hea\///' -e 's/.png//'|cut -d. -f3|sort|uniq`
          do
	    #echo "--- $h $port"
            echo "<TR><TD nowrap><A HREF=\"hea/hea-$h-$port.html\" target=\"sample\">HEA$heaindx-$port</A>" >> $MINDEX_TMP
            echo " </TD></TR>" >> $MINDEX_TMP
            print_hea_html_head > hea/hea-$h-$port.html
            echo "<NOBR>" >> hea/hea-$h-$port.html
            echo "<IMG SRC=\"$h.d.$port.png\" ALT=\"hea\">" >> hea/hea-$h-$port.html
            echo "<IMG SRC=\"$h.w.$port.png\" ALT=\"hea\">" >> hea/hea-$h-$port.html
            echo "</NOBR> <BR>" >> hea/hea-$h-$port.html
            echo "<NOBR>" >> hea/hea-$h-$port.html
            echo "<IMG SRC=\"$h.m.$port.png\" ALT=\"hea\">" >> hea/hea-$h-$port.html
            echo "<IMG SRC=\"$h.y.$port.png\" ALT=\"hea\">" >> hea/hea-$h-$port.html
            echo "</NOBR> <BR></CENTER>" >> hea/hea-$h-$port.html
	    if [ -f "$INPUTDIR/data/$managedname/$hmc/hea-$h-$port.html" ]; then
	      cat "$INPUTDIR/data/$managedname/$hmc/hea-$h-$port.html" >> hea/hea-$h-$port.html
	    fi
	    echo "<HR><center><b>Summary Bytes a day</b><BR>" >> hea/hea-$h-$port.html
            echo "<NOBR>" >> hea/hea-$h-$port.html
            echo "<IMG SRC=\"$h.m.summ-$port.png\" ALT=\"hea\">" >> hea/hea-$h-$port.html
            echo "<IMG SRC=\"$h.y.summ-$port.png\" ALT=\"hea\">" >> hea/hea-$h-$port.html
            echo "</NOBR> <BR>" >> hea/hea-$h-$port.html
            echo "</BODY> </HTML>" >> hea/hea-$h-$port.html
            #break
	  done
	  (( heaindx = heaindx + 1 ))
        done
          echo "<TR><TD nowrap><A HREF=\"hea/hea-error.html\" target=\"sample\">HEA-error</A>" >> $MINDEX_TMP
          echo " </TD></TR>" >> $MINDEX_TMP
          print_hea_html_head > hea/hea-error.html
          echo "<NOBR>" >> hea/hea-error.html
          echo "<IMG SRC=\"hea-error-d.png\" ALT=\"hea error\">" >> hea/hea-error.html
          echo "<IMG SRC=\"hea-error-w.png\" ALT=\"hea error\">" >> hea/hea-error.html
          echo "</NOBR> <BR>" >> hea/hea-error.html
          echo "<NOBR>" >> hea/hea-error.html
          echo "<IMG SRC=\"hea-error-m.png\" ALT=\"hea error\">" >> hea/hea-error.html
          echo "<IMG SRC=\"hea-error-y.png\" ALT=\"hea error\">" >> hea/hea-error.html
          echo "</NOBR> <BR><HR>" >> hea/hea-error.html
          echo "</BODY> </HTML>" >> hea/hea-error.html
        echo "</TABLE>" >> $MINDEX_TMP
      else
        if [ $DEBUG -eq 1 ]; then echo "no HEA found"; fi
      fi
    fi
    ls fcs/fcs*png >/dev/null 2>/dev/null    # workaround as 2.56 had a bug and created fcs subdir even when no HEA presented
    if [ $? -eq 0 ]; then
      echo "<BR><TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD>" >> $MINDEX_TMP
      echo "<CENTER><B>FC stats</B></CENTER>" >> $MINDEX_TMP
      echo " </TD></TR></TABLE>" >> $MINDEX_TMP
      echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $MINDEX_TMP
        for port in `find fcs -name \*.png|grep -v sum|sed -e 's/fcs\///g' -e 's/.png//'|cut -d. -f1|sort|uniq`
        do
          echo "<TR><TD nowrap><A HREF=\"fcs/fcs-$port.html\" target=\"sample\">$port</A>" >> $MINDEX_TMP
          echo " </TD></TR>" >> $MINDEX_TMP
          print_hea_html_head > fcs/fcs-$port.html
          echo "<NOBR>" >> fcs/fcs-$port.html
          echo "<IMG SRC=\"$port.d.png\" ALT=\"fcs\">" >> fcs/fcs-$port.html
          echo "<IMG SRC=\"$port.w.png\" ALT=\"fcs\">" >> fcs/fcs-$port.html
          echo "</NOBR> <BR>" >> fcs/fcs-$port.html
          echo "<NOBR>" >> fcs/fcs-$port.html
          echo "<IMG SRC=\"$port.m.png\" ALT=\"fcs\">" >> fcs/fcs-$port.html
          echo "<IMG SRC=\"$port.y.png\" ALT=\"fcs\">" >> fcs/fcs-$port.html
          echo "</NOBR> <BR><HR>" >> fcs/fcs-$port.html
          echo "<center><b>Summary Bytes a day</b><BR>" >> fcs/fcs-$port.html
          echo "<NOBR>" >> fcs/fcs-$port.html
          echo "<IMG SRC=\"$port-sum.m.png\" ALT=\"fcs\">" >> fcs/fcs-$port.html
          echo "<IMG SRC=\"$port-sum.y.png\" ALT=\"fcs\">" >> fcs/fcs-$port.html
          echo "</NOBR> <BR>" >> fcs/fcs-$port.html
          echo "</BODY> </HTML>" >> fcs/fcs-$port.html
        done
        echo "</TABLE>" >> $MINDEX_TMP
    else
      if [ $DEBUG -eq 1 ]; then echo "no FC stats found, this feature is supported only on IVM based systems"; fi
    fi

    print_cfg > ../../cfg.html
    print_log > ../../log.html

    if [ $custom -eq 1 ]; then 
      echo "<BR><TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD>" > $CUSTOM_INDX_TMP-trailer
      echo "<CENTER>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<B>LPAR2RRD</B> <font size=\"-1\">v$version</font></CENTER>" >> $CUSTOM_INDX_TMP-trailer
      echo " </TD></TR></TABLE>" >> $CUSTOM_INDX_TMP-trailer
      echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $CUSTOM_INDX_TMP-trailer
      echo "<TR><TD><A HREF=\"../../help.html\" target=\"sample\">Documentation</A></TD></TR> " >> $CUSTOM_INDX_TMP-trailer
      echo "<TR><TD><A HREF=\"../../daily_lpar_check.html\" target=\"sample\">Data check</A></TD></TR> " >> $CUSTOM_INDX_TMP-trailer
      echo "<TR><TD><A HREF=\"../../cfg.html\" target=\"sample\">Configuration</A></TD></TR>" >>$CUSTOM_INDX_TMP-trailer
      echo "<TR><TD><A HREF=\"../../log.html\" target=\"sample\">Logs</A></TD></TR>" >>$CUSTOM_INDX_TMP-trailer
      echo "<TR><TD align=\"center\"><A HREF=\"http://www.stor2rrd.com\" target=\"blank\"><img src="../../logo-stor2rrd-42.png" border="0" alt="STOR2RRD"></A></TD></TR>" >>$CUSTOM_INDX_TMP-trailer
      echo "</TABLE>" >> $CUSTOM_INDX_TMP-trailer
    fi

    if [ $custom -eq 1 ]; then 
      echo "<BR><TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD>" > $FAV_INDX_TMP-trailer
      echo "<CENTER>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<B>LPAR2RRD</B> <font size=\"-1\">v$version</font></CENTER>" >> $FAV_INDX_TMP-trailer
      echo " </TD></TR></TABLE>" >> $FAV_INDX_TMP-trailer
      echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $FAV_INDX_TMP-trailer
      echo "<TR><TD><A HREF=\"../../help.html\" target=\"sample\">Documentation</A></TD></TR> " >> $FAV_INDX_TMP-trailer
      echo "<TR><TD><A HREF=\"../../daily_lpar_check.html\" target=\"sample\">Data check</A></TD></TR> " >> $FAV_INDX_TMP-trailer
      echo "<TR><TD><A HREF=\"../../cfg.html\" target=\"sample\">Configuration</A></TD></TR>" >>$FAV_INDX_TMP-trailer
      echo "<TR><TD><A HREF=\"../../log.html\" target=\"sample\">Logs</A></TD></TR>" >>$FAV_INDX_TMP-trailer
      echo "<TR><TD align=\"center\"><A HREF=\"http://www.stor2rrd.com\" target=\"blank\"><img src="../../logo-stor2rrd-42.png" border="0" alt="STOR2RRD"/></A></TD></TR>" >>$FAV_INDX_TMP-trailer
      echo "</TABLE>" >> $FAV_INDX_TMP-trailer
    fi

    echo "<BR><TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD>" >> $MINDEX_TMP
    echo "<CENTER>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<B>LPAR2RRD</B> <font size=\"-1\">v$version</font></CENTER>" >> $MINDEX_TMP
    echo " </TD></TR></TABLE>" >> $MINDEX_TMP
    echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $MINDEX_TMP
    echo "<TR><TD><A HREF=\"../../help.html\" target=\"sample\">Documentation</A></TD></TR> " >> $MINDEX_TMP
    echo "<TR><TD><A HREF=\"../../daily_lpar_check.html\" target=\"sample\">Data check</A></TD></TR> " >> $MINDEX_TMP
    echo "<TR><TD><A HREF=\"../../cfg.html\" target=\"sample\">Configuration</A></TD></TR>" >>$MINDEX_TMP
    echo "<TR><TD><A HREF=\"../../log.html\" target=\"sample\">Logs</A></TD></TR>" >>$MINDEX_TMP
    echo "<TR><TD align=\"center\"><A HREF=\"http://www.stor2rrd.com\" target=\"blank\"><img src="../../logo-stor2rrd-42.png" border="0" alt="STOR2RRD"></A></TD></TR>" >>$MINDEX_TMP
    echo "</TABLE>" >> $MINDEX_TMP

    echo "</BODY> </HTML>" >> $MINDEX_TMP
    mv $MINDEX_TMP $MINDEX
    cd "$WEBDIR/$hmc/$managedname"
  done
done

#################################################
# Custom defined graphs
#################################################

print_custom_body  () {

# print html header
menu_head "../.."



if [ "$1"x = "x" ]; then
  #no group defined
  cat << END 
<br>
Custom groups feature allows you group selected lpars or pools from different servers into one aggregated graph.<br>
Functionality is similar to historical reports, however here you can preconfigure it so you will get required daily-yearly graphs in 2 or 3 clicks<br>
<br>
This might be found useful especially for grouping nodes of a active/active cluster to see on one page total CPU utilization per all its nodes
<br>
Also for active/passive cluster it might be useful, as you get total CPU utilization all nodes of the cluster (active and passives) no matter which one is actually active.
<br>
There can be found many other examples where possibility to group CPU pools or lpars from different servers can be useful.
<br>
<br>
<b>How to start?</b><br>
<ul>
<li>Create configuration file<br>
(upgrade process creates configuration file automatically, so you might skip this)<br>
<b>$ cd $INPUTDIR<br>
$ ./scripts/update_cfg_custom-groups.sh <br></b>
it creates this configuration file: <b>etc/custom_groups.cfg</b> <br>
</li>
<li> edit <b>./etc/custom_groups.cfg</b> and assign lpars or pools to groups <br><br></li>
<li>
when you want to refresh list of servers/pools/lpars within custom_groups.cfg then just run again:<br>
<b>$ ./scripts/update_cfg_custom-groups.sh <br></b>
</li>
</ul>
<br>
For more details and configuration examples visit <b><a href="http://www.lpar2rrd.com/custom_groups.html" target="_blank">Custom groups</a></b><br>
You can also try this functionality on <b><a href="http://www.lpar2rrd.com/live_demo.html" target="_blank">LPAR2RRD live demo</a></b>
<BR><BR>
Note that <b>free LPAR2RRD</b> edition you use has limitation of <b>maximum 4 lpars or pools in one custom group</b>.
<BR>


END
else
  item="custom"
  type_sam="na"
  type_sam_year="na"
  lpar_url=`$PERL -e '$s=shift;$s=~s/ /+/g;;$s=~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;print "$s\n";' "$1"`


cat << END 
<div  id="tabs"> <ul>
  <li><a href="#tabs-1">CPU</a></li>
END

if [ -f "$1/d-mem.png" ]; then
  echo "  <li><a href=\"#tabs-2\">MEM allocated</a></li>"
fi

if [ -f "$1/d-mem-os.png" ]; then
  echo "   <li><a href=\"#tabs-3\">MEM OS agent</a></li>"
fi

cat << END
   </ul>

<div id="tabs-1">
<CENTER>
<h4>$1 : CPU</h4>
<table border="0"><tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=na&server=na&lpar=$group&item=$item&time=d&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="d.png" ALT="daily stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$na&server=$na&lpar=$group&item=$item&time=w&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="w.png" ALT="weekly stats"></font></a>
</td></tr>
END

if [ -f "$1/ll" ]; then
  echo "<tr><td colspan=\"2\">"
  cat "$1/ll"
  rm -f "$1/ll"
  echo "</td></tr>"
fi

  cat << END 
<tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=na&server=na&lpar=$group&item=$item&time=m&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="m.png" ALT="monthly stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=na&server=na&lpar=$group&item=$item&time=y&type_sam=$type_sam_year&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="y.png" ALT="yearly stats"></font></a>
</td></tr>
</table>
</div>

END

if [ -f "$1/d-mem.png" ]; then
  item="custommem"
  cat << END 
<div id="tabs-2">
<center>
<h4>$1 : Allocated memory</h4>
<table border="0"><tr><td valign="top">
<tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=na&server=na&lpar=$group&item=$item&time=d&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="d-mem.png" ALT="daily stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$na&server=$na&lpar=$group&item=$item&time=w&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="w-mem.png" ALT="weekly stats"></font></a>
</td></tr>
<tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=na&server=na&lpar=$group&item=$item&time=m&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="m-mem.png" ALT="monthly stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=na&server=na&lpar=$group&item=$item&time=y&type_sam=$type_sam_year&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="y-mem.png" ALT="yearly stats"></font></a>
</td></tr>
</table>
</center>
</div>
END
fi

if [ -f "$1/d-mem-os.png" ]; then
  item="custommemos"
  cat << END 
<div id="tabs-3">
<center>
<h4>$1 : Used Memory - Operating System <font size=-1>(agent based, without FS cache)</font></h4>
<table border="0"><tr><td valign="top">
</td></tr>
<tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=na&server=na&lpar=$group&item=$item&time=d&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="d-mem-os.png" ALT="daily stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=$na&server=$na&lpar=$group&item=$item&time=w&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="w-mem-os.png" ALT="weekly stats"></font></a>
</td></tr>
<tr><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=na&server=na&lpar=$group&item=$item&time=m&type_sam=$type_sam&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="m-mem-os.png" ALT="monthly stats"></font></a>
</td><td valign="top">
<a href="/lpar2rrd-cgi/detail-graph.sh?host=na&server=na&lpar=$group&item=$item&time=y&type_sam=$type_sam_year&detail=1&entitle=$ENTITLEMENT_LESS&none=none" onClick="return popup(this, 'detail')"><font color="#C8C8C8"><IMG border="0" SRC="y-mem-os.png" ALT="yearly stats"></font></a>
</td></tr>
</table>
</center>
</div>
END
fi

echo " </div>"
fi

}

print_custom_lpar_details ()
{
group="$1"

if [ -f "$WEBDIR/$group/list.txt" ]; then

cat << END
</CENTER>
<BR><CENTER><TABLE border="0" cellpadding="0" cellspacing="0">

<TR> <TD><font size=-1><B>LPAR name&nbsp;&nbsp;&nbsp;</B></font></TD> <TD align="center"><font size=-1><B>&nbsp;&nbsp;&nbsp;Mode&nbsp;&nbsp;&nbsp;</B></font></TD> <TD align="center"><font size=-1><B>&nbsp;&nbsp;&nbsp;Min&nbsp;&nbsp;&nbsp;</B></font></TD> <TD align="center"><font size=-1><B>&nbsp;&nbsp;&nbsp;Assigned&nbsp;&nbsp;&nbsp;</B></font></TD> <TD align="center"><font size=-1><B>&nbsp;&nbsp;&nbsp;Max&nbsp;&nbsp;&nbsp;</B></font></TD> <TD align="center"><font size=-1><B>&nbsp;&nbsp;&nbsp;Virtual&nbsp;&nbsp;&nbsp;</B></font></TD> <TD align="center"><font size=-1><B>&nbsp;&nbsp;&nbsp;Sharing mode&nbsp;&nbsp;&nbsp;</B></font></TD> <TD align="center"><font size=-1><B>&nbsp;&nbsp;&nbsp;Uncap weight&nbsp;&nbsp;&nbsp;</B></font></TD><TD align="center"><font size=-1><B>&nbsp;&nbsp;&nbsp;Pool&nbsp;&nbsp;&nbsp;</B></font></TD><TD align="center"><font size=-1><B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;OS&nbsp;&nbsp;&nbsp;</b></TD></TR>
END

for line in `cat "$WEBDIR/custom/$group/list.txt" `
do
  lpar=`basename $line|sed 's/\.rr.*$//'`
  path=`dirname $line`
  hmc=`basename $path`
  path1=`dirname $path $hmc`
  server=`basename $path1`
  if [ ! -f "$WEBDIR/$hmc/$server/pool/cpu.html" ]; then
     # grrrr it prints it to stdout anyway ...
     # echo STDERR "custom group   : has not been found lpar cfg file: $WEBDIR/$hmc/$server/pool/cpu.html"
    continue
  fi 
  egrep "<B>$lpar<" "$WEBDIR/$hmc/$server/pool/cpu.html"
done

echo "</TABLE></CENTER>"
fi

echo "</body></html>"
 
}


CUSTOM_INDX_TMP_GROUPS="$WEBDIR/custom_index.html-group"

# go through all custom groups
number_groups=0
cd $WEBDIR/custom
for group_space in `ls|sort|sed -e 's/ *$//g' -e 's/ /+===============+/g'`
do
  group=`echo $group_space|sed 's/+===============+/ /g'`
  if [ ! -d "$group" ]; then
    continue # some trash
  fi

  # avoid group actually not configured
  egrep -v "#" $INPUTDIR/etc/custom_groups.cfg|egrep ".*:$group$" >/dev/null
  if [ ! $? -eq 0 ]; then
     echo "custom group $group is not more configured"
     continue
  fi

  (( number_groups = number_groups + 1 ))


  echo "custom group   : $group"
  # Add others managed systems into the menu
  echo "<BR><TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD nowrap>" > $CUSTOM_INDX_TMP_GROUPS
  echo "<CENTER><B>CUSTOM GROUPS</B></CENTER>" >> $CUSTOM_INDX_TMP_GROUPS
  echo "</TR></TD></TABLE>" >> $CUSTOM_INDX_TMP_GROUPS
  echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $CUSTOM_INDX_TMP_GROUPS

  for rest_groups_space in `ls|sort|sed -e 's/ *$//g' -e 's/ /+===============+/g'`
  do
    rest_groups=`echo $rest_groups_space|sed 's/+===============+/ /g'`

    if [ ! -d "$rest_groups" ]; then
      continue # some trash
    fi

    # avoid group actually not configured
    egrep -v "#" $INPUTDIR/etc/custom_groups.cfg|sed 's/ *$//g'|egrep ".*:$rest_groups$" >/dev/null
    if [ ! $? -eq 0 ]; then
       echo "custom group   : $rest_groups is not more configured, removing it ..."
       rm -rf "$WEBDIR/custom/$rest_groups"
       continue
    fi

    #rest_groups_base=`basename $rest_groups`
    rest_groups_nbsp=`echo $rest_groups|sed 's/ /\&nbsp;/g'`
    if [ "$group" = "$rest_groups" ]; then
      echo "<TR><TD nowrap><b>$rest_groups_nbsp</b>" >> $CUSTOM_INDX_TMP_GROUPS
    else
      echo "<TR><TD nowrap><A HREF=\"../../custom/$rest_groups/index.html\" target=\"main\">$rest_groups_nbsp</A>" >> $CUSTOM_INDX_TMP_GROUPS
    fi
    echo "</TD></TR>" >> $CUSTOM_INDX_TMP_GROUPS
  done
  echo "</TABLE>" >> $CUSTOM_INDX_TMP_GROUPS
  cat $CUSTOM_INDX_TMP-trailer >> $CUSTOM_INDX_TMP_GROUPS
  echo "</BODY> </HTML>" >> $CUSTOM_INDX_TMP_GROUPS

  print_custom_body  "$group" > "$group/cpu.html"
  print_custom_lpar_details "$group" >> "$group/cpu.html"

  cat $CUSTOM_INDX_TMP-header > "$group/servers.html"
  cat $CUSTOM_INDX_TMP  >> "$group/servers.html"
  cat $CUSTOM_INDX_TMP_GROUPS  >> "$group/servers.html"
  if [ ! -f "$group/index.html" ]; then
    cp $INDEX/index.html $INDEX/right_all.html "$group/"
    sed 's/\.\.\/servers/servers/' $INDEX/menuframe.html > "$group/menuframe.html"
    eval 'sed -e 's/XXXXXXXX/$group_space/g' -e 's/ENTITLE/$ENTITLEMENT_LESS/' $INDEX/top.src'|sed 's/+===============+/ /g'  > "$group/top.html" 
  fi
done

if [ $number_groups -eq 0 ]; then
  # no custom group defined yet, place there just default template

  echo "custom group   : no group, placing default"
  # Add others managed systems into the menu
  echo "<BR><TABLE width=\"100%\" border=\"0\" CLASS=\"header\"><TR><TD nowrap>" >> $CUSTOM_INDX_TMP_GROUPS
  echo "<CENTER><B>CUSTOM GROUPS</B></CENTER>" >> $CUSTOM_INDX_TMP_GROUPS
  echo "</TR></TD></TABLE>" >> $CUSTOM_INDX_TMP_GROUPS
  echo "<TABLE width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">" >> $CUSTOM_INDX_TMP_GROUPS

  echo "</TD></TR></TABLE>" >> $CUSTOM_INDX_TMP_GROUPS
  cat $CUSTOM_INDX_TMP-trailer >> $CUSTOM_INDX_TMP_GROUPS
  echo "</BODY> </HTML>" >> $CUSTOM_INDX_TMP_GROUPS

  print_custom_body  "" > "cpu.html"
  print_custom_lpar_details "" >> "cpu.html"

  cat $CUSTOM_INDX_TMP-header  | sed 's/\.\.\///' > "servers.html"
  cat $CUSTOM_INDX_TMP  | sed 's/\.\.\///' >> "servers.html"
  cat $CUSTOM_INDX_TMP_GROUPS  | sed 's/\.\.\///' >> "servers.html"
  rm -f $CUSTOM_INDX_TMP_GROUPS
  if [ ! -f index.html ]; then
    cp $INDEX/index.html $INDEX/right_all.html ./
    sed 's/\.\.\/servers/servers/' $INDEX/menuframe.html > ./menuframe.html
    eval 'sed -e 's/XXXXXXXX/No\\ groups\\ defined/g' -e 's/ENTITLE/$ENTITLEMENT_LESS/' $INDEX/top.src'  > ./top.html 
  fi
fi

# cleanup after groups
rm -f $CUSTOM_INDX_TMP $CUSTOM_INDX_TMP_GROUPS $CUSTOM_INDX_TMP-trailer $CUSTOM_INDX_TMP-header

#################################################
# End of custom defined graphs
#################################################

# Favourite section
favourite

#menu_head  > $MENU_SRC
#menu_create

