#!/usr/bin/perl

use strict;
use Date::Parse;

my $bindir = $ENV{BINDIR};
my $DEBUG = $ENV{DEBUG};
my $errlog = $ENV{ERRLOG};
my $xport = $ENV{EXPORT_TO_CSV};
my $inputdir = $ENV{INPUTDIR};
my $detail_yes = 1;
my $detail_no  = 0;
my $entitle = 1; # --PH dodelat
my $lpm = $ENV{LPM};
my $basedir = $ENV{INPUTDIR};
my $wrkdir = $basedir."/data";


open(OUT, ">> $errlog")  if $DEBUG == 2 ;

# print HTML header
print "Content-type: text/html\n\n";

my $premium = 0;
if ( -f "$bindir/premium.pl" ) {
  require "$bindir/premium.pl";
  $premium = 1;
}
else {
  require "$bindir/standard.pl";
}

#foreach $key (sort keys(%ENV)) {
#   print "$key = $ENV{$key}<p>";
#} 

# get QUERY_STRING
use Env qw(QUERY_STRING);
#$QUERY_STRING .= ":.";
print OUT  "-- $QUERY_STRING\n" if $DEBUG == 2 ;
#print STDERR  "-- $QUERY_STRING\n";

my $shour = "";
my $sday = "";
my $smon = "";
my $syear = "";
my $ehour = "";
my $eday = "";
my $emon = "";
my $eyear = "";
my $type = "";
my $height = "";
my $width = "";
my $lpar_list = "";
my @lpar_row = "";
my @pool_row = "";
my $sort_order = "";
my $pool = "";
my $new_server = "";
my $lparform = 0; # LPAR or POOL from global reports
my $yaxis = "";
my $newsrv = "";
my $estimator = 1; # euither CPU estimator or historical reporting
my $referer = "";



# First check whether POST or GET
my $r_method = $ENV{'REQUEST_METHOD'};
if ( $r_method eq '' ) {
  $r_method = "GET";
}
else {
 $r_method =~ tr/a-z/A-Z/;
}

if ( $r_method =~ m/POST/ )
{
  # POST is being used, it is just a workaround when GET reaches 
  #   Request-URI Too Large, and The requested URL's length exceeds the capacity limit for this server.
  # only historucal report so far implemented 

  my $buffer = "";
  my @pairs = "";
  my $pair = "";
  my $name = "";
  my $value = "";
  my %FORM = "";
  my $lpar_indx = 0;
  my $pool_indx = 0;

  read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  #`echo "$buffer " >> /tmp/e12`;
  # Split information into name/value pairs
  @pairs = split(/&/, $buffer);
  foreach $pair (@pairs)
  {
    ($name, $value) = split(/=/, $pair);
    if ( $name =~ m/^LPAR$/ ) {
      $lparform = 1;
      # specil handling of pasing lpars
      # do not do here pack ....
      $lpar_row[$lpar_indx] = $name."=".$value;
      $lpar_indx++;
      next;
    }
    if ( $name =~ m/^POOL$/ ) {
      # specil handling of pasing lpars
      # do not do here pack ....
      $pool_row[$pool_indx] = $name."=".$value;
      $pool_indx++;
      next;
    }
    $value =~ tr/+/ /;
    $value =~ s/%(..)/pack("C", hex($1))/seg;
    $FORM{$name} = $value;
    #`echo "$name - $value - $FORM{$name} " >> /tmp/e12`;
  }

  $smon = $FORM{"start-mon"};
  $sday = $FORM{"start-day"};
  $shour = $FORM{"start-hour"};
  $syear = $FORM{"start-yr"};
  $emon = $FORM{"end-mon"};
  $eday = $FORM{"end-day"};
  $ehour = $FORM{"end-hour"};
  $eyear = $FORM{"end-yr"};
  $type = $FORM{"type"};
  $height = $FORM{"HEIGHT"};
  $width = $FORM{"WIDTH"};
  $sort_order = $FORM{"sort"};
  $newsrv = $FORM{"newsrv"}; 
  if ( $newsrv eq '' ) { 
    $newsrv = 0; 
  }
  $pool = $FORM{"pool"};
  $yaxis = $FORM{"yaxis"};
  $referer = $FORM{"referer"};
  $estimator = 0;


  # `echo "$smon $sday $shour $syear $emon $eday  $ehour $eyear $type $height $width $sort_order $newsrv $pool $yaxis" >> /tmp/e12`;
  # foreach my $i (@lpar_row) {
  # `echo "001 $i" >> /tmp/e8`;
  # }
}

else {
  # GET, standard way ...

  #`echo "$QUERY_STRING" >> /tmp/e8`;
 
  # first time just separete if new or already existing server
  # complication can be if are highluighted some rows in both new and existing
  ($shour, $sday, $smon, $syear, $ehour, $eday, $emon,$eyear,$type, $height, $width, $yaxis, $sort_order, my $newsrv1, my $newsrv2, my $check1, my $check2) = split(/&/,$QUERY_STRING);

  if ( $newsrv1 =~ m/^newsrv=/ )  {
    $newsrv = $newsrv1;
  }
  else {
    if ( $newsrv2 =~ m/^newsrv=/ )  {
      $newsrv = $newsrv2;
    }
    else {
      $estimator = 0; # it was called from hoirstorical reporting therefore not CPU estimation
      ($shour, $sday, $smon, $syear, $ehour, $eday, $emon,$eyear,$type, $height, $width, $yaxis, $sort_order, $pool, @lpar_row) = split(/&/,$QUERY_STRING);
    }
  }
  
  
  if ( $estimator ) {
    $newsrv =~ s/newsrv=//;
    if ($newsrv == 0 ) {
      # usage with existing server / CPU pool
      if ( $newsrv1  =~ m/^newsrv=/ && $newsrv2 =~ m/^POOL=/ && $check1 =~ m/^LPAR/ ) {
       ($shour, $sday, $smon, $syear, $ehour, $eday, $emon,$eyear,$type, $height, $width, $yaxis, $sort_order, $newsrv, $pool, @lpar_row) = split(/&/,$QUERY_STRING);
      }
      else {
        if ( $newsrv1  =~ m/^NEW=/ && $newsrv2 =~ m/^newsrv=/ && $check1 =~ m/^POOL/ && $check2 =~ m/^LPAR/ ) {
         ($shour, $sday, $smon, $syear, $ehour, $eday, $emon,$eyear,$type, $height, $width, $yaxis, $sort_order,  my $trash, $newsrv, $pool, @lpar_row) = split(/&/,$QUERY_STRING);
        }
        else {
           err_html("Existing server has been checked but have not been choosen anyone");
        }
      }
    }
    
    if ($newsrv == 1 ) {
      # usage with new server
      if ( $newsrv1  =~ m/^newsrv=/ && $newsrv2 =~ m/^NEW=/ && $check1 =~ m/^POOL/ && $check2 =~ m/^LPAR/ ) {
         ($shour, $sday, $smon, $syear, $ehour, $eday, $emon,$eyear,$type, $height, $width, $yaxis, $sort_order, $newsrv, $new_server, ,my $trash, @lpar_row) = split(/&/,$QUERY_STRING);
      }
      else {
        if ( $newsrv1  =~ m/^newsrv=/ && $newsrv2 =~ m/^NEW=/ && $check1 =~ m/^LPAR/ ) {
           ($shour, $sday, $smon, $syear, $ehour, $eday, $emon,$eyear,$type, $height, $width, $yaxis, $sort_order, $newsrv, $new_server, , @lpar_row) = split(/&/,$QUERY_STRING);
        }
        else {
           err_html("New server has been checked but have not been choosen anyone");
        }
      }
    }
  }
  
  
  # `echo "000 $new_server " >> /tmp/e10`;
  #foreach my $i (@lpar_row) {
  #  `echo "001 $i" >> /tmp/e8`;
  #}
  #  `echo "002 " >> /tmp/e8`;
  #
  #`echo "EST:$estimator NEW:$newsrv" >> /tmp/e8`;
  
  $smon =~ s/start-mon=//;
  $sday =~ s/start-day=//;
  $shour =~ s/start-hour=//;
  $syear =~ s/start-yr=//;
  $emon =~ s/end-mon=//;
  $eday =~ s/end-day=//;
  $ehour =~ s/end-hour=//;
  $eyear =~ s/end-yr=//;
  $type =~ s/type=//;
  $height =~ s/\+//g;
  $height =~ s/HEIGHT=//;
  $width =~ s/\+//g;
  $width =~ s/WIDTH=//;
  $sort_order =~ s/sort=//;
  $newsrv =~ s/newsrv=//;
  $pool =~ s/pool=//;
  $yaxis =~ s/yaxis=//;
  
} # end of HTML GET

# http_base must be passed through cgi-bin script to get location of jquery scripts and others
# it is taken from HTTP_REFERER first time and then passed in the HTML GET
my $html_base = "";
#`echo "01 $referer " >> /tmp/xx32`;
#if ( $referer ne "" && $referer !~ m/none=none/ && $referer =~ m/^referer=/ ) {
  # when is referer set then it is already html_base --> not call html_base($refer) again
#  $referer =~ s/referer=//;
#  $referer =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/seg;
#  $referer =~ s/\+/ /g;
#  $html_base = $referer ;
#}
#else {
#  $referer = $ENV{HTTP_REFERER};
#  $html_base = html_base($referer); # it must be here behind $base setting
#}



# find ount number of selected lpars
my $count=0;
foreach my $line10 (@lpar_row) {
  $count++;
}


if (( $yaxis =~ m/w/ || $yaxis =~ m/s/ || $yaxis =~ m/r/ ) && $premium == 0) {
  print_head(0,$referer);
  # it is free version which does not support rPerf
  not_available();
  exit (0);
}
if ( $yaxis =~ m/s/ ) {
  # SAPs
  not_implemented ();
  exit 0;
}

my $start=$syear.$smon.$sday;
my $end=$eyear.$emon.$eday;
my $human_start=$shour.":00:00 ".$sday.".".$smon.".".$syear;
my $human_end=$ehour.":00:00 ".$eday.".".$emon.".".$eyear;

my $start_unix = str2time($syear."-".$smon."-".$sday." ".$shour.":00:00");
my $end_unix = "";

# workaround for 24:00. If is used proper 00:00 of the next day then there are 2 extra records in cvs after the midnight
# looks like rrdtool issue
if ( $ehour == 24 ) {
  $end_unix = str2time($eyear."-".$emon."-".$eday." 23:59:00");
}
else {
  $end_unix = str2time($eyear."-".$emon."-".$eday." ".$ehour.":00:00");
}

my $l=length($start_unix);
print OUT "$human_start : $human_end : $start_unix : $end_unix : $l \n" if $DEBUG == 2 ;

if (length($start_unix) < 1) {
  print_head(0,$referer);
  print "<center><br>Start date (<B>$sday.$smon.$syear</B>) does not seem to be valid";
  print "</center></BODY></HTML>";
  exit (0);
}

if (length($end_unix) < 1) {
  print_head(0,$referer);
  print "<center><br>End date (<B>$eday.$emon.$eyear</B>) does not seem to be valid";
  print "</center></BODY></HTML>";
  exit (0);
}

if ($end_unix <= $start_unix) {
  print_head(0,$referer);
  print "<center><br>Start (<B>$human_start</B>) should be less than end (<B>$human_end</B>)";
  print "</center></BODY></HTML>";
  exit (0);
}

my $agent = 0;
my $agent_oscpu = 0;
my $agent_ame = 0;
my $agent_pgs = 0;
my $agent_mem = 0;
my $agent_san = 0;
my $agent_lan = 0;
my $agent_sea = 0;

if ( $estimator == 0 ) {
  # reporting, chek if agen is in place and print out tabs
  foreach my $line_tmp (@lpar_row) {
    my $line = $line_tmp; # must be like that to do not modify the original script
    if ( $line =~ "LPAR=" ) {
      my $line_org = $line;
      $line =~ s/LPAR=//;
      $line =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/seg;
      $line =~ s/\+/ /g;
      (my $host , my $server, my $lpar) = split (/\|/,$line);
      #print STDERR "004 $host $server $lpar : $line\n";
      my $lpar_slash = $lpar; #must be in separate env!!
      $lpar_slash =~ s/\//\&\&1/g; # replace for "/"
      if ( ! -d "$wrkdir/$server/$host/$lpar_slash" ) {
        next;
      }
      $agent++;
      if (  test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","cpu" )) {
       $agent_oscpu++;
      }
      if (  test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","mem" )) {
       $agent_mem++;
      }
      if (  test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","pgs" )) {
        $agent_pgs++;
      }
      if (  test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","ame" )) {
        $agent_ame++;
      }
      if (  test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","san" )) {
        $agent_san++;
      }
      if (  test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","lan" )) {
        $agent_lan++;
      }
      if (  test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","sea" )) {
        $agent_sea++;
      }
    }
  }
}

my $html_base = "";
if ( $agent > 0 ) {
  $html_base = print_head(1,$referer);
}
else {
  $html_base = print_head(0,$referer);
}

if ( $estimator == 0 ) {
  if ( $agent > 0 ) {
    print "<div  id=\"tabs\"> <ul>\n";
    print "  <li><a href=\"#tabs-0\">CPU</a></li>\n";
    if ( $agent_oscpu > 0 ) {
      print "  <li><a href=\"#tabs-1\">CPU OS</a></li>\n";
    }
    if ( $agent_mem > 0 ) {
      print "  <li><a href=\"#tabs-2\">Memory</a></li>\n";
    }
    if ( $agent_pgs > 0 ) {
      print "  <li><a href=\"#tabs-3\">Paging 1</a></li>\n";
      print "  <li><a href=\"#tabs-4\">Paging 2</a></li>\n";
    }
    if ( $agent_lan > 0 ) {
      print "  <li><a href=\"#tabs-5\">LAN</a></li>\n";
    }
    if ( $agent_san > 0 ) {
      print "  <li><a href=\"#tabs-6\">SAN</a></li>\n";
      print "  <li><a href=\"#tabs-7\">SAN IOPS</a></li>\n";
    }
    if ( $agent_sea > 0 ) {
      print "  <li><a href=\"#tabs-8\">SEA</a></li>\n";
    }
    if ( $agent_ame > 0 ) {
      print "  <li><a href=\"#tabs-9\">AME</a></li>\n";
    }
    print "   </ul> \n";
    print "<div id=\"tabs-0\">\n";   ### CPU tab start
  }
}

print "<table align=\"center\" summary=\"Graphs\">\n";

if ( $estimator ) {
  my $txt = "<TABLE BORDER=0 width=\"100%\"><tr><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td align=\"center\"> <h3>CPU Workload Estimator ";
  if ( $newsrv ) {
   $txt .= "for new server ";
  }
  print "$txt";

  if ( $yaxis =~ m/r/ ) {
    print "in rPerfs </h3>";
  }
  else {
    if ( $yaxis =~ m/w/ ) {
      print "in CPWs </h3>";
    }
    else {
      print "in CPU cores </h3>";
    }
  }
  print "</td><td align=\"right\" valign=\"top\"><font size=\"-1\"><a href=\"http://www.lpar2rrd.com/cpu_workload_estimator.html\">How it works</a></font></td></tr></table>";

  if ( $yaxis =~ m/w/ || $yaxis =~ m/r/ ) {
    # If rPerf then find our rPerfs now, as in lpar-list-rep.pl it is too late as it generates only graphs
    # and there is no chance for error loging and CPU speed input

    my @rperf_all = "";
    my @rperf_user = "";
    # SAPs & rPerf: open cfg file and keep it in mem
    if ( ! -f "$inputdir/etc/rperf_table.txt" ) {
      err_html("$inputdir/etc/rperf_table.txt doe not exist!! Cannot continue, contact the support");
    }
    if ( ! -f "$inputdir/etc/rperf_user.txt" ) {
      err_html("$inputdir/etc/rperf_user.txt doe not exist!! Cannot continue, contact the support");
    }
    open(FR, "< $inputdir/etc/rperf_table.txt");
    @rperf_all = <FR>;
    close (FR);
    open(FR, "< $inputdir/etc/rperf_user.txt");
    @rperf_user = <FR>;
    close (FR);
    my $cpu_ghz_trash = "";
    my $cores_trash  = "";
    my $rperf_cpu_cores = "";
    my $rperf = "";
  
    # example how it looks here
    #new_server : 8203-E4A|520|P6+/4|4.7|39.73|18300
    #pool: sdmc|p710|SharedPool1|11.2825|3.0|4

    if ( $newsrv == 1 ) {
       # rperf is already provided as it is a new HW defined 
       $new_server  =~ s/NEW=//; # only used for CPU workload estimator
       $new_server =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/seg;
       $new_server =~ s/\+/ /g;
       my $cpu_all = 0;
       (my $trash1, my $model, $cpu_all, my $ghz, $rperf, my $cpw) = split (/\|/,$new_server);
       my $cpu = $cpu_all;
       $cpu_all =~ s/\/.*$//;
       $cpu =~ s/.*\///;
       my $ret = isdigit($cpu);
       if ( $ret == 0 ) {
         # $cpu must be a digit
         err_html("Could not find out number of cores, contact LPAR2RRD support, data:$cpu");
       }

       if ( $yaxis =~ m/w/) {
         $cpw =~ s/,//;
         if ( $cpw == 0 ) {
          err_html("This model $model:$trash1 does not have defined CPW by IBM, use other one");
         }
         my $cpw_per_core= $cpw / $cpu;
         $pool = "__XXX__|__XXX__".$trash1." ".$model." ".$cpu_all."|default|".$cpw_per_core."|".$ghz."|".$cpu;
       }
       else {
         if ( $rperf == 0 ) {
          err_html("This model $model:$trash1 does not have defined rPerf by IBM, use other one");
         }
         my $rperf_per_core= $rperf / $cpu;
         $pool = "__XXX__|__XXX__".$trash1." ".$model." ".$cpu_all."|default pool|".$rperf_per_core."|".$ghz."|".$cpu;
       }
    }
    else {
      $pool =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/seg;
      $pool =~ s/\+/ /g;
      $pool  =~ s/POOL=//; # only used for CPU workload estimator
      $pool  =~ s/pool=//; # only used for CPU workload estimator
      (my $hmc_pool , my $server_pool, my $trash2) = split (/\|/,$pool);
      $rperf_cpu_cores = get_rperf_all("","",$yaxis,$inputdir,$server_pool,$hmc_pool,\@rperf_user,\@rperf_all); 
      if ( $rperf_cpu_cores eq '' ) {
        err_html("$hmc_pool:$server_pool - get_rperf_all returned null");
      }
      ($rperf, $cpu_ghz_trash, $cores_trash) = split(/\|/,$rperf_cpu_cores);
      if ( $rperf eq '' || $cpu_ghz_trash eq '' || $cores_trash eq '') {
        err_html("$hmc_pool:$server_pool - rperf has not been found, check realt-error.log for more");
      }
      $pool = $pool."|".$rperf_cpu_cores;
    }
    #`echo "srv : $new_server yaxis=$yaxis" >> /tmp/e9`;
    #`echo "pool: $pool" >> /tmp/e9`;
  
    # Loop per each choosen lpar/CPU pool/Memory
    my $server_old = "";
    my $indx = 0;
    #print OUT "00 $lpar_list\n"  if $DEBUG == 2 ;
    foreach my $line1 (@lpar_row) {
      my $line = $line1; # --> keep original line without change
      chomp ($line);
      $line =~ s/LPAR=//;
      $line =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/seg;
      $line =~ s/Report=Generate\+Report//g;
      $line =~ s/\+/ /g;
      if (length($line) == 0) {
        next;
      }
      #print OUT "10 $line\n"  if $DEBUG == 2 ;
      (my $hmc, my $managedname, my $lpar) = split (/\|/,$line);
      $lpar =~ s/ $//;
      $lpar =~ s/\//\&\&1/g;
      print OUT "11 $hmc -- $managedname -- $lpar\n"  if $DEBUG == 2 ;
      #print STDERR "11 $hmc -- $managedname -- $lpar\n";

      # avoid finding rperf on already founded servers
      # tried also exclude there pool server, but it is not good idea ...

      if ( $managedname !~ m/^$server_old$/ ) {
        $rperf_cpu_cores = get_rperf_all("","",$yaxis,$inputdir,$managedname,$hmc,\@rperf_user,\@rperf_all); 
        #error("$0: $rperf_cpu_cores: $hmc -- $managedname -- $lpar\n" if $DEBUG == 2 ;
        if ( $rperf_cpu_cores eq '' ) {
          err_html("$hmc:$managedname - get_rperf_all returned null");
        }
        ($rperf, $cpu_ghz_trash, $cores_trash) = split(/\|/,$rperf_cpu_cores);
        if ( $rperf eq '' || $cpu_ghz_trash eq '' || $cores_trash eq '') {
          err_html("$hmc:$managedname - rperf has not been found, check realt-error.log for more");
        }
        $server_old = $managedname;
      }
      $lpar_row[$indx] = $line1."|".$rperf_cpu_cores;
      $indx++;
    }
  }


  if ($newsrv == 1 ) {
    if ( $yaxis =~ m/w/ || $yaxis =~ m/r/ ) {
      print "<tr><td><img src=\"/lpar2rrd-cgi/lpar-list-rep.sh?shour=$shour&smon=$smon&sday=$sday&syear=$syear&ehour=$ehour&emon=$emon&eday=$eday&eyear=$eyear&type=$type&height=$height&width=$width&yaxis=$yaxis&xport=0&sort=$sort_order&pool=$pool&@lpar_row&none=none\" ></td>";
    }
    else { # For CPU cores & new server
      $new_server =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/seg;
      ( my $model, my $machine_short, my $cpu, my $ghz, my $rperf, my $cpw) = split (/\|/,$new_server);
      $model =~ s/NEW=//;
      my $cpu_type = $cpu;
      $cpu_type =~ s/\/.*//;
      $cpu =~ s/^.*\///;
      $pool = "__XXX__|__XXX__".$model." ".$machine_short." ".$cpu_type."|default pool|".$rperf."|".$ghz."|".$cpu;
      #pool=__XXX__|__XXX__8203-E4A 520 P6|default pool|7.87|4.2|4
      print "<tr><td><img src=\"/lpar2rrd-cgi/lpar-list-rep.sh?shour=$shour&smon=$smon&sday=$sday&syear=$syear&ehour=$ehour&emon=$emon&eday=$eday&eyear=$eyear&type=$type&height=$height&width=$width&yaxis=$yaxis&xport=0&sort=$sort_order&pool=$pool&@lpar_row&none=none\"></td>\n";
    }
  }
  else {
      # not new server
      print "<tr><td><img src=\"/lpar2rrd-cgi/lpar-list-rep.sh?shour=$shour&smon=$smon&sday=$sday&syear=$syear&ehour=$ehour&emon=$emon&eday=$eday&eyear=$eyear&type=$type&height=$height&width=$width&yaxis=$yaxis&xport=0&sort=$sort_order&pool=$pool&@lpar_row&none=none\"></td>\n";
  }

  # only for CPU workload estimator where need just 1 aggregated graph, nothing more
  print "</td></tr></table><br></BODY></HTML>\n";
  close(OUT)  if $DEBUG == 2;
  exit (0);
}


if ( $count > 2 && $lparform == 1) {
  # show aggregated only if there is more than 1 lpar!!!
  print "<tr><td><center><h3>LPARs</h3><h4>Aggregated graph - all selected lpars in one</h4></center></td></tr>\n";

  print "<tr><td><img class=\"lazy\" data-src=\"/lpar2rrd-cgi/lpar-list-rep.sh?shour=$shour&smon=$smon&sday=$sday&syear=$syear&ehour=$ehour&emon=$emon&eday=$eday&eyear=$eyear&type=$type&height=$height&width=$width&yaxis=$yaxis&xport=0&sort=$sort_order&pool=$pool&@lpar_row&none=none\" src=\"$html_base/jquery/images/loading.gif\"></td>\n";
  if ( $xport == 1 ) {
    print "<td valign=\"top\"><font size=-1><A HREF=\"/lpar2rrd-cgi/lpar-list-rep.sh?shour=$shour&smon=$smon&sday=$sday&syear=$syear&ehour=$ehour&emon=$emon&eday=$eday&eyear=$eyear&type=$type&height=$height&width=$width&yaxis=$yaxis&xport=1&sort=$sort_order&pool=$pool&@lpar_row&none=none\">CSV</A></font></td></tr>\n";
  }
  else {
    print "</tr>\n";
  }
  print "<tr><td><A HREF=\"/lpar2rrd-cgi/lpar-list-rep.sh?shour=$shour&smon=$smon&sday=$sday&syear=$syear&ehour=$ehour&emon=$emon&eday=$eday&eyear=$eyear&type=$type&height=$height&width=$width&yaxis=$yaxis&xport=0&sort=$sort_order&pool=$pool&@lpar_row&none=none\" target=\"_blank\">Graph link</A></td></tr>\n";
}



#if ( $xport == 1 ) {
#  print "<tr><td>/lpar2rrd-cgi/lpar-list-rep.sh?shour=$shour&smon=$smon&sday=$sday&syear=$syear&ehour=$ehour&emon=$emon&eday=$eday&eyear=$eyear&type=$type&height=$height&width=$width&yaxis=$yaxis&xport=1&sort=$sort_order&pool=$pool&@lpar_row&none=none</td></tr>";
#}

print "<tr><td><center><h4>Individual graphs</h4></center></td></tr>\n";

# Loop per each choosen lpar/CPU pool/Memory
foreach my $line_tmp (@lpar_row) {
  my $line = $line_tmp;
  if ( $line =~ "LPAR=" ) {
    my $line_org =  $line;
    $line =~ s/LPAR=//;
    (my $hmc , my $managedname, my $lpar) = split (/%7C/,$line);
    #print OUT "$start $end $lpar $hmc $managedname $shour $smon $sday $syear $ehour $emon $eday $eyear\n";
    print "<tr><td><img class=\"lazy\" data-src=\"/lpar2rrd-cgi/lpar2rrd-rep.sh?hmc=$hmc&mname=$managedname&lpar=$lpar&shour=$shour&smon=$smon&sday=$sday&syear=$syear&ehour=$ehour&emon=$emon&eday=$eday&eyear=$eyear&type=$type&height=$height&width=$width&yaxis=$yaxis&xport=0&none=none\" src=\"$html_base/jquery/images/loading.gif\"></td>\n";
    if ( $xport == 1 ) {
      print "<td valign=\"top\"><font size=-1><A HREF=\"/lpar2rrd-cgi/lpar2rrd-rep.sh?hmc=$hmc&mname=$managedname&lpar=$lpar&shour=$shour&smon=$smon&sday=$sday&syear=$syear&ehour=$ehour&emon=$emon&eday=$eday&eyear=$eyear&type=$type&height=$height&width=$width&yaxis=$yaxis&xport=1&none=none\">CSV</A></font></td></tr>\n";
    }
    else {
      print "</tr>\n";
    }
  }
}

my $pool_once = 0;

foreach my $lpar (@pool_row) {
  if ( $lpar =~ "POOL=" ) {
    if ( $pool_once == 0 ) {
      print "<tr><td><center><h3>Servers and CPU pools</h3></center></td></tr>\n";
      $pool_once = 1;
    }
    $lpar =~ s/POOL=//;
    (my $hmc , my $managedname, $lpar) = split (/%7C/,$lpar);
    #print OUT "$start $end $lpar $hmc $managedname $shour $smon $sday $syear $ehour $emon $eday $eyear\n";
    print "<tr><td><img class=\"lazy\" data-src=\"/lpar2rrd-cgi/lpar2rrd-rep.sh?hmc=$hmc&mname=$managedname&lpar=$lpar&shour=$shour&smon=$smon&sday=$sday&syear=$syear&ehour=$ehour&emon=$emon&eday=$eday&eyear=$eyear&type=$type&height=$height&width=$width&yaxis=$yaxis&xport=0&none=none\" src=\"$html_base/jquery/images/loading.gif\"></td>\n";
    if ( $xport == 1 ) {
      print "<td valign=\"top\"><font size=-1><A HREF=\"/lpar2rrd-cgi/lpar2rrd-rep.sh?hmc=$hmc&mname=$managedname&lpar=$lpar&shour=$shour&smon=$smon&sday=$sday&syear=$syear&ehour=$ehour&emon=$emon&eday=$eday&eyear=$eyear&type=$type&height=$height&width=$width&yaxis=$yaxis&xport=1&none=none\">CSV</A></font></td></tr>\n";
    }
    else {
      print "</tr>\n";
    }
  }
}
print "</table>\n";

if ( $agent > 0 ) {
  print "</div>\n";
}
else {
  # Exit, no agent in place
  print "</BODY></HTML>";
  exit (0);
}

#
# OS CPU
#

if ( $agent_oscpu > 0 ) {
  print "<div id=\"tabs-1\">\n";
  my $item="oscpu";
  agent($item,$type,$entitle,$detail_yes,$start_unix,$end_unix,$html_base,\@lpar_row );
  print "</div>\n";
}

#
# OS mem
#

if ( $agent_mem > 0 ) {
  print "<div id=\"tabs-2\">\n";
  my $item="mem";
  agent($item,$type,$entitle,$detail_yes,$start_unix,$end_unix,$html_base,\@lpar_row );
  print "</div>\n";
}

#
# OS paging
#

if ( $agent_pgs > 0 ) {
  print "<div id=\"tabs-3\">\n";
  my $item="pg1";
  agent($item,$type,$entitle,$detail_yes,$start_unix,$end_unix,$html_base,\@lpar_row);
  print "</div>\n";
  print "<div id=\"tabs-4\">\n";
  my $item="pg2";
  agent($item,$type,$entitle,$detail_yes,$start_unix,$end_unix,$html_base,\@lpar_row);
  print "</div>\n";
}

#
# OS Ethernet
#

if ( $agent_lan > 0 ) {
  print "<div id=\"tabs-5\">\n";
  my $item="lan";
  agent($item,$type,$entitle,$detail_yes,$start_unix,$end_unix,$html_base,\@lpar_row );
  print "</div>\n";
}
#
# OS FC
#

if ( $agent_san > 0 ) {
  print "<div id=\"tabs-6\">\n";
  my $item="san1";
  agent($item,$type,$entitle,$detail_yes,$start_unix,$end_unix,$html_base,\@lpar_row );
  print "</div>\n";
  print "<div id=\"tabs-7\">\n";
  my $item="san2";
  agent($item,$type,$entitle,$detail_yes,$start_unix,$end_unix,$html_base,\@lpar_row );
  print "</div>\n";
}

#
# OS SEA
#

if ( $agent_sea > 0 ) {
  print "<div id=\"tabs-8\">\n";
  my $item="sea";
  agent($item,$type,$entitle,$detail_yes,$start_unix,$end_unix,$html_base,\@lpar_row );
  print "</div>\n";
}



#
# OS AME
#

if ( $agent_ame > 0 ) {
  print "<div id=\"tabs-9\">\n";
  my $item="ame";
  agent($item,$type,$entitle,$detail_yes,$start_unix,$end_unix,$html_base,\@lpar_row );
  print "</div>\n";
}


print "</div><br></BODY></HTML>";
close(OUT)  if $DEBUG == 2;

exit (0);


sub not_implemented {
  print "<br><br><center><strong>rPerf scaling is not implemented yet</strong>\n";
  print "</body></html>";

  return 0;
}

sub err_html {
  my $text = shift;

  print "<strong> ERROR: $text</strong>\n";
  print "</body></html>";
  exit (1);
}
 
sub not_available {
  print "<br><br><strong>CPU Workload Estimator based on <a href=\"http://www-03.ibm.com/systems/power/hardware/notices/rperf.html\" target=\"_blank\">rPerf</a> or <a href=\"http://www-03.ibm.com/systems/power/hardware/notices/cpw.html\" target=\"_blank\">CPW</a> benchmarks is not supported in free LPAR2RRD distribution.\n";
  print "<br>You might either buy <a href=\"http://www.lpar2rrd.com/support.htm\" target=\"_blank\">support</a> or use estimations based on CPU cores (go back and choice \"CPU core\" for \"Y-axis\").\n";
  print "<br><br>Note that comparing of CPU load based on CPU cores for different IBM Power server models is only informative.<br>\n";
  print "</strong></body></html>";

  return 0;

}

# error handling
sub error
{
  my $text = shift;
  my $act_time = localtime();
  chomp ($text);

  #print "ERROR          : $text : $!\n";
  print STDERR "$act_time: $text : $!\n";

  return 1;
}

sub isdigit
{
  my $digit = shift;
  my $text = shift;

  my $digit_work = $digit;
  $digit_work =~ s/[0-9]//g;
  $digit_work =~ s/\.//;

  if (length($digit_work) == 0) {
    # is a number
    return 1;
  }

  #if (($digit * 1) eq $digit){
  #  # is a number
  #  return 1;
  #}

  # NOT a number
  return 0;
}

sub print_head
{
  my $agent = shift;
  my $referer = shift;

  my $html_base = html_base($referer); 

# print HTML header
print "<HTML><HEAD>
<META HTTP-EQUIV=\"pragma\" CONTENT=\"no-cache\">
<META HTTP-EQUIV=\"Expires\" CONTENT=\"NOW\">
<META HTTP-EQUIV=\"last modified\" CONTENT=\"NOW\">
<STYLE TYPE=\"text/css\">
<!--
.header, .header TD, .header TH
{
background-color:#D3D2F3;
}
-->
</STYLE>
<style>
<!--
a {text-decoration: none}
-->
</style>
<SCRIPT TYPE=\"text/javascript\">
<!--
function popup(mylink, windowname)
{
if (! window.focus)return true;
var href;
if (typeof(mylink) == 'string')
   href=mylink;
else
   href=mylink.href;
window.open(href, windowname, 'width=1329,height=670,scrollbars=yes');
return false;
}
//-->
</SCRIPT>
<link rel=\"stylesheet\" href=\"$html_base/jquery/jquery-ui-1.10.3.custom.min.css\">
<link rel=\"stylesheet\" href=\"$html_base/jquery/magnific-popup.css\">

<script src=\"$html_base/jquery/jquery-1.9.1.js\"></script>
<script src=\"$html_base/jquery/jquery-ui-1.10.3.custom.min.js\"></script>
<script src=\"$html_base/jquery/jquery.lazy.min.js\"></script>
<script src='$html_base/jquery/magnific-popup.min.js'></script>
<script>
\$( document ).ready(function() {
        \$( \"#tabs\" ).tabs({
                activate: function() {
                        \$(\"img.lazy\").lazy({
                                bind: \"event\",
                                effect: \"fadeIn\",
                                effectTime: 1000
                                });
                }
        });
        \$( \"img.lazy\" ).lazy({
                        effect: \"fadeIn\",
                        effectTime: 1000
                        }
        );

        \$( 'a.detail' ).magnificPopup({
                type: 'image',
                closeOnContentClick: true,
                closeBtnInside: false,
                fixedContentPos: true,
                mainClass: 'mfp-no-margins mfp-with-zoom', // class to remove default margin from left and right side
                image: {
                        verticalFit: true
                },
                zoom: {
                        enabled: true,
                        duration: 300 // don't foget to change the duration also in CSS
                }
        });
});


</script>

</HEAD>
<BODY BGCOLOR=\"#D3D2D2\" TEXT=\"#000000\" LINK=\"#0000FF\" VLINK=\"#0000FF\" ALINK=\"#FF0000\">\n";

return $html_base;
}

sub html_base
{
    # Print link to full lpar cfg (must find out at first html_base
    # find out HTML_BASE
    # renove from the path last 3 things
    # http://nim.praha.cz.ibm.com/lpar2rrd/hmc1/PWR6B-9117-MMA-SN103B5C0%20ttt/pool/top.html
    # --> http://nim.praha.cz.ibm.com/lpar2rrd
    # my $refer = $ENV{HTTP_REFERER}; --> no, no, here is cgi-bin referer already
    my $referer = shift;
    my $html_base = "";
    my $base = 0;

    if ( $referer !~ m/^na$/ ) { # when is http refer pasing then it is enough ... via lpar search
      my @full_path = split(/\//, $referer);
      my $k = 0;
      foreach my $path (@full_path){
        $k++
      }
      $k--;
      $k--;
      $k--;
      my $j = 0;
      foreach my $path (@full_path){
        if ($j < $k) {
          if ( $j == 0 ) {
            $html_base .= $path;
          }
          else {
            $html_base .= "/".$path;
          }
          $j++;
        }
      }
    }
    else {
     $html_base = $referer;
    }
    return $html_base;
}


sub agent {
  my ($item,$type,$entitle,$detail_yes,$start_unix,$end_unix,$html_base,$lpar_list_tmp) = @_;
  my @lpar_list = @{$lpar_list_tmp};
  my $type_sam = "x"; # whatever, it is not significant for OS agent graphs

  print "<table align=\"center\" summary=\"$item\">\n";

  foreach my $line_tmp (@lpar_list) {
    my $line = $line_tmp;
    if ( $line =~ "LPAR=" ) {
      $line =~ s/LPAR=//;
      $line =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/seg;
      $line =~ s/\+/ /g;
      (my $host , my $server, my $lpar) = split (/\|/,$line);
      my $host_url = $host;
      my $server_url = $server;
      my $lpar_slash = $lpar;
      $lpar_slash =~ s/\//\&\&1/g; # replace for "/"
      my $lpar_url = $lpar;
      # DO NOT DO IT HERE!! IT DOES NOT WORK THEN (both 2 lines)
      #$lpar_url =~ s/\//\&\&1/g; # replace for "/"
      #$lpar_url =~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;
      #print STDERR "005 $lpar: $wrkdir/$server/$host/$lpar_slash.mmm\n";
      #print STDERR "004 $host $server $lpar : $line : $wrkdir/$server/$host/$lpar_slash.mmm\n";
      if ( -d "$wrkdir/$server/$host/$lpar_slash" ) {
        if ( $item =~ m/^oscpu$/ && test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","cpu" )) {
          print_item ($host_url,$server_url,$lpar_url,$item,$type,$type_sam,$entitle,$detail_yes,$start_unix,$end_unix,$html_base);
          next;
        }
        if ( $item =~ m/^mem$/ && test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","mem" )) {
          print_item ($host_url,$server_url,$lpar_url,$item,$type,$type_sam,$entitle,$detail_yes,$start_unix,$end_unix,$html_base);
          next;
        }
        if ( $item =~ m/^pg/ &&  test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","pgs" )) {
          print_item ($host_url,$server_url,$lpar_url,$item,$type,$type_sam,$entitle,$detail_yes,$start_unix,$end_unix,$html_base);
          next;
        }
        if ( $item =~ m/^lan$/ &&  test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","lan" )) {
          print_item ($host_url,$server_url,$lpar_url,$item,$type,$type_sam,$entitle,$detail_yes,$start_unix,$end_unix,$html_base);
          next;
        }
        if ( $item =~ m/^san/ &&  test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","san" )) {
          print_item ($host_url,$server_url,$lpar_url,$item,$type,$type_sam,$entitle,$detail_yes,$start_unix,$end_unix,$html_base);
          next;
        }
        if ( $item =~ m/^sea$/ &&  test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","sea" )) {
          print_item ($host_url,$server_url,$lpar_url,$item,$type,$type_sam,$entitle,$detail_yes,$start_unix,$end_unix,$html_base);
          next;
        }
        if ( $item =~ m/^ame$/ &&  test_file_in_directory( "$wrkdir/$server/$host/$lpar_slash","ame" )) {
          print_item ($host_url,$server_url,$lpar_url,$item,$type,$type_sam,$entitle,$detail_yes,$start_unix,$end_unix,$html_base);
          next;
        }
      }
    }
  }

  print "</table>\n";
  return 1;
}

sub type_sam
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;

  my $lpar_slash = $lpar;
  $lpar_slash =~ s/\//\&\&1/g; # replace for "/"
  if ( $type =~ m/d/ ) {
    if ( -f "$wrkdir/$server/$host/$lpar_slash.rrd" ) {
      return "d";
    }
    return "m";
  }

  if ( -f "$wrkdir/$server/$host/$lpar_slash.rrm" ) {
    return "m";
  }

  if ( -f "$wrkdir/$server/$host/$lpar_slash.rrh" ) {
    return "h";
  }

  return "m";
}


# print a link with detail
sub print_item
{
  my ($host_url,$server_url,$lpar_url,$item,$time_graph,$type_sam,$entitle,$detail,$start_unix,$end_unix,$html_base) = @_;
  my $upper = 0; # same limit for all 4 graphs, not used in hist graphs

  $lpar_url =~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;
  $host_url =~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;
  $server_url =~s/([^A-Za-z0-9\+-_])/sprintf("%%%02X",ord($1))/seg;

  #print STDERR "88 $lpar_url\n";
  if ( $detail > 0 ) {
    print "<tr><td valign=\"top\"><a href=\"/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar_url&item=$item&time=$time_graph&type_sam=$type_sam&detail=1&upper=$upper&entitle=$entitle&sunix=$start_unix&eunix=$end_unix&height=$height&width=$width&none=none\" onClick=\"return popup(this, \'detail\')\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data-src=\"/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar_url&item=$item&time=$time_graph&type_sam=$type_sam&detail=0&upper=$upper&entitle=$entitle&sunix=$start_unix&eunix=$end_unix&height=$height&width=$width&none=none\" src=\"$html_base/jquery/images/loading.gif\"></font></a></td></tr>\n";
  }
  else {
    print "<tr><td align=\"center\" valign=\"top\" colspan=\"2\"><font color=\"#C8C8C8\"><img class=\"lazy\" border=\"0\" data0src=\"/lpar2rrd-cgi/detail-graph.sh?host=$host_url&server=$server_url&lpar=$lpar_url&item=$item&time=$time_graph&type_sam=$type_sam&detail=0&upper=$upper&entitle=$entitle&sunix=$start_unix&eunix=$end_unix&height=$height&width=$width&none=none\" src=\"$html_base/jquery/images/loading.gif\"></td></tr>\n";
  }
  return 1;
}

sub test_file_in_directory
{
# Use a regular expression to find files
#    beginning by $fpn
#    ending by .mmm
#    returns 0 (zero) or first filename found i.e. non zero

 my $dir=shift;
 my $fpn=shift;

 my $found = 0;
 if ( !-d $dir ) { return $found;}
 opendir (DIR, $dir) || error("Error in opening dir $dir $! :".__FILE__.":".__LINE__) && return 0;

 while (my $file = readdir(DIR)) {
     if ($file =~ m/^$fpn.*\.mmm$/) {
        #if ($file =~ m/\.mmm$/) {
           $found = "$dir/$file";
           last;
        #}
     }
 }
 closedir (DIR);
 return $found;
}

