#!/usr/bin/perl


  #use strict;
  # no strict as definition of @inp does not work with it, o idea why ....

  #use lib qw (/opt/freeware/lib/perl/5.8.0);
  # no longer need to use "use lib qw" as the library PATH is already in PERL5LIB (lpar2rrd.cfg)

  use Env qw(QUERY_STRING);
  use Date::Parse;
  use POSIX qw(strftime);
  use RRDp;


  #$QUERY_STRING .= ":.";

  my $inputdir = $ENV{INPUTDIR};
  my $tmpdir = "$inputdir/tmp";
  if (defined $ENV{TMPDIR}) {
    $tmpdir = $ENV{TMPDIR};
  }
  my $webdir = $ENV{WEBDIR};
  my $rrdtool = $ENV{RRDTOOL};
  my $pic_col = $ENV{PICTURE_COLOR};
  my $wrkdir = "$inputdir/data";
  my $STEP = $ENV{SAMPLE_RATE};
  my $DEBUG = $ENV{DEBUG};
  my $errlog = $ENV{ERRLOG};

  my $bindir = $ENV{BINDIR};
  if ( -f "$bindir/premium.pl" ) {
    require "$bindir/premium.pl";
  }
  else {
    require "$bindir/standard.pl";
  }

  open(OUT, ">> $errlog") if $DEBUG == 2 ;

  (my $shour, my $smon, my $sday, my $syear, my $ehour, my $emon, my $eday, my $eyear, my $type, my $rrdheight, my $rrdwidth, my $yaxis, my $xport, my $sort_order, my $pool, my $lpar_list, my $none) = split(/&/,$QUERY_STRING);

  $shour =~ s/shour=//;
  $smon =~ s/smon=//;
  $sday =~ s/sday=//;
  $syear =~ s/syear=//;
  $ehour =~ s/ehour=//;
  $emon =~ s/emon=//;
  $eday =~ s/eday=//;
  $eyear =~ s/eyear=//;
  $type =~ s/type=//;
  $rrdheight =~ s/height=//;
  $rrdwidth  =~ s/width=//;
  $xport  =~ s/xport=//;
  $sort_order =~ s/sort=//;
  $pool  =~ s/POOL=//; # only used for CPU workload estimator
  $pool  =~ s/pool=//; # only used for CPU workload estimator
  $yaxis =~ s/yaxis=//;


  # XPORT is export to XML and then to CVS
  if ($xport) {
    # It should be here to do not influence normal report when XML is not in Perl
    require "$bindir/xml.pl";
    # use XML::Simple; --> it has to be in separete file
    print "Content-type: application/octet-stream\n";
    # for normal content type is printed just before picture print to be able print
    # text/html error if appears
  }
  else {
    print "Content-type: image/png\n\n";
  }

  if ( ! $pool eq '' ) {
   $xport=0; # do not need it when CPU workload estimator
   chomp ($pool);
   $pool =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/seg;
   $pool =~ s/\+/ /g;
  }

  #print STDERR "$0 -- $QUERY_STRING\n";

# Loop per each choosen lpar/CPU pool/Memory
  my @rperf_legend = "";
  my $rperf_legend_count = 0;
  my @managedname_all = "";
  my @hmc_all = "";
  my @lpar_all = "";
  my @rperf_all = "";
  my @cpu_ghz_all = "";
  my @cores_all = "";
  my $indx = 0;
  chomp ($lpar_list);
  $lpar_list =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/seg;
  $lpar_list =~ s/Report=Generate\+Report//g;
  $lpar_list =~ s/\+/ /g;
  #print OUT "00 $lpar_list\n"  if $DEBUG == 2 ;
  (my @lpar_row) = split (/LPAR=/,$lpar_list);
  foreach my $line (@lpar_row) {
    chomp ($line);
    if (length($line) == 0) {
      next;
    }
    #print OUT "10 $line\n"  if $DEBUG == 2 ;
    #( my $hmc_pool , my $managedname_pool, $lpar_pool, $rperf, $cpu_ghz, $cores) = split (/\|/,$pool);

    # parse each lpar line to get details passed here
    ($hmc_all[$indx] , $managedname_all[$indx], $lpar_all[$indx], $rperf_all[$indx], $cpu_ghz_all[$indx], $cores_all[$indx]) = split (/\|/,$line);
    $lpar_all[$indx] =~ s/ $//;
    $lpar_all[$indx] =~ s/\//\&\&1/g;
    #print STDERR "11 $hmc_all[$indx] -- $managedname_all[$indx] -- $lpar_all[$indx] -- $rperf_all[$indx] -- $cpu_ghz_all[$indx] -- $cores_all[$indx]\n";
    print OUT "11 $hmc_all[$indx] -- $managedname_all[$indx] -- $lpar_all[$indx]\n"  if $DEBUG == 2 ;
    $indx++;
  }
  $indx++;

  my $start_unix = str2time($syear."-".$smon."-".$sday." ".$shour.":00:00");
  my $end_unix = str2time($eyear."-".$emon."-".$eday." ".$ehour.":00:00");
  my $human_start=$shour.":00:00 ".$sday.".".$smon.".".$syear;
  my $human_end=$ehour.":00:00 ".$eday.".".$emon.".".$eyear;
  my $start="";
  if ( $shour == 24 ) {
    # workaround for rrdtool when it parses date with 24 on the start badly
    # RRDTool: ERROR: end time: did you really mean month 24?
    $start="23:59 ".$sday.".".$smon.".".$syear;
  }
  else {
    $start=$shour.":00 ".$sday.".".$smon.".".$syear;
  }
  my $end="";
  if ( $ehour == 24 ) {
    # workaround for rrdtool when it parses date with 24 on the start badly
    # RRDTool: ERROR: end time: did you really mean month 24?
    $end="23:59 ".$eday.".".$emon.".".$eyear;
  }
  else {
    $end=$ehour.":00 ".$eday.".".$emon.".".$eyear;
  }

  print OUT "22 $lpar $hmc $managedname $human_start $human_end | $start $end | $type : $start_unix - $end_unix xport=$xport\n" if $DEBUG == 2 ;

  # it must go into a temp file as direct stdout from RRDTOOL somehow does not work for me
  my $name = "/var/tmp/lpar2rrd-$$.png";
  #$name = "-";
  my $act_time = localtime();

  if ( ! -d "$webdir" ) {
     die "$act_time: Pls set correct path to Web server pages, it does not exist here: $webdir\n";
  }

  # start RRD via a pipe
  if ( ! -f "$rrdtool" ) {
     die "$act_time: Set correct path to rrdtool binarry, it does not exist here: $rrdtool\n";
  }
  RRDp::start "$rrdtool";

  multiview($name,$indx,$type,time(),$start,$end,$start_unix,$end_unix,$sort_order,$pool);

 
  # close RRD pipe
  RRDp::end;


  # exclude Export here
  if (!$xport) {
    print_png(); 
  }

  exit (0);

# Print the png out
sub print_png {

   open(PNG, "< $name") || die   "Cannot open  $name: $!";
   binmode(PNG);
   while (read(PNG,$b,4096)) {
      print "$b";
   }
   unlink ("$name");
}

sub xport_print
{
  my $xml_org = shift;
  my $multi = shift;
  my $xml = "";

  if ($multi == 1) {
    #print OUT "--xport-- $xml_org\n";
    $xml = XMLin( $xml_org );
  }
  else {
    #print OUT "--xport++ $$xml_org\n";
    $xml = XMLin( $$xml_org );
  }

  print join(";", 'Timestamp DD.MM.YYYY HH:MM', @{ $xml->{meta}{legend}{entry} } ), 
"\n";
  foreach my $row ( @{ $xml->{data}{row} } ) {
    my $time = strftime "%d.%m.%y %H:%M:%S", localtime($row->{t});
    my $line = join(";", $time, @{$row->{v}});
    $line =~ s/NaNQ/0/g;
    $line =~ s/NaN/0/g;
    $line =~ s/nan/0/g;
    print "$line\n";
  }
  return 0;
}

sub multiview
{
  my $name = shift;
  my $indx = shift;
  my $type = shift;
  my $act_time = shift ;
  my $start = shift;
  my $end   = shift;
  my $start_unix = shift;
  my $end_unix   = shift;
  my $sort_order = shift;
  my $pool = shift;
  my $sh_pool_name = "";

  # 10 basic colours, when is there mor than 10 need then switch to big global table @color_big
   my @color="";
  if ( $pool eq '' ) {
    @color=("#FF0000","#0000FF","#00FF00","#FFFF00","#FF3399","#00FFFF","#999933","#0099CC","#3300CC");
  }
  else {
    # 1st color == red i excuded and used manually for pool purposes
    @color=("#0000FF","#00FF00","#FFFF00","#FF3399","#00FFFF","#999933","#0099CC","#3300CC","#AAAAAA");
  }


  # 48 colors like for HMC bellow + 216 basic HTML colors x 6 == 1296 + 48
  my @color_big=("#FF0000","#0000FF","#00FF00","#FFFF00","#FF3399","#00FFFF","#999933","#0099CC","#3300CC",
"#FF8080", "#FFFF80", "#80FF80", "#00FF80", "#80FFFF", "#0080FF", "#FF80C0", "#FF80FF", "#FF0000", "#FFFF00", "#80FF00",
"#00FF40", "#00FFFF", "#0080C0", "#8080C0", "#FF00FF", "#804040", "#FF8040", "#00FF00", "#008080", "#004080", "#8080FF",
"#800040", "#FF0080", "#800000", "#FF8000", "#008000", "#008040", "#0000FF", "#0000A0", "#800080", "#8000FF", "#400000",
"#804000", "#004000", "#004040", "#000080", "#000040", "#400040", "#400080", 
"#408080", "#C0C0C0", "#400040", "#AAAAAA","#800040", "#FF0080", "#800000", "#FF8000", "#008000", "#008040", "#0000FF", "#0000A0", "#800080", "#8000FF", "#400000",
"#CC0000","#FF0000", "#CC00CC","#FF00CC","#0000CC","#0000FF","#00CCCC","#00FFFF","#00CC00","#00FF00",
"#CCCC00","#000000","#FFFF00","#333300","#FFFFFF","#330000","#999990","#336600","#FFCC00","#339900",
"#FF9900","#33CC00","#FF6600","#33FF00","#FF3300","#66FF00","#660000","#663300","#66CC00","#669900",
"#666600","#330033","#FFFF33","#333333","#FF0033","#336633","#FFCC33","#339933","#FF9933","#33CC33",
"#FF6633","#33FF33","#FF3333","#66FF33","#660033","#663333","#66CC33","#669933","#666633","#330066",
"#FFFF66","#333366","#FF0066","#336666","#FFCC66","#339966","#FF9966","#33CC66","#FF6666","#33FF66",
"#FF3366","#66FF66","#660066","#663366","#66CC66","#669966","#666666","#330099","#FFFF99","#333399",
"#FF0099","#336699","#FFCC99","#339999","#FF9999","#33CC99","#FF6699","#33FF99","#FF3399","#66FF99",
"#660099","#663399","#66CC99","#669999","#666699","#3300CC","#FFFFCC","#3333CC","#3366CC","#FFCCCC",
"#3399CC","#FF99CC","#33CCCC","#FF66CC","#33FFCC","#FF33CC","#66FFCC","#6600CC","#6633CC","#66CCCC",
"#6699CC","#6666CC","#3300FF","#FFFFFF","#3333FF","#FF00FF","#3366FF","#FFCCFF","#3399FF","#FF99FF",
"#33CCFF","#FF66FF","#33FFFF","#FF33FF","#66FFFF","#6600FF","#6633FF","#66CCFF","#6699FF","#6666FF",
"#CCFFFF","#0033FF","#CC00FF","#0066FF","#CCCCFF","#0099FF","#CC99FF","#00CCFF","#CC66FF","#CC33FF",
"#99FFFF","#9900FF","#9933FF","#99CCFF","#9999FF","#9966FF","#CCFFCC","#0033CC","#0066CC","#CCCCCC",
"#0099CC","#CC99CC","#CC66CC","#00FFCC","#CC33CC","#99FFCC","#9900CC","#9933CC","#99CCCC","#9999CC",
"#9966CC","#000099","#CCFF99","#003399","#CC0099","#006699","#CCCC99","#009999","#CC9999","#00CC99",
"#CC6699","#00FF99","#CC3399","#99FF99","#990099","#993399","#99CC99","#999999","#996699","#000066",
"#CCFF66","#003366","#CC0066","#006666","#CCCC66","#009966","#CC9966","#00CC66","#CC6666","#00FF66",
"#CC3366","#99FF66","#990066","#993366","#99CC66","#999966","#996666","#000033","#CCFF33","#003333",
"#CC0033","#006633","#CCCC33","#009933","#CC9933","#00CC33","#CC6633","#00FF33","#CC3333","#99FF33",
"#990033","#993333","#99CC33","#999933","#996633","#CCFF00","#003300","#006600","#009900","#CC9900",
"#CC6600","#CC3300","#99FF00","#990000","#993300","#99CC00","#999900","#996600",
"#CC0000","#FF0000","#CC00CC","#FF00CC","#0000CC","#0000FF","#00CCCC","#00FFFF","#00CC00","#00FF00",
"#CCCC00","#FFFF00","#000000","#999999","#FFFFFF","#330000","#333300","#336600","#FFCC00","#339900",
"#FF9900","#33CC00","#FF6600","#33FF00","#FF3300","#66FF00","#660000","#663300","#66CC00","#669900",
"#666600","#330033","#FFFF33","#333333","#FF0033","#336633","#FFCC33","#339933","#FF9933","#33CC33",
"#FF6633","#33FF33","#FF3333","#66FF33","#660033","#663333","#66CC33","#669933","#666633","#330066",
"#FFFF66","#333366","#FF0066","#336666","#FFCC66","#339966","#FF9966","#33CC66","#FF6666","#33FF66",
"#FF3366","#66FF66","#660066","#663366","#66CC66","#669966","#666666","#330099","#FFFF99","#333399",
"#FF0099","#336699","#FFCC99","#339999","#FF9999","#33CC99","#FF6699","#33FF99","#FF3399","#66FF99",
"#660099","#663399","#66CC99","#669999","#666699","#3300CC","#FFFFCC","#3333CC","#3366CC","#FFCCCC",
"#3399CC","#FF99CC","#33CCCC","#FF66CC","#33FFCC","#FF33CC","#66FFCC","#6600CC","#6633CC","#66CCCC",
"#6699CC","#6666CC","#3300FF","#FFFFFF","#3333FF","#FF00FF","#3366FF","#FFCCFF","#3399FF","#FF99FF",
"#33CCFF","#FF66FF","#33FFFF","#FF33FF","#66FFFF","#6600FF","#6633FF","#66CCFF","#6699FF","#6666FF",
"#CCFFFF","#0033FF","#CC00FF","#0066FF","#CCCCFF","#0099FF","#CC99FF","#00CCFF","#CC66FF","#CC33FF",
"#99FFFF","#9900FF","#9933FF","#99CCFF","#9999FF","#9966FF","#CCFFCC","#0033CC","#0066CC","#CCCCCC",
"#0099CC","#CC99CC","#CC66CC","#00FFCC","#CC33CC","#99FFCC","#9900CC","#9933CC","#99CCCC","#9999CC",
"#9966CC","#000099","#CCFF99","#003399","#CC0099","#006699","#CCCC99","#009999","#CC9999","#00CC99",
"#CC6699","#00FF99","#CC3399","#99FF99","#990099","#993399","#99CC99","#999999","#996699","#000066",
"#CCFF66","#003366","#CC0066","#006666","#CCCC66","#009966","#CC9966","#00CC66","#CC6666","#00FF66",
"#CC3366","#99FF66","#990066","#993366","#99CC66","#999966","#996666","#000033","#CCFF33","#003333",
"#CC0033","#006633","#CCCC33","#009933","#CC9933","#00CC33","#CC6633","#00FF33","#CC3333","#99FF33",
"#990033","#993333","#99CC33","#999933","#996633","#CCFF00","#003300","#006600","#009900","#CC9900",
"#CC6600","#CC3300","#99FF00","#990000","#993300","#99CC00","#999900","#996600",
"#CC0000","#FF0000","#CC00CC","#FF00CC","#0000CC","#0000FF","#00CCCC","#00FFFF","#00CC00","#00FF00",
"#CCCC00","#FFFF00","#000000","#999999","#FFFFFF","#330000","#333300","#336600","#FFCC00","#339900",
"#FF9900","#33CC00","#FF6600","#33FF00","#FF3300","#66FF00","#660000","#663300","#66CC00","#669900",
"#666600","#330033","#FFFF33","#333333","#FF0033","#336633","#FFCC33","#339933","#FF9933","#33CC33",
"#FF6633","#33FF33","#FF3333","#66FF33","#660033","#663333","#66CC33","#669933","#666633","#330066",
"#FFFF66","#333366","#FF0066","#336666","#FFCC66","#339966","#FF9966","#33CC66","#FF6666","#33FF66",
"#FF3366","#66FF66","#660066","#663366","#66CC66","#669966","#666666","#330099","#FFFF99","#333399",
"#FF0099","#336699","#FFCC99","#339999","#FF9999","#33CC99","#FF6699","#33FF99","#FF3399","#66FF99",
"#660099","#663399","#66CC99","#669999","#666699","#3300CC","#FFFFCC","#3333CC","#3366CC","#FFCCCC",
"#3399CC","#FF99CC","#33CCCC","#FF66CC","#33FFCC","#FF33CC","#66FFCC","#6600CC","#6633CC","#66CCCC",
"#6699CC","#6666CC","#3300FF","#FFFFFF","#3333FF","#FF00FF","#3366FF","#FFCCFF","#3399FF","#FF99FF",
"#33CCFF","#FF66FF","#33FFFF","#FF33FF","#66FFFF","#6600FF","#6633FF","#66CCFF","#6699FF","#6666FF",
"#CCFFFF","#0033FF","#CC00FF","#0066FF","#CCCCFF","#0099FF","#CC99FF","#00CCFF","#CC66FF","#CC33FF",
"#99FFFF","#9900FF","#9933FF","#99CCFF","#9999FF","#9966FF","#CCFFCC","#0033CC","#0066CC","#CCCCCC",
"#0099CC","#CC99CC","#CC66CC","#00FFCC","#CC33CC","#99FFCC","#9900CC","#9933CC","#99CCCC","#9999CC",
"#9966CC","#000099","#CCFF99","#003399","#CC0099","#006699","#CCCC99","#009999","#CC9999","#00CC99",
"#CC6699","#00FF99","#CC3399","#99FF99","#990099","#993399","#99CC99","#999999","#996699","#000066",
"#CCFF66","#003366","#CC0066","#006666","#CCCC66","#009966","#CC9966","#00CC66","#CC6666","#00FF66",
"#CC3366","#99FF66","#990066","#993366","#99CC66","#999966","#996666","#000033","#CCFF33","#003333",
"#CC0033","#006633","#CCCC33","#009933","#CC9933","#00CC33","#CC6633","#00FF33","#CC3333","#99FF33",
"#990033","#993333","#99CC33","#999933","#996633","#CCFF00","#003300","#006600","#009900","#CC9900",
"#CC6600","#CC3300","#99FF00","#990000","#993300","#99CC00","#999900","#996600",
"#CC0000","#FF0000","#CC00CC","#FF00CC","#0000CC","#0000FF","#00CCCC","#00FFFF","#00CC00","#00FF00",
"#CCCC00","#FFFF00","#000000","#999999","#FFFFFF","#330000","#333300","#336600","#FFCC00","#339900",
"#FF9900","#33CC00","#FF6600","#33FF00","#FF3300","#66FF00","#660000","#663300","#66CC00","#669900",
"#666600","#330033","#FFFF33","#333333","#FF0033","#336633","#FFCC33","#339933","#FF9933","#33CC33",
"#FF6633","#33FF33","#FF3333","#66FF33","#660033","#663333","#66CC33","#669933","#666633","#330066",
"#FFFF66","#333366","#FF0066","#336666","#FFCC66","#339966","#FF9966","#33CC66","#FF6666","#33FF66",
"#FF3366","#66FF66","#660066","#663366","#66CC66","#669966","#666666","#330099","#FFFF99","#333399",
"#FF0099","#336699","#FFCC99","#339999","#FF9999","#33CC99","#FF6699","#33FF99","#FF3399","#66FF99",
"#660099","#663399","#66CC99","#669999","#666699","#3300CC","#FFFFCC","#3333CC","#3366CC","#FFCCCC",
"#3399CC","#FF99CC","#33CCCC","#FF66CC","#33FFCC","#FF33CC","#66FFCC","#6600CC","#6633CC","#66CCCC",
"#6699CC","#6666CC","#3300FF","#FFFFFF","#3333FF","#FF00FF","#3366FF","#FFCCFF","#3399FF","#FF99FF",
"#33CCFF","#FF66FF","#33FFFF","#FF33FF","#66FFFF","#6600FF","#6633FF","#66CCFF","#6699FF","#6666FF",
"#CCFFFF","#0033FF","#CC00FF","#0066FF","#CCCCFF","#0099FF","#CC99FF","#00CCFF","#CC66FF","#CC33FF",
"#99FFFF","#9900FF","#9933FF","#99CCFF","#9999FF","#9966FF","#CCFFCC","#0033CC","#0066CC","#CCCCCC",
"#0099CC","#CC99CC","#CC66CC","#00FFCC","#CC33CC","#99FFCC","#9900CC","#9933CC","#99CCCC","#9999CC",
"#9966CC","#000099","#CCFF99","#003399","#CC0099","#006699","#CCCC99","#009999","#CC9999","#00CC99",
"#CC6699","#00FF99","#CC3399","#99FF99","#990099","#993399","#99CC99","#999999","#996699","#000066",
"#CCFF66","#003366","#CC0066","#006666","#CCCC66","#009966","#CC9966","#00CC66","#CC6666","#00FF66",
"#CC3366","#99FF66","#990066","#993366","#99CC66","#999966","#996666","#000033","#CCFF33","#003333",
"#CC0033","#006633","#CCCC33","#009933","#CC9933","#00CC33","#CC6633","#00FF33","#CC3333","#99FF33",
"#990033","#993333","#99CC33","#999933","#996633","#CCFF00","#003300","#006600","#009900","#CC9900",
"#CC6600","#CC3300","#99FF00","#990000","#993300","#99CC00","#999900","#996600",
"#CC0000","#FF0000","#CC00CC","#FF00CC","#0000CC","#0000FF","#00CCCC","#00FFFF","#00CC00","#00FF00",
"#CCCC00","#FFFF00","#000000","#999999","#FFFFFF","#330000","#333300","#336600","#FFCC00","#339900",
"#FF9900","#33CC00","#FF6600","#33FF00","#FF3300","#66FF00","#660000","#663300","#66CC00","#669900",
"#666600","#330033","#FFFF33","#333333","#FF0033","#336633","#FFCC33","#339933","#FF9933","#33CC33",
"#FF6633","#33FF33","#FF3333","#66FF33","#660033","#663333","#66CC33","#669933","#666633","#330066",
"#FFFF66","#333366","#FF0066","#336666","#FFCC66","#339966","#FF9966","#33CC66","#FF6666","#33FF66",
"#FF3366","#66FF66","#660066","#663366","#66CC66","#669966","#666666","#330099","#FFFF99","#333399",
"#FF0099","#336699","#FFCC99","#339999","#FF9999","#33CC99","#FF6699","#33FF99","#FF3399","#66FF99",
"#660099","#663399","#66CC99","#669999","#666699","#3300CC","#FFFFCC","#3333CC","#3366CC","#FFCCCC",
"#3399CC","#FF99CC","#33CCCC","#FF66CC","#33FFCC","#FF33CC","#66FFCC","#6600CC","#6633CC","#66CCCC",
"#6699CC","#6666CC","#3300FF","#FFFFFF","#3333FF","#FF00FF","#3366FF","#FFCCFF","#3399FF","#FF99FF",
"#33CCFF","#FF66FF","#33FFFF","#FF33FF","#66FFFF","#6600FF","#6633FF","#66CCFF","#6699FF","#6666FF",
"#CCFFFF","#0033FF","#CC00FF","#0066FF","#CCCCFF","#0099FF","#CC99FF","#00CCFF","#CC66FF","#CC33FF",
"#99FFFF","#9900FF","#9933FF","#99CCFF","#9999FF","#9966FF","#CCFFCC","#0033CC","#0066CC","#CCCCCC",
"#0099CC","#CC99CC","#CC66CC","#00FFCC","#CC33CC","#99FFCC","#9900CC","#9933CC","#99CCCC","#9999CC",
"#9966CC","#000099","#CCFF99","#003399","#CC0099","#006699","#CCCC99","#009999","#CC9999","#00CC99",
"#CC6699","#00FF99","#CC3399","#99FF99","#990099","#993399","#99CC99","#999999","#996699","#000066",
"#CCFF66","#003366","#CC0066","#006666","#CCCC66","#009966","#CC9966","#00CC66","#CC6666","#00FF66",
"#CC3366","#99FF66","#990066","#993366","#99CC66","#999966","#996666","#000033","#CCFF33","#003333",
"#CC0033","#006633","#CCCC33","#009933","#CC9933","#00CC33","#CC6633","#00FF33","#CC3333","#99FF33",
"#990033","#993333","#99CC33","#999933","#996633","#CCFF00","#003300","#006600","#009900","#CC9900",
"#CC6600","#CC3300","#99FF00","#990000","#993300","#99CC00","#999900","#996600",
"#CC0000","#FF0000","#CC00CC","#FF00CC","#0000CC","#0000FF","#00CCCC","#00FFFF","#00CC00","#00FF00",
"#CCCC00","#FFFF00","#000000","#999999","#FFFFFF","#330000","#333300","#336600","#FFCC00","#339900",
"#FF9900","#33CC00","#FF6600","#33FF00","#FF3300","#66FF00","#660000","#663300","#66CC00","#669900",
"#666600","#330033","#FFFF33","#333333","#FF0033","#336633","#FFCC33","#339933","#FF9933","#33CC33",
"#FF6633","#33FF33","#FF3333","#66FF33","#660033","#663333","#66CC33","#669933","#666633","#330066",
"#FFFF66","#333366","#FF0066","#336666","#FFCC66","#339966","#FF9966","#33CC66","#FF6666","#33FF66",
"#FF3366","#66FF66","#660066","#663366","#66CC66","#669966","#666666","#330099","#FFFF99","#333399",
"#FF0099","#336699","#FFCC99","#339999","#FF9999","#33CC99","#FF6699","#33FF99","#FF3399","#66FF99",
"#660099","#663399","#66CC99","#669999","#666699","#3300CC","#FFFFCC","#3333CC","#3366CC","#FFCCCC",
"#3399CC","#FF99CC","#33CCCC","#FF66CC","#33FFCC","#FF33CC","#66FFCC","#6600CC","#6633CC","#66CCCC",
"#6699CC","#6666CC","#3300FF","#FFFFFF","#3333FF","#FF00FF","#3366FF","#FFCCFF","#3399FF","#FF99FF",
"#33CCFF","#FF66FF","#33FFFF","#FF33FF","#66FFFF","#6600FF","#6633FF","#66CCFF","#6699FF","#6666FF",
"#CCFFFF","#0033FF","#CC00FF","#0066FF","#CCCCFF","#0099FF","#CC99FF","#00CCFF","#CC66FF","#CC33FF",
"#99FFFF","#9900FF","#9933FF","#99CCFF","#9999FF","#9966FF","#CCFFCC","#0033CC","#0066CC","#CCCCCC",
"#0099CC","#CC99CC","#CC66CC","#00FFCC","#CC33CC","#99FFCC","#9900CC","#9933CC","#99CCCC","#9999CC",
"#9966CC","#000099","#CCFF99","#003399","#CC0099","#006699","#CCCC99","#009999","#CC9999","#00CC99",
"#CC6699","#00FF99","#CC3399","#99FF99","#990099","#993399","#99CC99","#999999","#996699","#000066",
"#CCFF66","#003366","#CC0066","#006666","#CCCC66","#009966","#CC9966","#00CC66","#CC6666","#00FF66",
"#CC3366","#99FF66","#990066","#993366","#99CC66","#999966","#996666","#000033","#CCFF33","#003333",
"#CC0033","#006633","#CCCC33","#009933","#CC9933","#00CC33","#CC6633","#00FF33","#CC3333","#99FF33",
"#990033","#993333","#99CC33","#999933","#996633","#CCFF00","#003300","#006600","#009900","#CC9900",
"#CC6600","#CC3300","#99FF00","#990000","#993300","#99CC00","#999900","#996600");

  my $step = $STEP;

  if ( $type =~ "d") {
    $step = 86400;
  }
  else {
    if ( $type =~ "m") {
      $step = 60;
    }
    else {
      if ( $type =~ "n") {
        $type="m";
        $step = 600;
      }
      else {
        if ( $type =~ "h") {
          $step = 3600;
        }
      }
    }
  }

  my $unit="";
  if ( $yaxis =~ m/r/ ) {
    $unit="rPerfs";
  }
  else {
    if ( $yaxis =~ m/w/ ) {
      $unit="CPWs";
    }
    else {
    $unit="CPU cores";
    }
  }



  my $i = 0; # index for colors
  my $type_sam = $type;
  my $header = "LPARs in $unit: $human_start : $human_end";
  my $cmd = "";
  my $cmd_xport = "";

  $cmd .= "graph \\\"$name\\\"";
  $cmd .= " --title \\\"$header\\\"";
  $cmd .= " --start \\\"$start\\\"";
  $cmd .= " --end \\\"$end\\\"";
  $cmd .= " --imgformat PNG";
  $cmd .= " --slope-mode";
  $cmd .= " --width=$rrdwidth";
  $cmd .= " --height=$rrdheight";
  $cmd .= " --step=$step";
  $cmd .= " --lower-limit=0.00";
  $cmd .= " --color=BACK#$pic_col";
  $cmd .= " --color=SHADEA#$pic_col";
  $cmd .= " --color=SHADEB#$pic_col";
  $cmd .= " --color=CANVAS#$pic_col";
  $cmd .= " --alt-autoscale-max";
  $cmd .= " --upper-limit=0.1";
  if ( $yaxis =~ m/r/ ) {
    $cmd .= " --vertical-label=\\\"rPerf units\\\"";
  }
  else {
    if ( $yaxis =~ m/w/ ) {
      $cmd .= " --vertical-label=\\\"CPW units\\\"";
    }
    else {
      $cmd .= " --vertical-label=\\\"CPU cores\\\"";
    }
  }
  $cmd .= " --units-exponent=1.00";
  $cmd .= " --alt-y-grid";

  if ( $pool eq '' ) {
    # exclude CPU workload ....
    if ( $sort_order =~ m/lpar/ ) {
      # sorting per lpar
      $cmd .= " COMMENT:\\\"Average utilization in $unit (LPAR - Server)\\l\\\"";
    }
    else {
      if ($sort_order =~ m/hmc/ ) {
        # sorting per hmcr
        $cmd .= " COMMENT:\\\"Average utilization in $unit (Server - LPAR)\\l\\\"";
      }
      else {
        # sorting per server
        $cmd .= " COMMENT:\\\"Average utilization in $unit (Server - LPAR)\\l\\\"";
      }
    }
  }

  my $gtype="AREA";
  my $j = 0;
  my $legent_length = 60;
  my $name_all = "";
  my $max_cpu_txt = "";
  my $res_cpu_txt = "";
  my $lpar_pool = ""; # must be here
  my $managedname_pool = ""; # must be here
  my $rperf = "";
  my $cpu_ghz = "";
  my $cores = "";
  my $rperf_pool = "";
  my $cpu_ghz_pool = "";
  my $cores_pool = "";
  my $newsrv = 0;


  # section used only for CPU workload estimator (add as first CPU pool)
  if ( ! $pool eq '' ) {
    ( my $hmc_pool , $managedname_pool, $lpar_pool, $rperf_pool, $cpu_ghz_pool, $cores_pool) = split (/\|/,$pool);
    $rperf_legend[$rperf_legend_count] = $managedname_pool."|".$lpar_pool."|".$rperf_pool."|".$cpu_ghz_pool."|".$cores_pool;
    $rperf_legend[$rperf_legend_count] =~ s/__XXX__//;
    $rperf_legend_count++;
    my $file = "";
    if ( $type =~ "d") {
       $file = $lpar_pool.".rrd";
       if ( ! -f "$wrkdir/$managedname_pool/$hmc_pool/$file" ) {
	 # IVM & SDMC daily stats are here
         $file = $lpar_pool.".rrm";
         if ( ! -f "$wrkdir/$managedname_pool/$hmc_pool/$file" ) {
           print OUT " does not exists $wrkdir/$managedname_pool/$hmc_pool/$file and even .rrd\n" if ( $DEBUG == 2);
         }
       }
    }
    if (($type =~ "h") || ($type =~ "m") || ($type =~ "n")) {
       $file = $lpar_pool.".rrm";
       if ( ! -f "$wrkdir/$managedname_pool/$hmc_pool/$file" ) {
         $file = $lpar_pool.".rrh";
         if ( ! -f "$wrkdir/$managedname_pool/$hmc_pool/$file" ) {
           print OUT " does not exists $wrkdir/$managedname_pool/$hmc_pool/$file and even .rrm\n" if ( $DEBUG == 2);
         }
       }
    }
    print OUT "66 $hmc_pool $managedname_pool $lpar_pool $file\n" if ( $DEBUG == 2);

    print OUT "77 $wrkdir/$managedname_pool/$hmc_pool/$file \n" if ( $DEBUG == 2);

    # find out name of shared pool from given SharedPoolXY name
    $sh_pool_name = $lpar_pool;
    if ( $lpar_pool =~ m/SharedPool[1-9]/ && -f "$inputdir/data/$managedname_pool/$hmc_pool/cpu-pools-mapping.txt" ) {
       open(FR, "< $inputdir/data/$managedname_pool/$hmc_pool/cpu-pools-mapping.txt");
       my $pool_id = $lpar_pool;
       $pool_id =~ s/SharedPool//;
       foreach my $linep (<FR>) {
         chomp ($linep);
         (my $id, $pool_name) = split (/,/,$linep);
         if ( $id == $pool_id  ) {
           $sh_pool_name = $pool_name;
           last;
         }
       }
       close (FR);
    }
    else {
      if ( $lpar_pool =~ m/^pool$/ ) {
        $sh_pool_name = "Default pool";
      }
    }

    if ( $sort_order =~ m/lpar/ ) {
      # sorting per lpar
       $name_all = $sh_pool_name." - ".$managedname_pool;
    }
    else {
      if ($sort_order =~ m/hmc/ ) {
        # sorting per hmc
        $name_all = $managedname_pool." - ".$sh_pool_name;
      }
      else {
        # sorting per server
        $name_all = $managedname_pool." - ".$sh_pool_name;
      }
    }
   
    # add spaces to lpar name to have 25 chars total (for formating graph legend)
    $legent_length=length($name_all);
    if ( $legent_length < 60 ) {
      $legent_length=60;
    }

    for(my $k = length($name_all); $k < $legent_length; $k++) {
      $name_all .= " ";
    }

    $max_cpu_txt = "Max $unit";
    for(my $k = length($max_cpu_txt); $k < $legent_length; $k++) {
      $max_cpu_txt .= " ";
    }

    $res_cpu_txt = "Reserved $unit";
    for(my $k = length($res_cpu_txt); $k < $legent_length; $k++) {
      $res_cpu_txt .= " ";
    }

    $cmd .= " COMMENT:\\\" \\l\\\"";
    #$cmd .= " COMMENT:\\\"Average utilization in $unit\\l\\\"";
    $cmd .= " COMMENT:\\\" \\l\\\"";

    if ($name_all =~ m/__XXX__/ ) {
      $newsrv = 1; # mean it is for new HW estimation only
      $name_all =~ s/__XXX__//;
      $managedname_pool =~ s/__XXX__//;
    }

    if ($newsrv == 0){
      # except new HW server est
      if ( $sort_order =~ m/lpar/ ) {
        # sorting per lpar
        if ( $yaxis =~ m/w/ ) {
          $cmd .= " COMMENT:\\\"  POOL - Server (already existing load on the target)            average \\t     maximum  [$unit]\\l\\\"";
        }
        else {
          $cmd .= " COMMENT:\\\"  POOL - Server (already existing load on the target)         average  maximum  [$unit]\\l\\\"";
        }
      }
      else {
        if ($sort_order =~ m/hmc/ ) {
          # sorting per hmcr
          if ( $yaxis =~ m/w/ ) {
            $cmd .= " COMMENT:\\\"  Server - POOL (already existing load on the target)            average \\t     maximum  [$unit]\\l\\\"";
          }
          else {
            $cmd .= " COMMENT:\\\"  Server - POOL (already existing load on the target)         average  maximum  [$unit]\\l\\\"";
          }
        }
        else {
          # sorting per server
          if ( $yaxis =~ m/w/ ) {
            $cmd .= " COMMENT:\\\"  Server - POOL (already existing load on the target)            average \\t     maximum  [$unit]\\l\\\"";
          }
          else {
            $cmd .= " COMMENT:\\\"  Server - POOL (already existing load on the target)         average  maximum  [$unit]\\l\\\"";
          }
        }
      }
  
      # find our rPerf --> it is already just, just assure everything is ok
      if ( $yaxis =~ m/w/ || $yaxis =~ m/r/ ) {
        if ( $rperf_pool eq '' || $cpu_ghz_pool eq '' || $cores_pool eq '') {
          err_html("Contact LPAR2RRD support : rperf_pool:$rperf_pool cpu_ghz_pool:$cpu_ghz_pool cores_pool:$cores_pool");
        }
        # it exit before in case of any problem in finding rperf
      }

      my $rrd = "$wrkdir/$managedname_pool/$hmc_pool/$file";
      # bulid RRDTool cmd
      if ( $lpar_pool =~  "SharedPool[1-9]" || $lpar_pool =~  "SharedPool[1-9][0-9]" ) {
        # --PH somehow re-solve SharedPool[0]
        $cmd .= " DEF:max${i}=\\\"$rrd\\\":max_pool_units:AVERAGE";
        $cmd .= " DEF:res${i}=\\\"$rrd\\\":res_pool_units:AVERAGE";
        $cmd .= " DEF:totcyc${i}=\\\"$rrd\\\":total_pool_cycles:AVERAGE";
        $cmd .= " DEF:uticyc${i}=\\\"$rrd\\\":utilized_pool_cyc:AVERAGE";
        $cmd .= " CDEF:cpuutil${i}=uticyc${i},totcyc${i},/";
        if ( $yaxis =~ m/w/ || $yaxis =~ m/r/ ) {
          # rPerf
          $cmd .= " CDEF:cpuutiltot_r${i}=cpuutil${i},max${i},*";
          $cmd .= " CDEF:cpuutiltot${i}=cpuutiltot_r${i},$rperf_pool,*";
        }
        else {
          $cmd .= " CDEF:cpuutiltot${i}=cpuutil${i},max${i},*";
        }
        $cmd .= " $gtype:cpuutiltot${i}#FF0000:\\\"$name_all\\\"";
        $cmd .= " GPRINT:cpuutiltot${i}:AVERAGE:\\\"%4.0lf \\l\\\"";
      }
      else {
        # for default pool
        $cmd .= " DEF:totcyc${i}=\\\"$rrd\\\":total_pool_cycles:AVERAGE";
        $cmd .= " DEF:uticyc${i}=\\\"$rrd\\\":utilized_pool_cyc:AVERAGE";
        $cmd .= " DEF:cpu${i}=\\\"$rrd\\\":conf_proc_units:AVERAGE";
        $cmd .= " DEF:cpubor${i}=\\\"$rrd\\\":bor_proc_units:AVERAGE";
        $cmd .= " CDEF:totcpu${i}=cpu${i},cpubor${i},+";
        $cmd .= " CDEF:cpuutil${i}=uticyc${i},totcyc${i},/";
        if ( $yaxis =~ m/w/ || $yaxis =~ m/r/ ) {
          # rPerf
          $cmd .= " CDEF:cpuutiltot_r${i}=cpuutil${i},totcpu${i},*";
          $cmd .= " CDEF:cpuutiltot${i}=cpuutiltot_r${i},$rperf_pool,*";
        }
        else {
          $cmd .= " CDEF:cpuutiltot${i}=cpuutil${i},totcpu${i},*";
        } 
        $cmd .= " $gtype:cpuutiltot${i}#FF0000:\\\"$name_all\\\"";
        if ( $yaxis =~ m/w/ ) {
          $cmd .= " GPRINT:cpuutiltot${i}:AVERAGE:\\\"%7.0lf \\t\\\"";
          $cmd .= " GPRINT:cpuutiltot${i}:MAX:\\\"%7.0lf \\l\\\"";
        }
        else {
          $cmd .= " GPRINT:cpuutiltot${i}:AVERAGE:\\\"%4.1lf \\t\\\"";
          $cmd .= " GPRINT:cpuutiltot${i}:MAX:\\\"%4.1lf \\l\\\"";
        }
      }
      $cmd .= " COMMENT:\\\" \\l\\\"";
      $gtype="STACK";
    }

    if ( $sort_order =~ m/lpar/ ) {
      # sorting per lpar
      if ( $yaxis =~ m/w/ ) {
        $cmd .= " COMMENT:\\\"  LPAR - Server (will be migrated)                               average \\t     maximum  [$unit]\\l\\\"";
      }
      else {
        $cmd .= " COMMENT:\\\"  LPAR - Server (will be migrated)                            average  maximum  [$unit]\\l\\\"";
      }
    }
    else {
      if ($newsrv == 1){
        if ($sort_order =~ m/hmc/ ) {
          # sorting per hmcr
          if ( $yaxis =~ m/w/ ) {
            $cmd .= " COMMENT:\\\"  Server - LPAR (will be migrated)                               average \\t     maximum  [$unit]\\l\\\"";
          }
          else {
            $cmd .= " COMMENT:\\\"  Server - LPAR (will be migrated)                            average  maximum  [$unit]\\l\\\"";
          }
        }
        else {
          # sorting per server
          if ( $yaxis =~ m/w/ ) {
            $cmd .= " COMMENT:\\\"  Server - LPAR (will be migrated)                               average \\t     maximum  [$unit]\\l\\\"";
          }
          else {
            $cmd .= " COMMENT:\\\"  Server - LPAR (will be migrated)                            average  maximum  [$unit]\\l\\\"";
          }
        }
      }
      else { # for existing HW there must not be average and max ..
        if ($sort_order =~ m/hmc/ ) {
          # sorting per hmcr
          if ( $yaxis =~ m/w/ ) {
            $cmd .= " COMMENT:\\\"  Server - LPAR (will be migrated)\\l\\\"";
          }
          else {
            $cmd .= " COMMENT:\\\"  Server - LPAR (will be migrated)\\l\\\"";
          }
        }
        else {
          # sorting per server
          if ( $yaxis =~ m/w/ ) {
            $cmd .= " COMMENT:\\\"  Server - LPAR (will be migrated)\\l\\\"";
          }
          else {
            $cmd .= " COMMENT:\\\"  Server - LPAR (will be migrated)\\l\\\"";
          }
        }
      }
    }
  }


  print OUT "88 $name - $indx - $start - $end\n" if ( $DEBUG == 2);


  #############################
  # main loop through all lpars
  #############################

  my $color_indx = 0; # must be independent from $i --> 3.64 change

  for ($i = 0; $i < $indx; $i++) {
    my $hmc = @hmc_all[$i];
    my $managedname = @managedname_all[$i];
    my $lpar = @lpar_all[$i];
    $rperf = @rperf_all[$i];
    $cpu_ghz = @cpu_ghz_all[$i];
    $cores = @cores_all[$i];
    my $file = "";
    if ( $type =~ "d") {
       $file = $lpar.".rrd";
       if ( ! -f "$wrkdir/$managedname/$hmc/$file" ) {
	 # IVM & SDMC daily stats are here
         $file = $lpar.".rrm";
         if ( ! -f "$wrkdir/$managedname/$hmc/$file" ) {
           print OUT " does not exists $wrkdir/$managedname/$hmc/$file and even .rrd\n" if ( $DEBUG == 2);
	   next;
         }
       }
    }
    if (($type =~ "h") || ($type =~ "m") || ($type =~ "n")) {
       $file = $lpar.".rrm";
       if ( ! -f "$wrkdir/$managedname/$hmc/$file" ) {
         $file = $lpar.".rrh";
         if ( ! -f "$wrkdir/$managedname/$hmc/$file" ) {
           print OUT " does not exists $wrkdir/$managedname/$hmc/$file and even .rrm\n" if ( $DEBUG == 2);
	   next;
         }
       }
    }
    #print STDERR "88 $hmc $managedname $lpar : $rperf : $cpu_ghz : $cores\n";
    print OUT "88 $hmc $managedname $lpar $file\n" if ( $DEBUG == 2);

    # avoid old lpars which do not exist in the period
    my $rrd_upd_time = (stat("$wrkdir/$managedname/$hmc/$file"))[9];
    if ( $rrd_upd_time < $start_unix ) {
      next;
    }

    print OUT "99 $wrkdir/$managedname/$hmc/$file $rrd_upd_time $req_time $act_time\n" if ( $DEBUG == 2);

    if ( $sort_order =~ m/lpar/ ) {
      # sorting per lpar
       $name_all = $lpar." - ".$managedname;
    }
    else {
      if ($sort_order =~ m/hmc/ ) {
        # sorting per hmcr
        $name_all = $managedname." - ".$lpar;
      }
      else {
        # sorting per server
        $name_all = $managedname." - ".$lpar;
      }
    }
   
    # add spaces to lpar name to have 60 chars total (for formating graph legend)
    my $name_all_slash = $name_all;
    $name_all_slash =~ s/\&\&1/\//g;
    for(my $k = length($name_all_slash); $k < $legent_length; $k++) {
      $name_all_slash .= " ";
    }

    # find our rPerf --> it is already just, just assure everything is ok
    if ( $yaxis =~ m/w/ || $yaxis =~ m/r/ ) {
      if ( $rperf eq '' || $cpu_ghz eq '' || $cores eq '') {
        err_html("Whatever");
        # it exit before in case of any problem in finding rperf
      }
     
      # fill in server legend table
      $rperf_legend[$rperf_legend_count] = $managedname."||".$rperf."|".$cpu_ghz."|".$cores;
      $rperf_legend_count++;
      #print STDERR "89 $hmc $managedname $lpar : $rperf : $cpu_ghz : $cores -- $rperf_legend_count\n";
    }


    # bulid RRDTool cmd
    $cmd .= " DEF:cap${i}=\\\"$wrkdir/$managedname/$hmc/$file\\\":capped_cycles:AVERAGE";
    $cmd .= " DEF:uncap${i}=\\\"$wrkdir/$managedname/$hmc/$file\\\":uncapped_cycles:AVERAGE";
    $cmd .= " DEF:ent${i}=\\\"$wrkdir/$managedname/$hmc/$file\\\":entitled_cycles:AVERAGE";
    $cmd .= " DEF:cur${i}=\\\"$wrkdir/$managedname/$hmc/$file\\\":curr_proc_units:AVERAGE";
    $cmd .= " CDEF:tot${i}=cap${i},uncap${i},+";
    $cmd .= " CDEF:util${i}=tot${i},ent${i},/";
    if ( $yaxis =~ m/w/ || $yaxis =~ m/r/ ) {
      # rPerf
      $cmd .= " CDEF:utiltotu_n${i}=util${i},cur${i},*";
      $cmd .= " CDEF:utiltotu${i}=utiltotu_n${i},$rperf,*";
    }
    else {
      $cmd .= " CDEF:utiltotu${i}=util${i},cur${i},*";
    }
    $cmd .= " CDEF:utiltot${i}=utiltotu${i},UN,0,utiltotu${i},IF";
    $cmd .= " $gtype:utiltot${i}$color[$color_indx]:\\\"$name_all_slash\\\"";
    $cmd_xport .= "\\\"DEF:cap${i}=$wrkdir/$managedname/$hmc/$file:capped_cycles:AVERAGE\\\"\n";
    $cmd_xport .= "\\\"DEF:uncap${i}=$wrkdir/$managedname/$hmc/$file:uncapped_cycles:AVERAGE\\\"\n";
    $cmd_xport .= "\\\"DEF:ent${i}=$wrkdir/$managedname/$hmc/$file:entitled_cycles:AVERAGE\\\"\n";
    $cmd_xport .= "\\\"DEF:cur${i}=$wrkdir/$managedname/$hmc/$file:curr_proc_units:AVERAGE\\\"\n";
    $cmd_xport .= "\\\"CDEF:tot${i}=cap${i},uncap${i},+\\\"\n";
    $cmd_xport .= "\\\"CDEF:util${i}=tot${i},ent${i},/\\\"\n";
    $cmd_xport .= "\\\"CDEF:utiltotu${i}=util${i},cur${i},*\\\"\n";
    $cmd_xport .= "\\\"CDEF:utiltot${i}=utiltotu${i},UN,0,utiltotu${i},IF\\\"\n";
    $cmd_xport .= "\\\"XPORT:utiltot${i}:$name_all_slash\\\"\n";
    if ( $yaxis =~ m/w/ ) {
      $cmd .= " GPRINT:utiltot${i}:AVERAGE:\\\"%7.0lf \\t\\\"";
      $cmd .= " GPRINT:utiltot${i}:MAX:\\\"%7.0lf \\l\\\"";
    }
    else {
      $cmd .= " GPRINT:utiltot${i}:AVERAGE:\\\"%4.1lf \\t\\\"";
      $cmd .= " GPRINT:utiltot${i}:MAX:\\\"%4.1lf \\l\\\"";
    }

    $gtype="STACK";

    if ( $color_indx == 8 ) {
      # switch to big color table
      @color=@color_big;
    }
    $color_indx++;

  }

  # section used only for CPU workload estimator (add as first CPU pool)
  # max pool legend on the bottom of the graph

  if ( ! $pool eq '' ) {
    $i = 0;
    if ( $lpar_pool =~  "SharedPool[1-9]" || $lpar_pool =~  "SharedPool[1-9][0-9]" ) {
      $cmd .= " COMMENT:\\\" \\l\\\"";
      $cmd .= " COMMENT:\\\"CPU pool limit for\\: $managedname_pool / $sh_pool_name\\l\\\"";
      if ( $yaxis =~ m/w/ || $yaxis =~ m/r/ ) {
        # rPerf
        $cmd .= " CDEF:max_n${i}=max${i},$rperf_pool,*";
        $cmd .= " CDEF:res_n${i}=res${i},$rperf_pool,*";
      }
      else {
        $cmd .= " CDEF:max_n${i}=max${i},1,*";
        $cmd .= " CDEF:res_n${i}=res${i},1,*";
      }
      $cmd .= " LINE2:max_n${i}#000000:\\\"$max_cpu_txt\\\"";
      $cmd .= " GPRINT:max_n${i}:AVERAGE:\\\"%2.1lf\\l\\\"";
      $cmd .= " LINE2:res_n${i}#444444:\\\"$res_cpu_txt\\\"";
      $cmd .= " GPRINT:res_n${i}:AVERAGE:\\\"%2.1lf\\l\\\"";
    }
    else {
      if ( $yaxis =~ m/w/ || $yaxis =~ m/r/ ) {
        # rPerf
        if ( $newsrv == 0 ) {
          $cmd .= " CDEF:cpu_n${i}=cpu${i},$rperf_pool,*";
          $cmd .= " COMMENT:\\\" \\l\\\"";
          $cmd .= " COMMENT:\\\"CPU pool limits for\\: $managedname_pool / $sh_pool_name\\l\\\"";
          $cmd .= " LINE3:cpu_n${i}#000000:\\\"$max_cpu_txt\\\"";
          $cmd .= " GPRINT:cpu_n${i}:AVERAGE:\\\"%4.0lf\\l\\\"";
        }
        else {
          my $cpu_n_unrounded = $cores_pool * $rperf_pool;
  	  my $cpu_n = sprintf("%.0f", $cpu_n_unrounded);
          (my $mod, my $typ, my $cpu) = split (/ /,$managedname_pool);
          my $new_srv_name = "IBM Power $typ (model $mod)";
          for(my $k = length($new_srv_name); $k < $legent_length; $k++) {
            $new_srv_name .= " ";
          }
          $cmd .= " COMMENT:\\\" \\l\\\"";
          $cmd .= " COMMENT:\\\"CPU limit for target server\\: \\l\\\"";
          $cmd .= " LINE3:$cpu_n#000000:\\\"$new_srv_name  $cpu_n $unit\\\"";
          $cmd .= " COMMENT:\\\" \\l\\\"";
        }
      }
      else {
        if ( $newsrv == 0 ) {
          # for a existing server with CPU core yaxis
          $cmd .= " CDEF:cpu_n${i}=cpu${i},1,*";
          $cmd .= " COMMENT:\\\" \\l\\\"";
          $cmd .= " COMMENT:\\\"CPU pool limit for\\: $managedname_pool / $sh_pool_name\\l\\\"";
          $cmd .= " LINE2:cpu_n${i}#000000:\\\"$max_cpu_txt\\\"";
          $cmd .= " GPRINT:cpu_n${i}:AVERAGE:\\\"%4.0lf\\l\\\"";
        }
        else {
          # for a new server with CPU core yaxis
          my $cpu_n = $cores_pool;
          for(my $k = length($new_srv_name); $k < $legent_length; $k++) {
            $new_srv_name .= " ";
          }
          $cmd .= " COMMENT:\\\" \\l\\\"";
          $cmd .= " COMMENT:\\\"CPU pool limits for\\: $managedname_pool / $sh_pool_name\\l\\\"";
          $cmd .= " LINE2:$cpu_n#000000:\\\"$new_srv_name   $cpu_n\\\"";
        }
      }
    }

    if ( $yaxis =~ m/w/ || $yaxis =~ m/r/ ) {
      # append there server legend : server: cores x GHZ, rPerf/core ..."
      $cmd .= " COMMENT:\\\" \\l\\\"";
      if ( $yaxis =~ m/w/ ) {
        $cmd .= " COMMENT:\\\"Server details                                            number of cores   GHz     CPW/core\\l\\\"";
      }
      if ( $yaxis =~ m/r/ ) {
        $cmd .= " COMMENT:\\\"Server details                                            number of cores   GHz  rPerf/core\\l\\\"";
      }
      my @servers_used = "";
      my $count_srv = 0;
      foreach my $liner (@rperf_legend) {
        #print STDERR "$liner \n";
        (my $server_l, my $lpar_l, my $rperf_l, my $cpu_l, my $cores_l) = split (/\|/,$liner);

        # Exclde from legent server duplicates
        my $found = 0;
        foreach my $server_used (@servers_used) {
          if ( $server_used =~ m/^$server_l$/ ) {
            $found = 1;
            last;
          }
        }
        if ( $found == 1 ) {
          next;
        }
        @servers_used[$count_srv] = $server_l;
        $count_srv++;

        if ( $newsrv == 1 && $count_srv == 1 ) {
          # decode server type if it is a new server
          (my $mod, my $typ, my $cpu) = split (/ /,$managedname_pool);
          $server_l= "IBM Power $typ (target)";
        }

        my $rperf_dec = 0;
        if ( $yaxis =~ m/w/ ) {
          $rperf_dec = sprintf("%7.0f",$rperf_l);
        }
        else {
          $rperf_dec = sprintf("%4.1f",$rperf_l);
        }
        my $cores_dec = sprintf("%4.0f",$cores_l);
        for(my $k = length($server_l); $k < $legent_length + 2; $k++) {
          $server_l .= " ";
        }
        $cores_l =~ s/ //g;
        $cmd .= " COMMENT:\\\"$server_l $cores_dec         $cpu_l    $rperf_dec\\l\\\"";
      }
    }
  }

  if ($j) {
    $cmd .= " COMMENT:\\\" \\l\\\"";
  }
  $cmd .= " HRULE:0#000000";
  # $cmd .= " VRULE:0#000000"; --> it is causing sigsegv on linuxes
  $cmd =~ s/\\"/"/g;
  $cmd_xport =~ s/\\"/"/g;

  
  if ($xport) {
    print "Content-Disposition: attachment;filename=$hmc\_$managedname\_aggregated.csv\n\n";
    RRDp::cmd qq(xport   
         "--start" "$start"
         "--end" "$end"
         "--step" "$step"
	 "--maxrows" "65000"
         $cmd_xport
    );
    my $ret = RRDp::read;
    #print OUT "---- $ret\n +++ $cmd_xport";
    my $tmp_file="/var/tmp/lpar2rrd.tmp-$$";
    my  $FH;
    open(FH, "> $tmp_file") || die "$act_time: Can't open $tmp_file : $!";
    print FH "$$ret";
    close (FH);

    open(FH, "< $tmp_file") || die "$act_time: Can't open $tmp_file : $!";
    my $out = 0;
    my $out_txt = "";
    while (my $line = <FH>) {
      if ($out == 0 ){
        if ($line =~ m/xml version=/ ) {
	  $out_txt .= $line;
          $out = 1;
        }
      }
      else {
        if ($line !~ m/^OK u:/ ) {
	  $out_txt .= $line;
        }
      }
    }
    close (FH);
    unlink ("$tmp_file");
    #print OUT "--xport $out_txt\n";
    #print OUT "++xport $$ret\n";
    xport_print ($out_txt,1);
  }
  else {
    # execute rrdtool, it is not possible to use RRDp Perl due to the syntax issues therefore use not nice direct rrdtool way
  
    my $tmp_file="/var/tmp/lpar2rrd.tmp-$$";
    my  $FH;
    open(FH, "> $tmp_file") || die "$act_time: Can't open $tmp_file : $!";
    print FH "$cmd\n";
    close (FH);
    my $ret  = `$rrdtool - < "$tmp_file" 2>&1`;
    if ( $ret =~ "ERROR" ) {
      error("Multi graph rrdtool error : $ret");
      error("$cmd");
      print OUT "Multi graph rrdtool error : $ret" if ( $DEBUG == 2);
    }
    unlink ("$tmp_file");
  }
  close (OUT) if ( $DEBUG == 2);
  return 0;
}

sub rperf_not_found 
{
  my $server = shift;
  print "<br><br><center><strong>rPerf has not been found for server : $server</strong>\n";
  print "</body></html>";

  return 0;
}


# do not use it, it has to create an image
# fake rrdtool file and comment??
# --> find out a 
sub err_html {
  my $text = shift;
  my $name = "$tmpdir/general_error.png";

  if (! $xport) {
    open(PNG, "< $name") || die   "Cannot open  $name: $!";
    binmode(PNG);
    while (read(PNG,$b,4096)) {
      print "$b";
    }
  }

  exit 1;
}

# error handling
sub error
{
  my $text = shift;
  my $act_time = localtime();
  chomp ($text);

  #print "ERROR          : $text : $!\n";
  print STDERR "$act_time: $text : $!\n";

  return 1;
}

