#!/usr/bin/perl

#use strict;
use RRDp;
use POSIX qw(strftime);
use Env qw(QUERY_STRING);

my $DEBUG = $ENV{DEBUG};
#my $DEBUG = "2";
my $inputdir = $ENV{INPUTDIR};
my $rrdtool = $ENV{RRDTOOL};
my $refer = $ENV{HTTP_REFERER};
my $errlog = $ENV{ERRLOG};
my $managed_systems_exclude =  $ENV{MANAGED_SYSTEMS_EXCLUDE};

open(OUT, ">> $errlog")  if $DEBUG == 2 ;

# print HTML header
print "Content-type: text/html\n";
my $time = gmtime();
print "Expires: $time\n\n";
print "<HTML><HEAD>
<TITLE>LPAR2RRD</TITLE>
<style>
<!--
a {text-decoration: none}
-->
</style>
</HEAD>
<BODY BGCOLOR=\"#D3D2D2\" TEXT=\"#000000\" LINK=\"#0000FF\" VLINK=\"#0000FF\" ALINK=\"#FF0000\" >";


# case sensitive search was canceled
my $case = 0;

print OUT "-- $QUERY_STRING\n" if $DEBUG == 2 ;
(my $pattern, my $entitle, my $sort_order, my $referer, my $search )  = split(/&/,$QUERY_STRING);

$entitle =~ s/entitle=//;
$pattern =~ s/LPAR=//;
$sort_order =~ s/sort=//;
$pattern =~ tr/+/ /;
$pattern =~ s/%([\dA-Fa-f][\dA-Fa-f])/ pack ("C",hex ($1))/seg;
$referer =~ s/referer=//;

#$case =~ s/Search=Search:\.//;
#$case =~ s/case=//;

#if (length($case) == 0 ) {
#  # convert searched string to case non sensitive in find
#  my $lpar_new="";
#
#  for (my $i=0; $i < length($lpar); $i++) {
#    $lpar_new .= "[".lc(substr($lpar,$i,1))."|".uc(substr($lpar,$i,1))."]";
#  }
#
#  $lpar = $lpar_new;
#}

chdir ("$inputdir/data");

# search throug curr_profile
my @out_prof = "";
my @out_prof_tmp = "";
my $out_prof_indx = 0;
#`echo "$line" >> /tmp/e1`;
foreach my $line (<*/*/lpar.cfg>) {
  chomp ($line);
  my $sym_link = $line;
  $sym_link =~ s/\/.*//g;
  #`echo "00 $line : $sym_link" >> /tmp/e1`;
  if ( -l "$sym_link" ) {
    next; # avoid sym links
  }

  #`echo "01 $line : $lpar" >> /tmp/e1`;
  my @out_prof_act=`egrep "curr_profile=.\*.,work_group_id=" $line |sed -e 's/^name=//' -e 's/,lpar_id.*//g'`;
  foreach my $line_lpar (@out_prof_act) {
    chomp ($line_lpar);
    $line =~ s/lpar.cfg//g;
    $line_lpar =~ s/\//&&1/g;
    $out_prof_tmp[$out_prof_indx] = $line.$line_lpar;
    #`echo "$out_prof_tmp[$out_prof_indx]" >> /tmp/e1`;
    $out_prof_indx++;
  }
}


# search for lpars
my @out = "";
if ( $sort_order =~ m/lpar/ ) {
  # sorting per LPARs
  @out=`find . -type f -name "\*.rr[m|h]"|egrep -v "pool.rrh|pool.rrm|mem.rrh|mem.rrm|SharedPool[0-9].rrh|SharedPool[0-9].rrm|SharedPool[0-9][0-9].rrh|SharedPool[0-9][0-9].rrm"|sort -t "/" -f -k 4`;
  @out_prof = sort { (split '/', $a)[2] cmp (split '/', $b)[2] } @out_prof_tmp;
}
else {
  if ($sort_order =~ m/hmc/ ) {
    # sorting per HMC/SDMC/IVM
    @out=`find . -type f -name "\*.rr[m|h]"|egrep -v "pool.rrh|pool.rrm|mem.rrh|mem.rrm|SharedPool[0-9].rrh|SharedPool[0-9].rrm|SharedPool[0-9][0-9].rrh|SharedPool[0-9][0-9].rrm"|sort -t "/" -f -k 3`;
    @out_prof = sort { (split '/', $a)[1] cmp (split '/', $b)[1] } @out_prof_tmp;
  }
  else {
    #sorting per server
    @out=`find . -type f -name "\*.rr[m|h]"|egrep -v "pool.rrh|pool.rrm|mem.rrh|mem.rrm|SharedPool[0-9].rrh|SharedPool[0-9].rrm|SharedPool[0-9][0-9].rrh|SharedPool[0-9][0-9].rrm"|sort -f`;
    @out_prof = sort { (split '/', $a)[0] cmp (split '/', $b)[0] } @out_prof_tmp;
  }
}

print OUT "-- $inputdir $lpar +$case+ \n"if $DEBUG == 2 ;
#print "-- $inputdir $lpar -- $sort_order -- $out[0]  \n";
print "<table align=\"center\" summary=\"Graphs\">";

# Check whether AIX or another OS due to "grep -p" which supports only AIX
my $uname = `uname -a`;
chomp($uname);
my $aix = 0;
my @u_a = split(/ /,$uname);
foreach my $u (@u_a) {
  if ($u =~ "AIX") {
    $aix = 1;
  }
  break;
}

# find out HTML_referer
# renove from the path last 4 things
# http://nim.praha.cz.ibm.com/lpar2rrd/hmc1/PWR6B-9117-MMA-SN103B5C0%20ttt/pool/top.html
# --> http://nim.praha.cz.ibm.com/lpar2rrd
my @full_path = split(/\//, $refer);
my $k = 0;
foreach my $path (@full_path){
  $k++
}

#
# if it goes through "custom groups" then there are ony 2 subdirs instead standard 3 in lpar2rrd refere path!!!
#

if ( $refer =~ m/\/custom\// ) {
  $k--;
  $k--;
  $k--;
}
else {
  $k--;
  $k--;
  $k--;
  $k--;
}

my $j = 0;
my $html_base = "";
foreach my $path (@full_path){
  if ($j < $k) {
    if ( $j == 0 ) {
      $html_base .= $path;
    }
    else {
      $html_base .= "/".$path;
    }
    $j++;
  }
}
my $html_base_en = $html_base;
$html_base_en =~ s/([^A-Za-z0-9+-_])/sprintf("%%%02X", ord($1))/seg;

if ( ! $referer eq '' ) {
  $html_base_en = $referer;
  $referer =~ tr/+/ /;
  $referer =~ s/%([\dA-Fa-f][\dA-Fa-f])/ pack ("C",hex ($1))/seg;
  $html_base = $referer;
}

#$html_base_en contain encoded htlml_base (got from REFER) which has to be passed as HMC/Server sorting have there cgi-bin/...

#print "<BR>-- $html_base -- $refer <BR>";

if ( $aix == 1) {
  # AIX with grep -p support
  if ( $sort_order =~ m/lpar/ ) {
    # sorting per LPARs
    print "<tr><td align=\"center\"><A HREF=\"/lpar2rrd-cgi/lpar-search.sh?LPAR=$pattern&entitle=$entitle&sort=hmc&referer=$html_base_en\" target=\"sample\"><B>HMC</B></A></td><td align=\"center\">&nbsp;&nbsp;<A HREF=\"/lpar2rrd-cgi/lpar-search.sh?LPAR=$pattern&entitle=$entitle&sort=&referer=$html_base_en\" target=\"sample\"><B>Server</B></A></td><td align=\"center\"><B>&nbsp;&nbsp;LPAR</B></td><td align=\"center\"><B>&nbsp;&nbsp;Last update</B></td><td align=\"center\"><B>&nbsp;&nbsp;OS</B></td></tr>";
  }
  else {
    if ($sort_order =~ m/hmc/ ) {
      # sorting per HMC/SDMC/IVM
      print "<tr><td align=\"center\"><B>HMC</B></td><td align=\"center\">&nbsp;&nbsp;<A HREF=\"/lpar2rrd-cgi/lpar-search.sh?LPAR=$pattern&entitle=$entitle&sort=&referer=$html_base_en\" target=\"sample\"><B>Server</B></A></td><td align=\"center\">&nbsp;&nbsp;<A HREF=\"/lpar2rrd-cgi/lpar-search.sh?LPAR=$pattern&entitle=$entitle&sort=lpar&referer=$html_base_en\" target=\"sample\"><B>LPAR</B></A></td><td align=\"center\"><B>&nbsp;&nbsp;Last update</B></td><td align=\"center\"><B>&nbsp;&nbsp;OS</B></td></tr>";
    }
    else {
      #sorting per server
      print "<tr><td align=\"center\"><A HREF=\"/lpar2rrd-cgi/lpar-search.sh?LPAR=$pattern&entitle=$entitle&sort=hmc&referer=$html_base_en\" target=\"sample\"><B>HMC</B></A></td><td align=\"center\">&nbsp;&nbsp;<B>Server</B></td><td align=\"center\">&nbsp;&nbsp;<A HREF=\"/lpar2rrd-cgi/lpar-search.sh?LPAR=$pattern&entitle=$entitle&sort=lpar&referer=$html_base_en\" target=\"sample\"><B>LPAR</B></A></td><td align=\"center\"><B>&nbsp;&nbsp;Last update</B></td><td align=\"center\"><B>&nbsp;&nbsp;OS</B></td></tr>";
    }
  }
}
else {
  # other platforms without OS support
  if ( $sort_order =~ m/lpar/ ) {
    # sorting per LPARs
    print "<tr><td align=\"center\"><A HREF=\"/lpar2rrd-cgi/lpar-search.sh?LPAR=$pattern&entitle=$entitle&sort=hmc&referer=$html_base_en\" target=\"sample\"><B>HMC</B></A></td><td align=\"center\">&nbsp;&nbsp;<A HREF=\"/lpar2rrd-cgi/lpar-search.sh?LPAR=$pattern&entitle=$entitle&sort=&referer=$html_base_en\" target=\"sample\"><B>Server</B></A></td><td align=\"center\"><B>&nbsp;&nbsp;LPAR</B></td><td align=\"center\"><B>&nbsp;&nbsp;Last update</B></td></tr>";
  }
  else {
    if ($sort_order =~ m/hmc/ ) {
      # sorting per HMC/SDMC/IVM
      print "<tr><td align=\"center\"><B>HMC</B></td><td align=\"center\">&nbsp;&nbsp;<A HREF=\"/lpar2rrd-cgi/lpar-search.sh?LPAR=$pattern&entitle=$entitle&sort=&referer=$html_base_en\" target=\"sample\"><B>Server</B></A></td><td align=\"center\">&nbsp;&nbsp;<A HREF=\"/lpar2rrd-cgi/lpar-search.sh?LPAR=$pattern&entitle=$entitle&sort=lpar&referer=$html_base_en\" target=\"sample\"><B>LPAR</B></A></td><td align=\"center\"><B>&nbsp;&nbsp;Last update</B></td></tr>";
    }
    else {
      #sorting per server
      print "<tr><td align=\"center\"><A HREF=\"/lpar2rrd-cgi/lpar-search.sh?LPAR=$pattern&entitle=$entitle&sort=hmc&referer=$html_base_en\" target=\"sample\"><B>HMC</B></A></td><td align=\"center\">&nbsp;&nbsp;<B>Server</B></td><td align=\"center\">&nbsp;&nbsp;<A HREF=\"/lpar2rrd-cgi/lpar-search.sh?LPAR=$pattern&entitle=$entitle&sort=lpar&referer=$html_base_en\" target=\"sample\"><B>LPAR</B></A></td><td align=\"center\"><B>&nbsp;&nbsp;Last update</B></td></tr>";
    }
  }
}

print OUT "$uname $aix\n";

#print "<BR><BR>$html_base -- $html_base_en -- $referer -- $refer\n";

# start RRD via a pipe for getting last update of data in RRDTool files
RRDp::start "$rrdtool";

lpar_display ($pattern,$inputdir,\@out);

print "<tr><td colspan=\"5\" align=\"center\"><br><b>Search in current profile names</b><br></td></tr></n";

# profiles name search
lpar_display ($pattern,$inputdir,\@out_prof);

print "</table><br><br>\n";
print "Note you can use regular expressions for LPAR search (search is case non sensitive)\n";
print "</BODY></HTML>";

# close RRD pipe
RRDp::end;

close (OUT) if $DEBUG == 2;
exit (0);



sub lpar_display {
  my ($pattern,$inputdir,$out_tmp) = @_;
  my @out = @{$out_tmp};


  my $managedname_exl = "";
  my @m_excl = "";
  my $pattern_upper = uc($pattern);


  foreach my $line (@out) {
    chomp ($line);
    my $line_org = $line;
    $line =~ s/^.\///;
    $line =~ s/.rrh$//;
    $line =~ s/.rrm$//;
    (my $managed, my $hmc, my $lpar) =  split(/\//, $line);
    if ( $lpar eq '' ) {
      next;
    }

    if ( is_IP($managed) == 1 ) {
      next; # wrong entry from the HMC, a problem of the HMC or unconfigured server yet
    }
  
    # Exclude excluded managed systems
    my $managed_ok=1;
    if ( $managed_systems_exclude ne '' ) {
      @m_excl = split(/:/,$managed_systems_exclude);
      foreach $managedname_exl (@m_excl) {
        chomp($managedname_exl);
        if ( $managed =~ m/^$managedname_exl$/ ) {
          $managed_ok=0;
        }
      }
    }
    if ( $managed_ok == 0 ) {
        next;
    }
    my  $lpar_slash = $lpar;
    $lpar_slash =~ s/\&\&1/\//g;
    my $lpar_ok = $lpar_slash;
    #$lpar_slash =~ s/ /&nbsp;/g;
    my $managedn = $managed;
    #$managedn =~ s/ /&nbsp;/g;
    my $hmcn = $hmc; 
    #$hmcn =~ s/ /&nbsp;/g;

    # LPAR regex search
    my $lpar_upper = uc($lpar);
    if ( $lpar_upper !~ m/$pattern_upper/ && length($pattern_upper) > 0 ) {
      next;
    }
  
    #print "+++ $lpar $inputdir/data/$managed/$hmc/cpu.cfg\n";
    # open cpu.cfg to check if an LPAR is still exists (mostly due to LPM)
    my $cfg = "$inputdir/data/$managed/$hmc/cpu.cfg";
    if ( -f "$cfg" ) {
      my $found=1;
      open(FCFG, "< $cfg$RR") || next;
      foreach my $cline (<FCFG>) {
        $found=0;
        chomp ($cline);
        if ( $cline =~  m/^lpar_name=$lpar_slash,lpar_id=/ ) {
          $found=1;
          last; # lpar has been found, continue with displaing it
        }
      }
      close (FCFG);
      if ( $found == 0 ) {
        # lpar probbaly does not actually exist (removed/LPM)
        next;
      }
    }
    # end of checking if lpar exists
   
    print "<tr><td nowrap><A HREF=\"$html_base/$hmc/$managed/pool/index.html\" target=\"main\">$hmcn</A></td>";
    my $managed_unknown = $managedn;
    $managed_unknown =~ s/--unknown$//;
    print "<td nowrap>&nbsp;&nbsp;<A HREF=\"$html_base/$hmc/$managed/pool/index.html\" target=\"main\">$managed_unknown</A></td>";
    my $lpar_url = urlencode ($lpar_slash);
  
    print "<td nowrap>&nbsp;&nbsp;<a href=\"/lpar2rrd-cgi/detail.sh?host=$hmc&server=$managed&lpar=$lpar_url&item=lpar&entitle=$entitle&referer=$html_base_en&none=none\" target=\"sample\">$lpar_slash</a></td>";
    #print "<td nowrap>&nbsp;&nbsp;<A HREF=\"$html_base/$hmc/$managed/$lpar/index.html\" target=\"main\">$lpar_slash</A></td>";
    my $date = "";
    my $filesize = -s "$inputdir/data/$line_org";
    if ( $filesize > 0 ) {
      # lpars not being managed by HMC can have 0 size, exclude them here
      if ( -f "$inputdir/data/$line_org" ) {
        RRDp::cmd qq(last "$inputdir/data/$line_org" );
        my $last_rec = RRDp::read;
        chomp ($$last_rec);
        $date = strftime "%d.%m.%y %H:%M:%S", localtime($$last_rec);
      }
      else {
        # guess .rrm for profiles
        $line_org .= ".rrm";
        if ( ! -f "$inputdir/data/$line_org" ) {
          $line_org =~ s/rrm$/rrh/;
        }
        if ( -f "$inputdir/data/$line_org" ) {
          RRDp::cmd qq(last "$inputdir/data/$line_org" );
          my $last_rec = RRDp::read;
          chomp ($$last_rec);
          $date = strftime "%d.%m.%y %H:%M:%S", localtime($$last_rec);
        }
      }
    }
    my $os = "";
    if ( -f "$inputdir/data/$managed/$hmc/config.cfg" ) {
      if ( $aix == 1) {
        # AIX with grep -p support
        $os = `egrep -p \"^name\.\*    $lpar_ok\" $inputdir/data/"$managed"/"$hmc"/config.cfg|egrep \"^os_vers\"|head -1`;
      }
      else {
        $os = `egrep \"^name\.\*    $lpar_ok\" $inputdir/data/"$managed"/"$hmc"/config.cfg|egrep \"^os_vers\"|head -1`;
      }
      $os =~ s/^os_version//g;
      $os =~ s/  //g;
      $os =~ s/ /&nbsp;/g;
      $os =~ s/0.0.0.0.0.0//g; # IVM somehow do not suport that, it places there 0.0.0.0.0.0
    }
    else {
      $os = "";
    }
    $os =~ s/Unknown//;
    $date =~ s/ /&nbsp;/g;
    print OUT "$html_base -- $l -- $lpar $os $aix\n";
    if ( $aix == 1) {
      # AIX with grep -p support
      print "<td nowrap>&nbsp;&nbsp;$date</td><td nowrap>&nbsp;&nbsp;$os</td></tr>\n";
    }
    else {
      print "<td nowrap>&nbsp;&nbsp;$date</td></tr>\n";
    }
  }

}
  
sub urlencode {
    my $s = shift;
    $s =~ s/ /+/g;
    $s =~ s/([^A-Za-z0-9\+-_])/sprintf("%%%02X", ord($1))/seg;
    return $s;
}


# return 1 if the argument is valid IP, otherwise 0
sub is_IP
{
  my $ip = shift;

  if( $ip =~ /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/ && (($1<=255 && $2<=255 && $3<=255 && $4<=255 ))) {
     return 1;
  }
  else {
     return 0;
  }
}

