#!/bin/sh

pwd=`pwd`
if [ -d "etc" ]; then
   path="etc"
else
  if [ -d "../etc" ]; then
    path="../etc"
  else
    echo "problem with actual directory, assure you are in LPAR2RRD home"
    exit
  fi
fi
CFG="$pwd/$path/lpar2rrd.cfg"
. $CFG

HMC_USER=`egrep "HMC_USER=" $CFG|grep -v "#"| tail -1|awk -F = '{print $2}'`
HMC=`egrep "HMC_LIST=" $CFG|grep -v "#"| tail -1|awk -F = '{print $2}'|sed 's/"//g'`
SRATE=`egrep "SAMPLE_RATE=" $CFG|grep -v "#"| tail -1|awk -F = '{print $2}'`
SSH=`egrep "SSH=" $CFG|grep -v "#"| tail -1|awk -F = '{print $2}'`
TMP=/var/tmp/sample_rate.$$
rm -f $TMP

SSH=`echo $SSH|sed 's/"//g'`

echo "Going to check HMC as user $HMC_USER, will ask for a password if there is not allowed automatic access"
for i in $HMC
do
  MNAMES=`$SSH -l $HMC_USER $i "lssyscfg -r sys -F name"|sed 's/ /%20/g'|xargs`

  for j in $MNAMES
  do
    # Exclude excluded systems
    eval 'echo "$MANAGED_SYSTEMS_EXCLUDE" | egrep "^$j:|:$j:|:$j$|^$j$" >/dev/null 2>&1'
    if [ $? -eq 0 ]; then
      if [ $DEBUG -eq 1 ]; then echo "Excluding      : $j"; fi
      continue
    fi

    j_space=`echo $j|sed 's/%20/ /g'`
    RATE=`$SSH -l $HMC_USER $i "lslparutil -r config -m '"$j_space"' -F sample_rate "`
    if [ $SRATE -ne $RATE ]; then
      echo "$i:$j_space sample rate : $RATE, should be $SRATE"
      echo " $SSH -l hscroot $i \"chlparutil -r config -m $j_space -s $SRATE\"" >> $TMP
    else
      echo "$i:$j_space sample rate : $RATE, OK"
    fi
  done
done

if [ -f $TMP ]; then
  echo ""
  echo "Here are commands to fix it, just copy/paste it and provide password when you are prompted"
  echo "After fixing it run the script again to check whether it is ok now"
  cat $TMP

  echo ""
  echo "Optionaly you can do the same job globaly per the HMC"
  for i in `cut -f5  -d " " $TMP|sort|uniq`
  do
    echo " ssh -l hscroot $i \"chlparutil -r config $SRATE\""
  done
  rm -f $TMP
fi

