#!/bin/sh

# Load LPAR2RRD environment
CGID=`dirname $0`
if [ "$CGID" = "." ]; then
  CGID=`pwd`
fi
INPUTDIR_NEW=`dirname $CGID`
. $INPUTDIR_NEW/etc/lpar2rrd.cfg
INPUTDIR=$INPUTDIR_NEW
export INPUTDIR

BINDIR="$INPUTDIR/bin"
export BINDIR

TMPDIR="$INPUTDIR/tmp"
export TMPDIR

PERL5LIB=$PERL5LIB:$BINDIR
export PERL5LIB

umask 000
ERRLOG=/var/log/lpar2rrd/realt-error.log
export ERRLOG

# Load "magic" setup
if [ -f $INPUTDIR/etc/.magic ]; then
  . $INPUTDIR/etc/.magic
fi

exec $PERL $BINDIR/real-time.pl 2>>$ERRLOG

