#!/usr/bin/perl

use strict;
use Date::Parse;
use File::Basename;
use RRDp;
use POSIX qw(strftime);


my $alarm = 0;
my $graph_path = "";
my $graph_hours = 0; # $email_graph variable from alrt.pl --> EMAIL_GRAPH from alert.cfg
if ( $#ARGV > 0 && $ARGV[0] =~ m/alarm/ ) {
  # it is called from alrm.pl to generate a graph for alarming
  $graph_path = $ARGV[1]; 
  $graph_hours = $ARGV[2];
  $alarm=1;
  print "Graph creation : detail-graph-cgi.pl: $ARGV[0] $graph_path \n";
}

if ($alarm == 0) {
  # only for CGI-BIN purposes
  print "Content-type: image/png\n\n";
}

my $DEBUG = $ENV{DEBUG};
my $errlog = $ENV{ERRLOG};
my $bindir = $ENV{BINDIR};
my $basedir = $ENV{INPUTDIR};
my $rrdtool = $ENV{RRDTOOL};
my $pic_col = $ENV{PICTURE_COLOR};
my $STEP = $ENV{SAMPLE_RATE};
my $STEP_HEA=$ENV{STEP_HEA};;
my $width = 400;
my $height = 150;
my $width_trend = $width * 2;
my $detail_multipication = 3; # detail pop up will be 3 times bigger


my $wrkdir = $basedir."/data";

if ( -f "$bindir/premium.pl" ) {
  require "$bindir/premium.pl";
}
else {
  require "$bindir/standard.pl";
}


$DEBUG=2;
open(OUT, ">> $errlog")  if $DEBUG == 2 ;

# get QUERY_STRING
use Env qw(QUERY_STRING);
#$QUERY_STRING .= ":.";
#print OUT "-- $QUERY_STRING\n" if $DEBUG == 2 ;

my $STEP = $ENV{SAMPLE_RATE};
# --PH --> zjistit nejak jinak ... z rrdtool file??
my $pic_col = $ENV{PICTURE_COLOR};
my $basedir = $ENV{INPUTDIR};
my $rrdtool = $ENV{RRDTOOL};


( my $host, my $server, my $lpar, my $item, my $time, my $type_sam, my $detail, my $upper, my $amax,
  my $start_unix, my $end_unix, my $height_new, my $width_new ) = split(/&/,$QUERY_STRING);
 # `echo "$host:$server:$lpar:$item:$time:$type_sam:$detail:$upper:$amax:$start_unix:$end_unix:$height_new:$width_new" >> /tmp/e91`;

# no URL decode here, as it goes immediately into URL again
# --PH , yes URL decode must be here!!!

$host =~ s/host=//;
$host =~ s/\%([A-Fa-f0-9]{2})/pack('C', hex($1))/seg;
$host =~ s/\+/ /g;
$host =~ s/\//&&1/g; #slash workaround
$server =~ s/server=//;
$server =~ s/\%([A-Fa-f0-9]{2})/pack('C', hex($1))/seg;
$server =~ s/\+/ /g;
$server =~ s/\//&&1/g; #slash workaround
$lpar =~ s/lpar=//;
$lpar =~ s/%([\dA-Fa-f][\dA-Fa-f])/ pack ("C",hex ($1))/seg;
$lpar =~ s/\+/ /g;
$lpar =~ s/\//&&1/g; #slash workaround
$item =~ s/item=//;
$time =~ s/time=//;
$type_sam =~ s/type_sam=//;
$detail =~ s/detail=//;
$upper =~ s/upper=//;
my $name_out = "/var/tmp/lpar2rrd-$host-$server-$lpar-$item-$time-$type_sam-$$.png";
$name_out  =~ s/;//g; # ";" cannot be in the path

if ( $host eq '' || $server eq '' || $lpar eq '' ) {
  error ("One of passed args: hmc/server/lpar is null ($QUERY_STRING)");
  exit (1);
}

# parameters called only from historical reports, normally they are NULL
if ( ! $start_unix eq '' ) {
  $start_unix =~ s/sunix=//;
}
if ( ! $end_unix eq '' ) {
  $end_unix =~ s/eunix=//;
}
if ( ! $height_new eq '' && $detail == 0 ) {
  $height_new  =~ s/height=//;
  if ( isdigit($height_new) > 0 ) {
    $height = $height_new; #replace HEIGHT by passed one
  }
}
if ( ! $width_new eq '' && $detail == 0 ) {
  $width_new =~ s/width=//;
  if ( isdigit($width_new) > 0 ) {
    $width = $width_new; #replace WIDTH by passed one
  }
}


if ( $alarm == 1 ) {
  $name_out  = $graph_path;
}

if ( $detail == 1 ) {
  $width = $width * $detail_multipication;
  $width_trend = $width_trend * $detail_multipication;
  $height = $height * $detail_multipication;
}

# start RRD via a pipe
RRDp::start "$rrdtool";

my $ret = create_graph ($host,$server,$lpar,$item,$time,$name_out,$type_sam,$upper,$alarm,$graph_hours,$amax,$start_unix,$end_unix);

# close RRD pipe
RRDp::end;

if ( $alarm == 0 && $ret == 1 ) {
  print_png($name_out);
}

close(OUT)  if $DEBUG == 2;

exit (0);

sub create_graph
{
  my $host = shift;     
  my $server = shift;     
  my $lpar = shift;     
  my $item = shift;     
  my $time = shift;
  my $name_out = shift;     
  my $type_sam = shift;
  my $upper = shift;
  my $alarm = shift;
  my $graph_hours = shift;
  my $amax = shift;
  my $start_unix = shift;
  my $end_unix = shift;
  my $text = "";
  my $done = 0;

  #print OUT "$host:$server:$item:$lpar:$time:$name_out:$type_sam\n";
  #`echo "$host:$server:$item:$lpar:$time:$name_out:$type_sam" >> /tmp/e91`;
  if ( $item =~ m/^lpar$/ ){  graph_lpar   ($host,$server,$lpar,$time,$name_out,$type_sam,$upper,$detail,$graph_hours); $done=1;}
  if ( $item =~ m/^pool$/ ){  graph_pool   ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$graph_hours); $done=1;}
  if ( $item =~ m/shpool/ ){  graph_shpool ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$graph_hours); $done=1;}
  if ( $item =~ m/custom$/ ){  graph_custom      ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,"custom-group"); $done=1;}
  if ( $item =~ m/custommem$/ ){  graph_custom   ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,"custom-group-mem"); $done=1;}
  if ( $item =~ m/custommemos$/ ){  graph_custom ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,"custom-group-mem-os"); $done=1;}
  if ( $item =~ m/lparagg/){  graph_lparagg($host,$server,$lpar,$time,$name_out,$type_sam,$detail); $done=1;}
  if ( $item =~ m/trend/ ) {  graph_trend  ($host,$server,$lpar,$time,$name_out,$type_sam,$detail); $done=1;}
  if ( $item =~ m/ams/ )   {  graph_ams    ($host,$server,$lpar,$time,$name_out,$type_sam,$detail); $done=1;}
  if ( $item =~ m/lpm/ )   {  graph_lpm    ($host,$server,$lpar,$time,$name_out,$type_sam,$detail); $done=1;}
  if ( $item =~ m/hea/ )   {  graph_hea    ($host,$server,$lpar,$time,$name_out,$type_sam,$detail); $done=1;}
  if ( $item =~ m/^oscpu/) {  graph_oscpu  ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$item,$start_unix,$end_unix); $done=1;} 
  if ( $item =~ m/^lan/ )  {  graph_ent    ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$item,$start_unix,$end_unix); $done=1;}
  if ( $item =~ m/^san1/ ) {  graph_ent    ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$item,$start_unix,$end_unix); $done=1;}
  if ( $item =~ m/^san2/ ) {  graph_ent    ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$item,$start_unix,$end_unix); $done=1;}
  if ( $item =~ m/^sea/ )   {  graph_ent    ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$item,$start_unix,$end_unix); $done=1;}
  if ( $item =~ m/^pagingagg/ )   {  graph_osmem_agg    ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$item,$amax); $done=1;}
#  if ( $item =~ m/^tps/ ) {  graph_tps_lparagg    ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$item); $done=1;}
  if ( $item =~ m/^pg2/ )  {  graph_ent    ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$item,$start_unix,$end_unix); $done=1;}
  if ( $item =~ m/^slan/ ) {  graph_ent_sum    ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$item); $done=1;}
  if ( $item =~ m/^ssan1/) {  graph_ent_sum    ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$item); $done=1;}
  if ( $item =~ m/^ssan2/) {  graph_ent_sum    ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$item); $done=1;}
  if ( $item =~ m/^ssea/ ) {  graph_ent_sum    ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$item); $done=1;}
  if ( $item =~ m/^ame_mem/ )   {  graph_ame_mem    ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$start_unix,$end_unix); $done=1;}
  if ( $item =~ m/^codused$/ )  {  graph_cod_used    ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$graph_hours); $done=1;}
  if ( $item =~ m/^codunreport$/ ) {  graph_cod_unreport($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$graph_hours); $done=1;}
  if ( $item =~ m/^mem$/ ) { graph_osmem  ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$start_unix,$end_unix); $done=1;}
  if ( $item =~ m/^pg1$/ ) { graph_paging ($host,$server,$lpar,$time,$name_out,$type_sam,$detail,$start_unix,$end_unix); $done=1;}
  if ( $item =~ m/^multihmclpar$/ ){  graph_multihmclpar ($host,$server,$lpar,$time,$name_out,$type_sam,$detail); $done=1;}
  if ( $item =~ m/^multihmc$/ ) { graph_multihmc ($host,$server,$lpar,$time,$name_out,$type_sam,$detail); $done=1;}

  if ( $done == 0 ) {
    error ("Graph rrdtool error : create_graph: $item");
    return 0;
  }


  return 1;
}


# Print the png out
sub print_png {
   my $name_out = shift;

   if ( ! -f "$name_out" ) {
     error ("Graph rrdtool error : print_png : file does not exist : $name_out");
     return 0;
   }

   open(PNG, "< $name_out") || error("Cannot open  $name_out: $!".__FILE__.":".__LINE__) && return 0;
   binmode(PNG);
   while (read(PNG,$b,4096)) {
      print "$b";
   }
   close (PNG);
   unlink ("$name_out");

   return 1;
}

# error handling
sub error
{
  my $text = shift;
  my $act_time = localtime();
  my $basedir = $ENV{INPUTDIR};
  chomp ($text);

  #print "ERROR          : $text : $!\n";
  print STDERR "$act_time: $text : $!\n";

  if ( $alarm == 1 ) {
    print "$act_time: $text : $!\n";
    return 1;
  }

  # print error picture to check error-cgi.log or web error log
  open(PNG, "< $basedir/html/error.png") || error("Cannot open  $basedir/html/error.png: $!".__FILE__.":".__LINE__) && return 0;
  binmode(PNG);
  while (read(PNG,$b,4096)) {
    print "$b";
  }
  close (PNG);

  return 1;
}



sub graph_hea  
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;

  return 0;
}

sub graph_lpar 
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $upper = shift;
  my $detail = shift;
  my $graph_hours = shift;
  my $text = "";
  my $step = 60; # --PH dodelat --> no problem it could be here 60 fixed
  my $xgrid = "";
  my $t="COMMENT: ";
  my $t2="COMMENT:\\n";
  my $step_new = $step;
  my $last ="COMMENT: ";
  my $rigid = "\n --rigid";
  my $font_def =  "--font=DEFAULT:8:";
  my $font_tit =  "--font=TITLE:9:";

  my $keep_virtual = 0;
  if ( $ENV{KEEP_VIRTUAL} )  {
    $keep_virtual = $ENV{KEEP_VIRTUAL}; # keep number of virt processors in RRD --> etc/.magic
  }
  else {
    $keep_virtual = 0;
  }

  #print "001 $host:$server:$lpar:$name_out:$type_sam\n";

  if ( $upper eq '' || $upper == 0) {
    $upper=0.1;
  }
  
  if ( $detail == 1 ) {
    $font_def =  "--font=DEFAULT:10:";
    $font_tit =  "--font=TITLE:13:";
  }

  if ( $type =~ m/d/ ) { 
    $text="day";     
    if ( $detail == 0 ) {
      $xgrid="MINUTE:60:HOUR:2:HOUR:4:0:%H";
    }
    else {
      $xgrid="MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
  }
  if ( $type =~ m/w/ ) { 
    $text="week";    
    if ( $detail == 0 ) {
      $xgrid="HOUR:8:DAY:1:DAY:1:0:%a";
    }
    else {
      $xgrid="HOUR:12:HOUR:6:HOUR:12:0:%a %H";
    }
  }
  if ( $type =~ m/m/ ) { 
    $text="4 weeks"; 
    if ( $detail == 0 ) {
      $xgrid="DAY:1:DAY:2:DAY:7:0:%U";
    }
    else {
      $xgrid="HOUR:12:DAY:1:DAY:1:0:%d";
    }
  }
  if ( $type =~ m/y/ ) { 
    $text="year";    
    if ( $detail == 0 ) {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
    else {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
  }

  if ( $text eq '' ) {
    error ("Graph rrdtool error : graph_lpar: $type");
    return (0);
  }

  my $rrd= "$wrkdir/$server/$host/$lpar.rr$type_sam";

  my $lpar_slash = $lpar;
  $lpar_slash =~ s/\&\&1/\//g;   # to show slash and not &&1 which is general replacemnt for it
  my $header = "LPAR: $lpar_slash : last $text";

  if ($type =~ "d" && $graph_hours == 0 ) {
    RRDp::cmd qq(last "$rrd");
    my $last_tt = RRDp::read;    
    chomp ($$last_tt);
    my $l=localtime($$last_tt);
    # following must be for RRD 1.2+
    $l =~ s/:/\\:/g;
    $t ="COMMENT:Updated\\: $l ";

    # get LAST value from RRD
    RRDp::cmd qq(fetch "$rrd" "AVERAGE" "-s $$last_tt-$step" "-e $$last_tt-$step");
    my $row = RRDp::read;
    chomp($$row);
    my @row_arr = split(/\n/,$$row);
    my $m = "";
    my $i = 0;

    foreach $m (@row_arr) {
      chomp($m);
       $i++;
       if ( $i == 3 ) {
         my @m_arr = split(/ /,$m);
         # go further ony if it is a digit (avoid it when NaNQ (== no data) is there)
         if ($m_arr[1] =~ /\d/ && $m_arr[2] =~ /\d/ && $m_arr[3] =~ /\d/ && $m_arr[4] =~ /\d/ ) {
           #print "m : $m\n" if $DEBUG ;
           #print "\n$m_arr[1] $m_arr[2]" if $DEBUG ;
           my $entitled_cycles =  1;
           my $capped_cycles   =  1;
           my $uncapped_cycles =  1;
           my $curr_proc       =  1;

           if ( $keep_virtual == 1 ) {
	     # when KEEP_VIRTUAL then virtual_procs is the second field
             $entitled_cycles = sprintf("%e",$m_arr[3]);
             $capped_cycles   = sprintf("%e",$m_arr[4]);
             $uncapped_cycles = sprintf("%e",$m_arr[5]);
             $curr_proc       = sprintf("%e",$m_arr[1]);
           }
           else {
             $entitled_cycles = sprintf("%e",$m_arr[2]);
             $capped_cycles   = sprintf("%e",$m_arr[3]);
             $uncapped_cycles = sprintf("%e",$m_arr[4]);
             $curr_proc       = sprintf("%e",$m_arr[1]);
           }
           if ( $entitled_cycles != 0 ) {
             my $util = sprintf ("%5.2f",($capped_cycles + $uncapped_cycles) / $entitled_cycles) * $curr_proc;
	       #print ("\n $util $curr_proc $entitled_cycles $capped_cycles $uncapped_cycles\n");
           
             $last ="COMMENT:Last utilization in CPU cores  $util";
	     }
         }
       }
    }
  };  

  if ( $type =~ "y" ) {
    $step_new=86400;
  }

  if ( ! -f "$rrd" ) {
     if ( $type_sam =~ "d" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one day!!!\n";
       error ("$rrd does not exists");
     }
     if ( $type_sam =~ "h" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one hour!!!\n";
       error ("$rrd does not exists");
     }
     if ( $type_sam =~ "m" ) {
       error ("$rrd does not exists");
     }
     return 0;
  }

  my $start_time = "now-1$type";
  if ( $graph_hours > 0 ) {
    # alerting
    $start_time = "now-".$graph_hours."h";
    if ( $graph_hours < 12 ) {
      $xgrid="MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
    else {
      if ( $graph_hours > 24 ) {
        $xgrid="MINUTE:60:HOUR:2:HOUR:4:0:%H";
      }
      else {
        $xgrid="MINUTE:60:HOUR:2:HOUR:2:0:%H";
      }
    }  
  }

  #print "creating graph : $host:$server:$lpar_slash:$type_sam:$type:$name_out:$rrd\n" if $DEBUG ;
  RRDp::cmd qq(graph "$name_out"
      "--title" "$header"
      "--start" "$start_time"
      "--end" "now-1$type+1$type"
      "--imgformat" "PNG"
      "--slope-mode"
      "--width=$width"
      "--height=$height"
      "--step=$step_new"
      "--lower-limit=0.00"
      "--color=BACK#$pic_col"
      "--color=SHADEA#$pic_col"
      "--color=SHADEB#$pic_col"
      "--color=CANVAS#$pic_col"
      "--alt-autoscale-max"
      "--interlaced" 
      "--upper-limit=$upper"   
      "$font_def"
      "$font_tit"
      "--vertical-label=CPU cores"
      "--units-exponent=1.00"
      "--alt-y-grid"
      "--x-grid=$xgrid"
      "DEF:cur=$rrd:curr_proc_units:AVERAGE"
      "DEF:ent=$rrd:entitled_cycles:AVERAGE"
      "DEF:cap=$rrd:capped_cycles:AVERAGE"
      "DEF:uncap=$rrd:uncapped_cycles:AVERAGE"
      "CDEF:tot=cap,uncap,+"
      "CDEF:util=tot,ent,/"
      "CDEF:utilperct=util,100,*"
      "CDEF:utiltot=util,cur,*"
      "COMMENT:   Average   \\n"
      "AREA:cur#00FF00: Entitled processor cores"
      "GPRINT:cur:AVERAGE: %3.1lf"
      "$t2"
      "LINE1:utiltot#FF0000: Utilization in CPU cores"
      "GPRINT:utiltot:AVERAGE: %3.2lf"
      "PRINT:utiltot:AVERAGE: %3.2lf"
      "$t2"
      "COMMENT:Entitled CPU utilization  "
      "GPRINT:utilperct:AVERAGE: %4.1lf"
      "COMMENT:\%"
      "$t2"
      "$last"
      "$t2"
      "$t"
      "HRULE:0#000000"
      "VRULE:0#000000"
  );
  my $answer = RRDp::read; 
  if ( $$answer =~ "ERROR" ) {
    error ("$host:$server Graph rrdtool error : $$answer");
    if ( $$answer =~ "is not an RRD file" ) {
      (my $err,  my $file, my $txt) = split(/'/,$$answer);
      error ("It need to be removed due to corrpution: $file");
    }
    else {
      error ("Graph rrdtool error : $$answer");
    }
    return 0;
  }

  return 0;
}

sub graph_trend
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;
  my $step = 60; # --PH dodelat --> no problem it could be here 60 fixed
  my $t="COMMENT: ";
  my $t2="COMMENT:\\n";
  my $step_new = $step;
  my $last ="COMMENT: ";
  my $xgrid = "MONTH:1:MONTH:1:MONTH:1:0:%b";


  my $rrd= "$wrkdir/$server/$host/$lpar.rr$type_sam";

  my $lpar_slash = $lpar;
  $lpar_slash =~ s/\&\&1/\//g;   # to show slash and not &&1 which is general replacemnt for it
  my $header = "LPAR: $lpar_slash : last year";

  if ( $type =~ "y" ) {
    $step_new=86400;
  }

  # Trend for yearly chart 1y back  + 1y forward
  #print "creating graph : $host:$server:$lpar:$type_sam:$type:trend\n" if $DEBUG ;
  #error ( "creating graph : $host:$server:$lpar:$type_sam:$type:trend");

  RRDp::cmd qq(graph "$name_out"
    "--title" "$header - trends"
    "--start" "now-1$type"
    "--end" "now+1$type"
    "--imgformat" "PNG"
    "--slope-mode"
    "--width=$width_trend"
    "--height=$height"
    "--step=$step_new"
    "--color=BACK#$pic_col"
    "--color=SHADEA#$pic_col"
    "--color=SHADEB#$pic_col"
    "--color=CANVAS#$pic_col"
    "--upper-limit=0.1"
    "--lower-limit=0"
    "--alt-autoscale-max"
    "--interlaced" 
    "--vertical-label=CPU cores"
    "--units-exponent=1.00"
    "--alt-y-grid"
    "--x-grid=$xgrid"
    "DEF:curd=$rrd:curr_proc_units:AVERAGE:start=-1m"
    "DEF:curm=$rrd:curr_proc_units:AVERAGE:start=-3m"
    "DEF:cury=$rrd:curr_proc_units:AVERAGE:start=-1y"
    "DEF:cur=$rrd:curr_proc_units:AVERAGE"
    "DEF:entd=$rrd:entitled_cycles:AVERAGE:start=-1m"
    "DEF:entm=$rrd:entitled_cycles:AVERAGE:start=-3m"
    "DEF:enty=$rrd:entitled_cycles:AVERAGE:start=-1y"
    "DEF:ent=$rrd:entitled_cycles:AVERAGE"
    "DEF:capd=$rrd:capped_cycles:AVERAGE:start=-1m"
    "DEF:capm=$rrd:capped_cycles:AVERAGE:start=-3m"
    "DEF:capy=$rrd:capped_cycles:AVERAGE:start=-1y"
    "DEF:cap=$rrd:capped_cycles:AVERAGE"
    "DEF:uncapd=$rrd:uncapped_cycles:AVERAGE:start=-1m"
    "DEF:uncapm=$rrd:uncapped_cycles:AVERAGE:start=-3m"
    "DEF:uncapy=$rrd:uncapped_cycles:AVERAGE:start=-1y"
    "DEF:uncap=$rrd:uncapped_cycles:AVERAGE"
    "CDEF:totd=capd,uncapd,+"
    "CDEF:totm=capm,uncapm,+"
    "CDEF:toty=capy,uncapy,+"
    "CDEF:tot=cap,uncap,+"
    "CDEF:utild=totd,entd,/"
    "CDEF:utilm=totm,entm,/"
    "CDEF:utily=toty,enty,/"
    "CDEF:util=tot,ent,/"
    "CDEF:utilperct=util,100,*"
    "CDEF:utiltotd=utild,curd,*"
    "CDEF:utiltotm=utilm,curm,*"
    "CDEF:utiltoty=utily,cury,*"
    "CDEF:utiltot=util,cur,*"
    "VDEF:Dd=utiltotd,LSLSLOPE"
    "VDEF:Hd=utiltotd,LSLINT"
    "CDEF:utiltottrendd=utiltotd,POP,Dd,COUNT,*,Hd,+"
    "VDEF:Dm=utiltotm,LSLSLOPE"
    "VDEF:Hm=utiltotm,LSLINT"
    "CDEF:utiltottrendm=utiltotm,POP,Dm,COUNT,*,Hm,+"
    "VDEF:Dy=utiltoty,LSLSLOPE"
    "VDEF:Hy=utiltoty,LSLINT"
    "CDEF:utiltottrendy=utiltoty,POP,Dy,COUNT,*,Hy,+"
    "COMMENT:   Average   \\n"
    "AREA:cur#00FF00: Entitled processor cores "
    "GPRINT:cur:AVERAGE: %4.2lf"
    "$t2"
    "LINE1:utiltot#FF0000: Utilization in CPU cores"
    "GPRINT:utiltot:AVERAGE: %5.2lf"
    "$t2"
    "COMMENT:Entitled CPU utilization   "
    "GPRINT:utilperct:AVERAGE: %4.2lf"
	  "COMMENT:\%"
    "$t2"
    "LINE2:utiltottrendd#FFFF00: Utilization in CPU cores - last 1 month trend"
    "$t2"
    "LINE2:utiltottrendm#80FFFF: Utilization in CPU cores - last 3 months trend"
    "$t2"
    "LINE2:utiltottrendy#FF8080: Utilization in CPU cores - last year trend"
    "$last"
    "$t2"
    "$t"
    "HRULE:0#000000"
    "VRULE:0#000000"
  );
  my $answer = RRDp::read; 
  if ( $$answer =~ "ERROR" ) {
    error ("$host:$server Graph rrdtool error : $$answer");
    if ( $$answer =~ "is not an RRD file" ) {
      (my $err,  my $file, my $txt) = split(/'/,$$answer);
      error ("It need to be removed due to corrpution: $file");
    }
    else {
      error ("Graph rrdtool error : $$answer");
    }
  }

  return 0;
}

sub graph_ams 
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;
  my $text = "";
  my $step = 60; # --PH dodelat --> no problem it could be here 60 fixed
  my $xgrid = "";
  my $t="COMMENT: ";
  my $t2="COMMENT:\\n";
  my $step_new = $step;
  my $last ="COMMENT: ";
  my $font_def =  "--font=DEFAULT:8:";
  my $font_tit =  "--font=TITLE:9:";

  if ( $detail == 1 ) {
    $font_def =  "--font=DEFAULT:10:";
    $font_tit =  "--font=TITLE:13:";
  }
  if ( $type =~ m/d/ ) {
    $text="day";
    if ( $detail == 0 ) {
      $xgrid="MINUTE:60:HOUR:2:HOUR:4:0:%H";
    }
    else {
      $xgrid="MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
  }
  if ( $type =~ m/w/ ) {
    $text="week";
    if ( $detail == 0 ) {
      $xgrid="HOUR:8:DAY:1:DAY:1:0:%a";
    }
    else {
      $xgrid="HOUR:12:HOUR:6:HOUR:12:0:%a %H";
    }
  }
  if ( $type =~ m/m/ ) {
    $text="4 weeks";
    if ( $detail == 0 ) {
      $xgrid="DAY:1:DAY:2:DAY:7:0:%U";
    }
    else {
      $xgrid="HOUR:12:DAY:1:DAY:1:0:%d";
    }
  }
  if ( $type =~ m/y/ ) {
    $text="year";
    if ( $detail == 0 ) {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
    else {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
  }

  if ( $text eq '' ) {
    error ("Graph rrdtool error : graph_ams: $type");
    return (0);
  }


  if ( $lpar eq '' ) {
    return 0; # some workaround, it should not go here
  }

  my $rrd= "$wrkdir/$server/$host/$lpar.rm$type_sam";
  # print "001 AMS $rrd\n";

  my $lpar_slash = $lpar;
  $lpar_slash =~ s/\&\&1/\//g;   # to show slash and not &&1 which is general replacemnt for it
  my $header = "LPAR Memory: $lpar_slash : last $text";

  if ($type =~ "d") {
    RRDp::cmd qq(last "$rrd");
    my $last_tt = RRDp::read;    
    chomp ($$last_tt);
    my $l=localtime($$last_tt);
    # following must be for RRD 1.2+
    $l =~ s/:/\\:/g;
    $t ="COMMENT:Updated\\: $l ";

    # get LAST value from RRD
    RRDp::cmd qq(fetch "$rrd" "AVERAGE" "-s $$last_tt-$step" "-e $$last_tt-$step");
    my $row = RRDp::read;
    chomp($$row);
    my @row_arr = split(/\n/,$$row);
    my $m = "";
    my $i = 0;

    foreach $m (@row_arr) {
      chomp($m);
       $i++;
       if ( $i == 3 ) {
         my @m_arr = split(/ /,$m);
         # go further ony if it is a digit (avoid it when NaNQ (== no data) is there)
         if ($m_arr[1] =~ /\d/ && $m_arr[2] =~ /\d/ ) {
           #print "m : $m\n" if $DEBUG ;
           #print "\n$m_arr[1] $m_arr[2]" if $DEBUG ;

           #my $curr_mem = sprintf("%e",$m_arr[1]);
           #my $phys_run_mem    = sprintf("%e",$m_arr[2]);
           if ( $m_arr[2] > 0 ) {
             my $last_mem = sprintf( "%6.2d",$m_arr[2]) / 1024;
             my $last_mem_g = sprintf( "%.2f",$m_arr[2] / 1024);
             $last ="COMMENT:Last memory consuption in GB         $last_mem_g";
           }
         }
       }
    }
  };  

  if ( $type =~ "y" ) {
    $step_new=86400;
  }

  if ( ! -f "$rrd" ) {
     if ( $type_sam =~ "d" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one day!!!\n";
       error ("$rrd does not exists");
     }
     if ( $type_sam =~ "h" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one hour!!!\n";
       error ("$rrd does not exists");
     }
     if ( $type_sam =~ "m" ) {
       #print "\n$rrd does not exists\n";
       error ("$rrd does not exists");
     }
     return 0;
  }

  #print "graphing AMS   : $host:$server:$lpar_slash:$type_sam:$type\n" if $DEBUG ;
  RRDp::cmd qq(graph "$name_out"
      "--title" "$header"
      "--start" "now-1$type"
      "--end" "now-1$type+1$type"
      "--imgformat" "PNG"
      "--slope-mode"
      "--width=$width"
      "--height=$height"
      "--step=$step_new"
      "--lower-limit=0.00"
      "--color=BACK#$pic_col"
      "--color=SHADEA#$pic_col"
      "--color=SHADEB#$pic_col"
      "--color=CANVAS#$pic_col"
      "--alt-autoscale-max"
      "--interlaced" 
      "--upper-limit=0.1"
      "--vertical-label= Memory in GB"
      "--units-exponent=1.00"
      "--alt-y-grid"
      "--x-grid=$xgrid"
      "$font_def"
      "$font_tit"
      "DEF:ent=$rrd:curr_mem:AVERAGE"
      "DEF:cur=$rrd:phys_run_mem:AVERAGE"
      "DEF:io=$rrd:io_ent:AVERAGE"
      "CDEF:entg=ent,1024,/"
      "CDEF:curg=cur,1024,/"
      "CDEF:iog=io,1024,/"
      "COMMENT:   Average   \\n"
      "AREA:entg#00FF00: Current allocated memory    "
      "GPRINT:entg:AVERAGE: %6.2lf"
      "$t2"
      "LINE1:iog#0080FF: Current allocated IO memory "
      "GPRINT:iog:AVERAGE: %6.2lf"
      "PRINT:iog:AVERAGE: %6.2lf"
      "$t2"
      "LINE1:curg#FF0000: Actuall physical consumption"
      "GPRINT:curg:AVERAGE: %6.2lf"
      "PRINT:curg:AVERAGE: %6.2lf"
      "$t2"
      "$last"
      "$t2"
      "$t"
      "HRULE:0#000000"
      "VRULE:0#000000"
  );
  my $answ = RRDp::read; 
  if ( $$answ =~ "ERROR" ) {
    error ("$host:$server Graph rrdtool error : $$answ");
    if ( $answ =~ "is not an RRD file" ) {
      (my $err,  my $file, my $txt) = split(/'/,$answ);
      error ("It need to be removed due to corruption: $file");
    }
    else {
      error ( "Graph rrdtool error : $answ");
    }
  }

  return 0;
}

sub graph_ent_sum
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;
  my $item = shift;       # "slan" or "ssan1" or "ssan2" or "ssea"
  my $text = "";
  my $step = 60; # --PH dodelat --> no problem it could be here 60 fixed
  my $xgrid = "";
  my $t="COMMENT: ";
  my $t2="COMMENT:\\n";
  my $step_new = $step;
  my $last ="COMMENT: ";
  my $font_def =  "--font=DEFAULT:8:";
  my $font_tit =  "--font=TITLE:9:";
  my $start_time = "now-1$type";
  my $end_time = "now-1$type+1$type";

  if ( $detail == 1 ) {
    $font_def =  "--font=DEFAULT:10:";
    $font_tit =  "--font=TITLE:13:";
  }
  if ( $type =~ m/m/ ) {
    $text="4 weeks";
    if ( $detail == 0 ) {
      $xgrid="DAY:1:DAY:2:DAY:7:0:%U";
    }
    else {
      $xgrid="HOUR:12:DAY:1:DAY:1:0:%d";
    }
  }
  if ( $type =~ m/y/ ) {
    $text="year";
    if ( $detail == 0 ) {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
    else {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
  }

  if ( $text eq '' ) {
    error ("Graph rrdtool error : graph_ent_sum : $type");
    return (0);
  }

  if ( $lpar eq '' ) {
    return 0; # some workaround, it should not go here
  }
  my $dir = "$wrkdir/$server/$host/$lpar/";
  my $lpar_slash = $lpar;
  $lpar_slash =~ s/\&\&1/\//g;   # to show slash and not &&1 which is general replacement for it

  my $fpn = "lan";   # according to $item
  my $gpr_ave = "5.1lf";
  my $gpr_max = "6.1lf";
  my $divider = 1073741824;
  my $header = "LPAR ETH: $lpar_slash : last $text";
  my $twrite = "WRITE    ";
  my $tread  = "READ     ";
  my $ds_name1 = "recv_bytes";
  my $ds_name2 = "trans_bytes";
   if ( $item eq "slan" ) {
        $ds_name2 = "recv_bytes";
        $ds_name1 = "trans_bytes";
        $twrite = "WRITE/OUT";
        $tread  = "READ/IN  "
   }
  my $headline1 = "COMMENT:[ GB ]           Max";
  my $headline2 = "COMMENT:Interface     READ (Max)          WRITE (Max)";
  my $vertical_label = "Read - Bytes - Write";
  if ( $item eq "ssan1" ) {
     $fpn = "san-fcs" ;
     $header = "LPAR FCS: $lpar_slash : last $text";
  }
    if ( $item eq "ssea" ) {
     $fpn = "sea-ent" ;
     $header = "LPAR SEA: $lpar_slash : last $text";
     $ds_name2 = "recv_bytes";
     $ds_name1 = "trans_bytes";
     $twrite = "WRITE/OUT";
     $tread  = "READ/IN  "
  }
  if ( $item eq "ssan2" ) {
     $gpr_ave = "8.0lf";
     $gpr_max = "8.0lf";
     $divider = 1;
     $fpn = "san-fcs" ;
     $header = "LPAR IOPS: $lpar_slash : last $text";
     $ds_name1 = "iops_in";
     $ds_name2 = "iops_out";
     $headline1 = "COMMENT:[ IO/day ]        Max";
     $headline2 = "COMMENT:Interface     READ (Max)          WRITE (Max)";
     $vertical_label = "IO requests";
  }

  my @files;
  opendir(my $dh, $dir) || error ("can't opendir $dir: $! :".__FILE__.":".__LINE__) && return 0;
  my @files_unsorted = grep { /^$fpn/ && /\.mmm$/ } readdir($dh);
  @files = sort @files_unsorted;
  closedir $dh;

  my $col_indx = 0;
  my $line_indx = 0; # place enter every 3rd line
  my $file = "";
  my $cmd = "";
  my $j = 0;
  my $act_time = localtime();
  my $act_time_u = time();
  my $req_time = 0;
  my (@recb, @trab, @rname, @rpath, @avgx);
  my $days = 32;
  if ( "$type" =~ "m" ) {
    $req_time = $act_time_u - 2764800;
  }
  # for daily, must be even type as for IVM/SDMC it is not in $type_sam =~ "d"
  if ( $type_sam =~ "d"  || "$type" =~ "y" ) {
    $req_time = $act_time_u - 31536000;
    $days = 365; 
  }
  if ( $type =~ "y" ) {
     $step_new=86400;
  }

  #print "graphing ENT_SUM   : $host:$server:$lpar_slash:$type_sam:$type\n" if $DEBUG ;


     $cmd .= 'RRDp::cmd qq(graph "$name_out"
        "--title" "$header"
        "--start" "$start_time"
        "--end" "$end_time"
        "--imgformat" "PNG"
        "--slope-mode"
        "--width=$width"
        "--height=$height"
        "--step=86400"
        "--color=BACK#$pic_col"
        "--color=SHADEA#$pic_col"
        "--color=SHADEB#$pic_col"
        "--color=CANVAS#$pic_col"
        "--alt-autoscale-max"
        "--interlaced"
        "--vertical-label=$vertical_label"
        "--alt-y-grid"
        "--x-grid=$xgrid"
        "--base=1024"
        "$font_def"
        "$font_tit"
        "$headline1"
        "$t2"
';
# sum the databases
# take care: if all dtbs are old means nothing to graph
#            either only one dtb or more dtbs
  my $i = 0;
  my $summ_r = "";
  my $summ_w = "";
  my $count_avg_day = "";

  foreach $file (@files) {
    chomp($file);

    my $rrd = "$wrkdir/$server/$host/$lpar/$file";
    # avoid old files which do not exist in the period
    my $rrd_upd_time = (stat("$rrd"))[9];
    if ( $rrd_upd_time < $req_time ) {
      next;
    }
    if ($i == 0) {   # prepare better AVG
      $count_avg_day = rrd_running_days($rrd,$days);
      if ( ! ($count_avg_day eq ($count_avg_day+0))) {
         error ("error in rrd_running : $count_avg_day ");
         $count_avg_day = 1;
      }
      else {
         if ( "$type" =~ "m" ) { 
            $count_avg_day = 32 / $count_avg_day ;
         }
         else {
            $count_avg_day = 365 / $count_avg_day ;
         } 
      }
    }
    my $rrd_name = $file;
    $rrd_name =~ s/.mmm//;
    $rrd_name =~ s/lan-//;
    $rrd_name =~ s/san-//;
    $rrd_name =~ s/sea-//;
    $rrd_name = sprintf("%-8",$rrd_name);  #add spaces, 8 chars tot - format graph legend

    #print "graph_ent_sum $wrkdir/$server/$host/$lpar/$file 
            #  $rrd_upd_time $req_time $act_time\n" if ( $DEBUG == 3);

  # print "001 ENT SUM $rrd\n";

 $rname[$i] = "$rrd_name";   # for graphing
 $rpath[$i] = "$rrd";
 $recb[$i]  = "rcb${i}";
 $trab[$i]  = "trb${i}";
 $avgx[$i]  = "avg${i}";

# `echo "809: detail-graph-cgi - $rrd_name:$rrd:rcb${i}:trb${i}:$font_def:$font_tit" >> /tmp/e099`;

 $cmd .= '"DEF:$recb[$i]=$rpath[$i]:$ds_name1:AVERAGE"
          "CDEF:$recb[$i]_n=$recb[$i],UN,0,$recb[$i],IF"
          "DEF:$trab[$i]=$rpath[$i]:$ds_name2:AVERAGE"
          "CDEF:$trab[$i]_n=$trab[$i],UN,0,$trab[$i++],IF"
';
   if ($i == 0) {
      $summ_r = $recb[$i]."_n"; 
      $summ_w = $trab[$i]."_n"
   }
   else {
      $summ_r .=",".$recb[$i]."_n,+";
      $summ_w .=",".$trab[$i]."_n,+"
   }
   $i++;  
  } # end of foreach

  if ( $i == 0 ) {
    error ("$host:$server:$lpar_slash Graph rrdtool error : no active dbs ETH,FCS,SEA ");
  return 0
  }
#  "GPRINT:trans_smb_n:AVERAGE: %$gpr_ave"
#   "GPRINT:recv_smb_n:AVERAGE: %$gpr_ave"  

  $cmd .= '"CDEF:recv=$summ_r"
           "CDEF:trans=$summ_w"
           "CDEF:recv_s=recv,86400,*"
           "CDEF:recv_smb=recv_s,$divider,/"
           "CDEF:recv_smb_n=recv_smb,$count_avg_day,*"
           "CDEF:trans_s=trans,86400,*"
           "CDEF:trans_smb=trans_s,$divider,/"
           "CDEF:trans_smb_n=trans_smb,$count_avg_day,*"
           "CDEF:recv_neg=0,recv_s,-"
           "AREA:trans_s#FFFF00:$twrite "
           "GPRINT:trans_smb:MAX: %$gpr_max"
           "$t2"
           "AREA:recv_neg#00FF00:$tread "
           "GPRINT:recv_smb:MAX: %$gpr_max"
           "$t2"
           "$t"
           "HRULE:0#000000"
           "VRULE:0#000000"
   );';

 #if you want to see what is generated
 # my $sss = "/var/tmp/sss.out";
 # open (FF, ">$sss");
 #      print FF "$cmd\n";
 # close (FF);

  $i = 0;
  eval $cmd ;
  if ($@) {
     error ( "Graph error in eval cmd : !$@!");
  }
  else {
     my $answ = RRDp::read;
     if ( $$answ =~ "ERROR" ) {
       error ("$host:$server Graph rrdtool error : $$answ");
       if ( $answ =~ "is not an RRD file" ) {
         (my $err,  my $file, my $txt) = split(/\'/,$answ);
         error ("It needs to be removed due to corruption: $file");
       }
       else {
         error ( "Graph rrdtool error : $answ");
       }
     }
  }
  return 0;
}

sub graph_ent   
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;
  my $item = shift;   #lan or pg2 or san1 or san2 or sea, !?!?!?!?! if contains "a" then AREA STACK 
  my $start_unix = shift;
  my $end_unix = shift;
  my $text = "";
  my $step = 60; # --PH dodelat --> no problem it could be here 60 fixed
  my $xgrid = "";
  my $t="COMMENT: ";
  my $t2="COMMENT:\\n";
  my $step_new = $step;
  my $last ="COMMENT: ";
  my $font_def =  "--font=DEFAULT:8:";
  my $font_tit =  "--font=TITLE:9:";
  my $upper_limit = 0.1;
  my $start_time = "now-1$type";
  my $end_time = "now-1$type+1$type";
  if ( ! $start_unix eq '' && ! $end_unix eq '' ) {
    if ( isdigit($start_unix) > 0 && isdigit($end_unix) > 0 ) {
      $start_time = $start_unix;
      $end_time = $end_unix;
    }
  }
  my $headline2 = "COMMENT:Int      READ     Avg      Max      WRITE     Avg      Max";
  if ($item =~ "^lan") {
      $headline2 = "COMMENT:Int     READ/IN   Avg      Max    WRITE/OUT   Avg      Max";
  }
  if ( $detail == 1 ) {
    $font_def =  "--font=DEFAULT:10:";
    $font_tit =  "--font=TITLE:13:";
    if ($item =~ "^lan") {
       $headline2 .= "        Int      READ/IN   Avg      Max     WRITE/OUT   Avg      Max";
    }
    else {
       $headline2 .= "        Int       READ     Avg      Max       WRITE     Avg      Max"; 
    }
  }
  
# this is not the same as for LPM, first two are changed with second two
# 48 colors  + 216 basic HTML colors x 6 == 1296 + 48
  my @color=("#00FF00","#FFFF00","#FF0000","#0000FF","#FF3399","#00FFFF","#999933","#0099CC","#3300CC",
"#FF8080", "#FFFF80", "#80FF80", "#00FF80", "#80FFFF", "#0080FF", "#FF80C0", "#FF80FF", "#FF0000", "#FFFF00", "#80FF00",
"#00FF40", "#00FFFF", "#0080C0", "#8080C0", "#FF00FF", "#804040", "#FF8040", "#00FF00", "#008080", "#004080", "#8080FF",
"#800040", "#FF0080", "#800000", "#FF8000", "#008000", "#008040", "#0000FF", "#0000A0", "#800080", "#8000FF", "#400000",
"#804000", "#004000", "#004040", "#000080", "#000040", "#400040", "#400080", "#000000", "#808000", "#808040", "#808080",
"#408080", "#C0C0C0", "#400040", "#AAAAAA");
 
  if ( $type =~ m/d/ ) {
    $text="day";
    if ( $detail == 0 ) {
      $xgrid="--x-grid=MINUTE:60:HOUR:2:HOUR:4:0:%H";
    }
    else {
      $xgrid="--x-grid=MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
  }
  if ( $type =~ m/w/ ) {
    $text="week";
    if ( $detail == 0 ) {
      $xgrid="--x-grid=HOUR:8:DAY:1:DAY:1:0:%a";
    }
    else {
      $xgrid="--x-grid=HOUR:12:HOUR:6:HOUR:12:0:%a %H";
    }
  }
  if ( $type =~ m/m/ ) {
    $text="4 weeks";
    if ( $detail == 0 ) {
      $xgrid="--x-grid=DAY:1:DAY:2:DAY:7:0:%U";
    }
    else {
      $xgrid="--x-grid=HOUR:12:DAY:1:DAY:1:0:%d";
    }
  }
  if ( $type =~ m/y/ ) {
    $text="year";
    if ( $detail == 0 ) {
      $xgrid="--x-grid=MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
    else {
      $xgrid="--x-grid=MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
  }
  if ( $type_sam =~ m/x/ ) {
    # historical reports --> no xgrid
    $xgrid="COMMENT: "; # just a trick to place there something otherwise rrdtoll complains
  }

  if ( $text eq '' ) {
    error ("Graph rrdtool error : graph_ent: $type");
    return (0);
  }

  if ( $lpar eq '' ) {
    return 0; # some workaround, it should not go here
  }
  my $dir = "$wrkdir/$server/$host/$lpar/"; 
  my $lpar_slash = $lpar;
  $lpar_slash =~ s/\&\&1/\//g;   # to show slash and not &&1 which is general replacement for it

  my $ds_name1 = "recv_bytes";
  my $ds_name2 = "trans_bytes";
  my $fpn = "lan-";   # according to $item 
  my $header = "LPAR ETH: $lpar_slash : last $text";
  if ( ! $start_unix eq '' && ! $end_unix eq '' ) {
    if ( isdigit($start_unix) > 0 && isdigit($end_unix) > 0 ) {
      # historical reports
      my $start_human = strftime "%H:%M:%S %d.%m.%Y",localtime($start_unix);
      my $end_human = strftime "%H:%M:%S %d.%m.%Y",localtime($end_unix);
      $header = "LPAR ETH: $lpar_slash : $start_human - $end_human";
    }
  }
  my $g_format = "6.2lf";
  my $divider = 1000000;
  if ($item =~ "^lan") {
      $ds_name2 = "recv_bytes";
      $ds_name1 = "trans_bytes";
  }
  my $headline1 = "COMMENT:Average [MB/sec]";
  my $vertical_label = "Read - Bytes/sec - Write";

  if ( $item =~ m/^san/  ) {
    $fpn = "san-" ;
    $header = "LPAR FCS: $lpar_slash : last $text";
    if ( ! $start_unix eq '' && ! $end_unix eq '' ) {
      if ( isdigit($start_unix) > 0 && isdigit($end_unix) > 0 ) {
        # historical reports
        my $start_human = strftime "%H:%M:%S %d.%m.%Y",localtime($start_unix);
        my $end_human = strftime "%H:%M:%S %d.%m.%Y",localtime($end_unix);
        $header = "LPAR FCS: $lpar_slash : $start_human - $end_human";
      }
    }
  }
  if ( $item =~ m/^sea/  ) {
    $fpn = "sea-" ;
    $header = "LPAR SEA: $lpar_slash : last $text";
    if ( ! $start_unix eq '' && ! $end_unix eq '' ) {
      if ( isdigit($start_unix) > 0 && isdigit($end_unix) > 0 ) {
        # historical reports
        my $start_human = strftime "%H:%M:%S %d.%m.%Y",localtime($start_unix);
        my $end_human = strftime "%H:%M:%S %d.%m.%Y",localtime($end_unix);
        $header = "LPAR SEA: $lpar_slash : $start_human - $end_human";
      }
    }
    $ds_name2 = "recv_bytes";
    $ds_name1 = "trans_bytes";
    $vertical_label = "Read - Bytes/sec - Write";
    $headline1 = "COMMENT:Average [MB/sec]";
    $headline2 = "COMMENT:Phys  (SEA)  READ/IN  Avg      Max    WRITE/OUT   Avg      Max";
    if ( $detail == 1 ) {
       $headline2 .= "        Phys  (SEA)  READ/IN   Avg      Max     WRITE/OUT   Avg      Max";
    }
  }
  if ( $item eq "pg2" ) {
    $fpn = "pgs" ;
    $header = "LPAR PAGING SPACE: $lpar_slash : last $text";
    $upper_limit = 100;
    if ( ! $start_unix eq '' && ! $end_unix eq '' ) {
      if ( isdigit($start_unix) > 0 && isdigit($end_unix) > 0 ) {
        # historical reports
        my $start_human = strftime "%H:%M:%S %d.%m.%Y",localtime($start_unix);
        my $end_human = strftime "%H:%M:%S %d.%m.%Y",localtime($end_unix);
        $header = "LPAR PAGING SPACE: $lpar_slash : $start_human - $end_human";
      }
    }
    $ds_name1 = "paging_space";
    $ds_name2 = "percent";
    $headline1 = "COMMENT:Usage [%]  AVRG   MAX";
  #  $headline1 = "COMMENT:Average usage in %";
    $headline2 = "COMMENT:             ";
    $vertical_label = "Paging utilization in %";
  }
  if ( $item =~ m/^san2/ ) {
    $g_format = "6.0lf"; 
    $divider = 1; 
    $fpn = "san-" ;
    $header = "LPAR IOPS: $lpar_slash : last $text";
    if ( ! $start_unix eq '' && ! $end_unix eq '' ) {
      if ( isdigit($start_unix) > 0 && isdigit($end_unix) > 0 ) {
        # historical reports
        my $start_human = strftime "%H:%M:%S %d.%m.%Y",localtime($start_unix);
        my $end_human = strftime "%H:%M:%S %d.%m.%Y",localtime($end_unix);
        $header = "LPAR IOPS: $lpar_slash : $start_human - $end_human";
      }
    }
    $ds_name1 = "iops_in";
    $ds_name2 = "iops_out";
    $headline1 = "COMMENT:Average [IO per sec]";
    $vertical_label = "Read - IOPS - Write";
  }

  my @files;
  opendir(my $dh, $dir) || error ("can't opendir $dir: $! :".__FILE__.":".__LINE__) && return 0;
  my @files_unsorted = grep { /^$fpn/ && /\.mmm$/ } readdir($dh);
  @files = sort @files_unsorted;
  closedir $dh;

  my $col_indx = 0;
  my $line_indx = 0; # place enter every 3rd line
  my $file = "";
  my $i = 0;
  my $cmd = "";
  my $cmdx = "";
  my $j = 0;
  my $act_time = localtime();
  my $act_time_u = time();
  my $req_time = 0;
  my (@recb, @trab, @rname, @rpath, @avgx, @avgy);
  my $lnx = 0;
  my @gtype;
   $gtype[0] = "LINE1";
   $gtype[1] = "LINE1";
 #  $gtype[1] = "STACK";
 # if ($item =~ /^iops/ ) { $item .="a" };
 # if ($item =~ /^fic/ ) { $item .="a" };
 # if ($item =~ /^en/ ) { $item .="a" };
  if ($item =~ m/a/) { $gtype[0] = "AREA" };
  if ($item =~ m/a/) { $gtype[1] = "STACK" };

  if ( "$type" =~ "d" ) {
    $req_time = $act_time_u - 86400;
  }
  if ( "$type" =~ "w" ) {
    $req_time = $act_time_u - 604800;
  }
  if ( "$type" =~ "m" ) {
    $req_time = $act_time_u - 2764800;
  }
  # for daily, must be even type as for IVM/SDMC it is not in $type_sam =~ "d"
  if ( $type_sam =~ "d"  || "$type" =~ "y" ) {
    $req_time = $act_time_u - 31536000;
  }

  foreach $file (@files) {
    chomp($file);

    my $rrd = "$wrkdir/$server/$host/$lpar/$file";

    # PH --> show all files here
    # avoid old files which do not exist in the period
    #my $rrd_upd_time = (stat("$rrd"))[9];
    # `echo "1200: detail-graph-cgi - $rrd:$rrd_upd_time:$req_time" >> /tmp/e1099`;
    #if ( $rrd_upd_time < $req_time ) {
      #if ( $type_sam !~ m/x/ ) {
    #    next; # aviod that for historical reports
	      # --> not necessary as $req_time = 0
      #}
    #}
                     
    my $rrd_name = $file;     # prepare name for gprint
    $rrd_name =~ s/.mmm//;
    $rrd_name =~ s/lan-//;
    $rrd_name =~ s/san-//;
    if ( $rrd_name =~ m/sea-/ ) {
       my $name_cfg = "";
       my $file_cfg = "$wrkdir/$server/$host/$lpar/$rrd_name.cfg";
       if ( -f "$file_cfg" ) {
          open (FF,"<$file_cfg") || error ("can't open $file_cfg: $! :".__FILE__.":".__LINE__) && return 0;
          $name_cfg = (<FF>);
          close (FF);
          chomp ($name_cfg);
          if ( length($name_cfg) == 4) { $name_cfg .= " "; }
       }
       if ( length($rrd_name) == 8) { $rrd_name .= " " };
       $rrd_name .= "(".$name_cfg.")";      
    }
    $rrd_name =~ s/sea-//;  
      
    # add spaces to rrd name to have 8 chars total (for formating graph legend)
    for(my $k = length($rrd_name); $k < 8; $k++) {
      $rrd_name .= " ";
    }

    #print "$found $lpar $color[$found]\n";
    #print "$wrkdir/$server/$host/$lpar/$file $rrd_upd_time $req_time $act_time\n" if ( $DEBUG == 3);

  # print "001 ENT $rrd\n";
  
 $rname[$i] = "$rrd_name";   # for graphing
 $rpath[$i] = "$rrd";
 $recb[$i]  = "rcb${i}";
 $trab[$i]  = "trb${i}"; 
 $avgx[$i]  = "avg${i}";
 $avgy[$i]  = "avgy${i}";
 
 #`echo "809: detail-graph-cgi - $rrd_name:$rrd:rcb${i}:trb${i}:$font_def:$font_tit" >> /tmp/e099`;

 if ($i eq 0) {                                # first cycle only
     if ($type =~ "d") {
        RRDp::cmd qq(last "$rrd");
        my $last_tt = RRDp::read;
        chomp ($$last_tt);
        my $l=localtime($$last_tt);
        # following must be for RRD 1.2+
        $l =~ s/:/\\\:/g;
        $t ="COMMENT:Updated\\\: $l ";
     }
     if ( $type =~ "y" ) {
        $step_new=86400;
     }
 #       "--alt-autoscale-max"

  
  #print "graphing ENT   : $host:$server:$lpar_slash:$type_sam:$type\n" if $DEBUG ;

     $cmd .= 'RRDp::cmd qq(graph "$name_out"
        "--title" "$header"
        "--start" "$start_time"
        "--end" "$end_time"
        "--imgformat" "PNG"
        "--slope-mode"
        "--width=$width"
        "--height=$height"
        "--step=$step_new"
        "--color=BACK#$pic_col"
        "--color=SHADEA#$pic_col"
        "--color=SHADEB#$pic_col"
        "--color=CANVAS#$pic_col"
        "--upper-limit" "$upper_limit"
        "--lower-limit" "0"
        "--interlaced"
        "--vertical-label=$vertical_label"
        "--alt-y-grid"
        "$xgrid"
        "$font_def"
        "$font_tit"
        "$headline1"
        "$t2"
';
  if ( $item ne "pg2" ) {
     $cmd .= '"$headline2"
              "$t2"
';
      }
  }
# $cmd .= '"DEF:$recb[$i]-o=$rpath[$i]:$ds_name1:AVERAGE"
#          "DEF:$trab[$i]-o=$rpath[$i]:$ds_name2:AVERAGE"
#          "CDEF:$recb[$i]=$recb[$i]-o,UN,0,$recb[$i]-o,IF"
#          "CDEF:$trab[$i]=$trab[$i]-o,UN,0,$trab[$i]-o,IF"
#            "DEF:$recb[$i]=$rpath[$i]:$ds_name1:AVERAGE"
#            "DEF:$trab[$i]=$rpath[$i]:$ds_name2:AVERAGE"
 #    "CDEF:$recb[$i]-n=PREV,UN,$recb[$i],PREV,IF,$recb[$i],GE,$recb[$i],$recb[$i],$filter_max,/,PREV,UN,$recb[$i],PREV,IF,GT,PREV,UN,$recb[$i],PREV,IF,$recb[$i],IF,IF"
 #    "CDEF:$trab[$i]-n=PREV,UN,$trab[$i],PREV,IF,$trab[$i],GE,$trab[$i],$trab[$i],$filter_max,/,PREV,UN,$trab[$i],PREV,IF,GT,PREV,UN,$trab[$i],PREV,IF,$trab[$i],IF,IF"


# every cycle
 $cmd .= '"DEF:$recb[$i]=$rpath[$i]:$ds_name1:AVERAGE"
          "DEF:$trab[$i]=$rpath[$i]:$ds_name2:AVERAGE"
          "CDEF:$recb[$i]-neg=$recb[$i],-1,*"
          "CDEF:$recb[$i]-mil=$recb[$i],$divider,/"
          "CDEF:$trab[$i]-mil=$trab[$i],$divider,/"
         ';
  if ( $item eq "pg2" ) {    
    $col_indx = $col_indx + 2; 
    $cmd .= '"CDEF:$avgx[$i]=$recb[$i],100000,/,$trab[$i],*"
              "CDEF:$avgy[$i]=$recb[$i],1000,/"
              "LINE1:$trab[$i]$color[$col_indx++]: "
              "GPRINT:$trab[$i]:AVERAGE:       %2.1lf"
              "GPRINT:$trab[$i]:MAX:%2.1lf"
              "COMMENT:( from"
              "GPRINT:$avgy[$i++]:AVERAGE:%4.1lf GB )"
              "$t2"
             ';   #do you understand difference $i++ above and below ??
         $i++;
  }
  else  {            # LAN SAN1 SAN2 SEA
                    
    $cmd .= '"COMMENT:$rname[$i]"
             "$gtype[$i>0]:$recb[$i]-neg$color[$col_indx++]: "
             "GPRINT:$recb[$i]-mil:AVERAGE:%$g_format"
             "GPRINT:$recb[$i]-mil:MAX: %$g_format    "
            "STACK:$lnx$color[$col_indx++]: "
              "GPRINT:$trab[$i]-mil:AVERAGE: %$g_format"
              "GPRINT:$trab[$i++]-mil:MAX: %$g_format    "
    ';
    if ($j == 0) {
       $cmdx .= '"LINE1:$lnx:"
           ';
    }
    $cmdx .= '"$gtype[$j>0]:$trab[$j]$color[1 + 2 * $j++]:"
            ';
         #     "GPRINT:$trab[$j]-mil:AVERAGE: %$g_format"
         #     "GPRINT:$trab[$j++]-mil:MAX: %$g_format    "
   
  #  $cmd .= '"COMMENT:$rname[$i]"
  #           "$gtype[$i>0]:$trab[$i]$color[$col_indx++]: "
  #           "GPRINT:$trab[$i]-mil:AVERAGE: %$g_format"
  #           "GPRINT:$trab[$i]-mil:MAX: %$g_format    "
  #           "$gtype[$i>0]:$recb[$i]-neg$color[$col_indx++]: "
  #           "GPRINT:$recb[$i]-mil:AVERAGE:%$g_format"
  #           "GPRINT:$recb[$i++]-mil:MAX: %$g_format    "
  #          ';

    if ( $detail == 1 ) {
       if (1 == $i % 2) {
          $cmd .= '  "$t2"
                  ';   # There is remainder
       }
    }            #do you understand difference $i++ above and below ??
    else {
         $cmd .= '  "$t2"
                ';
    }
        $i++;
        $j++;
   }
  }                        # end of foreach
 if ($cmd eq "" ) {  
    error ( "Graph rrdtool error no valid rrd file : $item : ".__FILE__.":".__LINE__);
    return 0;
 }   
 $cmd .= $cmdx; 
 $cmd .= '"$t"
      "HRULE:0#000000"
      "VRULE:0#000000"
   );';

# if you want to see what is generated
 #  if ( $item =~  /^san1/ ) {
 #     my $sss = "/var/tmp/sss.out";
 #     open (FF, ">$sss");
 #     print FF "$cmd\n";
 #     close (FF);
 # }

  $i = 0;
  $j = 0;
  eval $cmd ;
  if ($@) {
     error ( "Graph error in eval cmd : !$@!");
  }
  else {
     my $answ = RRDp::read; 
     if ( $$answ =~ "ERROR" ) { 
       error ("$host:$server Graph rrdtool error : $$answ : ".__FILE__.":".__LINE__);
       if ( $answ =~ "is not an RRD file" ) { 
         (my $err,  my $file, my $txt) = split(/\'/,$answ);
         error ("It needs to be removed due to corruption: $file : ".__FILE__.":".__LINE__);
       }
       else { 
         error ( "Graph rrdtool error : $answ :".__FILE__.":".__LINE__);
       }
     }
  }
  return 0;
}

sub rrd_running_days
{
  my $rrd = shift;
  my $days = shift;   #inspected time interval in days from now into the past, max 365 days

# returns nr of days rounded up, so it is ( 1 up to $days - max is rrdtool first)
# returns nr (1 .. 365) or text if any error
# example of call
#  my $nrd = rrd_running_days ($file,4);
#
# example of result :
#                     recv_bytes         trans_bytes        recv_packets       trans_packets
#
# 1392508800: NaNQ NaNQ NaNQ NaNQ
# 1392595200: NaNQ NaNQ NaNQ NaNQ
# 1392681600: NaNQ NaNQ NaNQ NaNQ
# 1392768000: 0.0000000000e+00 8.8804282407e+01 NaNQ NaNQ
# 1392854400: NaNQ NaNQ NaNQ NaNQ
#
# in this case returns 2

  return "error file not existing" if ! -f "$rrd" ;
  return "bad nr of days $days" if ($days < 1 || $days > 365 );

  my $ctime = time;
  my $rrdres = 86400;
  my $daysd  = $days."d";
  my @answer = `rrdtool fetch $rrd AVERAGE -r $rrdres -e @{[int($ctime/$rrdres)*$rrdres]} -s e-$daysd`;
#  if ($answer[0] =~ m/rror/) { return $answer[0]; }
  for (my $i = 2; $i < ($days +2); $i++) {
     # print "$i,$answer[$i]";
     (undef, my $nan, undef ) = split(/ /,$answer[$i]);
     next if ( $nan =~ m/NaN/ || $nan =~ m/nan/);
     return ($days - $i +3 ) ;
  }
  return (1);
}

sub graph_ame_mem 
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;
  my $start_unix = shift;
  my $end_unix = shift;
  my $text = "";
  my $step = 60; # --PH dodelat --> no problem it could be here 60 fixed
  my $xgrid = "";
  my $t="COMMENT: ";
  my $t2="COMMENT:\\n";
  my $step_new = $step;
  my $last ="COMMENT: ";
  my $font_def =  "--font=DEFAULT:8:";
  my $font_tit =  "--font=TITLE:9:";

  # due to historical reports where is specific time passed
  my $start_time = "now-1$type";
  my $end_time = "now-1$type+1$type";
  if ( ! $start_unix eq '' && ! $end_unix eq '' ) {
    if ( isdigit($start_unix) > 0 && isdigit($end_unix) > 0 ) {
      $start_time = $start_unix;
      $end_time = $end_unix;
    }
  }


  if ( $detail == 1 ) {
    $font_def =  "--font=DEFAULT:10:";
    $font_tit =  "--font=TITLE:13:";
  }
  if ( $type =~ m/d/ ) {
    $text="day";
    if ( $detail == 0 ) {
      $xgrid="--x-grid=MINUTE:60:HOUR:2:HOUR:4:0:%H";
    }
    else {
      $xgrid="--x-grid=MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
  }
  if ( $type =~ m/w/ ) {
    $text="week";
    if ( $detail == 0 ) {
      $xgrid="--x-grid=HOUR:8:DAY:1:DAY:1:0:%a";
    }
    else {
      $xgrid="--x-grid=\"HOUR:12:HOUR:6:HOUR:12:0:%a %H\"";
    }
  }
  if ( $type =~ m/m/ ) {
    $text="4 weeks";
    if ( $detail == 0 ) {
      $xgrid="--x-grid=DAY:1:DAY:2:DAY:7:0:%U";
    }
    else {
      $xgrid="--x-grid=HOUR:12:DAY:1:DAY:1:0:%d";
    }
  }
  if ( $type =~ m/y/ ) {
    $text="year";
    if ( $detail == 0 ) {
      $xgrid="--x-grid=MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
    else {
      $xgrid="--x-grid=MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
  }
  if ( $type_sam =~ m/x/ ) {
    # historical reports --> no xgrid
    $xgrid="COMMENT: "; # just a trick to place there something otherwise rrdtoll complains
  }

  if ( $text eq '' ) {
    error ("Graph rrdtool error : graph_ent: $type");
    return (0);
  }

  if ( $lpar eq '' ) {
    return 0; # some workaround, it should not go here
  }

  my $dir = "$wrkdir/$server/$host/$lpar/";
  my $lpar_slash = $lpar;
  $lpar_slash =~ s/\&\&1/\//g;   # to show slash and not &&1 which is general replacement for it

  my $header = "LPAR AME: $lpar_slash : last $text";
  if ( ! $start_unix eq '' && ! $end_unix eq '' ) {
    if ( isdigit($start_unix) > 0 && isdigit($end_unix) > 0 ) {
      # historical reports
      my $start_human = strftime "%H:%M:%S %d.%m.%Y",localtime($start_unix);
      my $end_human = strftime "%H:%M:%S %d.%m.%Y",localtime($end_unix);
      $header = "LPAR AME: $lpar_slash : $start_human - $end_human";
    }
  }

  my $ds_name1 = "ame_mem";
  my $ds_name2 = "ame_ratio";
  my $ds_name3 = "ame_deficit";
  my $headline1 = "COMMENT:Average            MB          %*100     Deficit MB";
  my $headline2 = "COMMENT:       ";
  my $vertical_label = "MegaBytes";
  my $cmd = "";
  my $act_time = localtime();
  my $act_time_u = time();
  my $req_time = 0;
  my (@recb, @trab, @rname, @rpath);

  if ( "$type" =~ "d" ) {
    $req_time = $act_time_u - 86400;
  }
  if ( "$type" =~ "w" ) {
    $req_time = $act_time_u - 604800;
  }
  if ( "$type" =~ "m" ) {
    $req_time = $act_time_u - 2764800;
  }
  # for daily, must be even type as for IVM/SDMC it is not in $type_sam =~ "d"
  if ( $type_sam =~ "d"  || "$type" =~ "y" ) {
    $req_time = $act_time_u - 31536000;
  }

  my $rrd = "$wrkdir/$server/$host/$lpar/ame_mem.mmm";
  # avoid old files which do not exist in the period
  #my $rrd_upd_time = (stat("$rrd"))[9];
  #if ( $rrd_upd_time < $req_time ) {
  #  next;
  #}

  my $rrd_name = "ame_mem.mmm";
  $rrd_name =~ s/.mmm//;

  # add spaces to rrd name to have 8 chars total (for formating graph legend)
  for(my $k = length($rrd_name); $k < 8; $k++) {
    $rrd_name .= " ";
  }

  # print "001  AME_MEM  $rrd\n";

# `echo "809: detail-graph-cgi - $rrd_name:$rrd" >> /tmp/e099`;

 if ($type =~ "d") {
     RRDp::cmd qq(last "$rrd");
     my $last_tt = RRDp::read;
     chomp ($$last_tt);
     my $l=localtime($$last_tt);
     # following must be for RRD 1.2+
     $l =~ s/:/\\\:/g;
     $t ="COMMENT:Updated\\\: $l ";
 }
 if ( $type =~ "y" ) {
    $step_new=86400;
 }

#print "graphing AME_MEM  : $host:$server:$lpar_slash:$type_sam:$type\n" if $DEBUG ;

     $cmd .= 'RRDp::cmd qq(graph "$name_out"
        "--title" "$header"
        "--end" "$end_time"
        "--start" "$start_time"
        "--imgformat" "PNG"
        "--slope-mode"
        "--width=$width"
        "--height=$height"
        "--step=$step_new"
        "--lower-limit=0"
        "--color=BACK#$pic_col"
        "--color=SHADEA#$pic_col"
        "--color=SHADEB#$pic_col"
        "--color=CANVAS#$pic_col"
        "--alt-autoscale-max"
        "--interlaced"
        "--font=DEFAULT:8:"
        "--font=TITLE:10:"
        "--vertical-label=$vertical_label"
        "--alt-y-grid"
        "$xgrid"
        "$font_def"
        "$font_tit"
      "$headline1"
      "$t2"
      "$headline2"
      "$t2"
';
 $cmd .= '"DEF:mem=$rrd:$ds_name1:AVERAGE"
          "DEF:ratio=$rrd:$ds_name2:AVERAGE"
          "DEF:deficit=$rrd:$ds_name3:AVERAGE"
         ';
 $cmd .= '"LINE1:mem#00FF00:$rrd_name"
          "GPRINT:mem:AVERAGE: %6.3lf   "
          "LINE1:ratio#FF0000: "
          "GPRINT:ratio:AVERAGE: %6.3lf"
          "LINE1:deficit#FFFF00: "
          "GPRINT:deficit:AVERAGE: %6.3lf"
          "$t2"
         ';  
 $cmd .= '"$t"
      "HRULE:0#000000"
      "VRULE:0#000000"
   );';

# in /var/tmp you can see what is generated
#  my $ss1 = "/var/tmp/sss.out";
#  open (FF, ">$ss1");
#       print FF "$cmd\n";
#  close (FF);

  eval $cmd ;
  if ($@) {
     error ( "Graph error in eval cmd : !$@!");
  }
  else {
     my $answ = RRDp::read;
     if ( $$answ =~ "ERROR" ) {
       error ("$host:$server Graph rrdtool error : $$answ");
       if ( $answ =~ "is not an RRD file" ) {
         (my $err,  my $file, my $txt) = split(/\'/,$answ);
         error ("It needs to be removed due to corruption: $file");
       }
       else {
         error ( "Graph rrdtool error : $answ");
       }
     }
  }
  return 0;
}


sub graph_lpm 
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $detail = shift;
  my $type_sam = "m"; 
  my $text = "";
  my $step = $ENV{SAMPLE_RATE};
  my $step_new = $step;
  my $xgrid = "";
  my $act_time = time();
  my $lpm_suff = "rrl";
  # 48 colors like for HMC below + 216 basic HTML colors x 6 == 1296 + 48
  my @color=("#FF0000","#0000FF","#00FF00","#FFFF00","#FF3399","#00FFFF","#999933","#0099CC","#3300CC",
"#FF8080", "#FFFF80", "#80FF80", "#00FF80", "#80FFFF", "#0080FF", "#FF80C0", "#FF80FF", "#FF0000", "#FFFF00", "#80FF00",
"#00FF40", "#00FFFF", "#0080C0", "#8080C0", "#FF00FF", "#804040", "#FF8040", "#00FF00", "#008080", "#004080", "#8080FF",
"#800040", "#FF0080", "#800000", "#FF8000", "#008000", "#008040", "#0000FF", "#0000A0", "#800080", "#8000FF", "#400000",
"#804000", "#004000", "#004040", "#000080", "#000040", "#400040", "#400080", "#000000", "#808000", "#808040", "#808080",
"#408080", "#C0C0C0", "#400040", "#AAAAAA");

  if ( $type =~ m/d/ ) { $text="day";     $xgrid="MINUTE:60:HOUR:2:HOUR:4:0:%H";}
  if ( $type =~ m/w/ ) { $text="week";    $xgrid="HOUR:8:DAY:1:DAY:1:86400:%a";}
  if ( $type =~ m/m/ ) { $text="4 weeks"; $xgrid="DAY:1:DAY:2:DAY:7:0:%U";}
  if ( $type =~ m/y/ ) { 
                         $text="year";    $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b"; 
    # detection of daily data source : rrm vrs rrd
    if ( ! -f "$wrkdir/$server/$host/IVM" && ! -f "$wrkdir/$server/$host/SDMC" ) {
      $type_sam = "d";
      $lpm_suff = "rrk";
    }
  }
  if ( $text eq '' ) {
    error ("Graph rrdtool error : graph_lpm: $type : $host:$server:$lpar:$type:$name_out:$type_sam");
    return (0);
  }

  # LPM has been already detected in detail-cgi.pl

  my $rrd= "$wrkdir/$server/$host/$lpar.rm$type_sam";

  my $lpar_slash = $lpar;
  $lpar_slash =~ s/\&\&1/\//g;   # to show slash and not &&1 which is general replacemnt for it

  lpm ("","","","","","","","",$wrkdir,$name_out,$server,$host,$lpar,$lpar_slash,$text,$type_sam,$type,$step_new,$xgrid,$act_time,$pic_col,$DEBUG,$rrdtool,$lpm_suff,\@color);

  return 1;
}

sub graph_pool 
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;
  my $graph_hours = shift;
  my $text = "";
  my $step = 60; # --PH dodelat --> no problem it could be here 60 fixed
  my $xgrid = "";
  my $t="COMMENT: ";
  my $t2="COMMENT:\\n";
  my $step_new = $step;
  my $last ="COMMENT: ";
  my $font_def =  "--font=DEFAULT:8:";
  my $font_tit =  "--font=TITLE:9:";
  
  if ( $detail == 1 ) {
    $font_def =  "--font=DEFAULT:10:";
    $font_tit =  "--font=TITLE:13:";
  }

  if ( $type =~ m/d/ ) { 
    $text="day";     
    if ( $detail == 0 ) {
      $xgrid="MINUTE:60:HOUR:2:HOUR:4:0:%H";
    }
    else {
      $xgrid="MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
  }
  if ( $type =~ m/w/ ) { 
    $text="week";    
    if ( $detail == 0 ) {
      $xgrid="HOUR:8:DAY:1:DAY:1:0:%a";
    }
    else {
      $xgrid="HOUR:12:HOUR:6:HOUR:12:0:%a %H";
    }
  }
  if ( $type =~ m/m/ ) { 
    $text="4 weeks"; 
    if ( $detail == 0 ) {
      $xgrid="DAY:1:DAY:2:DAY:7:0:%U";
    }
    else {
      $xgrid="HOUR:12:DAY:1:DAY:1:0:%d";
    }
  }
  if ( $type =~ m/y/ ) { 
    $text="year";    
    if ( $detail == 0 ) {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
    else {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
  }

  if ( $text eq '' ) {
    error ("Graph rrdtool error : graph_ams: $type");
    return (0);
  }

  my $rrd= "$wrkdir/$server/$host/$lpar.rr$type_sam";

  my $header = "Totally for all CPU pools : last $text";

    if ($type =~ "d" && $graph_hours == 0 ) {
      RRDp::cmd qq(last "$rrd");
      my $last_tt = RRDp::read;
      my $l=localtime($$last_tt);
      # following must be for RRD 1.2+
      $l =~ s/:/\\:/g;
      $t ="COMMENT:Updated\\: $l ";

      # get LAST value from RRD
      RRDp::cmd qq(fetch "$rrd" "AVERAGE" "-s $$last_tt-$step" "-e $$last_tt-$step");
      my $row = RRDp::read;
      chomp($$row);
      my @row_arr = split(/\n/,$$row);
      my $m = "";
      my $i = 0;
      foreach $m (@row_arr) {
       chomp($m);
       $i++;
       if ( $i == 3 ) {
         my @m_arr = split(/ /,$m);
         # go further ony if it is a digit (avoid it when NaNQ (== no data) is there)
         if ($m_arr[1] =~ /\d/ && $m_arr[2] =~ /\d/ && $m_arr[3] =~ /\d/ && $m_arr[4] =~ /\d/ ) {
           #print "m : $m\n" if $DEBUG ;
           #print "\n$m_arr[1] $m_arr[2]" if $DEBUG ;
           my $total_pool_cycles = sprintf("%e",$m_arr[1]);
           my $utilized_pool_cyc = sprintf("%e",$m_arr[2]);
           my $conf_proc_units   = sprintf("%e",$m_arr[3]);
           my $bor_proc_units    = sprintf("%e",$m_arr[4]);
           if ( $total_pool_cycles != 0 ) {
             my $util = sprintf ("%.2f",($conf_proc_units + $bor_proc_units) * ($utilized_pool_cyc / $total_pool_cycles));
             #print ("\n $util $curr_proc $entitled_cycles $capped_cycles $uncapped_cycles\n");

             $last ="COMMENT:Last utilization in CPU cores  $util";
           }
         }
       }
      }
    };


  if ( $type =~ "y" ) {
    $step_new=86400;
  }

  if ( ! -f "$rrd" ) {
     if ( $type_sam =~ "d" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one day!!!\n";
       error ("$rrd does not exists");
     }
     if ( $type_sam =~ "h" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one hour!!!\n";
       error ("$rrd does not exists");
     }
     if ( $type_sam =~ "m" ) {
       error ("$rrd does not exists");
     }
     return 0;
  }

  #my $rrd_y = "";
  #if ( $type_sam =~ "y" ) {
  #  # u rocnich grafu nejdrive pouzit rrm data a pokud nejsou tak teprve rrd
  #  if ( $rrd !~ m/\.rrd$/ ) {
  #    $rrd_y = $rrd;
  #    $rrd_y =~ s/\.rrm$/\.rrd/;
  #    if ( -f $rrd_y ) {
  #     $rrd = $rrd_y;
  #    }
  #}

  #print "creating graph : $host:$server:$lpar_slash:$type_sam:$type\n" if $DEBUG ;
  my $start_time = "now-1$type";
  if ( $graph_hours > 0 ) {
    # alerting
    $start_time = "now-".$graph_hours."h";
    if ( $graph_hours < 12 ) {
      $xgrid="MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
    else {
      if ( $graph_hours > 24 ) {
        $xgrid="MINUTE:60:HOUR:2:HOUR:4:0:%H";
      }
      else {
        $xgrid="MINUTE:60:HOUR:2:HOUR:2:0:%H";
      }
    }  
  }

  RRDp::cmd qq(graph "$name_out"
      "--title" "$header"
      "--start" "$start_time"
      "--end" "now-1$type+1$type"
      "--imgformat" "PNG"
      "--slope-mode"
      "--font=DEFAULT:10:"
      "--font=TITLE:13:"
      "--width=$width"
      "--height=$height"
      "--step=$step_new"
      "--lower-limit=0.00"
      "--color=BACK#$pic_col"
      "--color=SHADEA#$pic_col"
      "--color=SHADEB#$pic_col"
      "--color=CANVAS#$pic_col"
      "--alt-autoscale-max"
      "--interlaced" 
      "--upper-limit=0.1"
      "--vertical-label=CPU cores"
      "--units-exponent=1.00"
      "--alt-y-grid"
      "--x-grid=$xgrid"
      "$font_def"
      "$font_tit"
      "DEF:totcyc=$rrd:total_pool_cycles:AVERAGE"
      "DEF:uticyc=$rrd:utilized_pool_cyc:AVERAGE"
      "DEF:cpu=$rrd:conf_proc_units:AVERAGE"
      "DEF:cpubor=$rrd:bor_proc_units:AVERAGE"
      "CDEF:totcpu=cpu,cpubor,+"
      "CDEF:cpuutil=uticyc,totcyc,/"
      "CDEF:cpuutiltot=cpuutil,totcpu,*"
      "CDEF:utilisa=cpuutil,100,*"
      "COMMENT:   Average   \\n"
      "AREA:cpu#00FF00: Configured CPU cores    "
      "GPRINT:cpu:AVERAGE: %2.1lf"
      "$t2"
      "STACK:cpubor#FFFF00: Not assigned CPU cores  "
      "GPRINT:cpubor:AVERAGE: %2.1lf"
      "$t2"
      "LINE1:cpuutiltot#FF0000: Utilization in CPU cores"
      "GPRINT:cpuutiltot:AVERAGE: %2.2lf"
      "COMMENT:("
      "GPRINT:utilisa:AVERAGE: %2.1lf"
      "COMMENT:\%)"
      "$t2"
      "$last"
      "$t2"
      "$t"
      "HRULE:0#000000"
      "VRULE:0#000000"
  );
  my $answer = RRDp::read; 
  if ( $$answer =~ "ERROR" ) {
    error ("$host:$server Graph rrdtool error : $$answer");
    if ( $$answer =~ "is not an RRD file" ) {
      (my $err,  my $file, my $txt) = split(/'/,$$answer);
      error ("It need to be removed due to corrpution: $file");
    }
    else {
      error ("Graph rrdtool error : $$answer");
    }
    return 0;
  }

  return 0;
}

sub graph_shpool 
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;
  my $graph_hours = shift;
  my $text = "";
  my $step = 60; # --PH dodelat --> no problem it could be here 60 fixed
  my $xgrid = "";
  my $t="COMMENT: ";
  my $t2="COMMENT:\\n";
  my $step_new = $step;
  my $last ="COMMENT: ";
  my $font_def =  "--font=DEFAULT:8:";
  my $font_tit =  "--font=TITLE:9:";
  
  if ( $detail == 1 ) {
    $font_def =  "--font=DEFAULT:10:";
    $font_tit =  "--font=TITLE:13:";
  }

  if ( $type =~ m/d/ ) { 
    $text="day";     
    if ( $detail == 0 ) {
      $xgrid="MINUTE:60:HOUR:2:HOUR:4:0:%H";
    }
    else {
      $xgrid="MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
  }
  if ( $type =~ m/w/ ) { 
    $text="week";    
    if ( $detail == 0 ) {
      $xgrid="HOUR:8:DAY:1:DAY:1:0:%a";
    }
    else {
      $xgrid="HOUR:12:HOUR:6:HOUR:12:0:%a %H";
    }
  }
  if ( $type =~ m/m/ ) { 
    $text="4 weeks"; 
    if ( $detail == 0 ) {
      $xgrid="DAY:1:DAY:2:DAY:7:0:%U";
    }
    else {
      $xgrid="HOUR:12:DAY:1:DAY:1:0:%d";
    }
  }
  if ( $type =~ m/y/ ) { 
    $text="year";    
    if ( $detail == 0 ) {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
    else {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
  }

  if ( $text eq '' ) {
    error ("Graph rrdtool error : graph_ams: $type");
    return (0);
  }

  my $rrd= "$wrkdir/$server/$host/$lpar.rr$type_sam";

  my $lpar_slash = $lpar;
  $lpar_slash =~ s/SharedPool//g;   # to show slash and not &&1 which is general replacemnt for it

  my $lpar_pool_alias = $lpar;
  $lpar_pool_alias =~ s/SharedPool/CPU pool /g;

  # add CPU pool alias into png header (if exists and it is not a default CPU pool)
  my $pool_id = $lpar;
  $pool_id =~ s/SharedPool//g;

  if ( -f "$wrkdir/$server/$host/cpu-pools-mapping.txt") {
    open(FR, "< $wrkdir/$server/$host/cpu-pools-mapping.txt");
    foreach my $linep (<FR>) {
      chomp ($linep);
      (my $id, my $pool_name) = split (/,/,$linep);
      if ( $id == $pool_id  ) {
        $lpar_pool_alias = "$pool_name";
        last;
      }
    }
    close (FR);
  }

  my $header = "CPU pool: $lpar_pool_alias : last $text";

    #print "Graph pool :$lpar\n";
    if ($type =~ "d" && $graph_hours == 0) {
      RRDp::cmd qq(last "$rrd");
      my $last_tt = RRDp::read;
      my $l=localtime($$last_tt);
      # following must be for RRD 1.2+
      $l =~ s/:/\\:/g;
      $t ="COMMENT:Updated\\: $l ";

      # get LAST value from RRD
      RRDp::cmd qq(fetch "$rrd" "AVERAGE" "-s $$last_tt-$step" "-e $$last_tt-$step");
      my $row = RRDp::read;
      chomp($$row);
      my @row_arr = split(/\n/,$$row);
      my $m = "";
      my $i = 0;
      foreach $m (@row_arr) {
       chomp($m);
       $i++;
       if ( $i == 3 ) {
         my @m_arr = split(/ /,$m);
         # go further ony if it is a digit (avoid it when NaNQ (== no data) is there)
         if ($m_arr[1] =~ /\d/ && $m_arr[2] =~ /\d/ && $m_arr[3] =~ /\d/ && $m_arr[4] =~ /\d/ ) {
           #print "m : $m\n" if $DEBUG ;
           #print "\n$m_arr[1] $m_arr[2]" if $DEBUG ;
           my $total_pool_cycles = sprintf("%e",$m_arr[1]);
           my $utilized_pool_cyc = sprintf("%e",$m_arr[2]);
           my $max_pool_units  = sprintf("%e",$m_arr[3]);
           my $res_pool_units  = sprintf("%e",$m_arr[4]);
           if ( $total_pool_cycles != 0 ) {
             my $util = sprintf ("%.2f",($utilized_pool_cyc / $total_pool_cycles ) * $max_pool_units);
             #print ("\n $util $curr_proc $entitled_cycles $capped_cycles $uncapped_cycles\n");

             $last ="COMMENT:Last utilization in CPU cores  $util";
           }
         }
       }
      }
    };


  if ( $type =~ "y" ) {
    $step_new=86400;
  }

  if ( ! -f "$rrd" ) {
     if ( $type_sam =~ "d" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one day!!!\n";
       error ("$rrd does not exists");
     }
     if ( $type_sam =~ "h" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one hour!!!\n";
       error ("$rrd does not exists");
     }
     if ( $type_sam =~ "m" ) {
       error ("$rrd does not exists");
     }
     return 0;
  }

  my $start_time = "now-1$type";
  if ( $graph_hours > 0 ) {
    # alerting
    $start_time = "now-".$graph_hours."h";
    if ( $graph_hours < 12 ) {
      $xgrid="MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
    else {
      if ( $graph_hours > 24 ) {
        $xgrid="MINUTE:60:HOUR:2:HOUR:4:0:%H";
      }
      else {
        $xgrid="MINUTE:60:HOUR:2:HOUR:2:0:%H";
      }
    }  
  }

  if ( $lpar =~  "SharedPool[1-9]" || $lpar =~  "SharedPool[1-9][0-9]" ) {
    #print "creating graph : $host:$server:$lpar_slash:$type_sam:$type\n" if $DEBUG ;
    RRDp::cmd qq(graph "$name_out"
      "--title" "$header"
      "--start" "$start_time"
      "--end" "now-1$type+1$type"
      "--imgformat" "PNG"
      "--slope-mode"
      "--font=DEFAULT:10:"
      "--font=TITLE:13:"
      "--width=$width"
      "--height=$height"
      "--step=$step_new"
      "--lower-limit=0.00"
      "--color=BACK#$pic_col"
      "--color=SHADEA#$pic_col"
      "--color=SHADEB#$pic_col"
      "--color=CANVAS#$pic_col"
      "--alt-autoscale-max"
      "--interlaced" 
      "--upper-limit=0.1"
      "--vertical-label=CPU cores"
      "--units-exponent=1.00"
      "--alt-y-grid"
      "--x-grid=$xgrid"
      "$font_def"
      "$font_tit"
      "DEF:max=$rrd:max_pool_units:AVERAGE"
      "DEF:res=$rrd:res_pool_units:AVERAGE"
      "DEF:totcyc=$rrd:total_pool_cycles:AVERAGE"
      "DEF:uticyc=$rrd:utilized_pool_cyc:AVERAGE"
      "CDEF:max1=max,res,-"
      "CDEF:cpuutil=uticyc,totcyc,/"
      "CDEF:cpuutiltot=cpuutil,max,*"
      "CDEF:utilisa=cpuutil,100,*"
      "COMMENT:   Average   \\n"
      "AREA:res#00FF00: Reserved CPU cores      "
      "GPRINT:res:AVERAGE: %2.1lf"
      "$t2"
      "STACK:max1#FFFF00: Max CPU cores           "
      "GPRINT:max1:AVERAGE: %2.1lf"
      "$t2"
      "LINE1:cpuutiltot#FF0000: Utilization in CPU cores"
      "GPRINT:cpuutiltot:AVERAGE: %2.2lf"
      "COMMENT:("
      "GPRINT:utilisa:AVERAGE: %2.1lf"
      "COMMENT:\%)"
      "$t2"
      "$last"
      "$t2"
      "$t"
      "HRULE:0#000000"
      "VRULE:0#000000"
    );
  }
  else { 
    #print "creating graph : $host:$server:$lpar_slash:$type_sam:$type\n" if $DEBUG ;
    RRDp::cmd qq(graph "$name_out"
      "--title" "$header"
      "--start" "$start_time"
      "--end" "now-1$type+1$type"
      "--imgformat" "PNG"
      "--slope-mode"
      "--font=DEFAULT:10:"
      "--font=TITLE:13:"
      "--width=$width"
      "--height=$height"
      "--step=$step_new"
      "--lower-limit=0.00"
      "--color=BACK#$pic_col"
      "--color=SHADEA#$pic_col"
      "--color=SHADEB#$pic_col"
      "--color=CANVAS#$pic_col"
      "--alt-autoscale-max"
      "--interlaced" 
      "--upper-limit=0.1"
      "--vertical-label=CPU cores"
      "--units-exponent=1.00"
      "--alt-y-grid"
      "--x-grid=$xgrid"
      "$font_def"
      "$font_tit"
      "DEF:max=$rrd:max_pool_units:AVERAGE"
      "DEF:totcyc=$rrd:total_pool_cycles:AVERAGE"
      "DEF:uticyc=$rrd:utilized_pool_cyc:AVERAGE"
      "CDEF:cpuutil=uticyc,totcyc,/"
      "CDEF:cpuutiltot=cpuutil,max,*"
      "CDEF:utilisa=cpuutil,100,*"
      "COMMENT:   Average   \\n"
      "AREA:max#00FF00: Max CPU cores           "
      "GPRINT:max:AVERAGE: %2.1lf"
      "$t2"
      "LINE1:cpuutiltot#FF0000: Utilization in CPU cores"
      "GPRINT:cpuutiltot:AVERAGE: %2.2lf"
      "COMMENT:("
      "GPRINT:utilisa:AVERAGE: %2.1lf"
      "COMMENT:\%)"
      "$t2"
      "$last"
      "$t2"
      "$t"
      "HRULE:0#000000"
      "VRULE:0#000000"
    );
  }
  my $answer = RRDp::read; 
  if ( $$answer =~ "ERROR" ) {
    error ("$host:$server Graph rrdtool error : $$answer");
    if ( $$answer =~ "is not an RRD file" ) {
      (my $err,  my $file, my $txt) = split(/'/,$$answer);
      error ("It need to be removed due to corrpution: $file");
    }
    else {
      error ("Graph rrdtool error : $$answer");
    }
    return 0;
  }

  return 0;
}



sub graph_osmem_agg

{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;
  my $item = shift;
  my $amax = shift;
  my $text = "";
  my $step = 60; # --PH dodelat --> no problem it could be here 60 fixed
  my $xgrid = "";
  my $ds_name1 = "page_in";
  my $ds_name2 = "page_out";
  my $headline1 = "COMMENT:             [MB/s]        READ   Avg    Max   WRITE  Avg    Max";
  if ( $detail == 1 ) {
    $headline1 = "COMMENT:             [MB/s]        READ   Avg    Max   WRITE  Avg    Max                  [MB/s]        READ   Avg    Max   WRITE  Avg    Max";
  }
  my $vertical_label = "READ  Paging MB/s  WRITE";
  my $t="COMMENT: ";
  my $t2="COMMENT:\\n";
  my $step_new = $step;
  my $last ="COMMENT: ";
  my $act_time = localtime();
  my $act_time_u = time();
  my $req_time = 0;
  my $font_def =  "--font=DEFAULT:8:";
  my $font_tit =  "--font=TITLE:9:";
  my $line_items = 0; # how many items in the legend per a line (default 2, when detail then 3)
  
  # 48 colors like for HMC below + 216 basic HTML colors x 6 == 1296 + 48
  my @color=("#FF0000","#0000FF","#00FF00","#FFFF00","#FF3399","#00FFFF","#999933","#0099CC","#3300CC",
"#FF8080", "#FFFF80", "#80FF80", "#00FF80", "#80FFFF", "#0080FF", "#FF80C0", "#FF80FF", "#FF0000", "#FFFF00", "#80FF00",
"#00FF40", "#00FFFF", "#0080C0", "#8080C0", "#FF00FF", "#804040", "#FF8040", "#00FF00", "#008080", "#004080", "#8080FF",
"#800040", "#FF0080", "#800000", "#FF8000", "#008000", "#008040", "#0000FF", "#0000A0", "#800080", "#8000FF", "#400000",
"#804000", "#004000", "#004040", "#000080", "#000040", "#400040", "#400080", "#000000", "#808000", "#808040", "#808080",
"#408080", "#C0C0C0", "#400040", "#AAAAAA",
"#CC0000","#FF0000", "#CC00CC","#FF00CC","#0000CC","#0000FF","#00CCCC","#00FFFF","#00CC00","#00FF00",
"#CCCC00","#000000","#FFFF00","#333300","#FFFFFF","#330000","#999990","#336600","#FFCC00","#339900",
"#FF9900","#33CC00","#FF6600","#33FF00","#FF3300","#66FF00","#660000","#663300","#66CC00","#669900",
"#666600","#330033","#FFFF33","#333333","#FF0033","#336633","#FFCC33","#339933","#FF9933","#33CC33",
"#FF6633","#33FF33","#FF3333","#66FF33","#660033","#663333","#66CC33","#669933","#666633","#330066",
"#FFFF66","#333366","#FF0066","#336666","#FFCC66","#339966","#FF9966","#33CC66","#FF6666","#33FF66",
"#FF3366","#66FF66","#660066","#663366","#66CC66","#669966","#666666","#330099","#FFFF99","#333399",
"#FF0099","#336699","#FFCC99","#339999","#FF9999","#33CC99","#FF6699","#33FF99","#FF3399","#66FF99",
"#660099","#663399","#66CC99","#669999","#666699","#3300CC","#FFFFCC","#3333CC","#3366CC","#FFCCCC",
"#3399CC","#FF99CC","#33CCCC","#FF66CC","#33FFCC","#FF33CC","#66FFCC","#6600CC","#6633CC","#66CCCC",
"#6699CC","#6666CC","#3300FF","#FFFFFF","#3333FF","#FF00FF","#3366FF","#FFCCFF","#3399FF","#FF99FF",
"#33CCFF","#FF66FF","#33FFFF","#FF33FF","#66FFFF","#6600FF","#6633FF","#66CCFF","#6699FF","#6666FF",
"#CCFFFF","#0033FF","#CC00FF","#0066FF","#CCCCFF","#0099FF","#CC99FF","#00CCFF","#CC66FF","#CC33FF",
"#99FFFF","#9900FF","#9933FF","#99CCFF","#9999FF","#9966FF","#CCFFCC","#0033CC","#0066CC","#CCCCCC",
"#0099CC","#CC99CC","#CC66CC","#00FFCC","#CC33CC","#99FFCC","#9900CC","#9933CC","#99CCCC","#9999CC",
"#9966CC","#000099","#CCFF99","#003399","#CC0099","#006699","#CCCC99","#009999","#CC9999","#00CC99",
"#CC6699","#00FF99","#CC3399","#99FF99","#990099","#993399","#99CC99","#999999","#996699","#000066",
"#CCFF66","#003366","#CC0066","#006666","#CCCC66","#009966","#CC9966","#00CC66","#CC6666","#00FF66",
"#CC3366","#99FF66","#990066","#993366","#99CC66","#999966","#996666","#000033","#CCFF33","#003333",
"#CC0033","#006633","#CCCC33","#009933","#CC9933","#00CC33","#CC6633","#00FF33","#CC3333","#99FF33",
"#990033","#993333","#99CC33","#999933","#996633","#CCFF00","#003300","#006600","#009900","#CC9900",
"#CC6600","#CC3300","#99FF00","#990000","#993300","#99CC00","#999900","#996600",
"#CC0000","#FF0000","#CC00CC","#FF00CC","#0000CC","#0000FF","#00CCCC","#00FFFF","#00CC00","#00FF00",
"#CCCC00","#FFFF00","#000000","#999999","#FFFFFF","#330000","#333300","#336600","#FFCC00","#339900",
"#FF9900","#33CC00","#FF6600","#33FF00","#FF3300","#66FF00","#660000","#663300","#66CC00","#669900",
"#666600","#330033","#FFFF33","#333333","#FF0033","#336633","#FFCC33","#339933","#FF9933","#33CC33",
"#FF6633","#33FF33","#FF3333","#66FF33","#660033","#663333","#66CC33","#669933","#666633","#330066",
"#FFFF66","#333366","#FF0066","#336666","#FFCC66","#339966","#FF9966","#33CC66","#FF6666","#33FF66",
"#FF3366","#66FF66","#660066","#663366","#66CC66","#669966","#666666","#330099","#FFFF99","#333399",
"#FF0099","#336699","#FFCC99","#339999","#FF9999","#33CC99","#FF6699","#33FF99","#FF3399","#66FF99",
"#660099","#663399","#66CC99","#669999","#666699","#3300CC","#FFFFCC","#3333CC","#3366CC","#FFCCCC",
"#3399CC","#FF99CC","#33CCCC","#FF66CC","#33FFCC","#FF33CC","#66FFCC","#6600CC","#6633CC","#66CCCC",
"#6699CC","#6666CC","#3300FF","#FFFFFF","#3333FF","#FF00FF","#3366FF","#FFCCFF","#3399FF","#FF99FF",
"#33CCFF","#FF66FF","#33FFFF","#FF33FF","#66FFFF","#6600FF","#6633FF","#66CCFF","#6699FF","#6666FF",
"#CCFFFF","#0033FF","#CC00FF","#0066FF","#CCCCFF","#0099FF","#CC99FF","#00CCFF","#CC66FF","#CC33FF",
"#99FFFF","#9900FF","#9933FF","#99CCFF","#9999FF","#9966FF","#CCFFCC","#0033CC","#0066CC","#CCCCCC",
"#0099CC","#CC99CC","#CC66CC","#00FFCC","#CC33CC","#99FFCC","#9900CC","#9933CC","#99CCCC","#9999CC",
"#9966CC","#000099","#CCFF99","#003399","#CC0099","#006699","#CCCC99","#009999","#CC9999","#00CC99",
"#CC6699","#00FF99","#CC3399","#99FF99","#990099","#993399","#99CC99","#999999","#996699","#000066",
"#CCFF66","#003366","#CC0066","#006666","#CCCC66","#009966","#CC9966","#00CC66","#CC6666","#00FF66",
"#CC3366","#99FF66","#990066","#993366","#99CC66","#999966","#996666","#000033","#CCFF33","#003333",
"#CC0033","#006633","#CCCC33","#009933","#CC9933","#00CC33","#CC6633","#00FF33","#CC3333","#99FF33",
"#990033","#993333","#99CC33","#999933","#996633","#CCFF00","#003300","#006600","#009900","#CC9900",
"#CC6600","#CC3300","#99FF00","#990000","#993300","#99CC00","#999900","#996600",
"#CC0000","#FF0000","#CC00CC","#FF00CC","#0000CC","#0000FF","#00CCCC","#00FFFF","#00CC00","#00FF00",
"#CCCC00","#FFFF00","#000000","#999999","#FFFFFF","#330000","#333300","#336600","#FFCC00","#339900",
"#FF9900","#33CC00","#FF6600","#33FF00","#FF3300","#66FF00","#660000","#663300","#66CC00","#669900",
"#666600","#330033","#FFFF33","#333333","#FF0033","#336633","#FFCC33","#339933","#FF9933","#33CC33",
"#FF6633","#33FF33","#FF3333","#66FF33","#660033","#663333","#66CC33","#669933","#666633","#330066",
"#FFFF66","#333366","#FF0066","#336666","#FFCC66","#339966","#FF9966","#33CC66","#FF6666","#33FF66",
"#FF3366","#66FF66","#660066","#663366","#66CC66","#669966","#666666","#330099","#FFFF99","#333399",
"#FF0099","#336699","#FFCC99","#339999","#FF9999","#33CC99","#FF6699","#33FF99","#FF3399","#66FF99",
"#660099","#663399","#66CC99","#669999","#666699","#3300CC","#FFFFCC","#3333CC","#3366CC","#FFCCCC",
"#3399CC","#FF99CC","#33CCCC","#FF66CC","#33FFCC","#FF33CC","#66FFCC","#6600CC","#6633CC","#66CCCC",
"#6699CC","#6666CC","#3300FF","#FFFFFF","#3333FF","#FF00FF","#3366FF","#FFCCFF","#3399FF","#FF99FF",
"#33CCFF","#FF66FF","#33FFFF","#FF33FF","#66FFFF","#6600FF","#6633FF","#66CCFF","#6699FF","#6666FF",
"#CCFFFF","#0033FF","#CC00FF","#0066FF","#CCCCFF","#0099FF","#CC99FF","#00CCFF","#CC66FF","#CC33FF",
"#99FFFF","#9900FF","#9933FF","#99CCFF","#9999FF","#9966FF","#CCFFCC","#0033CC","#0066CC","#CCCCCC",
"#0099CC","#CC99CC","#CC66CC","#00FFCC","#CC33CC","#99FFCC","#9900CC","#9933CC","#99CCCC","#9999CC",
"#9966CC","#000099","#CCFF99","#003399","#CC0099","#006699","#CCCC99","#009999","#CC9999","#00CC99",
"#CC6699","#00FF99","#CC3399","#99FF99","#990099","#993399","#99CC99","#999999","#996699","#000066",
"#CCFF66","#003366","#CC0066","#006666","#CCCC66","#009966","#CC9966","#00CC66","#CC6666","#00FF66",
"#CC3366","#99FF66","#990066","#993366","#99CC66","#999966","#996666","#000033","#CCFF33","#003333",
"#CC0033","#006633","#CCCC33","#009933","#CC9933","#00CC33","#CC6633","#00FF33","#CC3333","#99FF33",
"#990033","#993333","#99CC33","#999933","#996633","#CCFF00","#003300","#006600","#009900","#CC9900",
"#CC6600","#CC3300","#99FF00","#990000","#993300","#99CC00","#999900","#996600",
"#CC0000","#FF0000","#CC00CC","#FF00CC","#0000CC","#0000FF","#00CCCC","#00FFFF","#00CC00","#00FF00",
"#CCCC00","#FFFF00","#000000","#999999","#FFFFFF","#330000","#333300","#336600","#FFCC00","#339900",
"#FF9900","#33CC00","#FF6600","#33FF00","#FF3300","#66FF00","#660000","#663300","#66CC00","#669900",
"#666600","#330033","#FFFF33","#333333","#FF0033","#336633","#FFCC33","#339933","#FF9933","#33CC33",
"#FF6633","#33FF33","#FF3333","#66FF33","#660033","#663333","#66CC33","#669933","#666633","#330066",
"#FFFF66","#333366","#FF0066","#336666","#FFCC66","#339966","#FF9966","#33CC66","#FF6666","#33FF66",
"#FF3366","#66FF66","#660066","#663366","#66CC66","#669966","#666666","#330099","#FFFF99","#333399",
"#FF0099","#336699","#FFCC99","#339999","#FF9999","#33CC99","#FF6699","#33FF99","#FF3399","#66FF99",
"#660099","#663399","#66CC99","#669999","#666699","#3300CC","#FFFFCC","#3333CC","#3366CC","#FFCCCC",
"#3399CC","#FF99CC","#33CCCC","#FF66CC","#33FFCC","#FF33CC","#66FFCC","#6600CC","#6633CC","#66CCCC",
"#6699CC","#6666CC","#3300FF","#FFFFFF","#3333FF","#FF00FF","#3366FF","#FFCCFF","#3399FF","#FF99FF",
"#33CCFF","#FF66FF","#33FFFF","#FF33FF","#66FFFF","#6600FF","#6633FF","#66CCFF","#6699FF","#6666FF",
"#CCFFFF","#0033FF","#CC00FF","#0066FF","#CCCCFF","#0099FF","#CC99FF","#00CCFF","#CC66FF","#CC33FF",
"#99FFFF","#9900FF","#9933FF","#99CCFF","#9999FF","#9966FF","#CCFFCC","#0033CC","#0066CC","#CCCCCC",
"#0099CC","#CC99CC","#CC66CC","#00FFCC","#CC33CC","#99FFCC","#9900CC","#9933CC","#99CCCC","#9999CC",
"#9966CC","#000099","#CCFF99","#003399","#CC0099","#006699","#CCCC99","#009999","#CC9999","#00CC99",
"#CC6699","#00FF99","#CC3399","#99FF99","#990099","#993399","#99CC99","#999999","#996699","#000066",
"#CCFF66","#003366","#CC0066","#006666","#CCCC66","#009966","#CC9966","#00CC66","#CC6666","#00FF66",
"#CC3366","#99FF66","#990066","#993366","#99CC66","#999966","#996666","#000033","#CCFF33","#003333",
"#CC0033","#006633","#CCCC33","#009933","#CC9933","#00CC33","#CC6633","#00FF33","#CC3333","#99FF33",
"#990033","#993333","#99CC33","#999933","#996633","#CCFF00","#003300","#006600","#009900","#CC9900",
"#CC6600","#CC3300","#99FF00","#990000","#993300","#99CC00","#999900","#996600",
"#CC0000","#FF0000","#CC00CC","#FF00CC","#0000CC","#0000FF","#00CCCC","#00FFFF","#00CC00","#00FF00",
"#CCCC00","#FFFF00","#000000","#999999","#FFFFFF","#330000","#333300","#336600","#FFCC00","#339900",
"#FF9900","#33CC00","#FF6600","#33FF00","#FF3300","#66FF00","#660000","#663300","#66CC00","#669900",
"#666600","#330033","#FFFF33","#333333","#FF0033","#336633","#FFCC33","#339933","#FF9933","#33CC33",
"#FF6633","#33FF33","#FF3333","#66FF33","#660033","#663333","#66CC33","#669933","#666633","#330066",
"#FFFF66","#333366","#FF0066","#336666","#FFCC66","#339966","#FF9966","#33CC66","#FF6666","#33FF66",
"#FF3366","#66FF66","#660066","#663366","#66CC66","#669966","#666666","#330099","#FFFF99","#333399",
"#FF0099","#336699","#FFCC99","#339999","#FF9999","#33CC99","#FF6699","#33FF99","#FF3399","#66FF99",
"#660099","#663399","#66CC99","#669999","#666699","#3300CC","#FFFFCC","#3333CC","#3366CC","#FFCCCC",
"#3399CC","#FF99CC","#33CCCC","#FF66CC","#33FFCC","#FF33CC","#66FFCC","#6600CC","#6633CC","#66CCCC",
"#6699CC","#6666CC","#3300FF","#FFFFFF","#3333FF","#FF00FF","#3366FF","#FFCCFF","#3399FF","#FF99FF",
"#33CCFF","#FF66FF","#33FFFF","#FF33FF","#66FFFF","#6600FF","#6633FF","#66CCFF","#6699FF","#6666FF",
"#CCFFFF","#0033FF","#CC00FF","#0066FF","#CCCCFF","#0099FF","#CC99FF","#00CCFF","#CC66FF","#CC33FF",
"#99FFFF","#9900FF","#9933FF","#99CCFF","#9999FF","#9966FF","#CCFFCC","#0033CC","#0066CC","#CCCCCC",
"#0099CC","#CC99CC","#CC66CC","#00FFCC","#CC33CC","#99FFCC","#9900CC","#9933CC","#99CCCC","#9999CC",
"#9966CC","#000099","#CCFF99","#003399","#CC0099","#006699","#CCCC99","#009999","#CC9999","#00CC99",
"#CC6699","#00FF99","#CC3399","#99FF99","#990099","#993399","#99CC99","#999999","#996699","#000066",
"#CCFF66","#003366","#CC0066","#006666","#CCCC66","#009966","#CC9966","#00CC66","#CC6666","#00FF66",
"#CC3366","#99FF66","#990066","#993366","#99CC66","#999966","#996666","#000033","#CCFF33","#003333",
"#CC0033","#006633","#CCCC33","#009933","#CC9933","#00CC33","#CC6633","#00FF33","#CC3333","#99FF33",
"#990033","#993333","#99CC33","#999933","#996633","#CCFF00","#003300","#006600","#009900","#CC9900",
"#CC6600","#CC3300","#99FF00","#990000","#993300","#99CC00","#999900","#996600");

  if ( $detail == 1 ) {
    $font_def =  "--font=DEFAULT:10:";
    $font_tit =  "--font=TITLE:13:";
    $line_items = 2;
  }

  if ( $type =~ m/d/ ) {
    $text="day";
    if ( $detail == 0 ) {
      $xgrid="MINUTE:60:HOUR:2:HOUR:4:0:%H";
    }
    else {
      $xgrid="MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
  }
  if ( $type =~ m/w/ ) {
    $text="week";
    if ( $detail == 0 ) {
      $xgrid="HOUR:8:DAY:1:DAY:1:0:%a";
    }
    else {
      $xgrid="HOUR:12:HOUR:6:HOUR:12:0:%a %H";
    }
  }
  if ( $type =~ m/m/ ) {
    $text="4 weeks";
    if ( $detail == 0 ) {
      $xgrid="DAY:1:DAY:2:DAY:7:0:%U";
    }
    else {
      $xgrid="HOUR:12:DAY:1:DAY:1:0:%d";
    }
  }
  if ( $type =~ m/y/ ) {
    $text="year";
    if ( $detail == 0 ) {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
    else {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
  }

  if ( $text eq '' ) {
    error ("Graph rrdtool error : graph_osmem_agg: $type");
    return (0);
  }

  my $header = "Paging activity aggregated : last $text";

  if ( $type =~ "y" ) {
    $step_new=86400;
  }

  my $file = "";
  my $i = 0;
  my $lpar = "";
  my $cmd = "";
  my $j = 0;

  if ( "$type" =~ "d" ) {
    $req_time = $act_time_u - 86400;
  }
  if ( "$type" =~ "w" ) {
    $req_time = $act_time_u - 604800;
  }
  if ( "$type" =~ "m" ) {
    $req_time = $act_time_u - 2764800;
  }
  # for daily, must be even type as for IVM/SDMC it is not in $type_sam =~ "d"
  if ( $type_sam =~ "d"  || "$type" =~ "y" ) {
    $req_time = $act_time_u - 31536000;
  } #"--units-exponent=1.00"

     $cmd .= 'RRDp::cmd qq(graph "$name_out"
        "--title" "$header"
        "--start" "now-1$type"
        "--end" "now-1$type+1$type"
        "--imgformat" "PNG"
        "--slope-mode"
        "--width=$width"
        "--height=$height"
        "--step=$step"
        "--lower-limit=0.00"
        "--color=BACK#$pic_col"
        "--color=SHADEA#$pic_col"
        "--color=SHADEB#$pic_col"
        "--color=CANVAS#$pic_col"
        "--alt-autoscale-max"
        "--interlaced"
        "--vertical-label=$vertical_label"
        "--units-exponent=1.00"
        "--alt-y-grid"
        "--x-grid=$xgrid"
        "--base=1024"
        "$font_def"
        "$font_tit"
        "$headline1"
        "$t2"
';
  my $col_indx = 0;
  my $line_indx = 0; # place enter every 3rd line

  my $server_space = $server;
  if ( $server =~ m/ / ) { # workaround for server name with a space inside, nothing else works, grrr
     $server_space = "\"".$server."\"";
  }
  my $wrkdir_space = $wrkdir;
  if ( $wrkdir =~ m/ / ) { # workaround for server name with a space inside, nothing else works, grrr
     $wrkdir_space = "\"".$wrkdir."\"";
  }
  my $host_space = $host;
  if ( $host =~ m/ / ) { # workaround for server name with a space inside, nothing else works, grrr
     $host_space = "\"".$host."\"";
  }

  my @files_unsorted = (<$wrkdir_space/$server_space/$host_space/*/pgs\.mmm>);
 
#  my @files_unsorted = grep(/pgs\.mmm$/,readdir(DIR));
  my @files = sort { lc $a cmp lc $b } @files_unsorted;

  if ( $type_sam =~ "d" ) {
    $req_time = $act_time_u - 31536000;
  }

  my $last_dir  = "";
  my (@recb, @trab, @rname, @rpath, @avgx, @avgy, @lpnames);

  foreach $file (@files) {
    chomp($file);

  #`echo "2372: detail-graph-cgi - $file" >> /tmp/e099`;

    # avoid old files - lpars which do not exist in the period
    my $rrd_upd_time = (stat("$file"))[9];
    if ( $rrd_upd_time < $req_time ) {
       next;
    }

    # get MAX value from RRD
    my $answer;
    RRDp::cmd qq(graph "$name_out"
      "--start" "now-1$type"
      "--end" "now-1$type+1$type"
      "--step=$STEP"
      "DEF:item=$file:$ds_name1:AVERAGE"
      "DEF:item2=$file:$ds_name2:AVERAGE"
      "PRINT:item:MAX: %10.6lf"
      "PRINT:item2:MAX: %10.6lf"
    );  
     
    $answer = RRDp::read;
    if ( $$answer =~ m/NaN/ || $$answer =~ m/nan/ ) {
       # error ( "Graph rrdtool error instead of MAX returns : $$answer in osmem_agg detail-graph-cgi");
       next;  #return 0;
    }
    chomp ($$answer);
    my $addr = "";
    my $maxin = "";
    my $maxout = "";
    ( $addr,  $maxin, $maxout ) = split (/ +/,$$answer);
    # `echo  "2372: detail-graph-cgi - $file,MAX=$$answer, maxin,$maxin, maxout,$maxout, " >> /tmp/e099`;
    $maxin = $maxin * 4196  /1048576; 
    $maxout = $maxout * 4196  /1048576;
    # `echo "alimit ",$amax >>/tmp/ealimit`;
   ( undef, my $alimit) = split(/=/,$amax);
    $alimit = 10 if !defined $alimit;
    if ($alimit <= 0) { $alimit = 0; } 
    $alimit = $alimit / 1000;
    # `echo  "2376: detail-graph-cgi - amax is, $amax, alimit, $alimit, " >> /tmp/e099`;
    if ( $maxin < $alimit && $maxout < $alimit ) 
    {  next
    };
    #lpar name is last but one 
    my @n_parts  = split(/\//,$file);
    my $len = @n_parts;
    $lpar = $n_parts[$len - 2];
    my $lpar_space = $lpar;

    # add spaces to lpar name to have 25 chars total (for formatting graph legend)
    $lpar_space =~ s/\&\&1/\//g;
    $lpar_space = sprintf ("%-25s",$lpar_space);  
    
    $rpath[$i] = "$file";
    $lpnames[$i] = "$lpar_space";  
    $recb[$i]  = "rcb${i}";
    $trab[$i]  = "trb${i}";
    $avgx[$i]  = "avg${i}";
    $avgy[$i]  = "avgy${i}";

  $cmd .= '"DEF:$recb[$i]=$rpath[$i]:$ds_name1:AVERAGE"
           "DEF:$trab[$i]=$rpath[$i]:$ds_name2:AVERAGE"
           "CDEF:$recb[$i]_b=$recb[$i],4096,*"
           "CDEF:$trab[$i]_b=$trab[$i],4096,*"
           "CDEF:$recb[$i]_mb=$recb[$i]_b,1048576,/"
           "CDEF:$trab[$i]_mb=$trab[$i]_b,1048576,/"
           "CDEF:$recb[$i]_mbn=$recb[$i]_mb,UN,0,$recb[$i]_mb,IF"
           "CDEF:$recb[$i]_mbnm=0,$recb[$i]_mbn,-"
           "CDEF:$trab[$i]_mbn=$trab[$i]_mb,UN,0,$trab[$i]_mb,IF"
          ';
           $cmd .= '"COMMENT:$lpnames[$i]"
                   ';

       $cmd .= '"LINE1:$recb[$i]_mbnm$color[$col_indx++]: "
                "GPRINT:$recb[$i]_mb:AVERAGE:%5.1lf"
                "GPRINT:$recb[$i]_mb:MAX:%5.1lf"
                "LINE1:$trab[$i]_mbn$color[$col_indx++]: "
                "GPRINT:$trab[$i]_mb:AVERAGE:%5.1lf"
                "GPRINT:$trab[$i++]_mb:MAX:%5.1lf"
            ';
    if ( $detail == 1 ) {
       if (1 == $i % 2) {
          $cmd .= '  "$t2"
                  ';   # There is remainder  
       }
    }            #do you understand difference $i++ above and below ??
    else {
         $cmd .= '  "$t2"
                ';
    }
    # --> it does not work ideally with newer RRDTOOL (1.2.30 --> it needs to be separated by cariage return here)
    $i++;
    if ($line_indx == $line_items) {
      # put carriage return after each second lpar in the legend
      #      $cmd .= " COMMENT:\\\"\\l\\\"";
      #       $cmd .= '" COMMENT: \\n"
      #        ';
        $line_indx = 0;
    }
    else {
      $line_indx++;
    }
  }
 $cmd .= '"HRULE:0#000000"
          "VRULE:0#000000"
 );';

 #if you want to see what is generated
 # my $sss = "/var/tmp/sss.out";
 # open (FF, ">$sss");
 #  print FF "$cmd\n";
 # close (FF);

  $i = 0;
  eval $cmd ;
  if ($@) {
     error ( "Graph error in eval cmd : !$@!");
  }
  else {
     my $answ = RRDp::read;
     if ( $$answ =~ "ERROR" ) {
       error ("$host:$server Graph rrdtool error : $$answ");
       if ( $answ =~ "is not an RRD file" ) {
         (my $err,  my $file, my $txt) = split(/\'/,$answ);
         error ("It needs to be removed due to corruption: $file");
       }
       else {
         error ( "Graph rrdtool error : $answ");
       }
     }
  }
  return 0;

  # $cmd .= " VRULE:0#000000";  --> it is causing sigsegv on linuxeS
}

sub graph_lparagg
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;
  my $text = "";
  my $step = 60; # --PH dodelat --> no problem it could be here 60 fixed
  my $xgrid = "";
  my $t="COMMENT: ";
  my $t2="COMMENT:\\n";
  my $step_new = $step;
  my $last ="COMMENT: ";
  my $act_time = localtime();
  my $act_time_u = time();
  my $req_time = 0;
  my $font_def =  "--font=DEFAULT:8:";
  my $font_tit =  "--font=TITLE:9:";
  my $line_items = 0; # how many items in the legend per a line (default 2, when detail then 3)

  # 48 colors like for HMC below + 216 basic HTML colors x 6 == 1296 + 48
  my @color=("#FF0000","#0000FF","#00FF00","#FFFF00","#FF3399","#00FFFF","#999933","#0099CC","#3300CC",
"#fF8080", "#FFFF80", "#80FF80", "#00FF80", "#80FFFF", "#0080FF", "#FF80C0", "#FF80FF", "#FF0000", "#FFFF00", "#80FF00",
"#00FF40", "#00FFFF", "#0080C0", "#8080C0", "#FF00FF", "#804040", "#FF8040", "#00FF00", "#008080", "#004080", "#8080FF",
"#800040", "#FF0080", "#800000", "#FF8000", "#008000", "#008040", "#0000FF", "#0000A0", "#800080", "#8000FF", "#400000",
"#804000", "#004000", "#004040", "#000080", "#000040", "#400040", "#400080", "#000000", "#808000", "#808040", "#808080",
"#408080", "#C0C0C0", "#400040", "#AAAAAA",
"#CC0000","#FF0000", "#CC00CC","#FF00CC","#0000CC","#0000FF","#00CCCC","#00FFFF","#00CC00","#00FF00",
"#CCCC00","#000000","#FFFF00","#333300","#FFFFFF","#330000","#999990","#336600","#FFCC00","#339900",
"#FF9900","#33CC00","#FF6600","#33FF00","#FF3300","#66FF00","#660000","#663300","#66CC00","#669900",
"#666600","#330033","#FFFF33","#333333","#FF0033","#336633","#FFCC33","#339933","#FF9933","#33CC33",
"#FF6633","#33FF33","#FF3333","#66FF33","#660033","#663333","#66CC33","#669933","#666633","#330066",
"#FFFF66","#333366","#FF0066","#336666","#FFCC66","#339966","#FF9966","#33CC66","#FF6666","#33FF66",
"#FF3366","#66FF66","#660066","#663366","#66CC66","#669966","#666666","#330099","#FFFF99","#333399",
"#FF0099","#336699","#FFCC99","#339999","#FF9999","#33CC99","#FF6699","#33FF99","#FF3399","#66FF99",
"#660099","#663399","#66CC99","#669999","#666699","#3300CC","#FFFFCC","#3333CC","#3366CC","#FFCCCC",
"#3399CC","#FF99CC","#33CCCC","#FF66CC","#33FFCC","#FF33CC","#66FFCC","#6600CC","#6633CC","#66CCCC",
"#6699CC","#6666CC","#3300FF","#FFFFFF","#3333FF","#FF00FF","#3366FF","#FFCCFF","#3399FF","#FF99FF",
"#33CCFF","#FF66FF","#33FFFF","#FF33FF","#66FFFF","#6600FF","#6633FF","#66CCFF","#6699FF","#6666FF",
"#CCFFFF","#0033FF","#CC00FF","#0066FF","#CCCCFF","#0099FF","#CC99FF","#00CCFF","#CC66FF","#CC33FF",
"#99FFFF","#9900FF","#9933FF","#99CCFF","#9999FF","#9966FF","#CCFFCC","#0033CC","#0066CC","#CCCCCC",
"#0099CC","#CC99CC","#CC66CC","#00FFCC","#CC33CC","#99FFCC","#9900CC","#9933CC","#99CCCC","#9999CC",
"#9966CC","#000099","#CCFF99","#003399","#CC0099","#006699","#CCCC99","#009999","#CC9999","#00CC99",
"#CC6699","#00FF99","#CC3399","#99FF99","#990099","#993399","#99CC99","#999999","#996699","#000066",
"#CCFF66","#003366","#CC0066","#006666","#CCCC66","#009966","#CC9966","#00CC66","#CC6666","#00FF66",
"#CC3366","#99FF66","#990066","#993366","#99CC66","#999966","#996666","#000033","#CCFF33","#003333",
"#CC0033","#006633","#CCCC33","#009933","#CC9933","#00CC33","#CC6633","#00FF33","#CC3333","#99FF33",
"#990033","#993333","#99CC33","#999933","#996633","#CCFF00","#003300","#006600","#009900","#CC9900",
"#CC6600","#CC3300","#99FF00","#990000","#993300","#99CC00","#999900","#996600",
"#CC0000","#FF0000","#CC00CC","#FF00CC","#0000CC","#0000FF","#00CCCC","#00FFFF","#00CC00","#00FF00",
"#CCCC00","#FFFF00","#000000","#999999","#FFFFFF","#330000","#333300","#336600","#FFCC00","#339900",
"#FF9900","#33CC00","#FF6600","#33FF00","#FF3300","#66FF00","#660000","#663300","#66CC00","#669900",
"#666600","#330033","#FFFF33","#333333","#FF0033","#336633","#FFCC33","#339933","#FF9933","#33CC33",
"#FF6633","#33FF33","#FF3333","#66FF33","#660033","#663333","#66CC33","#669933","#666633","#330066",
"#FFFF66","#333366","#FF0066","#336666","#FFCC66","#339966","#FF9966","#33CC66","#FF6666","#33FF66",
"#FF3366","#66FF66","#660066","#663366","#66CC66","#669966","#666666","#330099","#FFFF99","#333399",
"#FF0099","#336699","#FFCC99","#339999","#FF9999","#33CC99","#FF6699","#33FF99","#FF3399","#66FF99",
"#660099","#663399","#66CC99","#669999","#666699","#3300CC","#FFFFCC","#3333CC","#3366CC","#FFCCCC",
"#3399CC","#FF99CC","#33CCCC","#FF66CC","#33FFCC","#FF33CC","#66FFCC","#6600CC","#6633CC","#66CCCC",
"#6699CC","#6666CC","#3300FF","#FFFFFF","#3333FF","#FF00FF","#3366FF","#FFCCFF","#3399FF","#FF99FF",
"#33CCFF","#FF66FF","#33FFFF","#FF33FF","#66FFFF","#6600FF","#6633FF","#66CCFF","#6699FF","#6666FF",
"#CCFFFF","#0033FF","#CC00FF","#0066FF","#CCCCFF","#0099FF","#CC99FF","#00CCFF","#CC66FF","#CC33FF",
"#99FFFF","#9900FF","#9933FF","#99CCFF","#9999FF","#9966FF","#CCFFCC","#0033CC","#0066CC","#CCCCCC",
"#0099CC","#CC99CC","#CC66CC","#00FFCC","#CC33CC","#99FFCC","#9900CC","#9933CC","#99CCCC","#9999CC",
"#9966CC","#000099","#CCFF99","#003399","#CC0099","#006699","#CCCC99","#009999","#CC9999","#00CC99",
"#CC6699","#00FF99","#CC3399","#99FF99","#990099","#993399","#99CC99","#999999","#996699","#000066",
"#CCFF66","#003366","#CC0066","#006666","#CCCC66","#009966","#CC9966","#00CC66","#CC6666","#00FF66",
"#CC3366","#99FF66","#990066","#993366","#99CC66","#999966","#996666","#000033","#CCFF33","#003333",
"#CC0033","#006633","#CCCC33","#009933","#CC9933","#00CC33","#CC6633","#00FF33","#CC3333","#99FF33",
"#990033","#993333","#99CC33","#999933","#996633","#CCFF00","#003300","#006600","#009900","#CC9900",
"#CC6600","#CC3300","#99FF00","#990000","#993300","#99CC00","#999900","#996600",
"#CC0000","#FF0000","#CC00CC","#FF00CC","#0000CC","#0000FF","#00CCCC","#00FFFF","#00CC00","#00FF00",
"#CCCC00","#FFFF00","#000000","#999999","#FFFFFF","#330000","#333300","#336600","#FFCC00","#339900",
"#FF9900","#33CC00","#FF6600","#33FF00","#FF3300","#66FF00","#660000","#663300","#66CC00","#669900",
"#666600","#330033","#FFFF33","#333333","#FF0033","#336633","#FFCC33","#339933","#FF9933","#33CC33",
"#FF6633","#33FF33","#FF3333","#66FF33","#660033","#663333","#66CC33","#669933","#666633","#330066",
"#FFFF66","#333366","#FF0066","#336666","#FFCC66","#339966","#FF9966","#33CC66","#FF6666","#33FF66",
"#FF3366","#66FF66","#660066","#663366","#66CC66","#669966","#666666","#330099","#FFFF99","#333399",
"#FF0099","#336699","#FFCC99","#339999","#FF9999","#33CC99","#FF6699","#33FF99","#FF3399","#66FF99",
"#660099","#663399","#66CC99","#669999","#666699","#3300CC","#FFFFCC","#3333CC","#3366CC","#FFCCCC",
"#3399CC","#FF99CC","#33CCCC","#FF66CC","#33FFCC","#FF33CC","#66FFCC","#6600CC","#6633CC","#66CCCC",
"#6699CC","#6666CC","#3300FF","#FFFFFF","#3333FF","#FF00FF","#3366FF","#FFCCFF","#3399FF","#FF99FF",
"#33CCFF","#FF66FF","#33FFFF","#FF33FF","#66FFFF","#6600FF","#6633FF","#66CCFF","#6699FF","#6666FF",
"#CCFFFF","#0033FF","#CC00FF","#0066FF","#CCCCFF","#0099FF","#CC99FF","#00CCFF","#CC66FF","#CC33FF",
"#99FFFF","#9900FF","#9933FF","#99CCFF","#9999FF","#9966FF","#CCFFCC","#0033CC","#0066CC","#CCCCCC",
"#0099CC","#CC99CC","#CC66CC","#00FFCC","#CC33CC","#99FFCC","#9900CC","#9933CC","#99CCCC","#9999CC",
"#9966CC","#000099","#CCFF99","#003399","#CC0099","#006699","#CCCC99","#009999","#CC9999","#00CC99",
"#CC6699","#00FF99","#CC3399","#99FF99","#990099","#993399","#99CC99","#999999","#996699","#000066",
"#CCFF66","#003366","#CC0066","#006666","#CCCC66","#009966","#CC9966","#00CC66","#CC6666","#00FF66",
"#CC3366","#99FF66","#990066","#993366","#99CC66","#999966","#996666","#000033","#CCFF33","#003333",
"#CC0033","#006633","#CCCC33","#009933","#CC9933","#00CC33","#CC6633","#00FF33","#CC3333","#99FF33",
"#990033","#993333","#99CC33","#999933","#996633","#CCFF00","#003300","#006600","#009900","#CC9900",
"#CC6600","#CC3300","#99FF00","#990000","#993300","#99CC00","#999900","#996600",
"#CC0000","#FF0000","#CC00CC","#FF00CC","#0000CC","#0000FF","#00CCCC","#00FFFF","#00CC00","#00FF00",
"#CCCC00","#FFFF00","#000000","#999999","#FFFFFF","#330000","#333300","#336600","#FFCC00","#339900",
"#FF9900","#33CC00","#FF6600","#33FF00","#FF3300","#66FF00","#660000","#663300","#66CC00","#669900",
"#666600","#330033","#FFFF33","#333333","#FF0033","#336633","#FFCC33","#339933","#FF9933","#33CC33",
"#FF6633","#33FF33","#FF3333","#66FF33","#660033","#663333","#66CC33","#669933","#666633","#330066",
"#FFFF66","#333366","#FF0066","#336666","#FFCC66","#339966","#FF9966","#33CC66","#FF6666","#33FF66",
"#FF3366","#66FF66","#660066","#663366","#66CC66","#669966","#666666","#330099","#FFFF99","#333399",
"#FF0099","#336699","#FFCC99","#339999","#FF9999","#33CC99","#FF6699","#33FF99","#FF3399","#66FF99",
"#660099","#663399","#66CC99","#669999","#666699","#3300CC","#FFFFCC","#3333CC","#3366CC","#FFCCCC",
"#3399CC","#FF99CC","#33CCCC","#FF66CC","#33FFCC","#FF33CC","#66FFCC","#6600CC","#6633CC","#66CCCC",
"#6699CC","#6666CC","#3300FF","#FFFFFF","#3333FF","#FF00FF","#3366FF","#FFCCFF","#3399FF","#FF99FF",
"#33CCFF","#FF66FF","#33FFFF","#FF33FF","#66FFFF","#6600FF","#6633FF","#66CCFF","#6699FF","#6666FF",
"#CCFFFF","#0033FF","#CC00FF","#0066FF","#CCCCFF","#0099FF","#CC99FF","#00CCFF","#CC66FF","#CC33FF",
"#99FFFF","#9900FF","#9933FF","#99CCFF","#9999FF","#9966FF","#CCFFCC","#0033CC","#0066CC","#CCCCCC",
"#0099CC","#CC99CC","#CC66CC","#00FFCC","#CC33CC","#99FFCC","#9900CC","#9933CC","#99CCCC","#9999CC",
"#9966CC","#000099","#CCFF99","#003399","#CC0099","#006699","#CCCC99","#009999","#CC9999","#00CC99",
"#CC6699","#00FF99","#CC3399","#99FF99","#990099","#993399","#99CC99","#999999","#996699","#000066",
"#CCFF66","#003366","#CC0066","#006666","#CCCC66","#009966","#CC9966","#00CC66","#CC6666","#00FF66",
"#CC3366","#99FF66","#990066","#993366","#99CC66","#999966","#996666","#000033","#CCFF33","#003333",
"#CC0033","#006633","#CCCC33","#009933","#CC9933","#00CC33","#CC6633","#00FF33","#CC3333","#99FF33",
"#990033","#993333","#99CC33","#999933","#996633","#CCFF00","#003300","#006600","#009900","#CC9900",
"#CC6600","#CC3300","#99FF00","#990000","#993300","#99CC00","#999900","#996600");

  if ( $detail == 1 ) {
    $font_def =  "--font=DEFAULT:10:";
    $font_tit =  "--font=TITLE:13:";
    $line_items = 2;
  }

  if ( $type =~ m/d/ ) { 
    $text="day";     
    if ( $detail == 0 ) {
      $xgrid="MINUTE:60:HOUR:2:HOUR:4:0:%H";
    }
    else {
      $xgrid="MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
  }
  if ( $type =~ m/w/ ) { 
    $text="week";    
    if ( $detail == 0 ) {
      $xgrid="HOUR:8:DAY:1:DAY:1:0:%a";
    }
    else {
      $xgrid="\"HOUR:12:HOUR:6:HOUR:12:0:%a %H\"";
    }
  }
  if ( $type =~ m/m/ ) { 
    $text="4 weeks"; 
    if ( $detail == 0 ) {
      $xgrid="DAY:1:DAY:2:DAY:7:0:%U";
    }
    else {
      $xgrid="HOUR:12:DAY:1:DAY:1:0:%d";
    }
  }
  if ( $type =~ m/y/ ) { 
    $text="year";    
    if ( $detail == 0 ) {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
    else {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
  }

  if ( $text eq '' ) {
    error ("Graph rrdtool error : graph_lparagg: $type");
    return (0);
  }

  my $header = "LPARs aggregated : last $text";

  if ( $type =~ "y" ) {
    $step_new=86400;
  }



  opendir(DIR, "$wrkdir/$server/$host") || error ("can't opendir $wrkdir/$server/$host: $! :".__FILE__.":".__LINE__) && return 0;
  my @files = "";
  if ( $type_sam =~ "m" ) {
    my @files_unsorted = grep(/\.rrm$/,readdir(DIR));
    @files = sort { lc $a cmp lc $b } @files_unsorted;
  }
  if ( $type_sam =~ "h" ) {
    my @files_unsorted = grep(/\.rrh$/,readdir(DIR));
    @files = sort { lc $a cmp lc $b } @files_unsorted;
  }
  if ( $type_sam =~ "d" ) {
    my @files_unsorted = grep(/\.rrd$/,readdir(DIR));
    @files = sort { lc $a cmp lc $b } @files_unsorted;
    $req_time = $act_time_u - 31536000;
  }
  closedir(DIR);
  my $file = "";
  my $i = 0;
  my $lpar = "";
  my $cmd = "";
  my $j = 0;

  if ( "$type" =~ "d" ) {
    $req_time = $act_time_u - 86400;
  }
  if ( "$type" =~ "w" ) {
    $req_time = $act_time_u - 604800;
  }
  if ( "$type" =~ "m" ) {
    $req_time = $act_time_u - 2764800;
  }
  # for daily, must be even type as for IVM/SDMC it is not in $type_sam =~ "d"
  if ( $type_sam =~ "d"  || "$type" =~ "y" ) {
    $req_time = $act_time_u - 31536000;
  }


  $cmd .= "graph \\\"$name_out\\\"";
  $cmd .= " --title \\\"$header\\\"";
  $cmd .= " --start now-1$type";
  $cmd .= " --end now-1$type+1$type";
  $cmd .= " --imgformat PNG";
  $cmd .= " --slope-mode";
  $cmd .= " --width=$width";
  $cmd .= " --height=$height";
  $cmd .= " --step=$step";
  $cmd .= " --lower-limit=0.00";
  $cmd .= " --color=BACK#$pic_col";
  $cmd .= " --color=SHADEA#$pic_col";
  $cmd .= " --color=SHADEB#$pic_col";
  $cmd .= " --color=CANVAS#$pic_col";
  $cmd .= " --alt-autoscale-max";
  $cmd .= " --interlaced";
  $cmd .= " --upper-limit=0.1";
  $cmd .= " --vertical-label=\\\"CPU cores\\\"";
  $cmd .= " --units-exponent=1.00";
  $cmd .= " --alt-y-grid";
  $cmd .= " --x-grid=$xgrid";
  $cmd .= " $font_def";
  $cmd .= " $font_tit";
  if ( $detail == 1 ) {
    $cmd .= " COMMENT:\\\"Utilization in CPU cores\\:    average  maximum                               average  maximum                               average  maximum\\l\\\"";
  }
  else {
    $cmd .= " COMMENT:\\\"Utilization in CPU cores\\:    average  maximum\\l\\\"";
  }


  my $gtype="AREA";
  my $col_indx = 0;
  my $line_indx = 0; # place enter every 3rd line
  foreach $file (@files) {
    chomp($file);

    # avoid old lpars which do not exist in the period
    my $rrd_upd_time = (stat("$wrkdir/$server/$host/$file"))[9];
    if ( $rrd_upd_time < $req_time ) {
      next;
    }

    $lpar = $file;
    $lpar =~ s/.rrh//;
    $lpar =~ s/.rrm//;
    $lpar =~ s/.rrd//;
    my $lpar_space = $lpar;

    # add spaces to lpar name to have 25 chars total (for formating graph legend)
    $lpar_space =~ s/\&\&1/\//g;
    for(my $k = length($lpar_space); $k < 25; $k++) {
      $lpar_space .= " ";
    }

    # Exclude pools and memory
    if ($lpar =~ m/^pool$/ || $lpar =~ m/^mem$/ || $lpar =~  /^SharedPool[0-9]$/ || $lpar =~  m/^SharedPool[1-9][0-9]$/ || $lpar =~ m/^mem-pool$/ || $lpar =~ m/^cod$/ ) {
      next;
    }
 
    #print "$found $lpar $color[$found]\n";
    #print "$wrkdir/$server/$host/$file $rrd_upd_time $req_time $act_time\n" if ( $DEBUG == 3);

    # bulid RRDTool cmd
    $cmd .= " DEF:cap${i}=\\\"$wrkdir/$server/$host/$file\\\":capped_cycles:AVERAGE";
    $cmd .= " DEF:uncap${i}=\\\"$wrkdir/$server/$host/$file\\\":uncapped_cycles:AVERAGE";
    $cmd .= " DEF:ent${i}=\\\"$wrkdir/$server/$host/$file\\\":entitled_cycles:AVERAGE";
    $cmd .= " DEF:cur${i}=\\\"$wrkdir/$server/$host/$file\\\":curr_proc_units:AVERAGE";

    $cmd .= " CDEF:tot${i}=cap${i},uncap${i},+";
    $cmd .= " CDEF:util${i}=tot${i},ent${i},/";
    $cmd .= " CDEF:utiltotu${i}=util${i},cur${i},*";
    $cmd .= " CDEF:utiltot${i}=utiltotu${i},UN,0,utiltotu${i},IF";
    $cmd .= " $gtype:utiltot${i}$color[$col_indx]:\\\"$lpar_space\\\"";
    $col_indx++;

    $cmd .= " GPRINT:utiltot${i}:AVERAGE:\\\"%5.2lf \\\"";
    $cmd .= " GPRINT:utiltot${i}:MAX:\\\" %5.2lf \\\"";
    #$cmd .= " GPRINT:utiltot${i}:MAX:\\\" %5.2lf \\l\\\"";
    # --> it does not work ideally with newer RRDTOOL (1.2.30 --> it needs to be separated by cariage return here)
    $gtype="STACK";
    $i++;
    if ($line_indx == $line_items) {
      # put carriage return after each second lpar in the legend
      $cmd .= " COMMENT:\\\"\\l\\\"";
      $line_indx = 0;
    }
    else {
      $line_indx++;
    }
  }

  $cmd .= " HRULE:0#000000";
  # $cmd .= " VRULE:0#000000";  --> it is causing sigsegv on linuxeS
  $cmd =~ s/\\"/"/g;

  my  $FH;
  my $tmp_file="/var/tmp/lpar2rrd.tmp-$$";
  open(FH, "> $tmp_file") || error("Can't open $tmp_file : $!".__FILE__.":".__LINE__) && return 0;
  print FH "$cmd\n";
  close (FH);
  
  # execute rrdtool, it is not possible to use RRDp Perl due to the syntax issues therefore use not nice direct rrdtool way
  my $ret  = `$rrdtool - < $tmp_file 2>&1`;
  #my $ret  = `echo  "$cmd" | $rrdtool - 2>&1`;
  if ( $ret =~ "ERROR" ) {
    error ("$host : Multi graph rrdtool error : $ret");
    if ( $ret =~ "is not an RRD file" ) {
      (my $err,  my $file, my $txt) = split(/'/,$ret);
      error ("Removing as it seems to be corrupted: $file");
      unlink("$file") || error("Cannot rm $file : $!".__FILE__.":".__LINE__) && return 0;
    }
    else {
      error ("$host: $cmd : Multi graph rrdtool error : $ret");
    }
  }
 # unlink ("$tmp_file");

  return 0;
}


sub isdigit
{
  my $digit = shift;

  my $digit_work = $digit;
  $digit_work =~ s/[0-9]//g;
  $digit_work =~ s/\.//;

  if (length($digit_work) == 0) {
    # is a number
    return 1;
  }

  #if (($digit * 1) eq $digit){
  #  # is a number
  #  return 1;
  #}

  # NOT a number
  #error ("there was expected a digit but a string is there, field: $text , value: $digit");
  return 0;
}

sub graph_cod_used
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;
  my $graph_hours = shift;
  my $text = "";
  my $step = 3600; # --PH dodelat --> no problem it could be here 60 fixed
  my $xgrid = "";
  my $t="COMMENT: ";
  my $t2="COMMENT:\\n";
  my $step_new = $step;
  my $last ="COMMENT: ";
  my $font_def =  "--font=DEFAULT:8:";
  my $font_tit =  "--font=TITLE:9:";
  my $time_range = "hour";
  
  if ( $detail == 1 ) {
    $font_def =  "--font=DEFAULT:10:";
    $font_tit =  "--font=TITLE:13:";
  }

  if ( $type =~ m/d/ ) { 
    $text="day";     
    if ( $detail == 0 ) {
      $xgrid="MINUTE:60:HOUR:2:HOUR:4:0:%H";
    }
    else {
      $xgrid="MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
  }
  if ( $type =~ m/w/ ) { 
    $text="week";    
    if ( $detail == 0 ) {
      $xgrid="HOUR:8:DAY:1:DAY:1:0:%a";
    }
    else {
      $xgrid="HOUR:12:HOUR:6:HOUR:12:0:%a %H";
    }
  }
  if ( $type =~ m/m/ ) { 
    $text="4 weeks"; 
    if ( $detail == 0 ) {
      $xgrid="DAY:1:DAY:2:DAY:7:0:%U";
    }
    else {
      $xgrid="HOUR:12:DAY:1:DAY:1:0:%d";
    }
    $step=86400; # daily step
    $time_range = "day";
  }
  if ( $type =~ m/y/ ) { 
    $text="year";    
    if ( $detail == 0 ) {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
    else {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
    $step=86400; # daily step
    $time_range = "day";
  }

  if ( $text eq '' ) {
    error ("Graph rrdtool error : graph_ams: $type");
    return (0);
  }

  my $rrd= "$wrkdir/$server/$host/$lpar.rr$type_sam";

  my $header = "Capacity on Demand - used: last $text";

  if ( $type =~ "y" ) {
    $step_new=86400;
  }

  if ( ! -f "$rrd" ) {
     if ( $type_sam =~ "d" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one day!!!\n";
       error ("$rrd does not exists");
     }
     if ( $type_sam =~ "h" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one hour!!!\n";
       error ("$rrd does not exists");
     }
     if ( $type_sam =~ "m" ) {
       error ("$rrd does not exists");
     }
     return 0;
  }

  #my $rrd_y = "";
  #if ( $type_sam =~ "y" ) {
  #  # u rocnich grafu nejdrive pouzit rrm data a pokud nejsou tak teprve rrd
  #  if ( $rrd !~ m/\.rrd$/ ) {
  #    $rrd_y = $rrd;
  #    $rrd_y =~ s/\.rrm$/\.rrd/;
  #    if ( -f $rrd_y ) {
  #     $rrd = $rrd_y;
  #    }
  #}

  #print "creating graph : $host:$server:$lpar_slash:$type_sam:$type\n" if $DEBUG ;
  my $start_time = "now-1$type";
  if ( $graph_hours > 0 ) {
    # alerting
    $start_time = "now-".$graph_hours."h";
    if ( $graph_hours < 12 ) {
      $xgrid="MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
    else {
      if ( $graph_hours > 24 ) {
        $xgrid="MINUTE:60:HOUR:2:HOUR:4:0:%H";
      }
      else {
        $xgrid="MINUTE:60:HOUR:2:HOUR:2:0:%H";
      }
    }  
  }

  RRDp::cmd qq(graph "$name_out"
      "--title" "$header"
      "--start" "$start_time"
      "--end" "now-1$type+1$type"
      "--imgformat" "PNG"
      "--slope-mode"
      "--font=DEFAULT:10:"
      "--font=TITLE:13:"
      "--width=$width"
      "--height=$height"
      "--step=$step"
      "--lower-limit=0.00"
      "--color=BACK#$pic_col"
      "--color=SHADEA#$pic_col"
      "--color=SHADEB#$pic_col"
      "--color=CANVAS#$pic_col"
      "--alt-autoscale-max"
      "--interlaced" 
      "--upper-limit=0.1"
      "--vertical-label=CoD in minutes per $time_range"
      "--units-exponent=1.00"
      "--alt-y-grid"
      "--x-grid=$xgrid"
      "$font_def"
      "$font_tit"
      "DEF:used=$rrd:used_proc_min:AVERAGE"
      "CDEF:used_null=used,UN,0,used,IF"
      "CDEF:used_s=used_null,$step,*"
      "AREA:used_s#00FF00: Used mins per $time_range  "
      "GPRINT:used_s:AVERAGE: %4.2lf"
      "$t2"
      "$t"
      "HRULE:0#000000"
      "VRULE:0#000000"
  );
  my $answer = RRDp::read; 
  if ( $$answer =~ "ERROR" ) {
    error ("$host:$server Graph rrdtool error : $$answer");
    if ( $$answer =~ "is not an RRD file" ) {
      (my $err,  my $file, my $txt) = split(/'/,$$answer);
      error ("It need to be removed due to corrpution: $file");
    }
    else {
      error ("Graph rrdtool error : $$answer");
    }
    return 0;
  }

  return 0;
}

sub graph_cod_unreport
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;
  my $graph_hours = shift;
  my $text = "";
  my $step = 60; 
  my $xgrid = "";
  my $t="COMMENT: ";
  my $t2="COMMENT:\\n";
  my $step_new = $step;
  my $last ="COMMENT: ";
  my $head = "COMMENT:                            Average   \\n";
  my $font_def =  "--font=DEFAULT:8:";
  my $font_tit =  "--font=TITLE:9:";
  
  if ( $detail == 1 ) {
    $font_def =  "--font=DEFAULT:10:";
    $font_tit =  "--font=TITLE:13:";
  }

  if ( $type =~ m/d/ ) { 
    $text="day";     
    if ( $detail == 0 ) {
      $xgrid="MINUTE:60:HOUR:2:HOUR:4:0:%H";
    }
    else {
      $xgrid="MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
    $t="GPRINT:unrep:LAST: %4.0lf";
    $head = "COMMENT:                            Average   Last\\n";
  }
  if ( $type =~ m/w/ ) { 
    $text="week";    
    if ( $detail == 0 ) {
      $xgrid="HOUR:8:DAY:1:DAY:1:0:%a";
    }
    else {
      $xgrid="HOUR:12:HOUR:6:HOUR:12:0:%a %H";
    }
  }
  if ( $type =~ m/m/ ) { 
    $text="4 weeks"; 
    if ( $detail == 0 ) {
      $xgrid="DAY:1:DAY:2:DAY:7:0:%U";
    }
    else {
      $xgrid="HOUR:12:DAY:1:DAY:1:0:%d";
    }
  }
  if ( $type =~ m/y/ ) { 
    $text="year";    
    if ( $detail == 0 ) {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
    else {
      $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
  }

  if ( $text eq '' ) {
    error ("Graph rrdtool error : graph_cod: $type");
    return (0);
  }

  my $rrd= "$wrkdir/$server/$host/$lpar.rr$type_sam";

  my $header = "Capacity on Demand - unreported: last $text";

  if ( $type =~ "y" ) {
    $step_new=86400;
  }

  if ( ! -f "$rrd" ) {
     if ( $type_sam =~ "d" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one day!!!\n";
       error ("$rrd does not exists");
     }
     if ( $type_sam =~ "h" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one hour!!!\n";
       error ("$rrd does not exists");
     }
     if ( $type_sam =~ "m" ) {
       error ("$rrd does not exists");
     }
     return 0;
  }

  #my $rrd_y = "";
  #if ( $type_sam =~ "y" ) {
  #  # u rocnich grafu nejdrive pouzit rrm data a pokud nejsou tak teprve rrd
  #  if ( $rrd !~ m/\.rrd$/ ) {
  #    $rrd_y = $rrd;
  #    $rrd_y =~ s/\.rrm$/\.rrd/;
  #    if ( -f $rrd_y ) {
  #     $rrd = $rrd_y;
  #    }
  #}

  #print "creating graph : $host:$server:$lpar_slash:$type_sam:$type\n" if $DEBUG ;
  my $start_time = "now-1$type";
  if ( $graph_hours > 0 ) {
    # alerting
    $start_time = "now-".$graph_hours."h";
    if ( $graph_hours < 12 ) {
      $xgrid="MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
    else {
      if ( $graph_hours > 24 ) {
        $xgrid="MINUTE:60:HOUR:2:HOUR:4:0:%H";
      }
      else {
        $xgrid="MINUTE:60:HOUR:2:HOUR:2:0:%H";
      }
    }  
  }

  RRDp::cmd qq(graph "$name_out"
      "--title" "$header"
      "--start" "$start_time"
      "--end" "now-1$type+1$type"
      "--imgformat" "PNG"
      "--slope-mode"
      "--font=DEFAULT:10:"
      "--font=TITLE:13:"
      "--width=$width"
      "--height=$height"
      "--step=$step"
      "--lower-limit=0.00"
      "--color=BACK#$pic_col"
      "--color=SHADEA#$pic_col"
      "--color=SHADEB#$pic_col"
      "--color=CANVAS#$pic_col"
      "--alt-autoscale-max"
      "--interlaced" 
      "--upper-limit=0.1"
      "--vertical-label=CoD in minutes"
      "--units-exponent=1.00"
      "--alt-y-grid"
      "--x-grid=$xgrid"
      "$font_def"
      "$font_tit"
      "$head"
      "DEF:unrep=$rrd:unreported_proc_min:AVERAGE"
      "LINE1:unrep#FF0000: Unreported minutes      "
      "GPRINT:unrep:AVERAGE: %4.0lf"
      "$t"
      "$t2"
      "HRULE:0#000000"
      "VRULE:0#000000"
  );
  my $answer = RRDp::read; 
  if ( $$answer =~ "ERROR" ) {
    error ("$host:$server Graph rrdtool error : $$answer");
    if ( $$answer =~ "is not an RRD file" ) {
      (my $err,  my $file, my $txt) = split(/'/,$$answer);
      error ("It need to be removed due to corrpution: $file");
    }
    else {
      error ("Graph rrdtool error : $$answer");
    }
    return 0;
  }

  return 0;
}

sub graph_osmem
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;
  my $start_unix = shift;
  my $end_unix = shift;
  my $text = "";
  my $step = 60; # --PH dodelat --> no problem it could be here 60 fixed
  my $xgrid = "";
  my $t="COMMENT: ";
  my $t2="COMMENT:\\n";
  my $step_new = $step;
  my $last ="COMMENT: ";
  my $head = "COMMENT:                            Average   \\n";
  my $font_def =  "--font=DEFAULT:8:";
  my $font_tit =  "--font=TITLE:9:";

  my $start_time = "now-1$type";
  my $end_time = "now-1$type+1$type";
  if ( ! $start_unix eq '' && ! $end_unix eq '' ) {
    if ( isdigit($start_unix) > 0 && isdigit($end_unix) > 0 ) {
      $start_time = $start_unix;
      $end_time = $end_unix;
    }
  }


  if ( $detail == 1 ) {
    $font_def =  "--font=DEFAULT:10:";
    $font_tit =  "--font=TITLE:13:";
  }

  if ( $type =~ m/d/ ) { 
    $text="day";     
    if ( $detail == 0 ) {
      $xgrid="--x-grid=MINUTE:60:HOUR:2:HOUR:4:0:%H";
    }
    else {
      $xgrid="--x-grid=MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
    $t="GPRINT:unrep:LAST: %4.0lf";
    $head = "COMMENT:                            Average   Last\\n";
  }
  if ( $type =~ m/w/ ) { 
    $text="week";    
    if ( $detail == 0 ) {
      $xgrid="--x-grid=HOUR:8:DAY:1:DAY:1:0:%a";
    }
    else {
      $xgrid="--x-grid=HOUR:12:HOUR:6:HOUR:12:0:%a %H";
    }
  }
  if ( $type =~ m/m/ ) { 
    $text="4 weeks"; 
    if ( $detail == 0 ) {
      $xgrid="--x-grid=DAY:1:DAY:2:DAY:7:0:%U";
    }
    else {
      $xgrid="--x-grid=HOUR:12:DAY:1:DAY:1:0:%d";
    }
  }
  if ( $type =~ m/y/ ) { 
    $text="year";    
    if ( $detail == 0 ) {
      $xgrid="--x-grid=MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
    else {
      $xgrid="--x-grid=MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
  }
  if ( $type_sam =~ m/x/ ) {
    # historical reports --> no xgrid
    $xgrid="COMMENT: "; # just a trick to place there something otherwise rrdtoll complains
  }


  if ( $text eq '' ) {
    error ("Graph rrdtool error : graph_osmem: $type");
    return (0);
  }

  if ( $lpar eq '' ) {
    return 0; # some workaround, it should not go here
  }

  my $rrd= "$wrkdir/$server/$host/$lpar/mem.mmm";
  # print "001 AMS $rrd\n";

  my $lpar_slash = $lpar;
  $lpar_slash =~ s/\&\&1/\//g;   # to show slash and not &&1 which is general replacemnt for it
  
  my $header = "LPAR OS Memory: $lpar_slash : last $text";
  if ( ! $start_unix eq '' && ! $end_unix eq '' ) {
    if ( isdigit($start_unix) > 0 && isdigit($end_unix) > 0 ) {
      # historical reports
      my $start_human = strftime "%H:%M:%S %d.%m.%Y",localtime($start_unix);
      my $end_human = strftime "%H:%M:%S %d.%m.%Y",localtime($end_unix);
      $header = "LPAR OS Memory: $lpar_slash : $start_human - $end_human";
    }
  }

  if ($type =~ "d") {
    RRDp::cmd qq(last "$rrd");
    my $last_tt = RRDp::read;    
    chomp ($$last_tt);
    my $l=localtime($$last_tt);
    # following must be for RRD 1.2+
    $l =~ s/:/\\:/g;
    $t ="COMMENT:Updated\\: $l ";

    # get LAST value from RRD
    RRDp::cmd qq(fetch "$rrd" "AVERAGE" "-s $$last_tt-$step" "-e $$last_tt-$step");
    my $row = RRDp::read;
    chomp($$row);
    my @row_arr = split(/\n/,$$row);
    my $m = "";
    my $i = 0;

    foreach $m (@row_arr) {
      chomp($m);
       $i++;
       if ( $i == 3 ) {
         my @m_arr = split(/ /,$m);
         # go further only if it is a digit (avoid it when NaNQ (== no data) is there)
         if ($m_arr[1] =~ /\d/ && $m_arr[2] =~ /\d/ ) {
           #print "m : $m\n" if $DEBUG ;
           #print "\n$m_arr[1] $m_arr[2]" if $DEBUG ;

           $last ="";
           #if ( $m_arr[2] > 0 ) {
           #  my $last_mem = sprintf( "%6.2d",$m_arr[2]) / 1024;
           #  my $last_mem_g = sprintf( "%.2f",$m_arr[2] / 1024);
           #  $last ="COMMENT:Last memory consuption in GB         $last_mem_g";
           #}
         }
       }
    }
  };  

  #if ( $type =~ "y" ) {
  #  $step_new=86400;
  #}

  if ( ! -f "$rrd" ) {
     if ( $type_sam =~ "d" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one day!!!\n";
       error ("$rrd does not exists");
     }
     if ( $type_sam =~ "h" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one hour!!!\n";
       error ("$rrd does not exists");
     }
     if ( $type_sam =~ "m" ) {
       #print "\n$rrd does not exists\n";
       error ("$rrd does not exists");
     }
     return 0;
  }

  #print "graphing OSMEM   : $host:$server:$lpar_slash:$type_sam:$type\n" if $DEBUG ;
  RRDp::cmd qq(graph "$name_out"
      "--title" "$header"
      "--end" "$end_time"
      "--start" "$start_time"
      "--imgformat" "PNG"
      "--slope-mode"
      "--width=$width"
      "--height=$height"
      "--step=$step_new"
      "--lower-limit=0.00"
      "--color=BACK#$pic_col"
      "--color=SHADEA#$pic_col"
      "--color=SHADEB#$pic_col"
      "--color=CANVAS#$pic_col"
      "--alt-autoscale-max"
      "--interlaced" 
      "--upper-limit=0.1"
      "--vertical-label= GB"
      "--units-exponent=1.00"
      "--alt-y-grid"
      "$xgrid"
      "$font_def"
      "$font_tit"
      "DEF:size=$rrd:size:AVERAGE"
      "DEF:used=$rrd:nuse:AVERAGE"
      "DEF:free=$rrd:free:AVERAGE"
      "DEF:in_use_work=$rrd:in_use_work:AVERAGE"
      "DEF:in_use_clnt=$rrd:in_use_clnt:AVERAGE"
      "DEF:pin=$rrd:pin:AVERAGE"
      "CDEF:free_g=free,1048576,/"
      "CDEF:in_use_work_g=in_use_work,1048576,/"
      "CDEF:in_use_clnt_g=in_use_clnt,1048576,/"
      "CDEF:pin_g=pin,1048576,/"
      "COMMENT:   [GB]             AVRG      MAX  \\n"
      "AREA:in_use_work_g#FF4040: Used memory "
      "GPRINT:in_use_work_g:AVERAGE: %6.2lf"
      "GPRINT:in_use_work_g:MAX: %6.2lf"
      "$t2"
      "STACK:in_use_clnt_g#0080FF: FS cache    "
      "GPRINT:in_use_clnt_g:AVERAGE: %6.2lf"
      "GPRINT:in_use_clnt_g:MAX: %6.2lf"
      "$t2"
      "STACK:free_g#00FF00: Free        "
      "GPRINT:free_g:AVERAGE: %6.2lf"
      "GPRINT:free_g:MAX: %6.2lf"
      "$t2"
      "LINE1:pin_g#000000: Pinned      "
      "GPRINT:pin_g:AVERAGE: %6.2lf"
      "GPRINT:pin_g:MAX: %6.2lf"
      "$t2"
      "$t"
      "HRULE:0#000000"
      "VRULE:0#000000"
  );
  #   "$last"
  my $answ = RRDp::read; 
  if ( $$answ =~ "ERROR" ) {
    error ("$host:$server Graph rrdtool error : $$answ");
    if ( $answ =~ "is not an RRD file" ) {
      (my $err,  my $file, my $txt) = split(/'/,$answ);
      error ("It need to be removed due to corrpution: $file");
    }
    else {
      error ( "Graph rrdtool error : $answ");
    }
  }

  return 0;
}

sub graph_oscpu
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;
  my $item = shift;       # "slan" or "ssan1" or "ssan2" or "ssea"
  my $start_unix = shift;
  my $end_unix = shift;
  my $text = "";
  my $step = 60; # --PH dodelat --> no problem it could be here 60 fixed
  my $xgrid = "";
  my $t="COMMENT: ";
  my $t2="COMMENT:\\n";
  my $step_new = $step;
  my $last ="COMMENT: ";
  my $head = "COMMENT:                            Average   \\n";
  my $font_def =  "--font=DEFAULT:8:";
  my $font_tit =  "--font=TITLE:9:";

  my $start_time = "now-1$type";
  my $end_time = "now-1$type+1$type";
  if ( ! $start_unix eq '' && ! $end_unix eq '' ) {
    if ( isdigit($start_unix) > 0 && isdigit($end_unix) > 0 ) {
      $start_time = $start_unix;
      $end_time = $end_unix;
    }
  }

  if ( $detail == 1 ) {
    $font_def =  "--font=DEFAULT:10:";
    $font_tit =  "--font=TITLE:13:";
  }

  if ( $type =~ m/d/ ) {
    $text="day";
    if ( $detail == 0 ) {
      $xgrid="--x-grid=MINUTE:60:HOUR:2:HOUR:4:0:%H";
    }
    else {
      $xgrid="--x-grid=MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
    $t="GPRINT:unrep:LAST: %4.0lf";
    $head = "COMMENT:                            Average   Last\\n";
  }
  if ( $type =~ m/w/ ) {
    $text="week";
    if ( $detail == 0 ) {
      $xgrid="--x-grid=HOUR:8:DAY:1:DAY:1:0:%a";
    }
    else {
      $xgrid="--x-grid=HOUR:12:HOUR:6:HOUR:12:0:%a %H";
    }
  }
  if ( $type =~ m/m/ ) {
    $text="4 weeks";
    if ( $detail == 0 ) {
      $xgrid="--x-grid=DAY:1:DAY:2:DAY:7:0:%U";
    }
    else {
      $xgrid="--x-grid=HOUR:12:DAY:1:DAY:1:0:%d";
    }
  }
  if ( $type =~ m/y/ ) {
    $text="year";
    if ( $detail == 0 ) {
      $xgrid="--x-grid=MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
    else {
      $xgrid="--x-grid=MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
  }
  if ( $type_sam =~ m/x/ ) {
    # historical reports --> no xgrid
    $xgrid="COMMENT: "; # just a trick to place there something otherwise rrdtoll complains
  }


  if ( $text eq '' ) {
    error ("Graph rrdtool error : graph_cpuos: $type");
    return (0);
  }

  if ( $lpar eq '' ) {
    return 0; # some workaround, it should not go here
  }

  my $rrd= "$wrkdir/$server/$host/$lpar/cpu.mmm";
  # print "001 CPUOS $rrd\n";

  my $lpar_slash = $lpar;
  $lpar_slash =~ s/\&\&1/\//g;   # to show slash and not &&1 which is general replacement for it

  my $header = "LPAR OS CPU: $lpar_slash : last $text";
  if ( ! $start_unix eq '' && ! $end_unix eq '' ) {
    if ( isdigit($start_unix) > 0 && isdigit($end_unix) > 0 ) {
      # historical reports
      my $start_human = strftime "%H:%M:%S %d.%m.%Y",localtime($start_unix);
      my $end_human = strftime "%H:%M:%S %d.%m.%Y",localtime($end_unix);
      $header = "LPAR OS CPU: $lpar_slash : $start_human - $end_human";
    }
  }

  if ($type =~ "d") {
    RRDp::cmd qq(last "$rrd");
    my $last_tt = RRDp::read;
    chomp ($$last_tt);
    my $l=localtime($$last_tt);
    # following must be for RRD 1.2+
    $l =~ s/:/\\:/g;
    $t ="COMMENT:Updated\\: $l ";

    # get LAST value from RRD
    RRDp::cmd qq(fetch "$rrd" "AVERAGE" "-s $$last_tt-$step" "-e $$last_tt-$step");
    my $row = RRDp::read;
    chomp($$row);
    my @row_arr = split(/\n/,$$row);
    my $m = "";
    my $i = 0;

    foreach $m (@row_arr) {
      chomp($m);
       $i++;
       if ( $i == 3 ) {
         my @m_arr = split(/ /,$m);
         # go further only if it is a digit (avoid it when NaNQ (== no data) is there)
         if ($m_arr[1] =~ /\d/ && $m_arr[2] =~ /\d/ ) {
           #print "m : $m\n" if $DEBUG ;
           #print "\n$m_arr[1] $m_arr[2]" if $DEBUG ;

           $last ="";
           #if ( $m_arr[2] > 0 ) {
           #  my $last_mem = sprintf( "%6.2d",$m_arr[2]) / 1024;
           #  my $last_mem_g = sprintf( "%.2f",$m_arr[2] / 1024);
           #  $last ="COMMENT:Last memory consuption in GB         $last_mem_g";
           #}
         }
       }
    }
  };

  #if ( $type =~ "y" ) {
  #  $step_new=86400;
  #}

  if ( ! -f "$rrd" ) {
     if ( $type_sam =~ "d" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one day!!!\n";
       error ("$rrd does not exists");
     }
     if ( $type_sam =~ "h" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one hour!!!\n";
       error ("$rrd does not exists");
     }
     if ( $type_sam =~ "m" ) {
       #print "\n$rrd does not exists\n";
       error ("$rrd does not exists");
     }
     return 0;
  }

  #print "graphing CPUOS   : $host:$server:$lpar_slash:$type_sam:$type\n" if $DEBUG ;
  RRDp::cmd qq(graph "$name_out"
      "--title" "$header"
      "--end" "$end_time"
      "--start" "$start_time"
      "--imgformat" "PNG"
      "--slope-mode"
      "--width=$width"
      "--height=$height"
      "--step=$step_new"
      "--lower-limit=0.00"
      "--color=BACK#$pic_col"
      "--color=SHADEA#$pic_col"
      "--color=SHADEB#$pic_col"
      "--color=CANVAS#$pic_col"
      "--alt-autoscale-max"
      "--interlaced"
      "--upper-limit=100"
      "--vertical-label= %"
      "--units-exponent=1.00"
      "--alt-y-grid"
      "$xgrid"
      "$font_def"
      "$font_tit"
      "DEF:entitled=$rrd:entitled:AVERAGE"
      "DEF:cpusy=$rrd:cpu_sy:AVERAGE"
      "DEF:cpuus=$rrd:cpu_us:AVERAGE"
      "DEF:cpuwa=$rrd:cpu_wa:AVERAGE"
      "CDEF:stog=100,cpusy,-,cpuus,-,cpuwa,-"
      "COMMENT:   [%]              AVRG      MAX  \\n"
      "AREA:cpusy#0080FF: Sys         "
      "GPRINT:cpusy:AVERAGE: %6.2lf"
      "GPRINT:cpusy:MAX: %6.2lf"
      "$t2"
      "STACK:cpuus#FFFF00: User        "
      "GPRINT:cpuus:AVERAGE: %6.2lf"
      "GPRINT:cpuus:MAX: %6.2lf"
      "$t2"
      "STACK:cpuwa#FF4040: IO wait     "
      "GPRINT:cpuwa:AVERAGE: %6.2lf"
      "GPRINT:cpuwa:MAX: %6.2lf"
      "$t2"
      "STACK:stog#00FF00: Idle        "
      "GPRINT:stog:AVERAGE: %6.2lf"
      "GPRINT:stog:MAX: %6.2lf"
      "$t2"
      "$t"
      "HRULE:0#000000"
      "VRULE:0#000000"
  );
  #    "CDEF:cpusyg=cpusy,entitled,*"
  #    "CDEF:cpuusg=cpuus,entitled,*"
  #    "CDEF:cpuwag=cpuwa,entitled,*"
  #   "$last"
  my $answ = RRDp::read;
  if ( $$answ =~ "ERROR" ) {
    error ("$host:$server Graph rrdtool error : $$answ");
    if ( $answ =~ "is not an RRD file" ) {
      (my $err,  my $file, my $txt) = split(/'/,$answ);
      error ("It needs to be removed due to corruption: $file");
    }
    else {
      error ( "Graph rrdtool error : $answ");
    }
  }

  return 0;
}


sub graph_paging
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;
  my $start_unix = shift;
  my $end_unix = shift;
  my $text = "";
  my $step = 60; # --PH dodelat --> no problem it could be here 60 fixed
  my $xgrid = "";
  my $t="COMMENT: ";
  my $t2="COMMENT:\\n";
  my $step_new = $step;
  my $last ="COMMENT: ";
  my $head = "COMMENT:                            Average   Max\\n";
  my $font_def =  "--font=DEFAULT:8:";
  my $font_tit =  "--font=TITLE:9:";

  # due to historical reports where is specific time passed
  my $start_time = "now-1$type";
  my $end_time = "now-1$type+1$type";
  if ( ! $start_unix eq '' && ! $end_unix eq '' ) {
    if ( isdigit($start_unix) > 0 && isdigit($end_unix) > 0 ) {
      $start_time = $start_unix;
      $end_time = $end_unix;
    }
  }


  if ( $detail == 1 ) {
    $font_def =  "--font=DEFAULT:10:";
    $font_tit =  "--font=TITLE:13:";
  }

  if ( $type =~ m/d/ ) { 
    $text="day";     
    if ( $detail == 0 ) {
      $xgrid="--x-grid=MINUTE:60:HOUR:2:HOUR:4:0:%H";
    }
    else {
      $xgrid="--x-grid=MINUTE:60:HOUR:1:HOUR:1:0:%H";
    }
    $t="GPRINT:unrep:LAST: %4.0lf";
    $head = "COMMENT:                            Average   Last\\n";
  }
  if ( $type =~ m/w/ ) { 
    $text="week";    
    if ( $detail == 0 ) {
      $xgrid="--x-grid=HOUR:8:DAY:1:DAY:1:0:%a";
    }
    else {
      $xgrid="--x-grid=HOUR:12:HOUR:6:HOUR:12:0:%a %H";
    }
  }
  if ( $type =~ m/m/ ) { 
    $text="4 weeks"; 
    if ( $detail == 0 ) {
      $xgrid="--x-grid=DAY:1:DAY:2:DAY:7:0:%U";
    }
    else {
      $xgrid="--x-grid=HOUR:12:DAY:1:DAY:1:0:%d";
    }
  }
  if ( $type =~ m/y/ ) { 
    $text="year";    
    if ( $detail == 0 ) {
      $xgrid="--x-grid=MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
    else {
      $xgrid="--x-grid=MONTH:1:MONTH:1:MONTH:1:0:%b";
    }
  }
  if ( $type_sam =~ m/x/ ) {
    # historical reports --> no xgrid
    $xgrid="COMMENT: "; # just a trick to place there something otherwise rrdtoll complains
  }


  if ( $text eq '' ) {
    error ("Graph rrdtool error : graph_paging: $type");
    return (0);
  }


  if ( $lpar eq '' ) {
    return 0; # some workaround, it should not go here
  }

  my $rrd= "$wrkdir/$server/$host/$lpar/pgs.mmm";
  # print "001 AMS $rrd\n";

  my $lpar_slash = $lpar;
  $lpar_slash =~ s/\&\&1/\//g;   # to show slash and not &&1 which is general replacement for it
  my $header = "LPAR paging: $lpar_slash : last $text";
  if ( ! $start_unix eq '' && ! $end_unix eq '' ) {
    if ( isdigit($start_unix) > 0 && isdigit($end_unix) > 0 ) {
      # historical reports
      my $start_human = strftime "%H:%M:%S %d.%m.%Y",localtime($start_unix);
      my $end_human = strftime "%H:%M:%S %d.%m.%Y",localtime($end_unix);
      $header = "LPAR paging: $lpar_slash : $start_human - $end_human";
    }
  }


  if ($type =~ "d") {
    RRDp::cmd qq(last "$rrd");
    my $last_tt = RRDp::read;    
    chomp ($$last_tt);
    my $l=localtime($$last_tt);
    # following must be for RRD 1.2+
    $l =~ s/:/\\:/g;
    $t ="COMMENT:Updated\\: $l ";

    # get LAST value from RRD
    RRDp::cmd qq(fetch "$rrd" "AVERAGE" "-s $$last_tt-$step" "-e $$last_tt-$step");
    my $row = RRDp::read;
    chomp($$row);
    my @row_arr = split(/\n/,$$row);
    my $m = "";
    my $i = 0;

    foreach $m (@row_arr) {
      chomp($m);
       $i++;
       if ( $i == 3 ) {
         my @m_arr = split(/ /,$m);
         # go further only if it is a digit (avoid it when NaNQ (== no data) is there)
         if ($m_arr[1] =~ /\d/ && $m_arr[2] =~ /\d/ ) {
           #print "m : $m\n" if $DEBUG ;
           #print "\n$m_arr[1] $m_arr[2]" if $DEBUG ;

           $last ="";
           #if ( $m_arr[2] > 0 ) {
           #  my $last_mem = sprintf( "%6.2d",$m_arr[2]) / 1024;
           #  my $last_mem_g = sprintf( "%.2f",$m_arr[2] / 1024);
           #  $last ="COMMENT:Last memory consumption in GB         $last_mem_g";
           #}
         }
       }
    }
  };  

  #if ( $type =~ "y" ) {
  #  $step_new=86400;
  #}

  if ( ! -f "$rrd" ) {
     if ( $type_sam =~ "d" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one day!!!\n";
       error ("$rrd does not exist");
     }
     if ( $type_sam =~ "h" ) {
       #print "\n$rrd does not exists, probably freshly enabled utilization data collection for that lpar/managed node, this message should not apear more than one hour!!!\n";
       error ("$rrd does not exist");
     }
     if ( $type_sam =~ "m" ) {
       #print "\n$rrd does not exist\n";
       error ("$rrd does not exist");
     }
     return 0;
  }

  #print "graphing PAGING   : $host:$server:$lpar_slash:$type_sam:$type\n" if $DEBUG ;
  RRDp::cmd qq(graph "$name_out"
      "--title" "$header"
      "--end" "$end_time"
      "--start" "$start_time"
      "--imgformat" "PNG"
      "--slope-mode"
      "--width=$width"
      "--height=$height"
      "--step=$step_new"
      "--lower-limit=0.00"
      "--color=BACK#$pic_col"
      "--color=SHADEA#$pic_col"
      "--color=SHADEB#$pic_col"
      "--color=CANVAS#$pic_col"
      "--alt-autoscale-max"
      "--interlaced" 
      
"--upper-limit=0.1"
      "--vertical-label= MB/sec"
      "--units-exponent=1.00"
      "--alt-y-grid"
      "$xgrid"
      "--base=1024"
      "$font_def"
      "$font_tit"
      "DEF:pagein=$rrd:page_in:AVERAGE"
      "DEF:pageout=$rrd:page_out:AVERAGE"
      "CDEF:pagein_b=pagein,4096,*"
      "CDEF:pageout_b=pageout,4096,*"
      "CDEF:pagein_mb=pagein_b,1048576,/"
      "CDEF:pageout_mb=pageout_b,1048576,/"
      "COMMENT:   [MB/sec]        Avrg        Max\\n"
      "LINE1:pagein_mb#FF4040: Page in     "
      "GPRINT:pagein_mb:AVERAGE: %6.3lf"
      "GPRINT:pagein_mb:MAX:%9.3lf"
      "$t2"
      "LINE1:pageout_mb#0080FF: Page out    "
      "GPRINT:pageout_mb:AVERAGE: %6.3lf"
      "GPRINT:pageout_mb:MAX:%9.3lf"
      "$t2"
      "$t"
      "HRULE:0#000000"
      "VRULE:0#000000"
  );

  my $answ = RRDp::read; 
  if ( $$answ =~ "ERROR" ) {
    error ("$host:$server Graph rrdtool error : $$answ");
    if ( $answ =~ "is not an RRD file" ) {
      (my $err,  my $file, my $txt) = split(/'/,$answ);
      error ("It needs to be removed due to corruption: $file");
    }
    else {
      error ( "Graph rrdtool error : $answ");
    }
  }

  return 0;
}

sub graph_multihmc
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;
  my $xgrid = "";

  if ( $type =~ m/d/ ) { 
    $xgrid="MINUTE:60:HOUR:1:HOUR:1:0:%H";
  }
  if ( $type =~ m/w/ ) { 
    $xgrid="\"HOUR:12:HOUR:6:HOUR:12:0:%a %H\"";
  }
  if ( $type =~ m/m/ ) { 
    $xgrid="HOUR:12:DAY:1:DAY:1:0:%d";
  }
  if ( $type =~ m/y/ ) { 
    $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
  }

  my $tmp_file="$basedir/tmp/multi-hmc-$host-$type.cmd";
  my $tmp_file_web="/var/tmp/multi-hmc-$host-$type-web.cmd";

  # replace graph size and total value
  open(FH, "< $tmp_file") || error("multihmc detail: Can't open $tmp_file : $!".__FILE__.":".__LINE__) && return 0;
  my @lines = <FH>;
  close (FH);
  open(FH, "> $tmp_file_web") || error("multihmc detail: Can't open $tmp_file : $!".__FILE__.":".__LINE__) && return 0;
  foreach my $line (@lines) {
    $line =~ s/graph .* --title/graph \"$name_out\" --title/;
    $line =~ s/ --width=400/ --width=$width  --font=DEFAULT:9: /;
    $line =~ s/ --height=150/ --height=$height --font=TITLE:13: /;
    $line =~ s/ --x-grid=.* COMMENT:\"Utilization/ --x-grid=$xgrid COMMENT:\"Utilization/;
    print FH "$line";
  }
  close (FH);
  
  
  # execute rrdtool, it is not possible to use RRDp Perl due to the syntax issues therefore use not nice direct rrdtool way
  my $ret  = `$rrdtool - < "$tmp_file_web" 2>&1`;
  if ( $ret =~ "ERROR" ) {
    error ("custom detail: Multi graph rrdtool error : $ret");
  }
  unlink ($tmp_file_web);

  return 0;
}

sub graph_multihmclpar
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;
  my $xgrid = "";

  if ( $type =~ m/d/ ) { 
    $xgrid="MINUTE:60:HOUR:1:HOUR:1:0:%H";
  }
  if ( $type =~ m/w/ ) { 
    $xgrid="\"HOUR:12:HOUR:6:HOUR:12:0:%a %H\"";
  }
  if ( $type =~ m/m/ ) { 
    $xgrid="HOUR:12:DAY:1:DAY:1:0:%d";
  }
  if ( $type =~ m/y/ ) { 
    $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
  }

  my $tmp_file="$basedir/tmp/multi-hmc-lpar-$host-$type.cmd";
  my $tmp_file_web="/var/tmp/multi-hmc-lpar-$host-$type-web.cmd";

  # replace graph size 
  open(FH, "< $tmp_file") || error("multihmclpar detail: Can't open $tmp_file : $!".__FILE__.":".__LINE__) && return 0;
  my @lines = <FH>;
  close (FH);
  open(FH, "> $tmp_file_web") || error("multihmclpar detail: Can't open $tmp_file : $!".__FILE__.":".__LINE__) && return 0;
  foreach my $line (@lines) {
    $line =~ s/graph .* --title/graph \"$name_out\" --title/;
    $line =~ s/ --width=400/ --width=$width  --font=DEFAULT:9: /;
    $line =~ s/ --height=150/ --height=$height --font=TITLE:13: /;
    $line =~ s/ --x-grid=.* COMMENT:\"Utilization/ --x-grid=$xgrid COMMENT:\"Utilization/;
    print FH "$line";
  }
  close (FH);
  
  
  # execute rrdtool, it is not possible to use RRDp Perl due to the syntax issues therefore use not nice direct rrdtool way
  my $ret  = `$rrdtool - < "$tmp_file_web" 2>&1`;
  if ( $ret =~ "ERROR" ) {
    error ("multihmclpar detail: Multi graph rrdtool error : $ret");
  }
  unlink ($tmp_file_web);

  return 0;
}

sub graph_custom
{
  my $host = shift;
  my $server = shift;
  my $lpar = shift;
  my $type = shift;
  my $name_out = shift;
  my $type_sam = shift;
  my $detail = shift;
  my $name_source = shift;
  my $xgrid = "";

  if ( $type =~ m/d/ ) { 
    $xgrid="MINUTE:60:HOUR:1:HOUR:1:0:%H";
  }
  if ( $type =~ m/w/ ) { 
    $xgrid="\"HOUR:12:HOUR:6:HOUR:12:0:%a %H\"";
  }
  if ( $type =~ m/m/ ) {
    $xgrid="HOUR:12:DAY:1:DAY:1:0:%d";
  }
  if ( $type =~ m/y/ ) { 
    $xgrid="MONTH:1:MONTH:1:MONTH:1:0:%b";
  }

  my $tmp_file_sum="$basedir/tmp/custom-group-$lpar-$type-sum.cmd";

  # Find out total value
  my $ret  = `$rrdtool - < "$tmp_file_sum" 2>&1`;
  my $total = 0;
  foreach my $ret_line (split(/ /,$ret)) {
    chomp($ret_line);
    if ( $ret_line =~ m/:/ ) {
      next;
    }
    $ret_line =~ s/0x0//g;
    if ( $ret_line eq '' ) {
      next;
    }
    my $len = length($ret_line) - 1;
    my $digit = substr($ret_line,1,$len);
    if ( $digit eq '' ) {
      next;
    }
    my $ret_digit = isdigit($digit);
    if ( $ret_digit == 0 ) {
      next;
    }
    $total = $total + $digit;
  }
  close (FH);

  my $tmp_file="$basedir/tmp/$name_source-$lpar-$type.cmd";
  my $tmp_file_web="/var/tmp/$name_source-$lpar-$type-web.cmd";

  # replace graph size and total value
  open(FH, "< $tmp_file") || error("custom detail: Can't open $tmp_file : $!".__FILE__.":".__LINE__) && return 0;
  my @lines = <FH>;
  close (FH);
  open(FH, "> $tmp_file_web") || error("custom detail: Can't open $tmp_file : $!".__FILE__.":".__LINE__) && return 0;
  foreach my $line (@lines) {
    $line =~ s/graph .* --title/graph \"$name_out\" --title/;
    $line =~ s/Total                                                .*\\l\"/Total                                                $total\\l\"/;
    $line =~ s/ --width=400/ --width=$width  --font=DEFAULT:9: /;
    $line =~ s/ --height=150/ --height=$height --font=TITLE:13: /;
    $line =~ s/ --x-grid=.* COMMENT:\"Utilization/ --x-grid=$xgrid COMMENT:\"Utilization/;
    print FH "$line";
  }
  close (FH);
  
  
  # execute rrdtool, it is not possible to use RRDp Perl due to the syntax issues therefore use not nice direct rrdtool way
  my $ret  = `$rrdtool - < "$tmp_file_web" 2>&1`;
  if ( $ret =~ "ERROR" ) {
    error ("custom detail: Multi graph rrdtool error : $ret");
  }
  unlink ($tmp_file_web);

  return 0;
}

sub isdigit
{
  my $digit = shift;
  my $text = shift;

  my $digit_work = $digit;
  $digit_work =~ s/[0-9]//g;
  $digit_work =~ s/\.//;

  if (length($digit_work) == 0) {
    # is a number
    return 1;
  }

  #if (($digit * 1) eq $digit){
  #  # is a number
  #  return 1;
  #}

  # NOT a number
  return 0;
}

